# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

### Serialize.py ###
 
import pickle
import CHOMP
chomp_items = dir(CHOMP)
 
def Serialize(archive, value):
	class_name = value.__class__.__name__
	
	if class_name in ['list', 'tuple']:
		CHOMP.SaveToArchive(archive, '', class_name)
		CHOMP.SaveToArchive(archive, '', '%d' % len(value))
		for item in value:
			Serialize(archive, item)

	elif class_name == 'dict':
		CHOMP.SaveToArchive(archive, '', class_name)
		CHOMP.SaveToArchive(archive, '', '%d' % len(value))
		for key, val in value.items():
			Serialize(archive, key)
			Serialize(archive, val)
	
	elif class_name in chomp_items:
		deserializer = 'Load' + class_name + 'FromArchive'
 
		if deserializer in chomp_items:
			CHOMP.SaveToArchive(archive, '', deserializer)
			CHOMP.SaveToArchive(archive, '', value)
		else:
			raise ValueError('Cannot serialize type ' + class_name)
	
	else:
		pickled = pickle.dumps(value)
		CHOMP.SaveToArchive(archive, '', 'pickle')
		CHOMP.SaveToArchive(archive, '', pickled)
 
def Deserialize(archive):
	loader = CHOMP.LoadStringFromArchive(archive)

	if loader in ['list', 'tuple']:
		n_elements = int( CHOMP.LoadStringFromArchive(archive) )
		lst = [ Deserialize(archive) for i in xrange(n_elements) ]
		
		if loader == 'tuple': return tuple(lst)
		else: return lst
		
	elif loader == 'dict':
		n_elements = int( CHOMP.LoadStringFromArchive(archive) )
		result = {}
		for i in xrange(n_elements):
			key = Deserialize(archive)
			val = Deserialize(archive)
			result[key] = val
		return result	
 
	elif loader == 'pickle':
		pickled = CHOMP.LoadStringFromArchive(archive)
		return pickle.loads(pickled)

	else:
		try:
			return CHOMP.__dict__[loader](archive)
		except:
			print archive
			sys.exit()



