#!/usr/local/bin/python32
# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 


import sys, os, pickle
from os import path
import logging, time

############ EDIT THESE VALUES TO CUSTOMIZE STARTUP ############

JQD_SESSION_ID = 0
SERVER_DIR = '/home/server/our.server2' 

LOG_FILE = 'JobQueue_s%d.log' % JQD_SESSION_ID
LOG_MODE = 'w'
LOG_LEVEL = logging.DEBUG




############ SET UP PATHS ##############

# get the trunk/ base directory for this CHOMP installation
base_dir = os.getcwd()
for i in xrange(3):
	base_dir = path.split(base_dir)[0]

jq_path = path.join(base_dir, 'fah', 'JobQueue')
dist_path = path.join(base_dir, 'dist')

# add the JobQueue path to the system path for importing
sys.path =  ['', dist_path, jq_path] + sys.path
 	
# add the LD_LIBRARY_PATHs we need
os.environ['LD_LIBRARY_PATH'] = dist_path + ':' + os.environ['LD_LIBRARY_PATH']

# store parameters needed by JQD as environment variables
os.environ['JQD_SESSION_ID'] = str(JQD_SESSION_ID)
os.environ['SERVER_DIR'] = SERVER_DIR
os.environ['PYTHON_SYS_PATH'] = pickle.dumps(sys.path)
 
os.environ['LOG_FILE'] = LOG_FILE
os.environ['LOG_MODE'] = LOG_MODE
os.environ['LOG_LEVEL'] = str(LOG_LEVEL)

# launch the JQD initializer
os.system('python32 -i deploy.py')



