# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

data = [
# \var DataDirectory::LJAttractiveTable
# \brief Lennard-Jones attractive term, [rosetta type, rosetta type, distance squared]
#
# Lennard-Jones attractive table, taken straight from Rosetta. See the Rosetta
# source for details on how this table is generated.

'Array<FLOAT,3>     LJAttractiveTable',

# \var DataDirectory::LJRepulsiveTable
# \brief Lennard-Jones repulsive term, [rosetta type, rosetta type, distance squared]
#
# Lennard-Jones repulsive table, taken straight from Rosetta. See the Rosetta
# source for details on how this table is generated.

'Array<FLOAT,3>	   LJRepulsiveTable',

# \var DataDirectory::SolvationTable1
# \brief Solvation term 1 (??) [rosetta type, rosetta type, distance squared]
#
# A solvation term, taken straight from Rosetta. See the Rosetta
# source for details on how this table is generated.

'Array<FLOAT,3>	   SolvationTable1',

# \var DataDirectory::SolvationTable2
# \brief Solvation term 2 (??) [rosetta type, rosetta type, distance squared]
#
# A solvation term, taken straight from Rosetta. See the Rosetta
# source for details on how this table is generated.

'Array<FLOAT,3>	   SolvationTable2',

# \var DataDirectory::CountPairTable
# \brief A little hack for use with the atomwise VDW and solvation terms [countpair type, countpair type]
#
# This table is used to weight pairwise interactions between atoms in adjacent residues. The idea
# is that some interactions are already accounted for in other residue-residue interaction terms, so
# they should be weighted down or removed altogether. 
#
# \see EnergyFunction::Atom_CountPair

# TODO: Document the rest of these

'Array<FLOAT,2>	   CountPairTable',

'Array<FLOAT,2>	   PairCutoffTable',

'Array<FLOAT,2>	   HB_AHTable',
'Array<FLOAT,2>	   HB_XDTable',
'Array<FLOAT,2>	   HB_XHTable',

'Array<FLOAT,5>	   PairLikelihoodTable',

'Array<FLOAT,1>	   BBStrainWeight',

'Array<FLOAT,3>	   AAProbabilityByAngle',
'Array<FLOAT,1>	   AAProbability',

'Array<FLOAT,3>	   IntraRes_CountPair',

'Array<FLOAT,2>    OPLSaa_chargeTable',

'Array<FLOAT,3>	   OPLSaa_vdwTable',

'Array<FLOAT,2>    OPLSaa_BondStretchTable',

'Array<FLOAT,2>    OPLSaa_AngleBendTable',

'Array<FLOAT,2>    OPLSaa_TorsionTable',

'Array<FLOAT,2>    OPLSaa_ImptorsTable']



