# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])
	
data = 	\
{
	'atomOrders' :
	{
	'trie' : ['C', 'O',  'N', 'H', 'CA', 'HA', 'CB', '1HB', '2HB', '3HB' ],
	'PDB'  : ['N', 'CA', 'C', 'O', 'CB', 'H',  'HA', '1HB', '2HB', '3HB' ]
	},

	'AA_class' : 0,

	'polar' : False,  

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
	'HA' :  [ 'CA', 'N', 'C'  ],
	'1HB' : [ 'CB', 'CA', 'N' ],
	'2HB' : [ 'CB', 'CA', 'N' ],
	'3HB' : [ 'CB', 'CA', 'N' ]
	},

	'chiDependent' : [],
	'chiAtoms' : [],

	'templateCoords' :
	{
	'N'   : (  0.0000, 1.5340, 3.3340  ),
	'CA'  : (  0.0000, 2.8360, 3.9900  ),
	'C'   : (  0.0000, 2.6880, 5.5060  ),
	'O'   : (  0.0020, 1.5660, 6.0130  ),
	'CB'  : ( -1.1960, 3.6590, 3.5340  ),
	'H'   : ( -0.0470, 0.7070, 3.9120  ),
	'HA'  : (  0.9120, 3.3660, 3.7150  ),
	'1HB' : ( -1.1810, 4.6280, 4.0330  ),
	'2HB' : ( -1.1470, 3.8060, 2.4550  ),
	'3HB' : ( -2.1160, 3.1350, 3.7880  )
	},

	'centroidAtoms' : [ 'CB' ],

	'neighborAtom' : 'CB',

	'bondLengths' : 
	[	#C	O	N	H	CA	HA	CB	1HB	2HB	3HB
		[0,	1,	2,	3,	1,	2,	2,	3,	3,	3],	#C
		[1,	0,	3,	4,	2,	3,	3,	4,	4,	4],	#O
		[2,	3,	0,	1,	1,	2,	2,	3,	3,	3],	#N
		[3,	4,	1,	0,	2,	3,	3,	4,	4,	4],	#H
		[1,	2,	1,	2,	0,	1,	1,	2,	2,	2],	#CA
		[2,	3,	2,	3,	1,	0,	2,	3,	3,	3],	#HA
		[2,	3,	2,	3,	1,	2,	0,	1,	1,	1],	#CB
		[3,	4,	3,	4,	2,	3,	1,	0,	2,	2],	#1HB
		[3,	4,	3,	4,	2,	3,	1,	2,	0,	2],	#2HB
		[3,	4,	3,	4,	2,	3,	1,	2,	2,	0]	#3HB
	]
}


