# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C', 'O',  'N', 'H', 'CA', 'HA', 'CB',  '1HB', '2HB', 'CG',   'OD1',  'ND2', '1HD2', '2HD2'],
		'PDB'  : ['N', 'CA', 'C', 'O', 'CB', 'CG', 'OD1', 'ND2', 'H',   '1HD2', '2HD2', 'HA',  '1HB',  '2HB' ]
	}, 

        'AA_class' : 11,

	'polar' : True,   

	'acceptors' : { 'O' : 'C', 'OD1' : 'CG' },

	'templateAtom' : 
	{
		'1HD2' : [ 'ND2', 'CG', 'CB' ],
		'2HD2' : [ 'ND2', 'CG', 'CB' ],
		'HA'   : [ 'CA',  'N',  'C'  ],
		'1HB'  : [ 'CB',  'CA', 'CG' ],
		'2HB'  : [ 'CB',  'CA', 'CG' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'OD1', 'ND2', '1HD2', '2HD2' ] 
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG'  ],
		[ 'CA', 'CB', 'CG', 'OD1' ]
	],

	'templateCoords' :
	{
		'N'    :  ( 1.463  , 0.000  , 0.000  )  , 
		'CA'   :  ( 0.000  , 0.000  , 0.000  )  , 
		'C'    :  ( -0.565 , 1.411  , 0.000  )  , 
		'O'    :  ( -1.619 , 1.666  , -0.603 )  , 
		'CB'   :  ( -0.555 , -0.778 , 1.179  )  , 
		'CG'   :  ( -0.282 , -2.255 , 1.112  )  , 
		'OD1'  :  ( 0.050  , -2.798 , 0.052  )  , 
		'ND2'  :  ( -0.499 , -2.920 , 2.218  )  , 
		'H'    :  ( 2.425  , -0.306 , 0.000  )  , 
		'1HD2' :  ( -0.338 , -3.907 , 2.247  )  , 
		'2HD2' :  ( -0.825 , -2.442 , 3.033  )  , 
		'HA'   :  ( -0.370 , -0.475 , -0.910 )  , 
		'1HB'  :  ( -0.397 , -0.431 , 2.201  )  , 
		'2HB'  :  ( -1.591 , -0.599 , 0.891  )   
	},

	'centroidAtoms' : [ 'CG', 'OD1', 'ND2' ],

	'neighborAtom' : 'CB',

	'bondLengths' : 
	[	#C	O	N	H	CA	HA	CB	1HB	2HB 	CG 	OD1 	ND2	1HD2 2HD2
		[0,	1,	2,	3,	1,	2,	2,	3,	3,	3,	4,	4,	5,	5],	#C
		[1,	0,	3,	4,	2,	3,	3,	4,	4,	4,	5,	5,	6,	6],	#O
		[2,	3,	0,	1,	1,	2,	2,	3,	3,	3,	4,	4,	5,	5],	#N
		[3,	4,	1,	0,	2,	3,	3,	4,	4,	4,	5,	5,	6,	6],	#H
		[1,	2,	1,	2,	0,	1,	1,	2,	2,	2,	3,	3,	4,	4],	#CA
		[2,	3,	2,	3,	1,	0,	2,	3,	3,	3,	4,	4,	5,	5],	#HA
		[2,	3,	2,	3,	1,	2,	0,	1,	1,	1,	2,	2,	3,	3],	#CB
		[3,	4,	3,	4,	2,	3,	1,	0,	2,	2,	3,	3,	4,	4],	#1HB
		[3,	4,	3,	4,	2,	3,	1,	2,	0,	2,	3,	3,	4,	4],	#2HB
		[3,	4,	3,	4,	2,	3,	1,	2,	2,	0,	1,	1,	2,	2],	#CG
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	1,	0,	2,	3,	3],	#OD1
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	1,	2,	0,	1,	1],	#ND2
		[5,	6,	5,	6,	4,	5,	3,	4,	4,	2,	3,	1,	0,	2],	#1HD2
		[5,	6,	5,	6,	4,	5,	3,	4,	4,	2,	3,	1,	2,	0]	#2HD2
	]
}


