# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',  'O',   'N',   'H',  'CA', 'HA', 'CB',  '1HB',  '2HB',  'CG',  '1HG',  '2HG', 
			  'CD', '1HD', '2HD', 'NE', 'HE', 'CZ', 'NH1', '1HH1', '2HH1', 'NH2', '1HH2', '2HH2','OXT' ],   
		
		'PDB'  : ['N',    'CA',   'C',    'O',  'CB', 'CG',  'CD',  'NE',  'CZ',  'NH1', 'NH2', 'H', '1HH1',
			  '2HH1', '1HH2', '2HH2', 'HE', 'HA', '1HB', '2HB', '1HG', '2HG', '1HD', '2HD','OXT' ]
	},

        'AA_class' : 14,

	'polar' : True,

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'1HH1' : [ 'NH1', 'CZ', 'NE' ],
		'2HH1' : [ 'NH1', 'CZ', 'NE' ],
		'1HH2' : [ 'NH2', 'CZ', 'NE' ],
		'2HH2' : [ 'NH2', 'CZ', 'NE' ],
		'HE'   : [ 'NE',  'CD', 'CZ' ],
		'HA'   : [ 'CA',  'N',  'C'  ],
		'1HB'  : [ 'CB',  'CA', 'CG' ],
		'2HB'  : [ 'CB',  'CA', 'CG' ],
		'1HG'  : [ 'CG',  'CB', 'CD' ],
		'2HG'  : [ 'CG',  'CB', 'CD' ],
		'1HD'  : [ 'CD',  'CG', 'NE' ],
		'2HD'  : [ 'CD',  'CG', 'NE' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ], 
		[ 'CD', '1HG', '2HG' ],
		[ 'NE', '1HD', '2HD' ],
		[ 'CZ', 'NH1', 'NH2', '1HH1', '2HH1', '1HH2', '2HH2', 'HE'  ] 
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG' ],
		[ 'CA', 'CB', 'CG', 'CD' ],
		[ 'CB', 'CG', 'CD', 'NE' ],
		[ 'CG', 'CD', 'NE', 'CZ' ]
	],

	'templateCoords' :
	{
		'N'    :  ( 1.455  , 0.000  , 0.000  )  , 
		'CA'   :  ( 0.000  , 0.000  , 0.000  )  , 
		'C'    :  ( -0.569 , 1.399  , -0.000 )  , 
		'O'    :  ( 0.1983 , 2.386  , 0      )  , 
		'CB'   :  ( -0.574 , -0.820 , 1.146  )  , 
		'CG'   :  ( -0.335 , -2.318 , 1.043  )  , 
		'CD'   :  ( -1.198 , -3.009 , 0.051  )  , 
		'NE'   :  ( -2.624 , -2.901 , 0.314  )  , 
		'CZ'   :  ( -3.279 , -3.584 , 1.273  )  , 
		'NH1'  :  ( -2.651 , -4.451 , 2.036  )  , 
		'NH2'  :  ( -4.577 , -3.377 , 1.411  )  , 
		'H'    :  ( 2.418  , -0.306 , 0.000  )  , 
		'1HH1' :  ( -1.662 , -4.611 , 1.906  )  , 
		'2HH1' :  ( -3.160 , -4.953 , 2.749  )  , 
		'1HH2' :  ( -5.048 , -2.720 , 0.804  )  , 
		'2HH2' :  ( -5.092 , -3.876 , 2.121  )  , 
		'HE'   :  ( -3.323 , -2.333 , -0.146 )  , 
		'HA'   :  ( -0.369 , -0.476 , -0.909 )  , 
		'1HB'  :  ( -0.121 , -0.446 , 2.063  )  , 
		'2HB'  :  ( -1.647 , -0.629 , 1.167  )  , 
		'1HG'  :  ( 0.704  , -2.485 , 0.758  )  , 
		'2HG'  :  ( -0.520 , -2.766 , 2.020  )  , 
		'1HD'  :  ( -1.015 , -2.583 , -0.935 )  , 
		'2HD'  :  ( -0.947 , -4.069 , 0.041  )  ,
		'OXT' :  ( -1.814 ,  1.505 ,  0.000 )
	},

	'centroidAtoms' : [ 'CZ' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H       CA      HA      CB      1HB     2HB     CG      1HG     2HG     CD      1HD     2HD     NE      HE      CZ      NH1     1HH1    2HH1    NH2     1HH2    2HH2	OXT
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      7,      8,      8,      7,      8,      8,	1],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      8,      9,      9,      8,      9,      9,	2],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      7,      8,      8,      7,      8,      8,	3],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      8,      9,      9,      8,      9,      9,	4],     #H
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      6,      7,      7,      6,      7,      7,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      7,      8,      8,      7,      8,      8,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,      2,      3,      3,      3,      4,      4,      5,      6,      6,      5,      6,      6,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      6,      7,      7,      6,      7,      7,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,      3,      4,      4,      4,      5,      5,      6,      7,      7,      6,      7,      7,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,      1,      2,      2,      2,      3,      3,      4,      5,      5,      4,      5,      5,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,      2,      3,      3,      3,      4,      4,      5,      6,      6,      5,      6,      6,	5],     #1HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,      2,      3,      3,      3,      4,      4,      5,      6,      6,      5,      6,      6,	5],     #2HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      2,      0,      1,      1,      1,      2,      2,      3,      4,      4,      3,      4,      4,	5],     #CD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      0,      2,      2,      3,      3,      4,      5,      5,      4,      5,      5,	6],     #1HD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      2,      0,      2,      3,      3,      4,      5,      5,      4,      5,      5,	6],     #2HD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      2,      2,      0,      1,      1,      2,      3,      3,      2,      3,      3,	6],     #NE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      3,      3,      1,      0,      2,      3,      4,      4,      3,      4,      4,	7],     #HE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      3,      3,      1,      2,      0,      1,      2,      2,      1,      2,      2,	7],     #CZ
                [7,     8,      7,      8,      6,      7,      5,      6,      6,      4,      5,      5,      3,      4,      4,      2,      3,      1,      0,      1,      1,      2,      3,      3,	8],     #NH1
                [8,     9,      8,      9,      7,      8,      6,      7,      7,      5,      6,      6,      4,      5,      5,      3,      4,      2,      1,      0,      2,      3,      4,      4,	9],     #1HH1
                [8,     9,      8,      9,      7,      8,      6,      7,      7,      5,      6,      6,      4,      5,      5,      3,      4,      2,      1,      2,      0,      3,      4,      4,	9],     #2HH1
                [7,     8,      7,      8,      6,      7,      5,      6,      6,      4,      5,      5,      3,      4,      4,      2,      3,      1,      2,      3,      3,      0,      1,      1,	8],     #NH2
                [8,     9,      8,      9,      7,      8,      6,      7,      7,      5,      6,      6,      4,      5,      5,      3,      4,      2,      3,      4,      4,      1,      0,      2,	9],     #1HH2
                [8,     9,      8,      9,      7,      8,      6,      7,      7,      5,      6,      6,      4,      5,      5,      3,      4,      2,      3,      4,      4,      1,      2,      0,	9],     #2HH2
                [1,     2,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      8,      9,      9,      8,      9,      9,      0]      #OXT
        ]


}

