# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C', 'O',  'N', 'H', 'CA', 'HA', 'CB',  '1HB', '2HB', 'CG', 'OD1', 'OD2', 'OXT'],
		'PDB'  : ['N', 'CA', 'C', 'O', 'CB', 'CG', 'OD1', 'OD2', 'H',   'HA', '1HB', '2HB', 'OXT']                         
	},

        'AA_class' : 2,

	'polar' : True,  

	'acceptors' : { 'O' : 'C', 'OD1' : 'CG', 'OD2' : 'CG' },

	'templateAtom' : 
	{
		'HA'  : [ 'CA', 'N',  'C'  ],
		'1HB' : [ 'CB', 'CA', 'CG' ],
		'2HB' : [ 'CB', 'CA', 'CG' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'OD1', 'OD2' ]
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG'  ],
		[ 'CA', 'CB', 'CG', 'OD1' ]
	],

	'templateCoords' :
	{
		'N'   :  ( 0.0000  , 5.2000 , 9.6580  )  , 
		'CA'  :  ( 0.0000  , 6.4570 , 10.3940 )  , 
		'C'   :  ( 0.0000  , 6.2160 , 11.8980 )  , 
		'O'   :  ( 0.0000  , 5.0482 , 12.3438 )  , 
		'CB'  :  ( -1.2080 , 7.3100 , 9.9990  )  , 
		'CG'  :  ( -1.2950 , 8.6490 , 10.7190 )  , 
		'OD1' :  ( -2.2210 , 9.3810 , 10.4610 )  , 
		'OD2' :  ( -0.5300 , 8.8620 , 11.6290 )  , 
		'H'   :  ( -0.0400 , 4.3370 , 10.1830 )  , 
		'HA'  :  ( 0.9090  , 7.0160 , 10.1700 )  , 
		'1HB' :  ( -1.2940 , 7.4700 , 8.9240  )  , 
		'2HB' :  ( -2.0180 , 6.6630 , 10.3370 )  ,
		'OXT' :  (  0.000 ,  7.226 , 12.635 )
	},

	'centroidAtoms' : [ 'CG', 'OD1', 'OD2' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H       CA      HA      CB      1HB     2HB     CG      OD1     OD2	OXT
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,	1],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,	2],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,	3],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,	4],     #H
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,	5],     #OD1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,	5],     #OD2
                [1,     2,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      0]      #OXT
        ]

}

