# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',    'O',   'N',    'H',    'CA',  'HA',   'CB',   'HB',  'CG2', '1HG2', '2HG2', 
			  '3HG2', 'CG1', '1HG1', '2HG1', 'CD1', '1HD1', '2HD1', '3HD1', 'OXT'],

		'PDB'  : ['N',    'CA',   'C',    'O',    'CB',   'CG1',  'CG2',  'CD1',  'H',  'HA',  'HB',  '1HG2', 
			  '2HG2', '3HG2', '1HG1', '2HG1', '1HD1', '2HD1', '3HD1','OXT']                                       
	},

        'AA_class' : 7,

	'polar' : False,  

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'HA' :   [ 'CA',  'N',   'C'   ],
		'HB' :   [ 'CB',  'CA',  'CG1' ],
		'1HG2' : [ 'CG2', 'CB',  'CA'  ],
		'2HG2' : [ 'CG2', 'CB',  'CA'  ],
		'3HG2' : [ 'CG2', 'CB',  'CA'  ],
		'1HG1' : [ 'CG1', 'CB',  'CD1' ],
		'2HG1' : [ 'CG1', 'CB',  'CD1' ],
		'1HD1' : [ 'CD1', 'CG1', 'CB'  ],
		'2HD1' : [ 'CD1', 'CG1', 'CB'  ],
		'3HD1' : [ 'CD1', 'CG1', 'CB'  ]
	},

	'chiDependent' :
	[
		[ 'CG1', 'CG2', 'HB', '1HG2', '2HG2', '3HG2' ],
		[ 'CD1', '1HG1', '2HG1', '1HD1', '2HD1', '3HD1' ] 
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG1'  ],
		[ 'CA', 'CB', 'CG1', 'CD1' ]
	],

	'templateCoords' :
	{
		'N'    :  ( 0.0000  , 13.5100 , 25.7330 )  , 
		'CA'   :  ( 0.0000  , 13.0790 , 27.1250 )  , 
		'C'    :  ( 0.0000  , 14.2670 , 28.0870 )  , 
		'O'    :  ( 0.0000  , 15.4340 , 27.6390 )  , 
		'CB'   :  ( 1.2140  , 12.1860 , 27.4400 )  , 
		'CG1'  :  ( 1.1890  , 11.7490 , 28.9070 )  , 
		'CG2'  :  ( 2.5090  , 12.9170 , 27.1210 )  , 
		'CD1'  :  ( 2.3510  , 10.8660 , 29.3010 )  , 
		'H'    :  ( 0.0310  , 14.5010 , 25.5390 )  , 
		'HA'   :  ( -0.9170 , 12.5400 , 27.3600 )  , 
		'HB'   :  ( 1.1520  , 11.2780 , 26.8410 )  , 
		'1HG2' :  ( 3.3570  , 12.2720 , 27.3500 )  , 
		'2HG2' :  ( 2.5280  , 13.1790 , 26.0640 )  , 
		'3HG2' :  ( 2.5720  , 13.8250 , 27.7210 )  , 
		'1HG1' :  ( 1.1970  , 12.6530 , 29.5150 )  , 
		'2HG1' :  ( 0.2540  , 11.2120 , 29.0690 )  , 
		'1HD1' :  ( 2.2640  , 10.5970 , 30.3540 )  , 
		'2HD1' :  ( 2.3430  , 9.9600  , 28.6940 )  , 
		'3HD1' :  ( 3.2860  , 11.4010 , 29.1410 )  ,
		'OXT' :  (  0.000 , 14.007 , 29.310 )
	},

	'centroidAtoms' : [ 'CG1', 'CG2', 'CD1' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H       CA      HA      CB      HB      CG2     1HG2    2HG2    3HG2    CG1     1HG1    2HG1    CD1     1HD1    2HD1    3HD1	OXT
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,      5,      5,      5,	1],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,      6,      6,      6,	2],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,      5,      5,      5,	3],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,      6,      6,      6,	4],     #H
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      3,      3,      3,      2,      3,      3,      3,      4,      4,      4,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,      5,      5,      5,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      2,      2,      2,      1,      2,      2,      2,      3,      3,      3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      3,      3,      3,      2,      3,      3,      3,      4,      4,      4,	4],     #HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      1,      1,      1,      2,      3,      3,      3,      4,      4,      4,	4],     #CG2
                [4,     5,      4,      5,      3,      4,      2,      3,      1,      0,      2,      2,      3,      4,      4,      4,      5,      5,      5,	5],     #1HG2
                [4,     5,      4,      5,      3,      4,      2,      3,      1,      2,      0,      2,      3,      4,      4,      4,      5,      5,      5,	5],     #2HG2
                [4,     5,      4,      5,      3,      4,      2,      3,      1,      2,      2,      0,      3,      4,      4,      4,      5,      5,      5,	5],     #3HG2
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      3,      3,      3,      0,      1,      1,      1,      2,      2,      2,	4],     #CG1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      4,      4,      4,      1,      0,      2,      2,      3,      3,      3,	5],     #1HG1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      4,      4,      4,      1,      2,      0,      2,      3,      3,      3,	5],     #2HG1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      4,      4,      4,      1,      2,      2,      0,      1,      1,      1,	5],     #CD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      5,      5,      5,      2,      3,      3,      1,      0,      2,      2,	6],     #1HD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      5,      5,      5,      2,      3,      3,      1,      2,      0,      2,	6],     #2HD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      5,      5,      5,      2,      3,      3,      1,      2,      2,      0,	6],     #3HD1
                [1,     2,      3,      4,      2,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,      6,      6,      6,      0]      #OXT
        ]

}

