# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',  'O',   'N',    'H',    'CA',   'HA',  'CB',   '1HB',  '2HB', 'CG', 
		          'HG', 'CD1', '1HD1', '2HD1', '3HD1', 'CD2', '1HD2', '2HD2', '3HD2', 'OXT'],

		'PDB'  : ['N',   'CA', 'C',    'O',    'CB',   'CG',   'CD1',  'CD2',  'H',  'HA',  '1HB', 
			  '2HB', 'HG', '1HD1', '2HD1', '3HD1', '1HD2', '2HD2', '3HD2', 'OXT']
	},

        'AA_class' : 9,

	'polar' : False, 

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'HA' :   [ 'CA',  'N',  'C'   ],
		'1HB' :  [ 'CB',  'CA', 'CG'  ],
		'2HB' :  [ 'CB',  'CA', 'CG'  ],
		'HG' :   [ 'CG',  'CB', 'CD1' ],
		'1HD1' : [ 'CD1', 'CG', 'CB'  ],
		'2HD1' : [ 'CD1', 'CG', 'CB'  ],
		'3HD1' : [ 'CD1', 'CG', 'CB'  ],
		'1HD2' : [ 'CD2', 'CG', 'CB'  ],
		'2HD2' : [ 'CD2', 'CG', 'CB'  ],
		'3HD2' : [ 'CD2', 'CG', 'CB'  ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ], 
		[ 'CD1', 'CD2', 'HG', '1HD1', '2HD1', '3HD1', '1HD2', '2HD2', '3HD2' ] 
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG'  ],
		[ 'CA', 'CB', 'CG', 'CD1' ]
	],

	'templateCoords' :
	{
		'N'    :  ( 1.460  , 0.000  , 0.000  )  , 
		'CA'   :  ( 0.000  , 0.000  , 0.000  )  , 
		'C'    :  ( -0.559 , 1.422  , -0.000 )  , 
		'O'    :  ( 0.2198 , 2.3997 , 0.000  )  , 
		'CB'   :  ( -0.530 , -0.778 , 1.211  )  , 
		'CG'   :  ( -0.286 , -2.292 , 1.172  )  , 
		'CD1'  :  ( -0.695 , -2.921 , 2.497  )  , 
		'CD2'  :  ( -1.069 , -2.904 , 0.020  )  , 
		'H'    :  ( 2.424  , -0.301 , 0.000  )  , 
		'HA'   :  ( -0.365 , -0.473 , -0.911 )  , 
		'1HB'  :  ( 0.075  , -0.322 , 1.993  )  , 
		'2HB'  :  ( -1.583 , -0.567 , 1.397  )  , 
		'HG'   :  ( 0.775  , -2.444 , 0.972  )  , 
		'1HD1' :  ( -0.518 , -3.996 , 2.460  )  , 
		'2HD1' :  ( -0.106 , -2.485 , 3.304  )  , 
		'3HD1' :  ( -1.753 , -2.734 , 2.677  )  , 
		'1HD2' :  ( -0.894 , -3.980 , -0.007 )  , 
		'2HD2' :  ( -2.133 , -2.712 , 0.160  )  , 
		'3HD2' :  ( -0.741 , -2.460 , -0.920 )  ,
		'OXT' :  ( -1.803 ,  1.543 ,  0.000 )
	},

	'centroidAtoms' : [ 'CG', 'CD1', 'CD2' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H       CA      HA      CB      1HB  2HB        CG      HG      CD1     1HD1    2HD1    3HD1 	CD2	1HD2	2HD2	3HD2	OXT
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,	1],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      6,      5,      6,      6,      6,	2],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,	3],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      6,      5,      6,      6,      6,	4],     #H
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,      3,      3,      3,      2,      3,      3,      3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,      2,      2,      2,      1,      2,      2,      2,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,      3,      3,      3,      2,      3,      3,      3,	5],     #HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,      1,      1,      1,      2,      3,      3,      3,	5],     #CD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      1,      0,      2,      2,      3,      4,      4,      4,	6],     #1HD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      1,      2,      0,      2,      3,      4,      4,      4,	6],     #2HD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      1,      2,      2,      0,      3,      4,      4,      4,	6],     #3HD1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      2,      3,      3,      3,      0,      1,      1,      1,	5],     #CD2
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      4,      4,      4,      1,      0,      2,      2,	6],     #1HD2
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      4,      4,      4,      1,      2,      0,      2,	6],     #2HD2
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      4,      4,      4,      1,      2,      2,      0,	6],     #3HD2
                [1,     2,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      6,      5,      6,      6,      6,      0]      #OXT
        ]

}

