# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',  'O',   'N',   'H',  'CA', 'HA',  'CB',  '1HB', '2HB', 
		          'CG', '1HG', '2HG', 'SD', 'CE', '1HE', '2HE', '3HE', 'OXT'],

		'PDB'  : ['N',   'CA',  'C',   'O',   'CB',  'CG',  'SD', 'CE',  'H',  'HA', 
		          '1HB', '2HB', '1HG', '2HG', '1HE', '2HE', '3HE', 'OXT']                                   
	},

        'AA_class' : 10,

	'polar' : False,  

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'HA' :  [ 'CA', 'N',  'C'  ],
		'1HB' : [ 'CB', 'CA', 'CG' ],
		'2HB' : [ 'CB', 'CA', 'CG' ],
		'1HG' : [ 'CG', 'CB', 'SD' ],
		'2HG' : [ 'CG', 'CB', 'SD' ],
		'1HE' : [ 'CE', 'SD', 'CG' ],
		'2HE' : [ 'CE', 'SD', 'CG' ],
		'3HE' : [ 'CE', 'SD', 'CG' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'SD', '1HG', '2HG' ],
		[ 'CE', '1HE', '2HE', '3HE' ]
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG' ],
		[ 'CA', 'CB', 'CG', 'SD' ],
		[ 'CB', 'CG', 'SD', 'CE' ]
	],

	'templateCoords' :
	{
		'N'   :  ( 0.0000  , 15.5330 , 36.4900 )  , 
		'CA'  :  ( 0.0000  , 16.4650 , 37.6220 )  , 
		'C'   :  ( 0.0000  , 15.5850 , 38.8610 )  , 
		'O'   :  ( 0.0000  , 14.3405 , 38.7437 )  , 
		'CB'  :  ( -1.2080 , 17.3960 , 37.5390 )  , 
		'CG'  :  ( -1.3030 , 18.4070 , 38.6730 )  , 
		'SD'  :  ( -2.7450 , 19.4810 , 38.5280 )  , 
		'CE'  :  ( -2.5470 , 20.5110 , 39.9790 )  , 
		'H'   :  ( -0.0400 , 14.5430 , 36.6850 )  , 
		'HA'  :  ( 0.9070  , 17.0690 , 37.6060 )  , 
		'1HB' :  ( -1.1380 , 17.9220 , 36.5880 )  , 
		'2HB' :  ( -2.0970 , 16.7640 , 37.5410 )  , 
		'1HG' :  ( -1.3580 , 17.8590 , 39.6130 )  , 
		'2HG' :  ( -0.4000 , 19.0170 , 38.6600 )  , 
		'1HE' :  ( -3.3650 , 21.2300 , 40.0300 )  , 
		'2HE' :  ( -2.5560 , 19.8860 , 40.8730 )  , 
		'3HE' :  ( -1.5980 , 21.0450 , 39.9190 )  ,
		'OXT' :  (  0.000 , 16.164 , 39.969 )
	},

	'centroidAtoms' : [ 'SD' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H       CA      HA      CB      1HB     2HB     CG      1HG     2HG     SD      CE      1HE     2HE     3HE	OXT
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      6,      6,      6,	1],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      7,      7,      7,	2],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      6,      6,      6,	3],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      7,      7,      7,	4],     #H
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,      3,      4,      5,      5,      5,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,      4,      5,      6,      6,      6,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,      2,      3,      4,      4,      4,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,      3,      4,      5,      5,      5,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,      3,      4,      5,      5,      5,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,      1,      2,      3,      3,      3,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,      2,      3,      4,      4,      4,	5],     #1HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,      2,      3,      4,      4,      4,	5],     #2HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      2,      0,      1,      2,      2,      2,	5],     #SD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      0,      1,      1,      1,	6],     #CE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      1,      0,      2,      2,	7],     #1HE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      1,      2,      0,      2,	7],     #2HE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      1,      2,      2,      0,	7],     #3HE
                [1,     2,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      7,      7,      7,      0]      #OXT
        ]

}

