# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C', 'O',  'N', 'H', 'CA', 'HA', 'CB', '1HB', '2HB', 'SG',  'HG'],
		'PDB'  : ['N', 'CA', 'C', 'O', 'CB', 'SG', 'H',  'HA',  '1HB', '2HB', 'HG']                       
	},

        'AA_class' : 1,

	'polar' : False,  

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'HA'  : [ 'CA', 'N',  'C'  ],
		'1HB' : [ 'CB', 'CA', 'SG' ],
		'2HB' : [ 'CB', 'CA', 'SG' ],
		'HG'  : [ 'SG', 'CB', 'CA' ]
	},

	'chiDependent' :
	[
		[ 'SG', '1HB', '2HB', 'HG' ]
	],

	'chiAtoms' :
	[
		[ 'N', 'CA', 'CB', 'SG' ]
	],

	'templateCoords' :
	{
		'N'   :  ( 0.0000  , 3.8070 , 6.2240 )  , 
		'CA'  :  ( 0.0000  , 3.7830 , 7.6880 )  , 
		'C'   :  ( 0.0000  , 5.1680 , 8.3290 )  , 
		'O'   :  ( 0.0050  , 6.1860 , 7.6360 )  , 
		'CB'  :  ( 1.3120  , 3.0690 , 8.0140 )  , 
		'SG'  :  ( 1.6350  , 2.8650 , 9.7820 )  , 
		'H'   :  ( -0.0250 , 4.7040 , 5.7600 )  , 
		'HA'  :  ( -0.8240 , 3.2090 , 8.1120 )  , 
		'1HB' :  ( 1.3110  , 2.0650 , 7.5890 )  , 
		'2HB' :  ( 2.1560  , 3.6320 , 7.6160 )  , 
		'HG'  :  ( 2.7990  , 2.2390 , 9.6390 )   
	},

	'centroidAtoms' : [ 'SG' ],

	'neighborAtom' : 'CB',

	'bondLengths' : 
	[	#C	O	N	H	CA	HA	CB	1HB	2HB	SG	HG
		[0,	1,	2,	3,	1,	2,	2,	3,	3,	3,	4],	#C
		[1,	0,	3,	4,	2,	3,	3,	4,	4,	4,	5],	#O
		[2,	3,	0,	1,	1,	2,	2,	3,	3,	3,	4],	#N
		[3,	4,	1,	0,	2,	3,	3,	4,	4,	4,	5],	#H
		[1,	2,	1,	2,	0,	1,	1,	2,	2,	2,	3],	#CA
		[2,	3,	2,	3,	1,	0,	2,	3,	3,	3,	4],	#HA
		[2,	3,	2,	3,	1,	2,	0,	1,	1,	1,	2],	#CB
		[3,	4,	3,	4,	2,	3,	1,	0,	2,	2,	3],	#1HB
		[3,	4,	3,	4,	2,	3,	1,	2,	0,	2,	3],	#2HB
		[3,	4,	3,	4,	2,	3,	1,	2,	2,	0,	1],	#SG
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	1,	0]	#HG
	]
}

