# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',   'O',   'N',  'H',   'CA',  'HA',   'CB', '1HB', '2HB', 'CG', 
			  '1HG', '2HG', 'CD', 'OE1', 'NE2', '1HE2', '2HE2'],

		'PDB'  : ['N',    'CA', 'C',   'O',   'CB',  'CG', 'CD', 'OE1', 'NE2', 'H', '1HE2',
			  '2HE2', 'HA', '1HB', '2HB', '1HG', '2HG']
	},

        'AA_class' : 13,

	'polar' : True,  

	'acceptors' : { 'O' : 'C', 'OE1' : 'CD' },

	'templateAtom' : 
	{
		'1HE2' : [ 'NE2', 'CD', 'CG' ],
		'2HE2' : [ 'NE2', 'CD', 'CG' ],
		'HA'   : [ 'CA',  'N',  'C'  ],
		'1HB'  : [ 'CB',  'CA', 'CG' ],
		'2HB'  : [ 'CB',  'CA', 'CG' ],
		'1HG'  : [ 'CG',  'CB', 'CD' ],
		'2HG'  : [ 'CG',  'CB', 'CD' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'CD', '1HG', '2HG' ],
		[ 'OE1', 'NE2', '1HE2', '2HE2' ] 
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG'  ],
		[ 'CA', 'CB', 'CG', 'CD'  ],
		[ 'CB', 'CG', 'CD', 'OE1' ],
	],

	'templateCoords' :
	{
		'N'    :  ( 1.458  , 0.000  , 0.000  )  , 
		'CA'   :  ( 0.000  , 0.000  , 0.000  )  , 
		'C'    :  ( -0.553 , 1.420  , 0.000  )  , 
		'O'    :  ( -1.607 , 1.682  , -0.580 )  , 
		'CB'   :  ( -0.536 , -0.762 , 1.215  )  , 
		'CG'   :  ( -0.317 , -2.264 , 1.154  )  , 
		'CD'   :  ( -0.856 , -2.876 , -0.125 )  , 
		'OE1'  :  ( -2.024 , -2.687 , -0.476 )  , 
		'NE2'  :  ( -0.008 , -3.618 , -0.828 )  , 
		'H'    :  ( 2.424  , -0.294 , 0.000  )  , 
		'1HE2' :  ( -0.307 , -4.048 , -1.681 )  , 
		'2HE2' :  ( 0.930  , -3.747 , -0.506 )  , 
		'HA'   :  ( -0.365 , -0.474 , -0.911 )  , 
		'1HB'  :  ( -0.034 , -0.351 , 2.091  )  , 
		'2HB'  :  ( -1.603 , -0.548 , 1.275  )  , 
		'1HG'  :  ( 0.645  , -2.729 , 1.368  )  , 
		'2HG'  :  ( -1.014 , -2.486 , 1.963  )   
	},

	'centroidAtoms' : [ 'CD', 'OE1', 'NE2' ],

	'neighborAtom' : 'CB',
	
	'bondLengths' : 
	[	#C	O	N	H	CA	HA	CB	1HB	2HB	CG	1HG	2HG	CD	OE1	NE2	1HE2	2HE2
		[0,	1,	2,	3,	1,	2,	2,	3,	3,	3,	4,	4,	4,	5,	5,	6,	6],	#C
		[1,	0,	3,	4,	2,	3,	3,	4,	4,	4,	5,	5,	5,	6,	6,	7,	7],	#O
		[2,	3,	0,	1,	1,	2,	2,	3,	3,	3,	4,	4,	4,	5,	5,	6,	6],	#N
		[3,	4,	1,	0,	2,	3,	3,	4,	4,	4,	5,	5,	5,	6,	6,	7,	7],	#H
		[1,	2,	1,	2,	0,	1,	1,	2,	2,	2,	3,	3,	3,	4,	4,	5,	5],	#CA
		[2,	3,	2,	3,	1,	0,	2,	3,	3,	3,	4,	4,	4,	5,	5,	6,	6],	#HA
		[2,	3,	2,	3,	1,	2,	0,	1,	1,	1,	2,	2,	2,	3,	3,	4,	4],	#CB
		[3,	4,	3,	4,	2,	3,	1,	0,	2,	2,	3,	3,	3,	4,	4,	5,	5],	#1HB
		[3,	4,	3,	4,	2,	3,	1,	2,	0,	2,	3,	3,	3,	4,	4,	5,	5],	#2HB
		[3,	4,	3,	4,	2,	3,	1,	2,	2,	0,	1,	1,	1,	2,	2,	3,	3],	#CG
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	1,	0,	2,	2,	3,	3,	4,	4],	#1HG
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	1,	2,	0,	2,	3,	3,	4,	4],	#2HG
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	1,	2,	2,	0,	1,	1,	2,	2],	#CD
		[5,	6,	5,	6,	4,	5,	3,	4,	4,	2,	3,	3,	1,	0,	2,	3,	3],	#OE1
		[5,	6,	5,	6,	4,	5,	3,	4,	4,	2,	3,	3,	1,	2,	0,	1,	1],	#NE2
		[6,	7,	6,	7,	5,	6,	4,	5,	5,	3,	4,	4,	2,	3,	1,	0,	2],	#1HE2
		[6,	7,	6,	7,	5,	6,	4,	5,	5,	3,	4,	4,	2,	3,	1,	2,	0],	#2HE2
	]	
}


