# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C', 'O',  'N', 'H', 'CA', '1HA', '2HA'],
		'PDB'  : ['N', 'CA', 'C', 'O', 'H',  '1HA', '2HA']               
	},

        'AA_class' : 5,

	'polar' : False,  

	'acceptors' : { 'O' : 'C' },
	
	'templateAtom' : 
	{
		'1HA' : [ 'CA', 'N', 'C' ],
		'2HA' : [ 'CA', 'N', 'C' ]
	},

	'chiDependent' : [],

	'chiAtoms' : [],

	'templateCoords' :
	{
		'N'   :  ( 0.0000  , 10.7220 , 19.0990 )  , 
		'CA'  :  ( 0.0000  , 10.6280 , 20.5540 )  , 
		'C'   :  ( 0.0000  , 12.0090 , 21.1960 )  , 
		'O'   :  ( -0.0030 , 13.0390 , 20.5210 )  , 
		'1HA' :  ( -0.8900 , 10.0870 , 20.8760 )  , 
		'2HA' :  ( 0.8890  , 10.0870 , 20.8760 )  , 
		'H'   :  ( 0.0000  , 11.6400 , 18.6790 )  
	},

	'centroidAtoms' : [ 'CA' ],

	'neighborAtom' : 'CA',
	
	'bondLengths' : 
	[	#C	O	N	H	CA	1HA	2HA
		[0,	1,	2,	3,	1,	2,	2],	#C
		[1,	0,	3,	4,	2,	3,	3],	#O
		[2,	3,	0,	1,	1,	2,	2],	#N
		[3,	4,	1,	0,	2,	3,	3],	#H
		[1,	2,	1,	2,	0,	1,	1],	#CA
		[2,	3,	2,	3,	1,	0,	2],	#1HA
		[2,	3,	2,	3,	1,	2,	0]	#2HA
	]
}


