# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',  'O',   'N',   'H',  'CA',  'HA',  'CB', '1HB', '2HB', 'CG', '1HG', '2HG', 
		          'CD', '1HD', '2HD', 'CE', '1HE', '2HE', 'NZ', '1HZ', '2HZ', '3HZ'],

		'PDB'  : ['N',  'CA',  'C',   'O',   'CB',  'CG',  'CD',  'CE',  'NZ',  'H', '1HZ', '2HZ', '3HZ', 
		          'HA', '1HB', '2HB', '1HG', '2HG', '1HD', '2HD', '1HE', '2HE']                                             
	},

        'AA_class' : 8,

	'polar' : True,  

	'acceptors' : { 'O' : 'C' }, 

	'templateAtom' : 
	{
		'1HZ' : [ 'NZ', 'CE', 'CD' ],
		'2HZ' : [ 'NZ', 'CE', 'CD' ],
		'3HZ' : [ 'NZ', 'CE', 'CD' ],
		'HA'  : [ 'CA', 'N',  'C'  ],
		'1HB' : [ 'CB', 'CA', 'CG' ],
		'2HB' : [ 'CB', 'CA', 'CG' ],
		'1HG' : [ 'CG', 'CB', 'CD' ],
		'2HG' : [ 'CG', 'CB', 'CD' ],
		'1HD' : [ 'CD', 'CG', 'CE' ],
		'2HD' : [ 'CD', 'CG', 'CE' ],
		'1HE' : [ 'CE', 'CD', 'NZ' ],
		'2HE' : [ 'CE', 'CD', 'NZ' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'CD', '1HG', '2HG' ],
		[ 'CE', '1HD', '2HD' ],
		[ 'NZ', '1HZ', '2HZ', '3HZ', '1HE', '2HE' ]  
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG' ],
		[ 'CA', 'CB', 'CG', 'CD' ],
		[ 'CB', 'CG', 'CD', 'CE' ],
		[ 'CG', 'CD', 'CE', 'NZ' ]
	],

	'templateCoords' :
	{
		'N'   :  ( 0.0000  , 13.9730 , 29.3820 )  , 
		'CA'  :  ( 0.0000  , 15.0130 , 30.4040 )  , 
		'C'   :  ( 0.0000  , 14.4110 , 31.8030 )  , 
		'O'   :  ( 0.0030  , 13.1890 , 31.9540 )  , 
		'CB'  :  ( -1.2070 , 15.9360 , 30.2290 )  , 
		'CG'  :  ( -1.2940 , 17.0590 , 31.2540 )  , 
		'CD'  :  ( -2.5170 , 17.9320 , 31.0160 )  , 
		'CE'  :  ( -2.6050 , 19.0540 , 32.0400 )  , 
		'NZ'  :  ( -3.7970 , 19.9170 , 31.8190 )  , 
		'H'   :  ( -0.0400 , 13.0090 , 29.6800 )  , 
		'1HZ' :  ( -3.8180 , 20.6470 , 32.5170 )  , 
		'2HZ' :  ( -3.7470 , 20.3320 , 30.8990 )  , 
		'3HZ' :  ( -4.6350 , 19.3580 , 31.8910 )  , 
		'HA'  :  ( 0.9090  , 15.6100 , 30.3230 )  , 
		'1HB' :  ( -1.1400 , 16.3630 , 29.2280 )  , 
		'2HB' :  ( -2.0990 , 15.3130 , 30.2980 )  , 
		'1HG' :  ( -1.3510 , 16.6160 , 32.2490 )  , 
		'2HG' :  ( -0.3930 , 17.6670 , 31.1790 )  , 
		'1HD' :  ( -2.4500 , 18.3580 , 30.0140 )  , 
		'2HD' :  ( -3.4080 , 17.3080 , 31.0850 )  , 
		'1HE' :  ( -2.6590 , 18.6080 , 33.0320 )  , 
		'2HE' :  ( -1.7010 , 19.6580 , 31.9630 )   
	},

	'centroidAtoms' : [ 'NZ' ],

	'neighborAtom' : 'CB',

	'bondLengths' : 
	[	#C	O	N	H	CA	HA	CB	1HB	2HB	CG	1HG	2HG	CD	1HD	2HD	CE	1HE	2HE	NZ	1HZ	2HZ	3HZ
		[0,	1,	2,	3,	1,	2,	2,	3,	3,	3,	4,	4,	4,	5,	5,	5,	6,	6,	6,	7,	7,	7],	#C
		[1,	0,	3,	4,	2,	3,	3,	4,	4,	4,	5,	5,	5,	6,	6,	6,	7,	7,	7,	8,	8,	8],	#O
		[2,	3,	0,	1,	1,	2,	2,	3,	3,	3,	4,	4,	4,	5,	5,	5,	6,	6,	6,	7,	7,	7],	#N
		[3,	4,	1,	0,	2,	3,	3,	4,	4,	4,	5,	5,	5,	6,	6,	6,	7,	7,	7,	8,	8,	8],	#H
		[1,	2,	1,	2,	0,	1,	1,	2,	2,	2,	3,	3,	3,	4,	4,	4,	5,	5,	5,	6,	6,	6],	#CA
		[2,	3,	2,	3,	1,	0,	2,	3,	3,	3,	4,	4,	4,	5,	5,	5,	6,	6,	6,	7,	7,	7],	#HA
		[2,	3,	2,	3,	1,	2,	0,	1,	1,	1,	2,	2,	2,	3,	3,	3,	4,	4,	4,	5,	5,	5],	#CB
		[3,	4,	3,	4,	2,	3,	1,	0,	2,	2,	3,	3,	3,	4,	4,	4,	5,	5,	5,	6,	6,	6],	#1HB
		[3,	4,	3,	4,	2,	3,	1,	2,	0,	2,	3,	3,	3,	4,	4,	4,	5,	5,	5,	6,	6,	6],	#2HB
		[3,	4,	3,	4,	2,	3,	1,	2,	2,	0,	1,	1,	1,	2,	2,	2,	3,	3,	3,	4,	4,	4],	#CG
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	1,	0,	2,	2,	3,	3,	3,	4,	4,	4,	5,	5,	5],	#1HG
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	1,	2,	0,	2,	3,	3,	3,	4,	4,	4,	5,	5,	5],	#2HG
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	1,	2,	2,	0,	1,	1,	1,	2,	2,	2,	3,	3,	3],	#CD
		[5,	6,	5,	6,	4,	5,	3,	4,	4,	2,	3,	3,	1,	0,	2,	2,	3,	3,	3,	4,	4,	4],	#1HD
		[5,	6,	5,	6,	4,	5,	3,	4,	4,	2,	3,	3,	1,	2,	0,	2,	3,	3,	3,	4,	4,	4],	#2HD
		[5,	6,	5,	6,	4,	5,	3,	4,	4,	2,	3,	3,	1,	2,	2,	0,	1,	1,	1,	2,	2,	2],	#CE
		[6,	7,	6,	7,	5,	6,	4,	5,	5,	3,	4,	4,	2,	3,	3,	1,	0,	2,	2,	3,	3,	3],	#1HE
		[6,	7,	6,	7,	5,	6,	4,	5,	5,	3,	4,	4,	2,	3,	3,	1,	2,	0,	2,	3,	3,	3],	#2HE
		[6,	7,	6,	7,	5,	6,	4,	5,	5,	3,	4,	4,	2,	3,	3,	1,	2,	2,	0,	1,	1,	1],	#NZ
		[7,	8,	7,	8,	6,	7,	5,	6,	6,	4,	5,	5,	3,	4,	4,	2,	3,	3,	1,	0,	2,	2],	#1HZ
		[7,	8,	7,	8,	6,	7,	5,	6,	6,	4,	5,	5,	3,	4,	4,	2,	3,	3,	1,	2,	0,	2],	#2HZ
		[7,	8,	7,	8,	6,	7,	5,	6,	6,	4,	5,	5,	3,	4,	4,	2,	3,	3,	1,	2,	2,	0]	#3HZ
	]
}


