# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 


from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
        def __init__(self):
                self.data = data
                AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data =          \
{
        'atomOrders' :
        {
# The indicies in the file aa_props_data.hxx are in the order of 'trie'.

#The only modification I made was to add H1, H2, and H3 entries to trie and pdb
#Hmm, how about replace H with H1, then add H2 and H3 to the end, so that the order of the backbone atoms is unchanged? That is what I will do and hope for the best.

                'trie' : ['C', 'O',  'N', 'H1', 'CA', 'HA', 'CB', '1HB', '2HB', '3HB', 'H2', 'H3'],
                'PDB'  : ['N', 'CA', 'C', 'O', 'CB', 'H1', 'HA', '1HB', '2HB', '3HB', 'H2', 'H3' ]
        },

        'AA_class' : 0,

        'polar' : False,

        'acceptors' : { 'O' : 'C' },

        'templateAtom' :
        {
                'HA' :  [ 'CA', 'N', 'C'  ],
                '1HB' : [ 'CB', 'CA', 'N' ],
                '2HB' : [ 'CB', 'CA', 'N' ],
                '3HB' : [ 'CB', 'CA', 'N' ],
        },

        'chiDependent' : [],
        'chiAtoms' : [],

        'templateCoords' :
        {
'N'   : ( -0.677,  -1.230,  -0.491  ),
'CA'  : ( -0.001,  0.064,  -0.491   ),  
'C'   : (  1.499,  -0.110,  -0.491  ),   
'O'   : (  2.030,  -1.227,  -0.502  ),
'CB'  : ( -0.509,   0.856,   0.727  ),
'H1' : ( -0.833,  -1.529,   0.462  ),
'HA'  : ( -0.269,   0.603,  -1.418  ),
'1HB' : ( -1.605,   1.006,   0.691  ),
'2HB' : ( -0.285,   0.342,   1.681  ), 
'3HB' : ( -0.053,   1.861,   0.784  ),
'H2' : ( -0.103,  -1.911,  -0.968  ),
'H3' : ( -1.564,  -1.146,  -0.966  )
        },

        'centroidAtoms' : [ 'CB' ],

        'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1      CA      HA      CB      1HB     2HB     3HB	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,	4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,	4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,	4,	4],     #3HB
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      2,      0]      #H3
        ]

}


