# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',  'O',   'N',   'H1',  'CA', 'HA', 'CB',  '1HB',  '2HB',  'CG',  '1HG',  '2HG', 
			  'CD', '1HD', '2HD', 'NE', 'HE', 'CZ', 'NH1', '1HH1', '2HH1', 'NH2', '1HH2', '2HH2', 'H2', 'H3' ],   
		
		'PDB'  : ['N',    'CA',   'C',    'O',  'CB', 'CG',  'CD',  'NE',  'CZ',  'NH1', 'NH2', 'H1', '1HH1',
			  '2HH1', '1HH2', '2HH2', 'HE', 'HA', '1HB', '2HB', '1HG', '2HG', '1HD', '2HD', 'H2', 'H3' ]
	},

        'AA_class' : 14,

	'polar' : True,

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'1HH1' : [ 'NH1', 'CZ', 'NE' ],
		'2HH1' : [ 'NH1', 'CZ', 'NE' ],
		'1HH2' : [ 'NH2', 'CZ', 'NE' ],
		'2HH2' : [ 'NH2', 'CZ', 'NE' ],
		'HE'   : [ 'NE',  'CD', 'CZ' ],
		'HA'   : [ 'CA',  'N',  'C'  ],
		'1HB'  : [ 'CB',  'CA', 'CG' ],
		'2HB'  : [ 'CB',  'CA', 'CG' ],
		'1HG'  : [ 'CG',  'CB', 'CD' ],
		'2HG'  : [ 'CG',  'CB', 'CD' ],
		'1HD'  : [ 'CD',  'CG', 'NE' ],
		'2HD'  : [ 'CD',  'CG', 'NE' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ], 
		[ 'CD', '1HG', '2HG' ],
		[ 'NE', '1HD', '2HD' ],
		[ 'CZ', 'NH1', 'NH2', '1HH1', '2HH1', '1HH2', '2HH2', 'HE'  ] 
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG' ],
		[ 'CA', 'CB', 'CG', 'CD' ],
		[ 'CB', 'CG', 'CD', 'NE' ],
		[ 'CG', 'CD', 'NE', 'CZ' ]
	],

	'templateCoords' :
	{
		'N'    :  ( -0.022 , -3.647 ,  2.514 )  , 
		'CA'   :  ( 0.519  , -2.968 ,  1.340 )  , 
		'C'    :  ( 2.029  , -2.951 ,  1.374 )  , 
		'O'    :  ( 2.666  , -3.478 ,  2.283 )  , 
		'CB'   :  ( -0.063 , -1.527 ,  1.282 )  , 
		'CG'   :  ( 0.188  , -0.757 , -0.045 )  , 
		'CD'   :  ( -0.388 ,  0.668 , -0.004 )  , 
		'NE'   :  ( -0.136 ,  1.349 , -1.308 )  , 
		'CZ'   :  ( -0.497 ,  2.593 , -1.608 )  , 
		'NH1'  :  ( -1.121 ,  3.383 , -0.780 )  , 
		'NH2'  :  ( -0.215 ,  3.048 , -2.788 )  , 
		'H1'   :  ( -0.040 , -3.007 ,  3.295 )  ,
		'1HH1' :  ( -1.312 ,  2.964 ,  0.133 )  , 
		'2HH1' :  ( -1.365 ,  4.326 , -1.087 )  , 
		'1HH2' :  ( 0.275  ,  2.415 , -3.423 )  , 
		'2HH2' :  ( -0.502 ,  4.005 , -3.000 )  , 
		'HE'   :  ( 0.348  ,  0.865 , -2.071 )  , 
		'HA'   :  ( 0.211  , -3.538 ,  0.443 )  , 
		'1HB'  :  ( 0.336  , -0.947 ,  2.140 )  , 
		'2HB'  :  ( -1.156 , -1.569 ,  1.465 )  , 
		'1HG'  :  ( -0.252 , -1.330 , -0.887 )  , 
		'2HG'  :  ( 1.276  , -0.706 , -0.255 )  , 
		'1HD'  :  ( 0.080  , 1.230  , 0.834  )  , 
		'2HD'  :  ( -1.476 ,  0.622 ,  0.217 )  ,
                'H2'   :  ( 0.558  , -4.442 ,  2.741 )  ,
                'H3'   :  ( -0.961 , -3.963 ,  2.316 ) 
	},

	'centroidAtoms' : [ 'CZ' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1      CA      HA      CB      1HB     2HB     CG      1HG     2HG     CD      1HD     2HD     NE      HE      CZ      NH1     1HH1    2HH1    NH2     1HH2    2HH2	H2	H#
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      7,      8,      8,      7,      8,      8,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      8,      9,      9,      8,      9,      9,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      7,      8,      8,      7,      8,      8,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      8,      9,      9,      8,      9,      9,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      6,      7,      7,      6,      7,      7,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      7,      8,      8,      7,      8,      8,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,      2,      3,      3,      3,      4,      4,      5,      6,      6,      5,      6,      6,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      6,      7,      7,      6,      7,      7,	4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,      3,      4,      4,      4,      5,      5,      6,      7,      7,      6,      7,      7,	4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,      1,      2,      2,      2,      3,      3,      4,      5,      5,      4,      5,      5,	4,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,      2,      3,      3,      3,      4,      4,      5,      6,      6,      5,      6,      6,	5,	5],     #1HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,      2,      3,      3,      3,      4,      4,      5,      6,      6,      5,      6,      6,	5,	5],     #2HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      2,      0,      1,      1,      1,      2,      2,      3,      4,      4,      3,      4,      4,	5,	5],     #CD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      0,      2,      2,      3,      3,      4,      5,      5,      4,      5,      5,	6,	6],     #1HD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      2,      0,      2,      3,      3,      4,      5,      5,      4,      5,      5,	6,	6],     #2HD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      2,      2,      0,      1,      1,      2,      3,      3,      2,      3,      3,	6,	6],     #NE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      3,      3,      1,      0,      2,      3,      4,      4,      3,      4,      4,	7,	7],     #HE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      3,      3,      1,      2,      0,      1,      2,      2,      1,      2,      2,	7,	7],     #CZ
                [7,     8,      7,      8,      6,      7,      5,      6,      6,      4,      5,      5,      3,      4,      4,      2,      3,      1,      0,      1,      1,      2,      3,      3,	8,	8],     #NH1
                [8,     9,      8,      9,      7,      8,      6,      7,      7,      5,      6,      6,      4,      5,      5,      3,      4,      2,      1,      0,      2,      3,      4,      4,	9,	9],     #1HH1
                [8,     9,      8,      9,      7,      8,      6,      7,      7,      5,      6,      6,      4,      5,      5,      3,      4,      2,      1,      2,      0,      3,      4,      4,	9,	9],     #2HH1
                [7,     8,      7,      8,      6,      7,      5,      6,      6,      4,      5,      5,      3,      4,      4,      2,      3,      1,      2,      3,      3,      0,      1,      1,	8,	8],     #NH2
                [8,     9,      8,      9,      7,      8,      6,      7,      7,      5,      6,      6,      4,      5,      5,      3,      4,      2,      3,      4,      4,      1,      0,      2,	9,	9],     #1HH2
                [8,     9,      8,      9,      7,      8,      6,      7,      7,      5,      6,      6,      4,      5,      5,      3,      4,      2,      3,      4,      4,      1,      2,      0,	9,	9],     #2HH2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      8,      9,      9,      8,      9,      9,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      8,      9,      9,      8,      9,      9,      2,      0]      #H3
       ]
}

