# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C', 'O',  'N', 'H1', 'CA', 'HA', 'CB',  '1HB', '2HB', 'CG',   'OD1',  'ND2', '1HD2', '2HD2', 'H2', 'H3'],
		'PDB'  : ['N', 'CA', 'C', 'O', 'CB', 'CG', 'OD1', 'ND2', 'H1',   '1HD2', '2HD2', 'HA',  '1HB',  '2HB', 'H2', 'H3' ]
	}, 

        'AA_class' : 11,

	'polar' : True,   

	'acceptors' : { 'O' : 'C', 'OD1' : 'CG' },

	'templateAtom' : 
	{
		'1HD2' : [ 'ND2', 'CG', 'CB' ],
		'2HD2' : [ 'ND2', 'CG', 'CB' ],
		'HA'   : [ 'CA',  'N',  'C'  ],
		'1HB'  : [ 'CB',  'CA', 'CG' ],
		'2HB'  : [ 'CB',  'CA', 'CG' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'OD1', 'ND2', '1HD2', '2HD2' ] 
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG'  ],
		[ 'CA', 'CB', 'CG', 'OD1' ]
	],

	'templateCoords' :
	{

		'N'    :  ( 0.209  , -1.748 , -0.613 )  , 
		'CA'   :  ( 0.793  , -0.410 , -0.613 )  , 
		'C'    :  ( 2.302  ,-0.479  , -0.613 )  , 
		'O'    :  ( 2.906  ,-1.551  , -0.613 )  , 
		'CB'   :  ( 0.278  , 0.381  , 0.624  )  , 
		'CG'   :  ( -1.240 , 0.532  , 0.768  )  , 
		'OD1'  :  ( -1.895 , -0.168 ,  1.526 )  , 
		'ND2'  :  ( -1.857 ,  1.423 ,  0.039 )  , 
		'H1'    : ( 0.074  ,-2.057  , 0.339  )  , 
		'1HD2' :  ( -2.875 ,  1.338 ,  0.098 )  , 
		'2HD2' :  ( -1.296 ,  1.927 , -0.647 )  , 
		'HA'   :  ( 0.489  ,  0.105 , -1.543 )  , 
		'1HB'  :  ( 0.730  , 1.390  , 0.652  )  , 
		'2HB'  :  ( 0.639  ,-0.106  , 1.551  )  ,
                'H2'   :  ( 0.829  ,-2.386  ,-1.090  )  ,
                'H3'   :  ( -0.682 , -1.726 , -1.089 )
	},

	'centroidAtoms' : [ 'CG', 'OD1', 'ND2' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1      CA      HA      CB      1HB     2HB     CG      OD1     ND2     1HD2 	2HD2	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,      5,      5,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,      5,      5,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,      4,      4,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,      5,      5,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,      3,      3,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,      4,      4,	4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,      4,      4,	4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,      2,      2,	4,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,      3,      3,	5,	5],     #OD1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,      1,      1,	5,	5],     #ND2
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      1,      0,      2,	6,	6],     #1HD2
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      1,      2,      0,	6,	6],     #2HD2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      2,      0]      #H3
        ]

}

