# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C', 'O',  'N', 'H1', 'CA', 'HA', 'CB',  '1HB', '2HB', 'CG', 'OD1', 'OD2', 'H2', 'H3'],
		'PDB'  : ['N', 'CA', 'C', 'O', 'CB', 'CG', 'OD1', 'OD2', 'H1', 'HA', '1HB', '2HB', 'H2', 'H3']                         
	},

        'AA_class' : 2,

	'polar' : True,  

	'acceptors' : { 'O' : 'C', 'OD1' : 'CG', 'OD2' : 'CG' },

	'templateAtom' : 
	{
		'HA'  : [ 'CA', 'N',  'C'  ],
		'1HB' : [ 'CB', 'CA', 'CG' ],
		'2HB' : [ 'CB', 'CA', 'CG' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'OD1', 'OD2' ]
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG'  ],
		[ 'CA', 'CB', 'CG', 'OD1' ]
	],

	'templateCoords' :
	{
		'N'   :  ( -0.610  , -1.825 ,  -0.630 )  , 
		'CA'  :  ( -0.051  , -0.476 ,  -0.630 )  , 
		'C'   :  ( 1.458   , -0.515 ,  -0.630 )  , 
		'O'   :  ( 2.088   , -1.584 ,  -0.630 )  , 
		'CB'  :  ( -0.586  ,  0.337 ,  0.582  )  , 
		'CG'  :  ( -0.124  ,  1.801 ,  0.652  )  , 
		'OD1' :  ( -0.007  ,  2.453 , -0.406  )  , 
		'OD2' :  ( 0.165   ,  2.283 ,  1.767  )  , 
		'H1'   : ( -0.740  ,-2.136  ,  0.322  )  , 
		'HA'  :  ( -0.366  , 0.030  , -1.563  )  , 
		'1HB' :  ( -0.291  , -0.154 ,  1.527  )  , 
		'2HB' :  ( -1.688  ,  0.354 ,  0.586  )  ,
                'H2'  :  ( 0.022   , -2.451 , -1.107  )  ,
                'H3'  :  (-1.501   , -1.819 , -1.105  )
	},

	'centroidAtoms' : [ 'CG', 'OD1', 'OD2' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1      CA      HA      CB      1HB     2HB     CG      OD1     OD2	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,	4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,	4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,	4,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,	5,	5],     #OD1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,	5,	5],     #OD2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      2,      0],     #H3
        ]

}

