# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C', 'O',  'N', 'H1', 'CA', 'HA', 'CB', '1HB', '2HB', 'SG',  'HG', 'H2', 'H3'],
		'PDB'  : ['N', 'CA', 'C', 'O', 'CB', 'SG', 'H1',  'HA',  '1HB', '2HB', 'HG', 'H2', 'H3']                       
	},

        'AA_class' : 1,

	'polar' : False,  

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'HA'  : [ 'CA', 'N',  'C'  ],
		'1HB' : [ 'CB', 'CA', 'SG' ],
		'2HB' : [ 'CB', 'CA', 'SG' ],
		'HG'  : [ 'SG', 'CB', 'CA' ]
	},

	'chiDependent' :
	[
		[ 'SG', '1HB', '2HB', 'HG' ]
	],

	'chiAtoms' :
	[
		[ 'N', 'CA', 'CB', 'SG' ]
	],

	'templateCoords' :
	{

		'N'   :  ( -0.664  , -1.578 , -0.633 )  , 
		'CA'  :  ( -0.105  , -0.229 , -0.633 ) , 
		'C'   :  ( 1.405   , -0.269 , -0.633 ) , 
		'O'   :  ( 2.034   , -1.337 , -0.633 ) , 
		'CB'  :  ( -0.674  , 0.537  , 0.577  ) , 
		'SG'  :  ( -0.163  , 2.270  , 0.535  ) , 
		'H1'  :  ( -0.793 , -1.889 ,  0.319 ) , 
		'HA'  :  ( -0.420 ,  0.277 , -1.564 ) , 
		'1HB' :  ( -0.349 ,  0.082 ,  1.535 ) , 
		'2HB' :  ( -1.778 ,  0.509 ,  0.585 ) , 
		'HG'  :  ( 0.749  , 2.191  , 1.501  ),
                'H2'  :  ( -0.032 , -2.205 , -1.111 ),
                'H3'  :  (-1.555  , -1.572 , -1.109 )
	},

	'centroidAtoms' : [ 'SG' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1      CA      HA      CB      1HB     2HB     SG      HG	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,	4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,	4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,	4,	4],     #SG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,	5,	5],     #HG
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      2,      0],     #H3
        ]
}

