# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',   'O',   'N',  'H1',   'CA',  'HA',   'CB', '1HB', '2HB', 'CG', 
			  '1HG', '2HG', 'CD', 'OE1', 'NE2', '1HE2', '2HE2', 'H2', 'H3'],

		'PDB'  : ['N',    'CA', 'C',   'O',   'CB',  'CG', 'CD', 'OE1', 'NE2', 'H1', '1HE2',
			  '2HE2', 'HA', '1HB', '2HB', '1HG', '2HG', 'H2', 'H3']
	},

        'AA_class' : 13,

	'polar' : True,  

	'acceptors' : { 'O' : 'C', 'OE1' : 'CD' },

	'templateAtom' : 
	{
		'1HE2' : [ 'NE2', 'CD', 'CG' ],
		'2HE2' : [ 'NE2', 'CD', 'CG' ],
		'HA'   : [ 'CA',  'N',  'C'  ],
		'1HB'  : [ 'CB',  'CA', 'CG' ],
		'2HB'  : [ 'CB',  'CA', 'CG' ],
		'1HG'  : [ 'CG',  'CB', 'CD' ],
		'2HG'  : [ 'CG',  'CB', 'CD' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'CD', '1HG', '2HG' ],
		[ 'OE1', 'NE2', '1HE2', '2HE2' ] 
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG'  ],
		[ 'CA', 'CB', 'CG', 'CD'  ],
		[ 'CB', 'CG', 'CD', 'OE1' ],
	],

	'templateCoords' :
	{

		'N'    :  ( -0.311 , -2.482 , -1.387 )  , 
		'CA'   :  ( 0.241  , -1.131 , -1.387 )  , 
		'C'    :  ( 1.751  , -1.162 , -1.387 )  , 
		'O'    :  ( 2.380  , -2.218 , -1.387 )  , 
		'CB'   :  ( -0.297 , -0.376 , -0.151 )  , 
		'CG'   :  ( 0.152  , 1.115  , -0.003 )  , 
		'CD'   :  ( -0.293 ,  1.910 ,  1.231 )  , 
		'OE1'  :  ( 0.069  , 3.064  , 1.402  )  , 
		'NE2'  :  ( -1.052 ,  1.345 ,  2.135 )  , 
		'H1'   :  ( -0.439 , -2.794 , -0.435 )  , 
		'1HE2' :  ( -1.249 ,  1.921 ,  2.955 )  , 
		'2HE2' :  ( -1.262 ,  0.359 ,  1.967 )  , 
		'HA'   :  ( -0.083 , -0.615 , -2.310 )  , 
		'1HB'  :  ( 0.002  , -0.934 ,  0.761 )  , 
		'2HB'  :  ( -1.404 , -0.411 , -0.164 )  , 
		'1HG'  :  ( -0.150 ,  1.693 , -0.896 )  , 
		'2HG'  :  ( 1.255  , 1.185  , 0.008  )  ,
                'H2'   :  ( 0.324  , -3.106 , -1.864 )  ,
                'H3'   :  ( -1.202 , -2.481 , -1.863 )
	},

	'centroidAtoms' : [ 'CD', 'OE1', 'NE2' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1      CA      HA      CB      1HB     2HB     CG      1HG     2HG     CD      OE1     NE2     1HE2    2HE2	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      6,      6,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      7,      7,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      6,      6,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      7,      7,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,      3,      4,      4,      5,      5,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,      4,      5,      5,      6,      6,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,      2,      3,      3,      4,      4,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,      3,      4,      4,      5,      5,	4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,      3,      4,      4,      5,      5,	4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,      1,      2,      2,      3,      3,	4,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,      2,      3,      3,      4,      4,	5,	5],     #1HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,      2,      3,      3,      4,      4,	5,	5],     #2HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      2,      0,      1,      1,      2,      2,	5,	5],     #CD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      0,      2,      3,      3,	6,	6],     #OE1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      2,      0,      1,      1,	6,	6],     #NE2
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      3,      1,      0,      2,	7,	7],     #1HE2
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      3,      1,      2,      0,	7,	7],     #2HE2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      7,      7,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      7,      7,      2,      0]      #H3

        ]
}

