# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C', 'O',  'N', 'H1', 'CA', 'HA', 'CB', '1HB', '2HB', 'CG', '1HG', '2HG', 'CD',  'OE1', 'OE2', 'H2', 'H3'],
		'PDB'  : ['N', 'CA', 'C', 'O', 'CB', 'CG', 'CD', 'OE1', 'OE2', 'H1',  'HA',  '1HB', '2HB', '1HG', '2HG', 'H2', 'H3'] 
	},

        'AA_class' : 3,

	'polar' : True,  

	'acceptors' : { 'O' : 'C', 'OE1' : 'CD', 'OE2' : 'CD' },

	'templateAtom' : 
	{
		'HA'  : [ 'CA', 'N',  'C'  ],
		'1HB' : [ 'CB', 'CA', 'CG' ],
		'2HB' : [ 'CB', 'CA', 'CG' ],
		'1HG' : [ 'CG', 'CB', 'CD' ],
		'2HG' : [ 'CG', 'CB', 'CD' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'CD', '1HG', '2HG' ],
		[ 'OE1', 'OE2' ] 
	],

	'chiAtoms' :
	[
	        [ 'N',  'CA', 'CB', 'CG'  ],	
		[ 'CA', 'CB', 'CG', 'CD'  ],
		[ 'CB', 'CG', 'CD', 'OE1' ]
	],

	'templateCoords' :
	{


		'N'   :  ( -0.517  , -2.346 , -1.038  )  , 
		'CA'  :  ( 0.042   , -0.997 , -1.038  )  , 
		'C'   :  ( 1.551   , -1.037 , -1.038  )  , 
		'O'   :  ( 2.180   , -2.105 , -1.038  )  , 
		'CB'  :  ( -0.481  , -0.212 ,  0.199  )  , 
		'CG'  :  ( -0.006  , 1.273  ,  0.310  )  , 
		'CD'  :  ( -0.430  , 2.077  ,  1.525  )  , 
		'OE1' :  ( -1.158  , 1.575  ,  2.403  )  , 
		'OE2' :  ( -0.000  , 3.247  ,  1.597  )  , 
		'H1'  :  ( -0.646  ,-2.658  , -0.086  )  , 
		'HA'  :  ( -0.284  ,0.479  ,  -1.958  )  , 
		'1HB' :  ( -0.192  ,-0.743 ,  1.129   )  , 
		'2HB' :  ( -1.588  ,-0.222 ,  0.212   )  , 
		'1HG' :  ( -0.316  , 1.858 , -0.571   )  , 
		'2HG' :  ( 1.094   , 1.340 ,  0.339   )  ,
                'H2'  :  ( 0.115   , -2.973,  -1.515  )  ,
                'H3'  :  ( -1.408  , -2.341,  -1.513  )
	},

	'centroidAtoms' : [ 'CD', 'OE1', 'OE2' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1      CA      HA      CB      1HB     2HB     CG      1HG     2HG     CD      OE1     OE2	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,      3,      4,      4,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,      4,      5,      5,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,      2,      3,      3,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,      3,      4,      4,	4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,      3,      4,      4,	4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,      1,      2,      2,	4,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,      2,      3,      3,	5,	5],     #1HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,      2,      3,      3,	5,	5],     #2HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      2,      0,      1,      1,	5,	5],     #CD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      0,      2,	6,	6],     #OE1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      2,      0,	6,	6],     #OE2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      2,      0],     #H3
        ]

}

