# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C', 'O',  'N', 'H1', 'CA', '1HA', '2HA', 'H2', 'H3'],
		'PDB'  : ['N', 'CA', 'C', 'O', 'H1',  '1HA', '2HA', 'H2', 'H3']               
	},

        'AA_class' : 5,

	'polar' : False,  

	'acceptors' : { 'O' : 'C' },
	
	'templateAtom' : 
	{
		'1HA' : [ 'CA', 'N', 'C' ],
		'2HA' : [ 'CA', 'N', 'C' ]
	},

	'chiDependent' : [],

	'chiAtoms' : [],

	'templateCoords' :
	{


		'N'   :  ( -1.195  , 0.201   , -0.206  )  , 
		'CA'  :  ( 0.230   , 0.318   , -0.502  )  , 
		'C'   :  ( 1.059   , -0.390  ,  0.542  )  , 
		'O'   :  ( 0.545   , -0.975  ,  1.499  )  , 
		'1HA' :  ( 0.482   , 1.337   , -0.514  )  , 
		'2HA' :  ( 0.434   , -0.159  , -1.479  )  , 
		'H1'  :  ( -1.483  , 0.975   , 0.376   )  ,
                'H2'  :  ( -1.368  , -0.668  , 0.278   )  ,
                'H3'  :  ( -1.719  , 0.216   , -1.069  )
	},

	'centroidAtoms' : [ 'CA' ],

	'neighborAtom' : 'CA',

        'bondLengths' :
        [       #C      O       N       H1      CA      1HA     2HA	H2	H3
                [0,     1,      2,      3,      1,      2,      2,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,	3,	3],     #1HA
                [2,     3,      2,      3,      1,      2,      0,	3,	3],     #2HA
                [3,     4,      1,      2,      2,      3,      3,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      2,      0],     #H3
        ]
}

