# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',  'O',   'N',   'H1',   'CA',  'HA',  'CB',  '1HB', '2HB', 
			  'CG', 'ND1', 'CD2', 'HD2', 'CE1', 'HE1', 'NE2', 'HE2', 'H2', 'H3'],

		'PDB'  : ['N', 'CA',  'C',  'O',   'CB',  'CG',  'ND1', 'CD2', 'CE1', 'NE2', 
			  'H1', 'HE2', 'HA', '1HB', '2HB', 'HE1', 'HD2', 'H2', 'H3']
	},

        'AA_class' : 6,

	'polar' : True,  

	'acceptors' : { 'O' : 'C', 'ND1' : ['CG', 'CE1'] },

	'templateAtom' : 
	{
		'HE2' : [ 'NE2', 'CD2', 'CE1' ],
		'HA' :  [ 'CA',  'N',   'C'   ],
		'1HB' : [ 'CB',  'CA',  'CG'  ],
		'2HB' : [ 'CB',  'CA',  'CG'  ],
		'HE1' : [ 'CE1', 'ND1', 'NE2' ],
		'HD2' : [ 'CD2', 'CG',  'NE2' ],
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'ND1', 'CD2', 'CE1', 'NE2', 'HE2', 'HE1', 'HD2' ]
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG'  ],
		[ 'CA', 'CB', 'CG', 'ND1' ]
	],

	'templateCoords' :
	{

		'N'     :  ( 0.498   , -2.372  ,  -1.127 )  , 
		'CA'    :  ( 1.052   , -1.053  ,  -0.834 )  , 
		'C'     :  ( 2.561   , -1.080  ,  -0.865 )  , 
		'O'     :  ( 3.195   , -2.117  ,  -1.112 )  , 
		'CB'    :  ( 0.551   , -0.676  ,  0.570  )  , 
		'CG'    :  ( -0.281  ,  0.573  ,  0.562  )  , 
		'ND1'   :  ( 0.197   ,  1.873  ,  0.711  )  , 
		'CD2'   :  ( -1.660  ,  0.555  ,  0.400  )  , 
		'CE1'   :  ( -0.959  ,  2.556  ,  0.620  )  , 
		'NE2'   :  ( -2.108  ,  1.850  ,  0.438  )  , 
		'H1'     :  ( 0.344  , -2.872  , -0.264  )  , 
		'HE2'   :  ( -3.075  , 2.194   , 0.348   )  , 
		'HA'    :  ( 0.732   , -0.370  , -1.639  )  , 
		'1HB'   :  ( 1.397   , -0.517  ,  1.268  )  , 
		'2HB'   :  ( -0.059  , -1.483  ,  1.027  )  , 
		'HE1'   :  ( -0.912  , 3.634   ,  0.700  )  , 
		'HD2'   :  ( -2.252  , -0.346  ,  0.268  )  ,
                'H2'    :  ( 1.145   , -2.888  ,  -1.706 )  ,
                'H3'    :  ( -0.380  , -2.267  ,  -1.616 ) 
	},

	'centroidAtoms' : [ 'ND1', 'CD2' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1       CA      HA      CB      1HB     2HB     CG      ND1     CD2     HD2     CE1     HE1     NE2     HE2	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,      5,      5,      6,      5,      6,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      7,      6,      7,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,      5,      5,      6,      5,      6,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      7,      6,      7,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,      4,      4,      5,      4,      5,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,      5,      5,      6,      5,      6,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,      3,      3,      4,      3,      4,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,      4,      4,      5,      4,      5,	4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,      4,      4,      5,      4,      5,	4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,      2,      2,      3,      2,      3,	4,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,      3,      1,      2,      2,      3,	5,	5],     #ND1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,      1,      2,      3,      1,      2,	5,	5],     #CD2
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      1,      0,      3,      4,      2,      3,	6,	6],     #HD2
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      1,      2,      3,      0,      1,      1,      2,	6,	6],     #CE1
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      2,      3,      4,      1,      0,      2,      3,	7,	7],     #HE1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      2,      1,      2,      1,      2,      0,      1,	6,	6],     #NE2
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      3,      2,      3,      2,      3,      1,      0,	7,	7],     #HE2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      7,      6,      7,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      7,      6,      7,      2,      0]      #H3
        ]

}

