# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',    'O',   'N',    'H1',    'CA',  'HA',   'CB',   'HB',  'CG2', '1HG2', '2HG2', 
			  '3HG2', 'CG1', '1HG1', '2HG1', 'CD1', '1HD1', '2HD1', '3HD1', 'H2', 'H3'],

		'PDB'  : ['N',    'CA',   'C',    'O',    'CB',   'CG1',  'CG2',  'CD1',  'H1',  'HA',  'HB',  '1HG2', 
			  '2HG2', '3HG2', '1HG1', '2HG1', '1HD1', '2HD1', '3HD1', 'H2', 'H3']                                       
	},

        'AA_class' : 7,

	'polar' : False,  

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'HA' :   [ 'CA',  'N',   'C'   ],
		'HB' :   [ 'CB',  'CA',  'CG1' ],
		'1HG2' : [ 'CG2', 'CB',  'CA'  ],
		'2HG2' : [ 'CG2', 'CB',  'CA'  ],
		'3HG2' : [ 'CG2', 'CB',  'CA'  ],
		'1HG1' : [ 'CG1', 'CB',  'CD1' ],
		'2HG1' : [ 'CG1', 'CB',  'CD1' ],
		'1HD1' : [ 'CD1', 'CG1', 'CB'  ],
		'2HD1' : [ 'CD1', 'CG1', 'CB'  ],
		'3HD1' : [ 'CD1', 'CG1', 'CB'  ]
	},

	'chiDependent' :
	[
		[ 'CG1', 'CG2', 'HB', '1HG2', '2HG2', '3HG2' ],
		[ 'CD1', '1HG1', '2HG1', '1HD1', '2HD1', '3HD1' ] 
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG1'  ],
		[ 'CA', 'CB', 'CG1', 'CD1' ]
	],

	'templateCoords' :
	{

		'N'    :  ( 0.394 , -2.167 , -1.142) , 
		'CA'   :  ( 0.891 , -0.794 , -1.142)  , 
		'C'    :  ( 2.400 , -0.765 , -1.142)  , 
		'O'    :  ( 3.077 , -1.804 , -1.142)  , 
		'CB'   :  ( 0.286 ,  0.038 ,  0.061)  , 
		'CG1'  :  ( -1.272,  -0.010,  0.168)  , 
		'CG2'  :  ( 0.725 ,  1.535 ,  0.043)  , 
		'CD1'  :  ( -1.872,   0.510,   1.491)  , 
		'H1'   :  ( 0.279 , -2.484 , -0.190 )  , 
		'HA'   :  ( 0.568 , -0.322 , -2.088 )  , 
		'HB'   :  ( 0.684 , -0.416 ,  0.993 )  , 
		'1HG2' :  ( 1.820 ,  1.668 ,  0.087 )  , 
		'2HG2' :  ( 0.366 ,  2.063 , -0.861 )  , 
		'3HG2' :  ( 0.345 ,  2.096 ,  0.916 )  , 
		'1HG1' :  ( -1.618,  -1.056,   0.070 )  , 
		'2HG1' :  ( -1.732,   0.515,  -0.692 )  , 
		'1HD1' :  ( -1.461,  -0.027,   2.367 )  , 
		'2HD1' :  ( -1.686,   1.588,   1.646 )  , 
		'3HD1' :  ( -2.969,   0.373,   1.513 )  ,
                'H2'   :  ( 1.054 , -2.765 ,  -1.619 )  ,
                'H3'   :  ( -0.497,  -2.203,  -1.618 ) 
	},

	'centroidAtoms' : [ 'CG1', 'CG2', 'CD1' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1      CA      HA      CB      HB      CG2     1HG2    2HG2    3HG2    CG1     1HG1    2HG1    CD1     1HD1    2HD1    3HD1	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,      5,      5,      5,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,      6,      6,      6,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,      5,      5,      5,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,      6,      6,      6,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      3,      3,      3,      2,      3,      3,      3,      4,      4,      4,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,      5,      5,      5,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      2,      2,      2,      1,      2,      2,      2,      3,      3,      3,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      3,      3,      3,      2,      3,      3,      3,      4,      4,      4,	4,	4],     #HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      1,      1,      1,      2,      3,      3,      3,      4,      4,      4,	4,	4],     #CG2
                [4,     5,      4,      5,      3,      4,      2,      3,      1,      0,      2,      2,      3,      4,      4,      4,      5,      5,      5,	5,	5],     #1HG2
                [4,     5,      4,      5,      3,      4,      2,      3,      1,      2,      0,      2,      3,      4,      4,      4,      5,      5,      5,	5,	5],     #2HG2
                [4,     5,      4,      5,      3,      4,      2,      3,      1,      2,      2,      0,      3,      4,      4,      4,      5,      5,      5,	5,	5],     #3HG2
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      3,      3,      3,      0,      1,      1,      1,      2,      2,      2,	4,	4],     #CG1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      4,      4,      4,      1,      0,      2,      2,      3,      3,      3,	5,	5],     #1HG1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      4,      4,      4,      1,      2,      0,      2,      3,      3,      3,	5,	5],     #2HG1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      4,      4,      4,      1,      2,      2,      0,      1,      1,      1,	5,	5],     #CD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      5,      5,      5,      2,      3,      3,      1,      0,      2,      2,	6,	6],     #1HD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      5,      5,      5,      2,      3,      3,      1,      2,      0,      2,	6,	6],     #2HD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      5,      5,      5,      2,      3,      3,      1,      2,      2,      0,	6,	6],     #3HD1
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,      6,      6,      6,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,      6,      6,      6,      2,      0]      #H3
        ]

}

