# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',  'O',   'N',    'H1',    'CA',   'HA',  'CB',   '1HB',  '2HB', 'CG', 
		          'HG', 'CD1', '1HD1', '2HD1', '3HD1', 'CD2', '1HD2', '2HD2', '3HD2', 'H2', 'H3'],

		'PDB'  : ['N',   'CA', 'C',    'O',    'CB',   'CG',   'CD1',  'CD2',  'H1',  'HA',  '1HB', 
			  '2HB', 'HG', '1HD1', '2HD1', '3HD1', '1HD2', '2HD2', '3HD2', 'H2', 'H3']
	},

        'AA_class' : 9,

	'polar' : False, 

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'HA' :   [ 'CA',  'N',  'C'   ],
		'1HB' :  [ 'CB',  'CA', 'CG'  ],
		'2HB' :  [ 'CB',  'CA', 'CG'  ],
		'HG' :   [ 'CG',  'CB', 'CD1' ],
		'1HD1' : [ 'CD1', 'CG', 'CB'  ],
		'2HD1' : [ 'CD1', 'CG', 'CB'  ],
		'3HD1' : [ 'CD1', 'CG', 'CB'  ],
		'1HD2' : [ 'CD2', 'CG', 'CB'  ],
		'2HD2' : [ 'CD2', 'CG', 'CB'  ],
		'3HD2' : [ 'CD2', 'CG', 'CB'  ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ], 
		[ 'CD1', 'CD2', 'HG', '1HD1', '2HD1', '3HD1', '1HD2', '2HD2', '3HD2' ] 
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG'  ],
		[ 'CA', 'CB', 'CG', 'CD1' ]
	],

	'templateCoords' :
	{
		'N'    :  ( 0.678 , -2.128 , -0.894  )  , 
		'CA'   :  ( 1.246 , -0.783 , -0.894  )  , 
		'C'    :  ( 2.755 , -0.834 , -0.894  )  , 
		'O'    :  ( 3.377 , -1.907 , -0.894  )  , 
		'CB'   :  ( 0.718 ,  0.033 ,  0.320  )  , 
		'CG'   :  ( -0.817,   0.218,   0.464 )  , 
		'CD1'  :  ( -1.129,   1.139,   1.652 )  , 
		'CD2'  :  ( -1.470,   0.778,  -0.811 )  , 
		'H1'   :  ( 0.546 , -2.439 ,  0.058  )  , 
		'HA'   :  ( 0.953 , -0.280 , -1.833  )  , 
		'1HB'  :  ( 1.188 ,  1.036 ,  0.300  )  , 
		'2HB'  :  ( 1.097 , -0.432 ,  1.252  )  , 
		'HG'   :  ( -1.266,  -0.775,   0.676 )  , 
		'1HD1' :  ( -0.710,   0.746,   2.598 )  , 
		'2HD1' :  ( -0.719,   2.157,   1.512 )  , 
		'3HD1' :  ( -2.218,   1.245,   1.810 )  , 
		'1HD2' :  ( -1.017,   1.735,  -1.128 )  , 
		'2HD2' :  ( -1.371,   0.071,  -1.656 )  , 
		'3HD2' :  ( -2.555,   0.947,  -0.680 )  ,
                'H2'   :  ( 1.305 ,  -2.759,  -1.371 )  ,
                'H3'   :  ( -0.213,  -2.117,  -1.370 ) 
	},

	'centroidAtoms' : [ 'CG', 'CD1', 'CD2' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1       CA      HA      CB      1HB	2HB	CG      HG      CD1     1HD1    2HD1    3HD1	CD2     1HD2	2HD2	3HD2	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      6,      5,      6,      6,      6,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      6,      5,      6,      6,      6,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,      3,      3,      3,      2,      3,      3,      3,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,	4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,	4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,      2,      2,      2,      1,      2,      2,      2,	4,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,      3,      3,      3,      2,      3,      3,      3,	5,	5],     #HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,      1,      1,      1,      2,      3,      3,      3,	5,	5],     #CD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      1,      0,      2,      2,      3,      4,      4,      4,	6,	6],     #1HD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      1,      2,      0,      2,      3,      4,      4,      4,	6,	6],     #2HD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      1,      2,      2,      0,      3,      4,      4,      4,	6,	6],     #3HD1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      2,      3,      3,      3,      0,      1,      1,      1,	5,	5],     #CD2
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      4,      4,      4,      1,      0,      2,      2,	6,	6],     #1HD2
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      4,      4,      4,      1,      2,      0,      2,	6,	6],     #2HD2
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      4,      4,      4,      1,      2,      2,      0,	6,	6],     #3HD2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      6,      5,      6,      6,      6,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      6,      6,      6,      5,      6,      6,      6,      2,      0]      #H3
        ]

}

