# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',  'O',   'N',   'H1',  'CA',  'HA',  'CB', '1HB', '2HB', 'CG', '1HG', '2HG', 
		          'CD', '1HD', '2HD', 'CE', '1HE', '2HE', 'NZ', '1HZ', '2HZ', '3HZ', 'H2', 'H3'],

		'PDB'  : ['N',  'CA',  'C',   'O',   'CB',  'CG',  'CD',  'CE',  'NZ',  'H1', '1HZ', '2HZ', '3HZ', 
		          'HA', '1HB', '2HB', '1HG', '2HG', '1HD', '2HD', '1HE', '2HE', 'H2', 'H3']                                             
	},

        'AA_class' : 8,

	'polar' : True,  

	'acceptors' : { 'O' : 'C' }, 

	'templateAtom' : 
	{
		'1HZ' : [ 'NZ', 'CE', 'CD' ],
		'2HZ' : [ 'NZ', 'CE', 'CD' ],
		'3HZ' : [ 'NZ', 'CE', 'CD' ],
		'HA'  : [ 'CA', 'N',  'C'  ],
		'1HB' : [ 'CB', 'CA', 'CG' ],
		'2HB' : [ 'CB', 'CA', 'CG' ],
		'1HD' : [ 'CD', 'CG', 'CE' ],
		'2HD' : [ 'CD', 'CG', 'CE' ],
		'1HE' : [ 'CE', 'CD', 'NZ' ],
		'2HE' : [ 'CE', 'CD', 'NZ' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'CD', '1HG', '2HG' ],
		[ 'CE', '1HD', '2HD' ],
		[ 'NZ', '1HZ', '2HZ', '3HZ', '1HE', '2HE' ]  
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG' ],
		[ 'CA', 'CB', 'CG', 'CD' ],
		[ 'CB', 'CG', 'CD', 'CE' ],
		[ 'CG', 'CD', 'CE', 'NZ' ]
	],

	'templateCoords' :
	{

		'N'   :  ( -0.449  , -3.572  , -1.666  )  , 
		'CA'  :  ( 0.110   , -2.223  , -1.666  )  , 
		'C'   :  ( 1.620   , -2.263  , -1.666  )  , 
		'O'   :  ( 2.249   , -3.331  , -1.666  )  , 
		'CB'  :  ( -0.425  , -1.442  , -0.435  )  , 
		'CG'  :  ( 0.052   , 0.031   , -0.385  )  , 
		'CD'  :  ( -0.403  , 0.814   , 0.850   )  , 
		'CE'  :  (  0.198  , 2.225   , 0.804   )  , 
		'NZ'  :  ( -0.372  , 3.036   , 1.894   )  , 
		'H1'  :  ( -0.578  , -3.884  , -0.714  )  , 
		'1HZ' :  ( -0.508  , 2.465   , 2.737   )  , 
		'2HZ' :  ( 0.261   , 3.796   , 2.164   )  , 
		'3HZ' :  ( -1.247  , 3.402   , 1.548   )  , 
		'HA'  :  ( -0.209  , -1.713  , -2.594  )  , 
		'1HB' :  ( -0.128  , -1.966  ,  0.497  )  ,
		'2HB' :  ( -1.533  , -1.464  , -0.432  )  ,
		'1HG' :  ( -0.270  , 0.557   , -1.305  )  , 
		'2HG' :  (  1.157  , 0.075   , -0.392  )  , 
		'1HD' :  ( -0.075  , 0.288   , 1.770   )  , 
		'2HD' :  ( -1.509  , 0.846   , 0.887   )  , 
		'1HE' :  ( -0.007  , 2.716   , -0.170  )  , 
		'2HE' :  ( 1.304   , 2.179   , 0.893   )  ,
                'H2'  :  ( 0.183   , -4.199  , -2.143  )  ,
                'H3'  :  ( -1.340  , -3.567  , -2.142  ) 
	},

	'centroidAtoms' : [ 'NZ' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1      CA      HA      CB      1HB     2HB     CG      1HG     2HG     CD      1HD     2HD     CE      1HE     2HE     NZ      1HZ     2HZ     3HZ	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      7,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      7,      8,      8,      8,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      7,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      7,      8,      8,      8,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      7,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,	4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,	4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,      1,      2,      2,      2,      3,      3,      3,      4,      4,      4,	4,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,	5,	5],     #1HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,      2,      3,      3,      3,      4,      4,      4,      5,      5,      5,	5,	5],     #2HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      2,      0,      1,      1,      1,      2,      2,      2,      3,      3,      3,	5,	5],     #CD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      0,      2,      2,      3,      3,      3,      4,      4,      4,	6,	6],     #1HD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      2,      0,      2,      3,      3,      3,      4,      4,      4,	6,	6],     #2HD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      2,      2,      0,      1,      1,      1,      2,      2,      2,	6,	6],     #CE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      3,      3,      1,      0,      2,      2,      3,      3,      3,	7,	7],     #1HE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      3,      3,      1,      2,      0,      2,      3,      3,      3,	7,	7],     #2HE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      3,      3,      1,      2,      2,      0,      1,      1,      1,	7,	7],     #NZ
                [7,     8,      7,      8,      6,      7,      5,      6,      6,      4,      5,      5,      3,      4,      4,      2,      3,      3,      1,      0,      2,      2,	8,	8],     #1HZ
                [7,     8,      7,      8,      6,      7,      5,      6,      6,      4,      5,      5,      3,      4,      4,      2,      3,      3,      1,      2,      0,      2,	8,	8],     #2HZ
                [7,     8,      7,      8,      6,      7,      5,      6,      6,      4,      5,      5,      3,      4,      4,      2,      3,      3,      1,      2,      2,      0,	8,	8],     #3HZ
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      7,      8,      8,      8,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      6,      6,      7,      7,      7,      8,      8,      8,      2,      0]      #H3
        ]
}

