# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',  'O',   'N',   'H1',  'CA', 'HA',  'CB',  '1HB', '2HB', 
		          'CG', '1HG', '2HG', 'SD', 'CE', '1HE', '2HE', '3HE', 'H2', 'H3'],

		'PDB'  : ['N',   'CA',  'C',   'O',   'CB',  'CG',  'SD', 'CE',  'H1',  'HA', 
		          '1HB', '2HB', '1HG', '2HG', '1HE', '2HE', '3HE', 'H2', 'H3']                                   
	},

        'AA_class' : 10,

	'polar' : False,  

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'HA' :  [ 'CA', 'N',  'C'  ],
		'1HB' : [ 'CB', 'CA', 'CG' ],
		'2HB' : [ 'CB', 'CA', 'CG' ],
		'1HG' : [ 'CG', 'CB', 'SD' ],
		'2HG' : [ 'CG', 'CB', 'SD' ],
		'1HE' : [ 'CE', 'SD', 'CG' ],
		'2HE' : [ 'CE', 'SD', 'CG' ],
		'3HE' : [ 'CE', 'SD', 'CG' ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'SD', '1HG', '2HG' ],
		[ 'CE', '1HE', '2HE', '3HE' ]
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG' ],
		[ 'CA', 'CB', 'CG', 'SD' ],
		[ 'CB', 'CG', 'SD', 'CE' ]
	],

	'templateCoords' :
	{
		'N'   :  ( 1.052,  -1.937,  -1.166 )  , 
		'CA'  :  ( 1.540,  -0.561,  -1.166 )  , 
		'C'   :  ( 3.049,  -0.521,  -1.166 )  , 
		'O'   :  ( 3.733,  -1.556,  -1.166 )  , 
		'CB'  :  ( 0.965,   0.202,   0.059 )  , 
		'CG'  :  ( -0.571,   0.352,   0.100 )  , 
		'SD'  :  ( -1.038,   1.496,   1.409 )  , 
		'CE'  :  ( -2.801,   1.147,   1.451 )  , 
		'H1'  :  ( 0.939 , -2.255 , -0.214  )  , 
		'HA'  :  ( 1.202 , -0.067 , -2.096  )  , 
		'1HB' :  ( 1.403 ,  1.218 ,  0.096  )  , 
		'2HB' :  ( 1.300 , -0.285 ,  0.997  )  , 
		'1HG' :  ( -1.043,  -0.631,   0.287 )  , 
		'2HG' :  ( -0.970,   0.718,  -0.864 )  , 
		'1HE' :  ( -3.258,   1.295,   0.456 )  , 
		'2HE' :  ( -2.979,   0.103,   1.764 )  , 
		'3HE' :  ( -3.310,   1.813,   2.169 )  ,
                'H2'  :  ( 1.716,  -2.530,  -1.643 )  ,
                'H3'  :  ( 0.162,  -1.978,  -1.642 )  
	},

	'centroidAtoms' : [ 'SD' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1      CA      HA      CB      1HB     2HB     CG      1HG     2HG     SD      CE      1HE     2HE     3HE	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      6,      6,      6,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      7,      7,      7,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      4,      4,      5,      6,      6,      6,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      7,      7,      7,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      3,      3,      4,      5,      5,      5,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      4,      4,      5,      6,      6,      6,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      2,      2,      3,      4,      4,      4,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      3,      3,      4,      5,      5,      5,	4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      3,      3,      4,      5,      5,      5,	4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      1,      1,      2,      3,      3,      3,	4,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      2,      2,      3,      4,      4,      4,	5,	5],     #1HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      0,      2,      3,      4,      4,      4,	5,	5],     #2HG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      2,      0,      1,      2,      2,      2,	5,	5],     #SD
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      3,      1,      0,      1,      1,      1,	6,	6],     #CE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      1,      0,      2,      2,	7,	7],     #1HE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      1,      2,      0,      2,	7,	7],     #2HE
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      4,      2,      1,      2,      2,      0,	7,	7],     #3HE
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      7,      7,      7,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      5,      5,      6,      7,      7,      7,      2,      0]      #H3

        ]

}

