# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',   'O',   'N',   'H1',   'CA',  'HA',  'CB',  '1HB', '2HB', 'CG', 
		          'CD1', 'HD1', 'CD2', 'HD2', 'CE1', 'HE1', 'CE2', 'HE2', 'CZ',  'HZ', 'H2', 'H3'],

		'PDB'  : ['N',  'CA', 'C',   'O',   'CB', 'CG',  'CD1', 'CD2', 'CE1', 'CE2', 
		          'CZ', 'H1',  'HD1', 'HE1', 'HZ', 'HE2', 'HD2', 'HA',  '1HB', '2HB', 'H2', 'H3']                                         
	},

        'AA_class' : 4,

	'polar' : False,  

	'acceptors' : { 'O' : 'C' },
	
	'templateAtom' : 
	{
		'HD1' : [ 'CD1', 'CG',  'CE1' ],
		'HE1' : [ 'CE1', 'CD1', 'CZ'  ],
		'HZ'  : [ 'CZ',  'CE1', 'CE2' ],
		'HE2' : [ 'CE2', 'CD2', 'CZ'  ],
		'HD2' : [ 'CD2', 'CG',  'CE2' ],
		'HA'  : [ 'CA',  'N',   'C'   ],
		'1HB' : [ 'CB',  'CA',  'CG'  ],
		'2HB' : [ 'CB',  'CA',  'CG'  ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'CD1', 'CD2', 'CE1', 'CE2', 'CZ', 'HD1', 'HE1', 'HZ', 'HE2', 'HD2' ]
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG'  ],
		[ 'CA', 'CB', 'CG', 'CD1' ]
	],

	'templateCoords' :
	{
		'N'   :  ( 1.378,  -1.795,  -1.043 )  , 
		'CA'  :  ( 1.893,  -0.429,  -1.043 )  , 
		'C'   :  ( 3.403,  -0.419,  -1.043 )  , 
		'O'   :  ( 4.078,  -1.486,  -1.043 )  , 
		'CB'  :  ( 1.385,   0.334,   0.218 )  , 
		'CG'  :  ( -0.139,   0.429,   0.393)  , 
		'CD1' :  ( -0.821,  -0.586,   1.074)  , 
		'CD2' :  ( -0.860,   1.483,  -0.173)  , 
		'CE1' :  ( -2.208,  -0.556,   1.171)  , 
		'CE2' :  ( -2.248,   1.518,  -0.066)  , 
		'CZ'  :  ( -2.921,   0.497,   0.603)  , 
		'H1'  :  ( 1.259 , -2.110,  -0.091 )  , 
		'HD1' :  ( -0.276,  -1.423,   1.490)  , 
		'HE1' :  ( -2.727,  -1.360,   1.672)  , 
		'HZ'  :  ( -3.998,   0.515,   0.675)  , 
		'HE2' :  ( -2.802,   2.331,  -0.512)  , 
		'HD2' :  ( -0.346,   2.267,  -0.712)  , 
		'HA'  :  ( 1.547,   0.085,  -1.960 )  , 
		'1HB' :  ( 1.801,   1.361,   0.219 )  , 
		'2HB' :  ( 1.822,  -0.122,   1.130 )  ,
                'H2'  :  ( 2.030,  -2.401,  -1.521 )  ,
                'H3'  :  ( 0.488,  -1.818,  -1.519 ) 
	},

	'centroidAtoms' : [ 'CG', 'CZ' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1      CA      HA      CB      1HB     2HB     CG      CD1     HD1     CD2     HD2     CE1     HE1     CE2     HE2     CZ      HZ	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      3,      4,      5,      4,      5,      5,      6,      5,      6,      6,      7,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      4,      5,      6,      5,      6,      6,      7,      6,      7,      7,      8,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      3,      4,      5,      4,      5,      5,      6,      5,      6,      6,      7,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      4,      5,      6,      5,      6,      6,      7,      6,      7,      7,      8,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      2,      3,      4,      3,      4,      4,      5,      4,      5,      5,      6,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      3,      4,      5,      4,      5,      5,      6,      5,      6,      6,      7,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      1,      2,      3,      2,      3,      3,      4,      3,      4,      4,      5,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      2,      3,      4,      3,      4,      4,      5,      4,      5,      5,      6,	4,	4],     #1HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      2,      3,      4,      3,      4,      4,      5,      4,      5,      5,      6,	4,	4],     #2HB
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      0,      1,      2,      1,      2,      2,      3,      2,      3,      3,      4,	4,	4],     #CG
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      0,      1,      2,      3,      1,      2,      3,      4,      2,      3,	5,	5],     #CD1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      1,      0,      3,      4,      2,      3,      4,      5,      3,      4,	6,	6],     #HD1
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      1,      2,      3,      0,      1,      3,      4,      1,      2,      2,      3,	5,	5],     #CD2
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      4,      1,      0,      4,      5,      2,      3,      3,      4,	6,	6],     #HD2
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      1,      2,      3,      4,      0,      1,      2,      3,      1,      2,	6,	6],     #CE1
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      2,      3,      4,      5,      1,      0,      3,      4,      2,      3,	7,	7],     #HE1
                [5,     6,      5,      6,      4,      5,      3,      4,      4,      2,      3,      4,      1,      2,      2,      3,      0,      1,      1,      2,	6,	6],     #CE2
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      4,      5,      2,      3,      3,      4,      1,      0,      2,      3,	7,	7],     #HE2
                [6,     7,      6,      7,      5,      6,      4,      5,      5,      3,      2,      3,      2,      3,      1,      2,      1,      2,      0,      1,	7,	7],     #CZ
                [7,     8,      7,      8,      6,      7,      5,      6,      6,      4,      3,      4,      3,      4,      2,      3,      2,      3,      1,      0,	8,	8],     #HZ
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      6,      5,      6,      6,      7,      6,      7,      7,      8,      0,      2],     #H2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      4,      5,      6,      5,      6,      6,      7,      6,      7,      7,      8,      2,      0]      #H3

        ]
}

