# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Ram Kandasamy, Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',    'O',    'N',    'H1',   'CA',   'HA',   'CB',   'HB',  'CG1', 
		          '1HG1', '2HG1', '3HG1', 'CG2', '1HG2', '2HG2', '3HG2', 'H2', 'H3'],

		'PDB'  : ['N',  'CA',   'C',    'O',    'CB',   'CG1',  'CG2',  'H1',  'HA', 
		          'HB', '1HG1', '2HG1', '3HG1', '1HG2', '2HG2', '3HG2', 'H2', 'H3']                                 
	},

        'AA_class' : 17,

	'polar' : False, 

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'HA'   : [ 'CA',  'N',  'C'   ],
		'HB'   : [ 'CB',  'CA', 'CG1' ],
		'1HG1' : [ 'CG1', 'CB', 'CA'  ],
		'2HG1' : [ 'CG1', 'CB', 'CA'  ],
		'3HG1' : [ 'CG1', 'CB', 'CA'  ],
		'1HG2' : [ 'CG2', 'CB', 'CA'  ],
		'2HG2' : [ 'CG2', 'CB', 'CA'  ],
		'3HG2' : [ 'CG2', 'CB', 'CA'  ]
	},

	'chiDependent' :
	[
		[ 'CG1', 'CG2', 'HB', '1HG1', '2HG1', '3HG1', '1HG2', '2HG2', '3HG2' ]  
	],

	'chiAtoms' :
	[
		[ 'N', 'CA', 'CB', 'CG1' ]
	],

	'templateCoords' :
	{
		'N'    :  ( -0.090  , -2.047  , -0.848  )  , 
		'CA'   :  ( 0.431   , -0.683  , -0.848  )  , 
		'C'    :  ( 1.941   , -0.681  , -0.848  )  , 
		'O'    :  ( 2.599   , -1.729  , -0.848  )  , 
		'CB'   :  ( -0.132  , 0.106   , 0.400   )  , 
		'CG1'  :  ( 0.469   , 1.516   , 0.653   )  , 
		'CG2'  :  ( -1.665  , 0.316   , 0.369   )  , 
		'H1'   :  ( -0.210  , -2.362  , 0.104   )  , 
		'HA'   :  ( 0.107   , -0.178  , -1.776  )  , 
		'HB'   :  ( 0.097   , -0.501  ,  1.302  )  , 
		'1HG1' :  ( 0.314   , 2.202   ,  -0.201 )  , 
		'2HG1' :  ( 0.036   , 2.003   , 1.548   )  , 
		'3HG1' :  ( 1.558   , 1.482   , 0.848   )  , 
		'1HG2' :  ( -2.209  , -0.640  , 0.259   )  , 
		'2HG2' :  ( -2.037  ,  0.772  , 1.307   )  , 
		'3HG2' :  ( -1.983  ,  0.971  , -0.464  )  ,
                'H2'   :  ( 0.559   ,  -2.656 , -1.325  )  ,
                'H3'   :  ( -0.981  , -2.067  , -1.324  ) 
	},

	'centroidAtoms' : [ 'CB', 'CG1', 'CG2' ],

	'neighborAtom' : 'CB',

        'bondLengths' :
        [       #C      O       N       H1      CA      HA      CB      HB      CG1     1HG1    2HG1    3HG1    CG2     1HG2    2HG2    3HG2	H2	H3
                [0,     1,      2,      3,      1,      2,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,	3,	3],     #C
                [1,     0,      3,      4,      2,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,	4,	4],     #O
                [2,     3,      0,      1,      1,      2,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,	1,	1],     #N
                [3,     4,      1,      0,      2,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,	2,	2],     #H1
                [1,     2,      1,      2,      0,      1,      1,      2,      2,      3,      3,      3,      2,      3,      3,      3,	2,	2],     #CA
                [2,     3,      2,      3,      1,      0,      2,      3,      3,      4,      4,      4,      3,      4,      4,      4,	3,	3],     #HA
                [2,     3,      2,      3,      1,      2,      0,      1,      1,      2,      2,      2,      1,      2,      2,      2,	3,	3],     #CB
                [3,     4,      3,      4,      2,      3,      1,      0,      2,      3,      3,      3,      2,      3,      3,      3,	4,	4],     #HB
                [3,     4,      3,      4,      2,      3,      1,      2,      0,      1,      1,      1,      2,      3,      3,      3,	4,	4],     #CG1
                [4,     5,      4,      5,      3,      4,      2,      3,      1,      0,      2,      2,      3,      4,      4,      4,	5,	5],     #1HG1
                [4,     5,      4,      5,      3,      4,      2,      3,      1,      2,      0,      2,      3,      4,      4,      4,	5,	5],     #2HG1
                [4,     5,      4,      5,      3,      4,      2,      3,      1,      2,      2,      0,      3,      4,      4,      4,	5,	5],     #3HG1
                [3,     4,      3,      4,      2,      3,      1,      2,      2,      3,      3,      3,      0,      1,      1,      1,	4,	4],     #CG2
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      4,      4,      4,      1,      0,      2,      2,	5,	5],     #1HG2
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      4,      4,      4,      1,      2,      0,      2,	5,	5],     #2HG2
                [4,     5,      4,      5,      3,      4,      2,      3,      3,      4,      4,      4,      1,      2,      2,      0,	5,	5],     #3HG2
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,      0,      2],     #H1
                [3,     4,      1,      2,      2,      3,      3,      4,      4,      5,      5,      5,      4,      5,      5,      5,      2,      0]      #H1
        ]

}

