# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C', 'O',  'N', 'H', 'CA', 'HA', 'CB', '1HB', '2HB', 'OG',  'HG'],
		'PDB'  : ['N', 'CA', 'C', 'O', 'CB', 'OG', 'H',  'HG',  'HA',  '1HB', '2HB']                       
	},

        'AA_class' : 15,

	'polar' : True,  

	# note that the base for OG is at a *deeper* branch depth
	# (in the chiDependent array) than the OG itself! This requires
	# special handling for rotamer trie generation.
	'acceptors' : { 'O' : 'C', 'OG' : 'HG' },

	'templateAtom' : 
	{
		'HG'  : [ 'OG', 'CB', 'CA' ],
		'HA'  : [ 'CA', 'N',  'C'  ],
		'1HB' : [ 'CB', 'CA', 'OG' ],
		'2HB' : [ 'CB', 'CA', 'OG' ]
	},

	'chiDependent' :
	[
		[ 'OG', '1HB', '2HB' ],
		[ 'HG' ]
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'OG' ],
		[ 'CA', 'CB', 'OG', 'HG' ]
	],

	'templateCoords' :
	{
		'N'   :  ( 1.470  , 0.000  , 0.000  )  , 
		'CA'  :  ( 0.000  , 0.000  , 0.000  )  , 
		'C'   :  ( -0.572 , 1.422  , 0.000  )  , 
		'O'   :  ( -1.553 , 1.698  , -0.675 )  , 
		'CB'  :  ( -0.522 , -0.769 , 1.198  )  , 
		'OG'  :  ( -0.231 , -2.137 , 1.113  )  , 
		'H'   :  ( 2.435  , -0.299 , 0.000  )  , 
		'HG'  :  ( -0.577 , -2.586 , 1.888  )  , 
		'HA'  :  ( -0.433 , -0.566 , -0.826 )  , 
		'1HB' :  ( -0.062 , -0.364 , 2.099  )  , 
		'2HB' :  ( -1.602 , -0.639 , 1.253  )   
	},

	'centroidAtoms' : [ 'OG' ],

	'neighborAtom' : 'CB',
	
	'bondLengths' : 
	[	#C	O	N	H	CA	HA	CB	1HB	2HB	OG	HG
		[0,	1,	2,	3,	1,	2,	2,	3,	3,	3,	4],	#C
		[1,	0,	3,	4,	2,	3,	3,	4,	4,	4,	5],	#O
		[2,	3,	0,	1,	1,	2,	2,	3,	3,	3,	4],	#N
		[3,	4,	1,	0,	2,	3,	3,	4,	4,	4,	5],	#H
		[1,	2,	1,	2,	0,	1,	1,	2,	2,	2,	3],	#CA
		[2,	3,	2,	3,	1,	0,	2,	3,	3,	3,	4],	#HA
		[2,	3,	2,	3,	1,	2,	0,	1,	1,	1,	2],	#CB
		[3,	4,	3,	4,	2,	3,	1,	0,	2,	2,	3],	#1HB
		[3,	4,	3,	4,	2,	3,	1,	2,	0,	2,	3],	#2HB
		[3,	4,	3,	4,	2,	3,	1,	2,	2,	0,	1],	#OG
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	1,	0]	#HG
	]
}


