# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',   'O',   'N',   'H',   'CA',  'HA',  'CB',  '1HB', '2HB', 'CG', 'CD1', 'HD1', 'CD2', 'NE1', 
		          'HE1', 'CE2', 'CE3', 'HE3', 'CZ2', 'HZ2', 'CZ3', 'HZ3', 'CH2', 'HH2'],

		'PDB'  : ['N', 'CA',  'C',   'O',   'CB',  'CG',  'CD1', 'CD2', 'NE1', 'CE2', 'CE3', 'CZ2', 'CZ3', 'CH2', 
		          'H', 'HE1', 'HD1', 'HZ2', 'HH2', 'HZ3', 'HE3', 'HA',  '1HB', '2HB']                                                 
	},

        'AA_class' : 18,

	'polar' : False, 

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'HE1' : [ 'NE1', 'CD1', 'CE2' ],
		'HD1' : [ 'CD1', 'CG',  'NE1' ],
		'HZ2' : [ 'CZ2', 'CE2', 'CH2' ],
		'HH2' : [ 'CH2', 'CZ2', 'CZ3' ],
		'HZ3' : [ 'CZ3', 'CE3', 'CH2' ],
		'HE3' : [ 'CE3', 'CD2', 'CZ3' ],
		'HA'  : [ 'CA',  'N',   'C'   ],
		'1HB' : [ 'CB',  'CA',  'CG'  ],
		'2HB' : [ 'CB',  'CA',  'CG'  ]
	},

	'chiDependent' :
	[
		[ 'CG', '1HB', '2HB' ],
		[ 'CD1', 'CD2', 'NE1', 'CE2', 'CE3', 'CZ2', 'CZ3', 
		  'CH2', 'HE1', 'HD1', 'HZ2', 'HH2', 'HZ3', 'HE3' ]
	],

	'chiAtoms' :
	[
		[ 'N',  'CA', 'CB', 'CG'  ],
		[ 'CA', 'CB', 'CG', 'CD1' ]
	],

	'templateCoords' :
	{
		'N'   :  ( 0.0000  , 17.2040 , 65.5540 )  , 
		'CA'  :  ( 0.0000  , 18.0180 , 66.7640 )  , 
		'C'   :  ( 0.0000  , 17.1480 , 68.0140 )  , 
		'O'   :  ( 0.0020  , 15.9210 , 67.9270 )  , 
		'CB'  :  ( -1.2100 , 18.9540 , 66.7770 )  , 
		'CG'  :  ( -1.2790 , 19.8260 , 67.9940 )  , 
		'CD1' :  ( -2.2370 , 20.7520 , 68.2800 )  , 
		'CD2' :  ( -0.3540 , 19.8530 , 69.0880 )  , 
		'NE1' :  ( -1.9670 , 21.3560 , 69.4830 )  , 
		'CE2' :  ( -0.8150 , 20.8190 , 70.0000 )  , 
		'CE3' :  ( 0.8210  , 19.1510 , 69.3840 )  , 
		'CZ2' :  ( -0.1480 , 21.1040 , 71.1810 )  , 
		'CZ3' :  ( 1.4890  , 19.4360 , 70.5690 )  , 
		'CH2' :  ( 1.0180  , 20.3840 , 71.4420 )  , 
		'H'   :  ( -0.0380 , 16.1990 , 65.6530 )  , 
		'HE1' :  ( -2.5240 , 22.0780 , 69.9170 )  , 
		'HD1' :  ( -3.0370 , 20.8740 , 67.5520 )  , 
		'HZ2' :  ( -0.5570 , 21.8650 , 71.8460 )  , 
		'HH2' :  ( 1.5720  , 20.5770 , 72.3610 )  , 
		'HZ3' :  ( 2.4030  , 18.8830 , 70.7870 )  , 
		'HE3' :  ( 1.2370  , 18.3870 , 68.7280 )  , 
		'HA'  :  ( 0.9070  , 18.6210 , 66.8040 )  , 
		'1HB' :  ( -1.1800 , 19.6220 , 65.9160 )  , 
		'2HB' :  ( -2.1330 , 18.3750 , 66.7550 )   
	},

	'centroidAtoms' : [ 'CD2', 'CE2' ],

	'neighborAtom' : 'CB',

	'bondLengths' : 
	[	#C	O	N	H	CA	HA	CB	1HB	2HB	CG	CD1	HD1	CD2	NE1	HE1	CE2	CE3	HE3	CZ2	HZ2	CZ3	HZ3	CH2	HH2
		[0,	1,	2,	3,	1,	2,	2,	3,	3,	3,	4,	5,	4,	5,	6,	5,	5,	6,	6,	7,	6,	7,	7,	8],	#C
		[1,	0,	3,	4,	2,	3,	3,	4,	4,	4,	5,	6,	5,	6,	7,	6,	6,	7,	7,	8,	7,	8,	8,	9],	#O
		[2,	3,	0,	1,	1,	2,	2,	3,	3,	3,	4,	5,	4,	5,	6,	5,	5,	6,	6,	7,	6,	7,	7,	8],	#N
		[3,	4,	1,	0,	2,	3,	3,	4,	4,	4,	5,	6,	5,	6,	7,	6,	6,	7,	7,	8,	7,	8,	8,	9],	#H
		[1,	2,	1,	2,	0,	1,	1,	2,	2,	2,	3,	4,	3,	4,	5,	4,	4,	5,	5,	6,	5,	6,	6,	7],	#CA
		[2,	3,	2,	3,	1,	0,	2,	3,	3,	3,	4,	5,	4,	5,	6,	5,	5,	6,	6,	7,	6,	7,	7,	8],	#HA
		[2,	3,	2,	3,	1,	2,	0,	1,	1,	1,	2,	3,	2,	3,	4,	3,	3,	4,	4,	5,	4,	5,	5,	6],	#CB
		[3,	4,	3,	4,	2,	3,	1,	0,	2,	2,	3,	4,	3,	4,	5,	4,	4,	5,	5,	6,	5,	6,	6,	7],	#1HB
		[3,	4,	3,	4,	2,	3,	1,	2,	0,	2,	3,	4,	3,	4,	5,	4,	4,	5,	5,	6,	5,	6,	6,	7],	#2HB
		[3,	4,	3,	4,	2,	3,	1,	2,	2,	0,	1,	2,	1,	2,	3,	2,	2,	3,	3,	4,	3,	4,	4,	5],	#CG
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	1,	0,	1,	2,	1,	2,	2,	3,	4,	3,	4,	4,	5,	4,	5],	#CD1
		[5,	6,	5,	6,	4,	5,	3,	4,	4,	2,	1,	0,	3,	2,	3,	3,	4,	5,	4,	5,	5,	6,	5,	6],	#HD1
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	1,	2,	3,	0,	2,	3,	1,	1,	2,	2,	3,	2,	3,	3,	4],	#CD2
		[5,	6,	5,	6,	4,	5,	3,	4,	4,	2,	1,	2,	2,	0,	1,	1,	3,	4,	2,	3,	4,	5,	3,	4],	#NE1
		[6,	7,	6,	7,	5,	6,	4,	5,	5,	3,	2,	3,	3,	1,	0,	2,	4,	5,	3,	4,	5,	6,	4,	5],	#HE1
		[5,	6,	5,	6,	4,	5,	3,	4,	4,	2,	2,	3,	1,	1,	2,	0,	2,	3,	1,	2,	3,	4,	2,	3],	#CE2
		[5,	6,	5,	6,	4,	5,	3,	4,	4,	2,	3,	4,	1,	3,	4,	2,	0,	1,	3,	4,	1,	2,	2,	3],	#CE3
		[6,	7,	6,	7,	5,	6,	4,	5,	5,	3,	4,	5,	2,	4,	5,	3,	1,	0,	4,	5,	2,	3,	3,	4],	#HE3
		[6,	7,	6,	7,	5,	6,	4,	5,	5,	3,	3,	4,	2,	2,	3,	1,	3,	4,	0,	1,	2,	3,	1,	2],	#CZ2
		[7,	8,	7,	8,	6,	7,	5,	6,	6,	4,	4,	5,	3,	3,	4,	2,	4,	5,	1,	0,	3,	4,	2,	3],	#HZ2
		[6,	7,	6,	7,	5,	6,	4,	5,	5,	3,	4,	5,	2,	4,	5,	3,	1,	2,	2,	3,	0,	1,	1,	2],	#CZ3
		[7,	8,	7,	8,	6,	7,	5,	6,	6,	4,	5,	6,	3,	5,	6,	4,	2,	3,	3,	4,	1,	0,	2,	3],	#HZ3
		[7,	8,	7,	8,	6,	7,	5,	6,	6,	4,	5,	6,	3,	3,	4,	2,	2,	3,	1,	2,	1,	2,	0,	1],	#CH2
		[8,	9,	8,	9,	7,	8,	6,	7,	7,	5,	6,	7,	4,	4,	5,	3,	3,	4,	2,	3,	2,	3,	1,	0]	#HH2
	]
}


