# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Contributor(s): Albert Ng 
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

from AminoAcid import AminoAcidInfo

class AAData(AminoAcidInfo):
	def __init__(self):
		self.data = data
		AminoAcidInfo.__init__(self, data['atomOrders']['trie'])

data = 		\
{
	'atomOrders' : 
	{
		'trie' : ['C',    'O',    'N',    'H',   'CA',   'HA',   'CB',   'HB',  'CG1', 
		          '1HG1', '2HG1', '3HG1', 'CG2', '1HG2', '2HG2', '3HG2'],

		'PDB'  : ['N',  'CA',   'C',    'O',    'CB',   'CG1',  'CG2',  'H',  'HA', 
		          'HB', '1HG1', '2HG1', '3HG1', '1HG2', '2HG2', '3HG2']                                 
	},

        'AA_class' : 17,

	'polar' : False, 

	'acceptors' : { 'O' : 'C' },

	'templateAtom' : 
	{
		'HA'   : [ 'CA',  'N',  'C'   ],
		'HB'   : [ 'CB',  'CA', 'CG1' ],
		'1HG1' : [ 'CG1', 'CB', 'CA'  ],
		'2HG1' : [ 'CG1', 'CB', 'CA'  ],
		'3HG1' : [ 'CG1', 'CB', 'CA'  ],
		'1HG2' : [ 'CG2', 'CB', 'CA'  ],
		'2HG2' : [ 'CG2', 'CB', 'CA'  ],
		'3HG2' : [ 'CG2', 'CB', 'CA'  ]
	},

	'chiDependent' :
	[
		[ 'CG1', 'CG2', 'HB', '1HG1', '2HG1', '3HG1', '1HG2', '2HG2', '3HG2' ]  
	],

	'chiAtoms' :
	[
		[ 'N', 'CA', 'CB', 'CG1' ]
	],

	'templateCoords' :
	{
		'N'    :  ( 0.0000  , 17.5010 , 61.8970 )  , 
		'CA'   :  ( 0.0000  , 16.7860 , 63.1670 )  , 
		'C'    :  ( 0.0000  , 17.7530 , 64.3440 )  , 
		'O'    :  ( -0.0020 , 18.9700 , 64.1600 )  , 
		'CB'   :  ( 1.2150  , 15.8470 , 63.2870 )  , 
		'CG1'  :  ( 1.1920  , 15.1140 , 64.6200 )  , 
		'CG2'  :  ( 1.2370  , 14.8540 , 62.1350 )  , 
		'H'    :  ( 0.0310  , 18.5100 , 61.9150 )  , 
		'HA'   :  ( -0.9090 , 16.1960 , 63.2900 )  , 
		'HB'   :  ( 2.1280  , 16.4380 , 63.2130 )  , 
		'1HG1' :  ( 2.0580  , 14.4550 , 64.6880 )  , 
		'2HG1' :  ( 1.2230  , 15.8380 , 65.4340 )  , 
		'3HG1' :  ( 0.2800  , 14.5220 , 64.6940 )  , 
		'1HG2' :  ( 2.1020  , 14.1990 , 62.2350 )  , 
		'2HG2' :  ( 0.3250  , 14.2570 , 62.1530 )  , 
		'3HG2' :  ( 1.2990  , 15.3940 , 61.1900 )   
	},

	'centroidAtoms' : [ 'CB', 'CG1', 'CG2' ],

	'neighborAtom' : 'CB',
	
	'bondLengths' : 
	[	#C	O	N	H	CA	HA	CB	HB	CG1	1HG1	2HG1	3HG1	CG2	1HG2	2HG2	3HG2
		[0,	1,	2,	3,	1,	2,	2,	3,	3,	4,	4,	4,	3,	4,	4,	4],	#C
		[1,	0,	3,	4,	2,	3,	3,	4,	4,	5,	5,	5,	4,	5,	5,	5],	#O
		[2,	3,	0,	1,	1,	2,	2,	3,	3,	4,	4,	4,	3,	4,	4,	4],	#N
		[3,	4,	1,	0,	2,	3,	3,	4,	4,	5,	5,	5,	4,	5,	5,	5],	#H
		[1,	2,	1,	2,	0,	1,	1,	2,	2,	3,	3,	3,	2,	3,	3,	3],	#CA
		[2,	3,	2,	3,	1,	0,	2,	3,	3,	4,	4,	4,	3,	4,	4,	4],	#HA
		[2,	3,	2,	3,	1,	2,	0,	1,	1,	2,	2,	2,	1,	2,	2,	2],	#CB
		[3,	4,	3,	4,	2,	3,	1,	0,	2,	3,	3,	3,	2,	3,	3,	3],	#HB
		[3,	4,	3,	4,	2,	3,	1,	2,	0,	1,	1,	1,	2,	3,	3,	3],	#CG1
		[4,	5,	4,	5,	3,	4,	2,	3,	1,	0,	2,	2,	3,	4,	4,	4],	#1HG1
		[4,	5,	4,	5,	3,	4,	2,	3,	1,	2,	0,	2,	3,	4,	4,	4],	#2HG1
		[4,	5,	4,	5,	3,	4,	2,	3,	1,	2,	2,	0,	3,	4,	4,	4],	#3HG1
		[3,	4,	3,	4,	2,	3,	1,	2,	2,	3,	3,	3,	0,	1,	1,	1],	#CG2
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	4,	4,	4,	1,	0,	2,	2],	#1HG2
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	4,	4,	4,	1,	2,	0,	2],	#2HG2
		[4,	5,	4,	5,	3,	4,	2,	3,	3,	4,	4,	4,	1,	2,	2,	0]	#3HG2
	]
}


