# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

import rosetta

class AtomType:
	def __init__(self, type_lst):
		# required fields (see rosetta.py for details)
		self.name = 'Hybridization'
		self.enumFn = lambda x: x
		self.enumName = 'HYBRIDIZATION'
		self.types = dict( [(type, []) for type in type_list] )
		self.typeList = type_list

		for aa, data in rosetta.type_data.items():
			for atom, type in data.items():
				self.types[ type_data[type] ].append(aa + ':' + atom)

type_list =		\
[
	'SP2',
	'SP3',
	'RING',
	'H'
]

type_data =		\
{	
	'CNH2':  'SP2',
	'COO': 	 'SP2',
	'CH1': 	 'SP3',
	'CH2': 	 'SP3',
	'CH3': 	 'SP3',
	'ARO_C': 'SP2',
	'TRP_N': 'SP2',
	'HIS_N': 'RING',
	'H2O_N': 'SP2',
	'LYS_N': 'SP3',
	'ARG_N': 'SP2',
	'PRO_N': 'SP2',
	'OH':	 'SP3',
	'ONH2':	 'SP2',
	'OOC': 	 'SP2',
	'S': 	 'SP3',
	'BB_N':  'SP2',
	'BB_CA': 'SP3',
	'BB_CO': 'SP2',
	'BB_OC': 'SP2',
	'PHOS':  'SP3',
	'POL_H': 'H',
	'APO_H': 'H',
	'ARO_H': 'H',
	'BB_HN': 'H',
	'H2O': 	 'SP3' 
}



