# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 


class AtomType:
	def __init__(self, type_lst):
		# the following are the required fields

		# the name of the type system (must be a valid C++ symbol)
		self.name = 'Raw'

		# if the names of the types are not valid C++ symbols, this must be
		# a function that turns them into valid ones
		self.enumFn = lambda x: '_'.join(x.split(':'))

		# the name of the type system in a form that looks like a constant
		# in an enumeration
		self.enumName = 'RAW_TYPE'

		# a map that goes from each type in type_list, to a list of raw types
		# (the raw types being strings in the form AA:ATOM)
		self.types = dict( [(type, [type]) for type in type_lst] )

		# the list of types in this system. This defines the order in which
		# data tables and such have the types
		self.typeList = type_lst


