// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

	blitz::Array<FLOAT,3> const& GetLJAttractiveTable() const { return LJAttractiveTable_; }
	blitz::Array<FLOAT,3> const& GetLJRepulsiveTable() const { return LJRepulsiveTable_; }
	blitz::Array<FLOAT,3> const& GetSolvationTable1() const { return SolvationTable1_; }
	blitz::Array<FLOAT,3> const& GetSolvationTable2() const { return SolvationTable2_; }
	blitz::Array<FLOAT,2> const& GetCountPairTable() const { return CountPairTable_; }
	blitz::Array<FLOAT,2> const& GetPairCutoffTable() const { return PairCutoffTable_; }
	blitz::Array<FLOAT,2> const& GetHB_AHTable() const { return HB_AHTable_; }
	blitz::Array<FLOAT,2> const& GetHB_XDTable() const { return HB_XDTable_; }
	blitz::Array<FLOAT,2> const& GetHB_XHTable() const { return HB_XHTable_; }
	blitz::Array<FLOAT,5> const& GetPairLikelihoodTable() const { return PairLikelihoodTable_; }
	blitz::Array<FLOAT,1> const& GetBBStrainWeight() const { return BBStrainWeight_; }
	blitz::Array<FLOAT,3> const& GetAAProbabilityByAngle() const { return AAProbabilityByAngle_; }
	blitz::Array<FLOAT,1> const& GetAAProbability() const { return AAProbability_; }
	blitz::Array<FLOAT,3> const& GetIntraRes_CountPair() const { return IntraRes_CountPair_; }
	blitz::Array<FLOAT,2> const& GetOPLSaa_chargeTable() const { return OPLSaa_chargeTable_; }
	blitz::Array<FLOAT,3> const& GetOPLSaa_vdwTable() const { return OPLSaa_vdwTable_; }
	blitz::Array<FLOAT,2> const& GetOPLSaa_BondStretchTable() const { return OPLSaa_BondStretchTable_; }
	blitz::Array<FLOAT,2> const& GetOPLSaa_AngleBendTable() const { return OPLSaa_AngleBendTable_; }
	blitz::Array<FLOAT,2> const& GetOPLSaa_TorsionTable() const { return OPLSaa_TorsionTable_; }
	blitz::Array<FLOAT,2> const& GetOPLSaa_ImptorsTable() const { return OPLSaa_ImptorsTable_; }
	void SetLJAttractiveTable(blitz::Array<FLOAT,3> const& value) { LJAttractiveTable_ = value; }
	void SetLJRepulsiveTable(blitz::Array<FLOAT,3> const& value) { LJRepulsiveTable_ = value; }
	void SetSolvationTable1(blitz::Array<FLOAT,3> const& value) { SolvationTable1_ = value; }
	void SetSolvationTable2(blitz::Array<FLOAT,3> const& value) { SolvationTable2_ = value; }
	void SetCountPairTable(blitz::Array<FLOAT,2> const& value) { CountPairTable_ = value; }
	void SetPairCutoffTable(blitz::Array<FLOAT,2> const& value) { PairCutoffTable_ = value; }
	void SetHB_AHTable(blitz::Array<FLOAT,2> const& value) { HB_AHTable_ = value; }
	void SetHB_XDTable(blitz::Array<FLOAT,2> const& value) { HB_XDTable_ = value; }
	void SetHB_XHTable(blitz::Array<FLOAT,2> const& value) { HB_XHTable_ = value; }
	void SetPairLikelihoodTable(blitz::Array<FLOAT,5> const& value) { PairLikelihoodTable_ = value; }
	void SetBBStrainWeight(blitz::Array<FLOAT,1> const& value) { BBStrainWeight_ = value; }
	void SetAAProbabilityByAngle(blitz::Array<FLOAT,3> const& value) { AAProbabilityByAngle_ = value; }
	void SetAAProbability(blitz::Array<FLOAT,1> const& value) { AAProbability_ = value; }
	void SetIntraRes_CountPair(blitz::Array<FLOAT,3> const& value) { IntraRes_CountPair_ = value; }
	void SetOPLSaa_chargeTable(blitz::Array<FLOAT,2> const& value) { OPLSaa_chargeTable_ = value; }
	void SetOPLSaa_vdwTable(blitz::Array<FLOAT,3> const& value) { OPLSaa_vdwTable_ = value; }
	void SetOPLSaa_BondStretchTable(blitz::Array<FLOAT,2> const& value) { OPLSaa_BondStretchTable_ = value; }
	void SetOPLSaa_AngleBendTable(blitz::Array<FLOAT,2> const& value) { OPLSaa_AngleBendTable_ = value; }
	void SetOPLSaa_TorsionTable(blitz::Array<FLOAT,2> const& value) { OPLSaa_TorsionTable_ = value; }
	void SetOPLSaa_ImptorsTable(blitz::Array<FLOAT,2> const& value) { OPLSaa_ImptorsTable_ = value; }
private:
	blitz::Array<FLOAT,3> LJAttractiveTable_;
	blitz::Array<FLOAT,3> LJRepulsiveTable_;
	blitz::Array<FLOAT,3> SolvationTable1_;
	blitz::Array<FLOAT,3> SolvationTable2_;
	blitz::Array<FLOAT,2> CountPairTable_;
	blitz::Array<FLOAT,2> PairCutoffTable_;
	blitz::Array<FLOAT,2> HB_AHTable_;
	blitz::Array<FLOAT,2> HB_XDTable_;
	blitz::Array<FLOAT,2> HB_XHTable_;
	blitz::Array<FLOAT,5> PairLikelihoodTable_;
	blitz::Array<FLOAT,1> BBStrainWeight_;
	blitz::Array<FLOAT,3> AAProbabilityByAngle_;
	blitz::Array<FLOAT,1> AAProbability_;
	blitz::Array<FLOAT,3> IntraRes_CountPair_;
	blitz::Array<FLOAT,2> OPLSaa_chargeTable_;
	blitz::Array<FLOAT,3> OPLSaa_vdwTable_;
	blitz::Array<FLOAT,2> OPLSaa_BondStretchTable_;
	blitz::Array<FLOAT,2> OPLSaa_AngleBendTable_;
	blitz::Array<FLOAT,2> OPLSaa_TorsionTable_;
	blitz::Array<FLOAT,2> OPLSaa_ImptorsTable_;

