// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

#include "stdafx.h"
#include "runtime_stats.h"

///////////////////////////////////////////////////////////////////////////
//////                         CONSTRUCTORS                         ///////
///////////////////////////////////////////////////////////////////////////

RuntimeStats::Pointer RuntimeStats::Create()
{
	return RuntimeStats::Pointer( new RuntimeStats() );
}

RuntimeStats::RuntimeStats()
{
	ResetCount(RSTATS_ALL);
}

///////////////////////////////////////////////////////////////////////////
//////                       PUBLIC INTERFACE                       ///////
///////////////////////////////////////////////////////////////////////////

void RuntimeStats::ResetCount( RuntimeStatType type /*= RSTATS_ALL*/ )
{
	if (type != RSTATS_ALL)
		data_[type] = 0;
	else
	{
		for (int i = 0; i < N_STAT_TYPES; ++i)
			data_[i] = 0;
	}
}

unsigned long long RuntimeStats::Get( RuntimeStatType type ) const
{
	return data_[type];
}

double RuntimeStats::GetTotalWork() const
{
	return 	data_[0] * 4.848e-8 +
		data_[1] * 1.548e-7 +
		data_[2] * 8.549e-7 +
		data_[3] * 9.810e-6 +
		data_[4] * 1.114e-8;
}


