// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Contributor(s): Albert Ng 
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

#ifndef ATOM_TYPE_TABLES_H
#define ATOM_TYPE_TABLES_H

#include "general.h"

//bond stretch interaction type tuples
const blitz::TinyVector<int, 2> bondstretch_tuples[] =
{
	blitz::TinyVector<int, 2>(0,0),
	blitz::TinyVector<int, 2>(0,1),
	blitz::TinyVector<int, 2>(0,2),
	blitz::TinyVector<int, 2>(0,4),
	blitz::TinyVector<int, 2>(0,6),
	blitz::TinyVector<int, 2>(0,7),
	blitz::TinyVector<int, 2>(0,8),
	blitz::TinyVector<int, 2>(0,10),
	blitz::TinyVector<int, 2>(0,12),
	blitz::TinyVector<int, 2>(0,14),
	blitz::TinyVector<int, 2>(0,16),
	blitz::TinyVector<int, 2>(0,18),
	blitz::TinyVector<int, 2>(0,20),
	blitz::TinyVector<int, 2>(0,25),
	blitz::TinyVector<int, 2>(0,26),
	blitz::TinyVector<int, 2>(0,28),
	blitz::TinyVector<int, 2>(1,28),
	blitz::TinyVector<int, 2>(2,2),
	blitz::TinyVector<int, 2>(2,3),
	blitz::TinyVector<int, 2>(2,6),
	blitz::TinyVector<int, 2>(2,20),
	blitz::TinyVector<int, 2>(2,21),
	blitz::TinyVector<int, 2>(2,22),
	blitz::TinyVector<int, 2>(2,23),
	blitz::TinyVector<int, 2>(3,24),
	blitz::TinyVector<int, 2>(3,25),
	blitz::TinyVector<int, 2>(3,26),
	blitz::TinyVector<int, 2>(4,5),
	blitz::TinyVector<int, 2>(5,6),
	blitz::TinyVector<int, 2>(7,9),
	blitz::TinyVector<int, 2>(8,8),
	blitz::TinyVector<int, 2>(10,11),
	blitz::TinyVector<int, 2>(10,12),
	blitz::TinyVector<int, 2>(12,13),
	blitz::TinyVector<int, 2>(12,28),
	blitz::TinyVector<int, 2>(13,23),
	blitz::TinyVector<int, 2>(14,15),
	blitz::TinyVector<int, 2>(16,17),
	blitz::TinyVector<int, 2>(17,18),
	blitz::TinyVector<int, 2>(18,19),
	blitz::TinyVector<int, 2>(20,21),
	blitz::TinyVector<int, 2>(21,22),
	blitz::TinyVector<int, 2>(22,23),
	blitz::TinyVector<int, 2>(23,24),
	blitz::TinyVector<int, 2>(23,26),
	blitz::TinyVector<int, 2>(24,27),
	blitz::TinyVector<int, 2>(25,26),
	blitz::TinyVector<int, 2>(25,27),
	blitz::TinyVector<int, 2>(26,26),
};

//angle bend interaction type tuples
const blitz::TinyVector<int, 3> anglebend_tuples[] =
{
	blitz::TinyVector<int, 3>(0,0,0),
	blitz::TinyVector<int, 3>(0,0,1),
	blitz::TinyVector<int, 3>(0,0,2),
	blitz::TinyVector<int, 3>(0,0,4),
	blitz::TinyVector<int, 3>(0,0,7),
	blitz::TinyVector<int, 3>(0,0,8),
	blitz::TinyVector<int, 3>(0,0,10),
	blitz::TinyVector<int, 3>(0,0,12),
	blitz::TinyVector<int, 3>(0,0,14),
	blitz::TinyVector<int, 3>(0,0,16),
	blitz::TinyVector<int, 3>(0,0,18),
	blitz::TinyVector<int, 3>(0,0,20),
	blitz::TinyVector<int, 3>(0,0,25),
	blitz::TinyVector<int, 3>(0,0,26),
	blitz::TinyVector<int, 3>(0,0,28),
	blitz::TinyVector<int, 3>(1,0,1),
	blitz::TinyVector<int, 3>(1,0,2),
	blitz::TinyVector<int, 3>(1,0,4),
	blitz::TinyVector<int, 3>(1,0,6),
	blitz::TinyVector<int, 3>(1,0,7),
	blitz::TinyVector<int, 3>(1,0,8),
	blitz::TinyVector<int, 3>(1,0,10),
	blitz::TinyVector<int, 3>(1,0,12),
	blitz::TinyVector<int, 3>(1,0,14),
	blitz::TinyVector<int, 3>(1,0,16),
	blitz::TinyVector<int, 3>(1,0,18),
	blitz::TinyVector<int, 3>(1,0,20),
	blitz::TinyVector<int, 3>(1,0,25),
	blitz::TinyVector<int, 3>(1,0,26),
	blitz::TinyVector<int, 3>(1,0,28),
	blitz::TinyVector<int, 3>(10,0,12),
	blitz::TinyVector<int, 3>(10,0,16),
	blitz::TinyVector<int, 3>(12,0,14),
	blitz::TinyVector<int, 3>(14,0,16),
	blitz::TinyVector<int, 3>(0,2,2),
	blitz::TinyVector<int, 3>(2,2,2),
	blitz::TinyVector<int, 3>(2,2,3),
	blitz::TinyVector<int, 3>(2,2,6),
	blitz::TinyVector<int, 3>(2,2,21),
	blitz::TinyVector<int, 3>(2,2,22),
	blitz::TinyVector<int, 3>(3,2,20),
	blitz::TinyVector<int, 3>(3,2,21),
	blitz::TinyVector<int, 3>(3,2,22),
	blitz::TinyVector<int, 3>(3,2,23),
	blitz::TinyVector<int, 3>(20,2,23),
	blitz::TinyVector<int, 3>(0,4,5),
	blitz::TinyVector<int, 3>(0,6,5),
	blitz::TinyVector<int, 3>(2,6,5),
	blitz::TinyVector<int, 3>(0,7,9),
	blitz::TinyVector<int, 3>(0,8,0),
	blitz::TinyVector<int, 3>(0,8,8),
	blitz::TinyVector<int, 3>(0,10,11),
	blitz::TinyVector<int, 3>(0,10,12),
	blitz::TinyVector<int, 3>(11,10,12),
	blitz::TinyVector<int, 3>(0,12,0),
	blitz::TinyVector<int, 3>(0,12,10),
	blitz::TinyVector<int, 3>(0,12,13),
	blitz::TinyVector<int, 3>(0,12,28),
	blitz::TinyVector<int, 3>(10,12,13),
	blitz::TinyVector<int, 3>(10,12,28),
	blitz::TinyVector<int, 3>(13,12,13),
	blitz::TinyVector<int, 3>(0,14,15),
	blitz::TinyVector<int, 3>(15,14,15),
	blitz::TinyVector<int, 3>(0,16,0),
	blitz::TinyVector<int, 3>(0,16,17),
	blitz::TinyVector<int, 3>(17,16,17),
	blitz::TinyVector<int, 3>(0,18,17),
	blitz::TinyVector<int, 3>(0,18,19),
	blitz::TinyVector<int, 3>(17,18,17),
	blitz::TinyVector<int, 3>(17,18,19),
	blitz::TinyVector<int, 3>(18,19,18),
	blitz::TinyVector<int, 3>(0,20,2),
	blitz::TinyVector<int, 3>(0,20,21),
	blitz::TinyVector<int, 3>(2,20,21),
	blitz::TinyVector<int, 3>(2,21,20),
	blitz::TinyVector<int, 3>(2,21,22),
	blitz::TinyVector<int, 3>(20,21,22),
	blitz::TinyVector<int, 3>(2,22,21),
	blitz::TinyVector<int, 3>(2,22,23),
	blitz::TinyVector<int, 3>(21,22,23),
	blitz::TinyVector<int, 3>(2,23,13),
	blitz::TinyVector<int, 3>(2,23,22),
	blitz::TinyVector<int, 3>(13,23,22),
	blitz::TinyVector<int, 3>(13,23,24),
	blitz::TinyVector<int, 3>(13,23,26),
	blitz::TinyVector<int, 3>(24,23,26),
	blitz::TinyVector<int, 3>(3,24,23),
	blitz::TinyVector<int, 3>(3,24,27),
	blitz::TinyVector<int, 3>(23,24,23),
	blitz::TinyVector<int, 3>(23,24,27),
	blitz::TinyVector<int, 3>(0,25,26),
	blitz::TinyVector<int, 3>(3,25,26),
	blitz::TinyVector<int, 3>(0,25,27),
	blitz::TinyVector<int, 3>(3,25,27),
	blitz::TinyVector<int, 3>(26,25,27),
	blitz::TinyVector<int, 3>(0,26,23),
	blitz::TinyVector<int, 3>(0,26,25),
	blitz::TinyVector<int, 3>(0,26,26),
	blitz::TinyVector<int, 3>(3,26,23),
	blitz::TinyVector<int, 3>(3,26,25),
	blitz::TinyVector<int, 3>(3,26,26),
	blitz::TinyVector<int, 3>(23,26,25),
	blitz::TinyVector<int, 3>(23,26,26),
	blitz::TinyVector<int, 3>(24,27,25),
	blitz::TinyVector<int, 3>(0,28,1),
	blitz::TinyVector<int, 3>(0,28,12),
	blitz::TinyVector<int, 3>(1,28,1),
	blitz::TinyVector<int, 3>(1,28,12),
};

//improper torsion interaction type tuples
const blitz::TinyVector<int, 4> imptors_tuples[] =
{
	blitz::TinyVector<int, 4>(2,2,2,0),
	blitz::TinyVector<int, 4>(2,2,2,3),
	blitz::TinyVector<int, 4>(2,2,2,6),
	blitz::TinyVector<int, 4>(2,22,2,3),
	blitz::TinyVector<int, 4>(21,2,2,3),
	blitz::TinyVector<int, 4>(23,20,2,3),
	blitz::TinyVector<int, 4>(12,0,10,11),
	blitz::TinyVector<int, 4>(0,10,12,13),
	blitz::TinyVector<int, 4>(0,10,12,28),
	blitz::TinyVector<int, 4>(13,10,12,13),
	blitz::TinyVector<int, 4>(15,0,14,15),
	blitz::TinyVector<int, 4>(0,19,18,17),
	blitz::TinyVector<int, 4>(17,19,18,17),
	blitz::TinyVector<int, 4>(18,18,19,18),
	blitz::TinyVector<int, 4>(21,2,20,0),
	blitz::TinyVector<int, 4>(20,2,21,22),
	blitz::TinyVector<int, 4>(23,21,22,2),
	blitz::TinyVector<int, 4>(22,2,23,13),
	blitz::TinyVector<int, 4>(26,24,23,13),
	blitz::TinyVector<int, 4>(23,23,24,3),
	blitz::TinyVector<int, 4>(23,27,24,3),
	blitz::TinyVector<int, 4>(26,27,25,0),
	blitz::TinyVector<int, 4>(26,27,25,3),
	blitz::TinyVector<int, 4>(23,25,26,0),
	blitz::TinyVector<int, 4>(23,25,26,3),
	blitz::TinyVector<int, 4>(23,26,26,0),
	blitz::TinyVector<int, 4>(23,26,26,3)
};

//proper torsion interaction type tuples
const blitz::TinyVector<int, 4> torsion_tuples[] =
{
	blitz::TinyVector<int, 4>(0,0,0,0),
	blitz::TinyVector<int, 4>(0,0,0,1),
	blitz::TinyVector<int, 4>(0,0,0,8),
	blitz::TinyVector<int, 4>(0,0,0,10),
	blitz::TinyVector<int, 4>(0,0,0,12),
	blitz::TinyVector<int, 4>(0,0,0,14),
	blitz::TinyVector<int, 4>(0,0,0,16),
	blitz::TinyVector<int, 4>(0,0,0,18),
	blitz::TinyVector<int, 4>(0,0,0,28),
	blitz::TinyVector<int, 4>(1,0,0,1),
	blitz::TinyVector<int, 4>(1,0,0,2),
	blitz::TinyVector<int, 4>(1,0,0,4),
	blitz::TinyVector<int, 4>(1,0,0,7),
	blitz::TinyVector<int, 4>(1,0,0,8),
	blitz::TinyVector<int, 4>(1,0,0,10),
	blitz::TinyVector<int, 4>(1,0,0,12),
	blitz::TinyVector<int, 4>(1,0,0,14),
	blitz::TinyVector<int, 4>(1,0,0,16),
	blitz::TinyVector<int, 4>(1,0,0,18),
	blitz::TinyVector<int, 4>(1,0,0,20),
	blitz::TinyVector<int, 4>(1,0,0,25),
	blitz::TinyVector<int, 4>(1,0,0,26),
	blitz::TinyVector<int, 4>(1,0,0,28),
	blitz::TinyVector<int, 4>(2,0,0,10),
	blitz::TinyVector<int, 4>(2,0,0,12),
	blitz::TinyVector<int, 4>(2,0,0,14),
	blitz::TinyVector<int, 4>(2,0,0,16),
	blitz::TinyVector<int, 4>(4,0,0,10),
	blitz::TinyVector<int, 4>(4,0,0,12),
	blitz::TinyVector<int, 4>(4,0,0,14),
	blitz::TinyVector<int, 4>(4,0,0,16),
	blitz::TinyVector<int, 4>(7,0,0,10),
	blitz::TinyVector<int, 4>(7,0,0,12),
	blitz::TinyVector<int, 4>(7,0,0,14),
	blitz::TinyVector<int, 4>(7,0,0,16),
	blitz::TinyVector<int, 4>(8,0,0,10),
	blitz::TinyVector<int, 4>(8,0,0,12),
	blitz::TinyVector<int, 4>(8,0,0,14),
	blitz::TinyVector<int, 4>(8,0,0,16),
	blitz::TinyVector<int, 4>(10,0,0,10),
	blitz::TinyVector<int, 4>(10,0,0,12),
	blitz::TinyVector<int, 4>(10,0,0,14),
	blitz::TinyVector<int, 4>(10,0,0,16),
	blitz::TinyVector<int, 4>(10,0,0,20),
	blitz::TinyVector<int, 4>(10,0,0,25),
	blitz::TinyVector<int, 4>(10,0,0,26),
	blitz::TinyVector<int, 4>(12,0,0,14),
	blitz::TinyVector<int, 4>(12,0,0,20),
	blitz::TinyVector<int, 4>(12,0,0,25),
	blitz::TinyVector<int, 4>(12,0,0,26),
	blitz::TinyVector<int, 4>(14,0,0,14),
	blitz::TinyVector<int, 4>(14,0,0,16),
	blitz::TinyVector<int, 4>(14,0,0,20),
	blitz::TinyVector<int, 4>(14,0,0,25),
	blitz::TinyVector<int, 4>(14,0,0,26),
	blitz::TinyVector<int, 4>(16,0,0,20),
	blitz::TinyVector<int, 4>(16,0,0,25),
	blitz::TinyVector<int, 4>(16,0,0,26),
	blitz::TinyVector<int, 4>(0,0,2,2),
	blitz::TinyVector<int, 4>(1,0,2,2),
	blitz::TinyVector<int, 4>(0,0,4,5),
	blitz::TinyVector<int, 4>(1,0,4,5),
	blitz::TinyVector<int, 4>(1,0,6,5),
	blitz::TinyVector<int, 4>(0,0,7,9),
	blitz::TinyVector<int, 4>(1,0,7,9),
	blitz::TinyVector<int, 4>(0,0,8,0),
	blitz::TinyVector<int, 4>(0,0,8,8),
	blitz::TinyVector<int, 4>(1,0,8,0),
	blitz::TinyVector<int, 4>(1,0,8,8),
	blitz::TinyVector<int, 4>(0,0,10,11),
	blitz::TinyVector<int, 4>(0,0,10,12),
	blitz::TinyVector<int, 4>(1,0,10,11),
	blitz::TinyVector<int, 4>(1,0,10,12),
	blitz::TinyVector<int, 4>(12,0,10,11),
	blitz::TinyVector<int, 4>(12,0,10,12),
	blitz::TinyVector<int, 4>(16,0,10,11),
	blitz::TinyVector<int, 4>(16,0,10,12),
	blitz::TinyVector<int, 4>(0,0,12,10),
	blitz::TinyVector<int, 4>(0,0,12,13),
	blitz::TinyVector<int, 4>(0,0,12,28),
	blitz::TinyVector<int, 4>(1,0,12,0),
	blitz::TinyVector<int, 4>(1,0,12,10),
	blitz::TinyVector<int, 4>(1,0,12,13),
	blitz::TinyVector<int, 4>(1,0,12,28),
	blitz::TinyVector<int, 4>(10,0,12,10),
	blitz::TinyVector<int, 4>(10,0,12,13),
	blitz::TinyVector<int, 4>(10,0,12,28),
	blitz::TinyVector<int, 4>(14,0,12,10),
	blitz::TinyVector<int, 4>(14,0,12,13),
	blitz::TinyVector<int, 4>(14,0,12,28),
	blitz::TinyVector<int, 4>(0,0,14,15),
	blitz::TinyVector<int, 4>(1,0,14,15),
	blitz::TinyVector<int, 4>(12,0,14,15),
	blitz::TinyVector<int, 4>(16,0,14,15),
	blitz::TinyVector<int, 4>(0,0,16,0),
	blitz::TinyVector<int, 4>(0,0,16,17),
	blitz::TinyVector<int, 4>(1,0,16,0),
	blitz::TinyVector<int, 4>(1,0,16,17),
	blitz::TinyVector<int, 4>(10,0,16,0),
	blitz::TinyVector<int, 4>(10,0,16,17),
	blitz::TinyVector<int, 4>(14,0,16,0),
	blitz::TinyVector<int, 4>(14,0,16,17),
	blitz::TinyVector<int, 4>(0,0,18,17),
	blitz::TinyVector<int, 4>(0,0,18,19),
	blitz::TinyVector<int, 4>(1,0,18,17),
	blitz::TinyVector<int, 4>(1,0,18,19),
	blitz::TinyVector<int, 4>(0,0,20,2),
	blitz::TinyVector<int, 4>(0,0,20,21),
	blitz::TinyVector<int, 4>(1,0,20,2),
	blitz::TinyVector<int, 4>(1,0,20,21),
	blitz::TinyVector<int, 4>(0,0,25,26),
	blitz::TinyVector<int, 4>(0,0,25,27),
	blitz::TinyVector<int, 4>(1,0,25,26),
	blitz::TinyVector<int, 4>(1,0,25,27),
	blitz::TinyVector<int, 4>(0,0,26,23),
	blitz::TinyVector<int, 4>(0,0,26,25),
	blitz::TinyVector<int, 4>(0,0,26,26),
	blitz::TinyVector<int, 4>(1,0,26,23),
	blitz::TinyVector<int, 4>(1,0,26,25),
	blitz::TinyVector<int, 4>(1,0,26,26),
	blitz::TinyVector<int, 4>(0,0,28,1),
	blitz::TinyVector<int, 4>(0,0,28,12),
	blitz::TinyVector<int, 4>(1,0,28,1),
	blitz::TinyVector<int, 4>(1,0,28,12),
	blitz::TinyVector<int, 4>(0,2,2,2),
	blitz::TinyVector<int, 4>(0,2,2,3),
	blitz::TinyVector<int, 4>(2,2,2,2),
	blitz::TinyVector<int, 4>(2,2,2,3),
	blitz::TinyVector<int, 4>(2,2,2,6),
	blitz::TinyVector<int, 4>(2,2,2,21),
	blitz::TinyVector<int, 4>(2,2,2,22),
	blitz::TinyVector<int, 4>(3,2,2,3),
	blitz::TinyVector<int, 4>(3,2,2,6),
	blitz::TinyVector<int, 4>(3,2,2,21),
	blitz::TinyVector<int, 4>(3,2,2,22),
	blitz::TinyVector<int, 4>(2,2,6,5),
	blitz::TinyVector<int, 4>(3,2,20,0),
	blitz::TinyVector<int, 4>(3,2,20,21),
	blitz::TinyVector<int, 4>(23,2,20,0),
	blitz::TinyVector<int, 4>(23,2,20,21),
	blitz::TinyVector<int, 4>(2,2,21,20),
	blitz::TinyVector<int, 4>(2,2,21,22),
	blitz::TinyVector<int, 4>(2,2,22,21),
	blitz::TinyVector<int, 4>(2,2,22,23),
	blitz::TinyVector<int, 4>(3,2,21,20),
	blitz::TinyVector<int, 4>(3,2,21,22),
	blitz::TinyVector<int, 4>(3,2,22,21),
	blitz::TinyVector<int, 4>(3,2,22,23),
	blitz::TinyVector<int, 4>(3,2,23,13),
	blitz::TinyVector<int, 4>(3,2,23,22),
	blitz::TinyVector<int, 4>(20,2,23,13),
	blitz::TinyVector<int, 4>(20,2,23,22),
	blitz::TinyVector<int, 4>(0,8,17,0),
	blitz::TinyVector<int, 4>(0,10,12,0),
	blitz::TinyVector<int, 4>(0,10,12,13),
	blitz::TinyVector<int, 4>(0,10,12,28),
	blitz::TinyVector<int, 4>(11,10,12,0),
	blitz::TinyVector<int, 4>(11,10,12,13),
	blitz::TinyVector<int, 4>(11,10,12,28),
	blitz::TinyVector<int, 4>(0,12,28,0),
	blitz::TinyVector<int, 4>(0,12,28,1),
	blitz::TinyVector<int, 4>(10,12,28,0),
	blitz::TinyVector<int, 4>(10,12,28,1),
	blitz::TinyVector<int, 4>(0,18,19,18),
	blitz::TinyVector<int, 4>(17,18,19,18),
	blitz::TinyVector<int, 4>(0,20,21,2),
	blitz::TinyVector<int, 4>(0,20,21,22),
	blitz::TinyVector<int, 4>(2,20,21,2),
	blitz::TinyVector<int, 4>(2,20,21,22),
	blitz::TinyVector<int, 4>(2,21,22,2),
	blitz::TinyVector<int, 4>(2,21,22,23),
	blitz::TinyVector<int, 4>(20,21,22,2),
	blitz::TinyVector<int, 4>(20,21,22,23),
	blitz::TinyVector<int, 4>(2,22,23,2),
	blitz::TinyVector<int, 4>(2,22,23,13),
	blitz::TinyVector<int, 4>(21,22,23,2),
	blitz::TinyVector<int, 4>(21,22,23,13),
	blitz::TinyVector<int, 4>(13,23,24,3),
	blitz::TinyVector<int, 4>(13,23,24,23),
	blitz::TinyVector<int, 4>(13,23,24,27),
	blitz::TinyVector<int, 4>(26,23,24,3),
	blitz::TinyVector<int, 4>(26,23,24,23),
	blitz::TinyVector<int, 4>(26,23,24,27),
	blitz::TinyVector<int, 4>(13,23,26,0),
	blitz::TinyVector<int, 4>(13,23,26,3),
	blitz::TinyVector<int, 4>(13,23,26,25),
	blitz::TinyVector<int, 4>(13,23,26,26),
	blitz::TinyVector<int, 4>(24,23,26,0),
	blitz::TinyVector<int, 4>(24,23,26,3),
	blitz::TinyVector<int, 4>(24,23,26,25),
	blitz::TinyVector<int, 4>(24,23,26,26),
	blitz::TinyVector<int, 4>(3,24,27,25),
	blitz::TinyVector<int, 4>(23,24,27,25),
	blitz::TinyVector<int, 4>(0,25,26,3),
	blitz::TinyVector<int, 4>(0,25,26,23),
	blitz::TinyVector<int, 4>(3,25,26,0),
	blitz::TinyVector<int, 4>(3,25,26,3),
	blitz::TinyVector<int, 4>(3,25,26,23),
	blitz::TinyVector<int, 4>(27,25,26,0),
	blitz::TinyVector<int, 4>(27,25,26,3),
	blitz::TinyVector<int, 4>(27,25,26,23),
	blitz::TinyVector<int, 4>(0,25,27,24),
	blitz::TinyVector<int, 4>(3,25,27,24),
	blitz::TinyVector<int, 4>(26,25,27,24),
	blitz::TinyVector<int, 4>(0,26,26,3),
	blitz::TinyVector<int, 4>(0,26,26,23),
	blitz::TinyVector<int, 4>(3,26,26,23),
	blitz::TinyVector<int, 4>(23,26,26,23)
};

//tuple table sizes
const int bondstretch_size = sizeof bondstretch_tuples/sizeof bondstretch_tuples[0];
const int anglebend_size = sizeof anglebend_tuples/sizeof anglebend_tuples[0];
const int imptors_size = sizeof imptors_tuples/sizeof imptors_tuples[0];
const int torsion_size = sizeof torsion_tuples/sizeof torsion_tuples[0];

//obtains index of the given atom type tuples in the given table
//this index is used to look up the data tables for energy calculations
//checks both the forward and reverse order of the atom type tuples
template <typename TinyVecType>
inline int getIndex(const TinyVecType atomTypes[], TinyVecType atoms, const int size, bool reverseOrder)
{
	//check forward order
	for (int i = 0; i < size; i++)
	{
		bool isEqual = true;
		for (unsigned int j = 0; j < atoms.length(); j++)	
			if (atomTypes[i][j] != atoms[j])
				isEqual = false;
		if (isEqual == true)
			return i;
	}
	
	if (reverseOrder == true)
	{
		//check reverse order
		TinyVecType reverse;
		for (unsigned int i = 0; i < atoms.length(); i++)
			reverse[atoms.length() - i - 1] = atoms[i];
		for (int i = 0; i < size; i ++)
		{
			bool isEqual = true;
			for (unsigned int j = 0; j < reverse.length(); j++)
				if (atomTypes[i][j] != reverse[j])
					isEqual = false;
			if (isEqual == true)
				return i;
		}
	}
	
	return -1;
}

#endif


