// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Contributor(s): Albert Ng 
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

#ifndef OPLSAA_ENERGY_TERMS_H
#define OPLSAA_ENERGY_TERMS_H

#define N_PAIRWISE_ENERGY_TERMS 6
#define N_ONEBODY_ENERGY_TERMS 6

#include "general.h"

//Inter-residue energy terms
enum PairwiseEnergyTerm
{
	PTERM_COUL,			//electrostatics
	PTERM_LJ,			//Lennard-Jones
	PTERM_BS,			//bond stretching
	PTERM_AB,			//angle bending
	PTERM_TORS,			//torsion
	PTERM_IMPTORS			//improper torsion
};

//Intra-residue energy terms
enum OneBodyEnergyTerm
{
	OBTERM_COUL,			//electrostatics
	OBTERM_LJ,			//Lennard-Jones
	OBTERM_BS,			//bond stretching
	OBTERM_AB,			//angle bending
	OBTERM_TORS,			//torsion
	OBTERM_IMPTORS			//improper torsion
};

#endif

