// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Contributor(s): Cheng Hong 
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

#ifndef JP_CCD_H
#define JP_CCD_H

#include "general.h"
#include "system.h"

/** \file ccd.h
 *  \brief Contains object used to change cyclic coordinate descent (CCD) parameters.
 **/

struct DllExport CCDParameters {
	///// Default values
	int NUMCCDROUNDS;
	int dofweightedflag;
	int fray;
	int dt;
	FLOAT convergedalpha;
	FLOAT SSDconverge;
	CCDParameters() {
		NUMCCDROUNDS = 101;
		dofweightedflag = 1;
		fray = 2;
		dt = 60;
		convergedalpha = .05;
		SSDconverge = .0001;
	}
	//also the vector "dofweight"
}; 

System::Pointer DllExport RebuildLoopsCCD(System::ConstPointer system, std::vector<int> const& chainbreaks, CCDParameters const& parameters);

#endif


