// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "AminoAcid.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "amino_acid.h"

namespace bp = boost::python;

void register_AminoAcid_class(){

    { //::AminoAcid
        typedef bp::class_< AminoAcid > AminoAcid_exposer_t;
        AminoAcid_exposer_t AminoAcid_exposer = AminoAcid_exposer_t( "AminoAcid" );
        bp::scope AminoAcid_scope( AminoAcid_exposer );
        AminoAcid_exposer.def( bp::init< >() );
        { //::AminoAcid::getBondAngleAtoms
        
            typedef ::std::vector<blitz::TinyVector<int, 3>,std::allocator<blitz::TinyVector<int, 3> > > ( ::AminoAcid::*getBondAngleAtoms_function_type )(  ) const;
            
            AminoAcid_exposer.def( 
                "getBondAngleAtoms"
                , getBondAngleAtoms_function_type( &::AminoAcid::getBondAngleAtoms ) );
        
        }
        { //::AminoAcid::getImptorsAtoms
        
            typedef ::std::vector<blitz::TinyVector<int, 4>,std::allocator<blitz::TinyVector<int, 4> > > ( ::AminoAcid::*getImptorsAtoms_function_type )( ::boost::shared_ptr<AtomTypes const> ) const;
            
            AminoAcid_exposer.def( 
                "getImptorsAtoms"
                , getImptorsAtoms_function_type( &::AminoAcid::getImptorsAtoms )
                , ( bp::arg("atomTypes") ) );
        
        }
        { //::AminoAcid::getTorsionAtoms
        
            typedef ::std::vector<blitz::TinyVector<int, 4>,std::allocator<blitz::TinyVector<int, 4> > > ( ::AminoAcid::*getTorsionAtoms_function_type )(  ) const;
            
            AminoAcid_exposer.def( 
                "getTorsionAtoms"
                , getTorsionAtoms_function_type( &::AminoAcid::getTorsionAtoms ) );
        
        }
        { //::AminoAcid::indexOf
        
            typedef int ( ::AminoAcid::*indexOf_function_type )( int,::std::string const & ) const;
            
            AminoAcid_exposer.def( 
                "indexOf"
                , indexOf_function_type( &::AminoAcid::indexOf )
                , ( bp::arg("atomOrdering"), bp::arg("atom") ) );
        
        }
        AminoAcid_exposer.def_readwrite( "AA_class", &AminoAcid::AA_class );
        AminoAcid_exposer.def_readwrite( "_bool_vector_inst", &AminoAcid::_bool_vector_inst );
        AminoAcid_exposer.def_readwrite( "_str_vector_inst", &AminoAcid::_str_vector_inst );
        AminoAcid_exposer.def_readwrite( "acceptorBase", &AminoAcid::acceptorBase );
        AminoAcid_exposer.def_readwrite( "acceptorList", &AminoAcid::acceptorList );
        AminoAcid_exposer.def_readwrite( "aminoAcid", &AminoAcid::aminoAcid );
        AminoAcid_exposer.def_readwrite( "atomFlags", &AminoAcid::atomFlags );
        AminoAcid_exposer.def_readwrite( "atomOrders", &AminoAcid::atomOrders );
        AminoAcid_exposer.def_readwrite( "atomType", &AminoAcid::atomType );
        AminoAcid_exposer.def_readwrite( "bondLengths", &AminoAcid::bondLengths );
        AminoAcid_exposer.def_readwrite( "centroidAtoms", &AminoAcid::centroidAtoms );
        AminoAcid_exposer.def_readwrite( "chiAtoms", &AminoAcid::chiAtoms );
        AminoAcid_exposer.def_readwrite( "chiDependent", &AminoAcid::chiDependent );
        AminoAcid_exposer.def_readwrite( "nCentroidAtoms", &AminoAcid::nCentroidAtoms );
        AminoAcid_exposer.def_readwrite( "nChi", &AminoAcid::nChi );
        AminoAcid_exposer.def_readwrite( "nHBAcceptors", &AminoAcid::nHBAcceptors );
        AminoAcid_exposer.def_readwrite( "nHeavyAtoms", &AminoAcid::nHeavyAtoms );
        AminoAcid_exposer.def_readwrite( "nTotalAtoms", &AminoAcid::nTotalAtoms );
        AminoAcid_exposer.def_readwrite( "name3Char", &AminoAcid::name3Char );
        AminoAcid_exposer.def_readwrite( "neighborAtom", &AminoAcid::neighborAtom );
        AminoAcid_exposer.def_readwrite( "polar", &AminoAcid::polar );
        AminoAcid_exposer.def_readwrite( "templateAtom", &AminoAcid::templateAtom );
        AminoAcid_exposer.def_readwrite( "templateCoords", &AminoAcid::templateCoords );
        AminoAcid_exposer.def_readonly( "tg_IndexMap", &AminoAcid::tg_IndexMap );
        AminoAcid_exposer.def_readwrite( "topoGraph", &AminoAcid::topoGraph );
        bp::register_ptr_to_python< boost::shared_ptr< AminoAcid > >();
    }

}

