// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "DataDirectory.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "data_table.h"

namespace bp = boost::python;

void register_DataDirectory_class(){

    { //::DataDirectory
        typedef bp::class_< DataDirectory, boost::noncopyable > DataDirectory_exposer_t;
        DataDirectory_exposer_t DataDirectory_exposer = DataDirectory_exposer_t( "DataDirectory", bp::init< std::string const & >(( bp::arg("directoryFile") )) );
        bp::scope DataDirectory_scope( DataDirectory_exposer );
        { //::DataDirectory::Compile
        
            typedef void ( ::DataDirectory::*Compile_function_type )( ::std::string const & ) const;
            
            DataDirectory_exposer.def( 
                "Compile"
                , Compile_function_type( &::DataDirectory::Compile )
                , ( bp::arg("outputFileName") ) );
        
        }
        { //::DataDirectory::Create
        
            typedef ::boost::shared_ptr<DataDirectory> ( *Create_function_type )( ::std::string const & );
            
            DataDirectory_exposer.def( 
                "Create"
                , Create_function_type( &::DataDirectory::Create )
                , ( bp::arg("directoryFile") ) );
        
        }
        { //::DataDirectory::ReloadAllDataTables
        
            typedef void ( ::DataDirectory::*ReloadAllDataTables_function_type )(  ) ;
            
            DataDirectory_exposer.def( 
                "ReloadAllDataTables"
                , ReloadAllDataTables_function_type( &::DataDirectory::ReloadAllDataTables ) );
        
        }
        { //::DataDirectory::ReloadDataTable
        
            typedef void ( ::DataDirectory::*ReloadDataTable_function_type )( ::std::string const &,::std::string const & ) ;
            
            DataDirectory_exposer.def( 
                "ReloadDataTable"
                , ReloadDataTable_function_type( &::DataDirectory::ReloadDataTable )
                , ( bp::arg("tableName"), bp::arg("fileName")="" ) );
        
        }
        { //::DataDirectory::SetDirectoryFile
        
            typedef void ( ::DataDirectory::*SetDirectoryFile_function_type )( ::std::string const & ) ;
            
            DataDirectory_exposer.def( 
                "SetDirectoryFile"
                , SetDirectoryFile_function_type( &::DataDirectory::SetDirectoryFile )
                , ( bp::arg("fileName") ) );
        
        }
        DataDirectory_exposer.staticmethod( "Create" );
        { //property "LJAttractiveTable"[fget=::DataDirectory::GetLJAttractiveTable, fset=::DataDirectory::SetLJAttractiveTable]
        
            typedef ::blitz::Array<float, 3> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 3> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "LJAttractiveTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetLJAttractiveTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetLJAttractiveTable )
                , "get\\set property, built on top of \"blitz::Array<float, 3> const & DataDirectory::GetLJAttractiveTable() const [member function]\" and \"void DataDirectory::SetLJAttractiveTable(blitz::Array<float, 3> const & value) [member function]\"" );
        
        }
        { //property "LJRepulsiveTable"[fget=::DataDirectory::GetLJRepulsiveTable, fset=::DataDirectory::SetLJRepulsiveTable]
        
            typedef ::blitz::Array<float, 3> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 3> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "LJRepulsiveTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetLJRepulsiveTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetLJRepulsiveTable )
                , "get\\set property, built on top of \"blitz::Array<float, 3> const & DataDirectory::GetLJRepulsiveTable() const [member function]\" and \"void DataDirectory::SetLJRepulsiveTable(blitz::Array<float, 3> const & value) [member function]\"" );
        
        }
        { //property "SolvationTable1"[fget=::DataDirectory::GetSolvationTable1, fset=::DataDirectory::SetSolvationTable1]
        
            typedef ::blitz::Array<float, 3> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 3> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "SolvationTable1"
                , bp::make_function( 
                      fget( &::DataDirectory::GetSolvationTable1 )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetSolvationTable1 )
                , "get\\set property, built on top of \"blitz::Array<float, 3> const & DataDirectory::GetSolvationTable1() const [member function]\" and \"void DataDirectory::SetSolvationTable1(blitz::Array<float, 3> const & value) [member function]\"" );
        
        }
        { //property "SolvationTable2"[fget=::DataDirectory::GetSolvationTable2, fset=::DataDirectory::SetSolvationTable2]
        
            typedef ::blitz::Array<float, 3> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 3> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "SolvationTable2"
                , bp::make_function( 
                      fget( &::DataDirectory::GetSolvationTable2 )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetSolvationTable2 )
                , "get\\set property, built on top of \"blitz::Array<float, 3> const & DataDirectory::GetSolvationTable2() const [member function]\" and \"void DataDirectory::SetSolvationTable2(blitz::Array<float, 3> const & value) [member function]\"" );
        
        }
        { //property "CountPairTable"[fget=::DataDirectory::GetCountPairTable, fset=::DataDirectory::SetCountPairTable]
        
            typedef ::blitz::Array<float, 2> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 2> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "CountPairTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetCountPairTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetCountPairTable )
                , "get\\set property, built on top of \"blitz::Array<float, 2> const & DataDirectory::GetCountPairTable() const [member function]\" and \"void DataDirectory::SetCountPairTable(blitz::Array<float, 2> const & value) [member function]\"" );
        
        }
        { //property "PairCutoffTable"[fget=::DataDirectory::GetPairCutoffTable, fset=::DataDirectory::SetPairCutoffTable]
        
            typedef ::blitz::Array<float, 2> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 2> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "PairCutoffTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetPairCutoffTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetPairCutoffTable )
                , "get\\set property, built on top of \"blitz::Array<float, 2> const & DataDirectory::GetPairCutoffTable() const [member function]\" and \"void DataDirectory::SetPairCutoffTable(blitz::Array<float, 2> const & value) [member function]\"" );
        
        }
        { //property "HB_AHTable"[fget=::DataDirectory::GetHB_AHTable, fset=::DataDirectory::SetHB_AHTable]
        
            typedef ::blitz::Array<float, 2> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 2> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "HB_AHTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetHB_AHTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetHB_AHTable )
                , "get\\set property, built on top of \"blitz::Array<float, 2> const & DataDirectory::GetHB_AHTable() const [member function]\" and \"void DataDirectory::SetHB_AHTable(blitz::Array<float, 2> const & value) [member function]\"" );
        
        }
        { //property "HB_XDTable"[fget=::DataDirectory::GetHB_XDTable, fset=::DataDirectory::SetHB_XDTable]
        
            typedef ::blitz::Array<float, 2> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 2> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "HB_XDTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetHB_XDTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetHB_XDTable )
                , "get\\set property, built on top of \"blitz::Array<float, 2> const & DataDirectory::GetHB_XDTable() const [member function]\" and \"void DataDirectory::SetHB_XDTable(blitz::Array<float, 2> const & value) [member function]\"" );
        
        }
        { //property "HB_XHTable"[fget=::DataDirectory::GetHB_XHTable, fset=::DataDirectory::SetHB_XHTable]
        
            typedef ::blitz::Array<float, 2> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 2> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "HB_XHTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetHB_XHTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetHB_XHTable )
                , "get\\set property, built on top of \"blitz::Array<float, 2> const & DataDirectory::GetHB_XHTable() const [member function]\" and \"void DataDirectory::SetHB_XHTable(blitz::Array<float, 2> const & value) [member function]\"" );
        
        }
        { //property "PairLikelihoodTable"[fget=::DataDirectory::GetPairLikelihoodTable, fset=::DataDirectory::SetPairLikelihoodTable]
        
            typedef ::blitz::Array<float, 5> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 5> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "PairLikelihoodTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetPairLikelihoodTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetPairLikelihoodTable )
                , "get\\set property, built on top of \"blitz::Array<float, 5> const & DataDirectory::GetPairLikelihoodTable() const [member function]\" and \"void DataDirectory::SetPairLikelihoodTable(blitz::Array<float, 5> const & value) [member function]\"" );
        
        }
        { //property "BBStrainWeight"[fget=::DataDirectory::GetBBStrainWeight, fset=::DataDirectory::SetBBStrainWeight]
        
            typedef ::blitz::Array<float, 1> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 1> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "BBStrainWeight"
                , bp::make_function( 
                      fget( &::DataDirectory::GetBBStrainWeight )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetBBStrainWeight )
                , "get\\set property, built on top of \"blitz::Array<float, 1> const & DataDirectory::GetBBStrainWeight() const [member function]\" and \"void DataDirectory::SetBBStrainWeight(blitz::Array<float, 1> const & value) [member function]\"" );
        
        }
        { //property "AAProbabilityByAngle"[fget=::DataDirectory::GetAAProbabilityByAngle, fset=::DataDirectory::SetAAProbabilityByAngle]
        
            typedef ::blitz::Array<float, 3> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 3> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "AAProbabilityByAngle"
                , bp::make_function( 
                      fget( &::DataDirectory::GetAAProbabilityByAngle )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetAAProbabilityByAngle )
                , "get\\set property, built on top of \"blitz::Array<float, 3> const & DataDirectory::GetAAProbabilityByAngle() const [member function]\" and \"void DataDirectory::SetAAProbabilityByAngle(blitz::Array<float, 3> const & value) [member function]\"" );
        
        }
        { //property "AAProbability"[fget=::DataDirectory::GetAAProbability, fset=::DataDirectory::SetAAProbability]
        
            typedef ::blitz::Array<float, 1> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 1> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "AAProbability"
                , bp::make_function( 
                      fget( &::DataDirectory::GetAAProbability )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetAAProbability )
                , "get\\set property, built on top of \"blitz::Array<float, 1> const & DataDirectory::GetAAProbability() const [member function]\" and \"void DataDirectory::SetAAProbability(blitz::Array<float, 1> const & value) [member function]\"" );
        
        }
        { //property "IntraRes_CountPair"[fget=::DataDirectory::GetIntraRes_CountPair, fset=::DataDirectory::SetIntraRes_CountPair]
        
            typedef ::blitz::Array<float, 3> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 3> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "IntraRes_CountPair"
                , bp::make_function( 
                      fget( &::DataDirectory::GetIntraRes_CountPair )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetIntraRes_CountPair )
                , "get\\set property, built on top of \"blitz::Array<float, 3> const & DataDirectory::GetIntraRes_CountPair() const [member function]\" and \"void DataDirectory::SetIntraRes_CountPair(blitz::Array<float, 3> const & value) [member function]\"" );
        
        }
        { //property "OPLSaa_chargeTable"[fget=::DataDirectory::GetOPLSaa_chargeTable, fset=::DataDirectory::SetOPLSaa_chargeTable]
        
            typedef ::blitz::Array<float, 2> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 2> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "OPLSaa_chargeTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetOPLSaa_chargeTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetOPLSaa_chargeTable )
                , "get\\set property, built on top of \"blitz::Array<float, 2> const & DataDirectory::GetOPLSaa_chargeTable() const [member function]\" and \"void DataDirectory::SetOPLSaa_chargeTable(blitz::Array<float, 2> const & value) [member function]\"" );
        
        }
        { //property "OPLSaa_vdwTable"[fget=::DataDirectory::GetOPLSaa_vdwTable, fset=::DataDirectory::SetOPLSaa_vdwTable]
        
            typedef ::blitz::Array<float, 3> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 3> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "OPLSaa_vdwTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetOPLSaa_vdwTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetOPLSaa_vdwTable )
                , "get\\set property, built on top of \"blitz::Array<float, 3> const & DataDirectory::GetOPLSaa_vdwTable() const [member function]\" and \"void DataDirectory::SetOPLSaa_vdwTable(blitz::Array<float, 3> const & value) [member function]\"" );
        
        }
        { //property "OPLSaa_BondStretchTable"[fget=::DataDirectory::GetOPLSaa_BondStretchTable, fset=::DataDirectory::SetOPLSaa_BondStretchTable]
        
            typedef ::blitz::Array<float, 2> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 2> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "OPLSaa_BondStretchTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetOPLSaa_BondStretchTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetOPLSaa_BondStretchTable )
                , "get\\set property, built on top of \"blitz::Array<float, 2> const & DataDirectory::GetOPLSaa_BondStretchTable() const [member function]\" and \"void DataDirectory::SetOPLSaa_BondStretchTable(blitz::Array<float, 2> const & value) [member function]\"" );
        
        }
        { //property "OPLSaa_AngleBendTable"[fget=::DataDirectory::GetOPLSaa_AngleBendTable, fset=::DataDirectory::SetOPLSaa_AngleBendTable]
        
            typedef ::blitz::Array<float, 2> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 2> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "OPLSaa_AngleBendTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetOPLSaa_AngleBendTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetOPLSaa_AngleBendTable )
                , "get\\set property, built on top of \"blitz::Array<float, 2> const & DataDirectory::GetOPLSaa_AngleBendTable() const [member function]\" and \"void DataDirectory::SetOPLSaa_AngleBendTable(blitz::Array<float, 2> const & value) [member function]\"" );
        
        }
        { //property "OPLSaa_TorsionTable"[fget=::DataDirectory::GetOPLSaa_TorsionTable, fset=::DataDirectory::SetOPLSaa_TorsionTable]
        
            typedef ::blitz::Array<float, 2> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 2> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "OPLSaa_TorsionTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetOPLSaa_TorsionTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetOPLSaa_TorsionTable )
                , "get\\set property, built on top of \"blitz::Array<float, 2> const & DataDirectory::GetOPLSaa_TorsionTable() const [member function]\" and \"void DataDirectory::SetOPLSaa_TorsionTable(blitz::Array<float, 2> const & value) [member function]\"" );
        
        }
        { //property "OPLSaa_ImptorsTable"[fget=::DataDirectory::GetOPLSaa_ImptorsTable, fset=::DataDirectory::SetOPLSaa_ImptorsTable]
        
            typedef ::blitz::Array<float, 2> const & ( ::DataDirectory::*fget )(  ) const;
            typedef void ( ::DataDirectory::*fset )( ::blitz::Array<float, 2> const & ) ;
            
            DataDirectory_exposer.add_property( 
                "OPLSaa_ImptorsTable"
                , bp::make_function( 
                      fget( &::DataDirectory::GetOPLSaa_ImptorsTable )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , fset( &::DataDirectory::SetOPLSaa_ImptorsTable )
                , "get\\set property, built on top of \"blitz::Array<float, 2> const & DataDirectory::GetOPLSaa_ImptorsTable() const [member function]\" and \"void DataDirectory::SetOPLSaa_ImptorsTable(blitz::Array<float, 2> const & value) [member function]\"" );
        
        }
        bp::register_ptr_to_python< boost::shared_ptr< DataDirectory > >();
    }

}

