// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "DunbrackLibrary.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "dunbrack.h"

namespace bp = boost::python;

void register_DunbrackLibrary_class(){

    { //::DunbrackLibrary
        typedef bp::class_< DunbrackLibrary, boost::noncopyable > DunbrackLibrary_exposer_t;
        DunbrackLibrary_exposer_t DunbrackLibrary_exposer = DunbrackLibrary_exposer_t( "DunbrackLibrary", bp::init< boost::shared_ptr<AminoAcidDirectory const>, std::string const & >(( bp::arg("aadir"), bp::arg("fileName") )) );
        bp::scope DunbrackLibrary_scope( DunbrackLibrary_exposer );
        bp::class_< DunbrackLibrary::AngleBinData, boost::noncopyable >( "AngleBinData", bp::no_init )    
            .def_readwrite( "dphi", &DunbrackLibrary::AngleBinData::dphi )    
            .def_readwrite( "dpsi", &DunbrackLibrary::AngleBinData::dpsi )    
            .def_readwrite( "phi1", &DunbrackLibrary::AngleBinData::phi1 )    
            .def_readwrite( "phi2", &DunbrackLibrary::AngleBinData::phi2 )    
            .def_readwrite( "psi1", &DunbrackLibrary::AngleBinData::psi1 )    
            .def_readwrite( "psi2", &DunbrackLibrary::AngleBinData::psi2 );
        bp::class_< DunbrackLibrary::IntAngleBins, boost::noncopyable >( "IntAngleBins", bp::no_init )    
            .def_readwrite( "phi", &DunbrackLibrary::IntAngleBins::phi )    
            .def_readwrite( "psi", &DunbrackLibrary::IntAngleBins::psi );
        { //::DunbrackLibrary::Compile
        
            typedef void ( ::DunbrackLibrary::*Compile_function_type )( ::std::string const & ) const;
            
            DunbrackLibrary_exposer.def( 
                "Compile"
                , Compile_function_type( &::DunbrackLibrary::Compile )
                , ( bp::arg("outputFileName") ) );
        
        }
        { //::DunbrackLibrary::Create
        
            typedef ::boost::shared_ptr<DunbrackLibrary const> ( *Create_function_type )( ::boost::shared_ptr<AminoAcidDirectory const>,::std::string const & );
            
            DunbrackLibrary_exposer.def( 
                "Create"
                , Create_function_type( &::DunbrackLibrary::Create )
                , ( bp::arg("aadir"), bp::arg("fileName") ) );
        
        }
        { //::DunbrackLibrary::GetAngleBins
        
            typedef ::DunbrackLibrary::IntAngleBins ( ::DunbrackLibrary::*GetAngleBins_function_type )( ::FLOAT,::FLOAT,bool,bool ) const;
            
            DunbrackLibrary_exposer.def( 
                "GetAngleBins"
                , GetAngleBins_function_type( &::DunbrackLibrary::GetAngleBins )
                , ( bp::arg("phi"), bp::arg("psi"), bp::arg("start"), bp::arg("end") ) );
        
        }
        { //::DunbrackLibrary::GetBaseRotamer
        
            typedef int ( ::DunbrackLibrary::*GetBaseRotamer_function_type )( int,::Vector4 const & ) const;
            
            DunbrackLibrary_exposer.def( 
                "GetBaseRotamer"
                , GetBaseRotamer_function_type( &::DunbrackLibrary::GetBaseRotamer )
                , ( bp::arg("aminoAcid"), bp::arg("chi") ) );
        
        }
        { //::DunbrackLibrary::GetInterpChi
        
            typedef ::Vector4 ( ::DunbrackLibrary::*GetInterpChi_function_type )( int,::DunbrackLibrary::AngleBinData const &,int ) const;
            
            DunbrackLibrary_exposer.def( 
                "GetInterpChi"
                , GetInterpChi_function_type( &::DunbrackLibrary::GetInterpChi )
                , ( bp::arg("aminoAcid"), bp::arg("interpData"), bp::arg("nRot") ) );
        
        }
        { //::DunbrackLibrary::GetInterpData
        
            typedef ::DunbrackLibrary::AngleBinData ( ::DunbrackLibrary::*GetInterpData_function_type )( ::FLOAT,::FLOAT,bool,bool ) const;
            
            DunbrackLibrary_exposer.def( 
                "GetInterpData"
                , GetInterpData_function_type( &::DunbrackLibrary::GetInterpData )
                , ( bp::arg("phi"), bp::arg("psi"), bp::arg("start"), bp::arg("end") ) );
        
        }
        { //::DunbrackLibrary::GetInterpPercent
        
            typedef ::FLOAT ( ::DunbrackLibrary::*GetInterpPercent_function_type )( int,::DunbrackLibrary::AngleBinData const &,int ) const;
            
            DunbrackLibrary_exposer.def( 
                "GetInterpPercent"
                , GetInterpPercent_function_type( &::DunbrackLibrary::GetInterpPercent )
                , ( bp::arg("aminoAcid"), bp::arg("interpData"), bp::arg("nRot") ) );
        
        }
        { //::DunbrackLibrary::GetInterpSD
        
            typedef ::Vector4 ( ::DunbrackLibrary::*GetInterpSD_function_type )( int,::DunbrackLibrary::AngleBinData const &,int ) const;
            
            DunbrackLibrary_exposer.def( 
                "GetInterpSD"
                , GetInterpSD_function_type( &::DunbrackLibrary::GetInterpSD )
                , ( bp::arg("aminoAcid"), bp::arg("interpData"), bp::arg("nRot") ) );
        
        }
        { //::DunbrackLibrary::GetNRotByDunbrackID
        
            typedef int ( ::DunbrackLibrary::*GetNRotByDunbrackID_function_type )( int,::blitz::TinyVector<int, 4> const & ) const;
            
            DunbrackLibrary_exposer.def( 
                "GetNRotByDunbrackID"
                , GetNRotByDunbrackID_function_type( &::DunbrackLibrary::GetNRotByDunbrackID )
                , ( bp::arg("aminoAcid"), bp::arg("dunIndex") ) );
        
        }
        { //::DunbrackLibrary::GetNRotByPercent
        
            typedef int ( ::DunbrackLibrary::*GetNRotByPercent_function_type )( int,int,int,int ) const;
            
            DunbrackLibrary_exposer.def( 
                "GetNRotByPercent"
                , GetNRotByPercent_function_type( &::DunbrackLibrary::GetNRotByPercent )
                , ( bp::arg("aminoAcid"), bp::arg("iPhi"), bp::arg("iPsi"), bp::arg("percentOrder") ) );
        
        }
        DunbrackLibrary_exposer.staticmethod( "Create" );
    }

}

