// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "EnergyFunction.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "energy_function.h"

namespace bp = boost::python;

void register_EnergyFunction_class(){

    bp::class_< EnergyFunction, boost::noncopyable >( "EnergyFunction", bp::init< std::string const &, boost::shared_ptr<AtomTypes const>, boost::shared_ptr<DataDirectory const>, boost::shared_ptr<DunbrackLibrary const>, bp::optional< boost::shared_ptr<RuntimeStats> > >(( bp::arg("libName"), bp::arg("atypes"), bp::arg("directory"), bp::arg("dunLib"), bp::arg("rstats")=boost::shared_ptr<RuntimeStats>() )) )    
        .def( 
            "FillEnergyGraph"
            , &::EnergyFunction::FillEnergyGraph
            , ( bp::arg("rotamers"), bp::arg("nmap"), bp::arg("rmap"), bp::arg("graphOut") ) )    
        .def( 
            "GetFloatParameter"
            , &::EnergyFunction::GetFloatParameter
            , ( bp::arg("paramName") ) )    
        .def( 
            "GetOneBodyEnergies"
            , &::EnergyFunction::GetOneBodyEnergies
            , ( bp::arg("residues"), bp::arg("nmap") ) )    
        .def( 
            "GetPairwiseEnergies"
            , &::EnergyFunction::GetPairwiseEnergies
            , ( bp::arg("residues"), bp::arg("nmap") ) )    
        .def( 
            "GetPluginPath"
            , &::EnergyFunction::GetPluginPath )    
        .def( 
            "Reinitialize"
            , &::EnergyFunction::Reinitialize
            , ( bp::arg("atypes"), bp::arg("directory"), bp::arg("dunLib"), bp::arg("rstats")=boost::shared_ptr<RuntimeStats>() ) )    
        .def( 
            "ScoreSystem"
            , &::EnergyFunction::ScoreSystem
            , ( bp::arg("residues"), bp::arg("nmap") ) )    
        .def( 
            "SetParameter"
            , (void ( ::EnergyFunction::* )( ::std::string const &,::FLOAT ) )( &::EnergyFunction::SetParameter )
            , ( bp::arg("paramName"), bp::arg("value") ) )    
        .def( 
            "SetPluginPath"
            , &::EnergyFunction::SetPluginPath
            , ( bp::arg("path") ) )    
        .staticmethod( "GetPluginPath" )    
        .staticmethod( "SetPluginPath" );

}

