// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "EnergyGraph.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "energy_graph.h"

namespace bp = boost::python;

struct EnergyGraph_wrapper : EnergyGraph, bp::wrapper< EnergyGraph > {

    EnergyGraph_wrapper( )
    : EnergyGraph( )
      , bp::wrapper< EnergyGraph >(){
        // null constructor
    
    }

    virtual ::FLOAT ComputeEnergy( ::std::vector<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default>, std::allocator<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default> > > const & stateVector, bool noActivate=false ) {
        if( bp::override func_ComputeEnergy = this->get_override( "ComputeEnergy" ) )
            return func_ComputeEnergy( boost::ref(stateVector), noActivate );
        else
            return this->EnergyGraph::ComputeEnergy( boost::ref(stateVector), noActivate );
    }
    
    
    ::FLOAT default_ComputeEnergy( ::std::vector<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default>, std::allocator<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default> > > const & stateVector, bool noActivate=false ) {
        return EnergyGraph::ComputeEnergy( boost::ref(stateVector), noActivate );
    }

    virtual ::FLOAT ComputeEnergy( ::std::vector<int, std::allocator<int> > const & stateVector, bool noActivate=false ) {
        if( bp::override func_ComputeEnergy = this->get_override( "ComputeEnergy" ) )
            return func_ComputeEnergy( boost::ref(stateVector), noActivate );
        else
            return this->EnergyGraph::ComputeEnergy( boost::ref(stateVector), noActivate );
    }
    
    
    ::FLOAT default_ComputeEnergy( ::std::vector<int, std::allocator<int> > const & stateVector, bool noActivate=false ) {
        return EnergyGraph::ComputeEnergy( boost::ref(stateVector), noActivate );
    }

    virtual void DeleteNodes( ::IDSet const & nodes ) {
        if( bp::override func_DeleteNodes = this->get_override( "DeleteNodes" ) )
            func_DeleteNodes( boost::ref(nodes) );
        else
            this->EnergyGraph::DeleteNodes( boost::ref(nodes) );
    }
    
    
    void default_DeleteNodes( ::IDSet const & nodes ) {
        EnergyGraph::DeleteNodes( boost::ref(nodes) );
    }

    virtual ::FLOAT DiffEnergy( ::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default> IDIn, ::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default> IDOut, ::boost::shared_ptr<RuntimeStats> rstats=boost::shared_ptr<RuntimeStats>() ) const  {
        if( bp::override func_DiffEnergy = this->get_override( "DiffEnergy" ) )
            return func_DiffEnergy( IDIn, IDOut, rstats );
        else
            return this->EnergyGraph::DiffEnergy( IDIn, IDOut, rstats );
    }
    
    
    ::FLOAT default_DiffEnergy( ::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default> IDIn, ::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default> IDOut, ::boost::shared_ptr<RuntimeStats> rstats=boost::shared_ptr<RuntimeStats>() ) const  {
        return EnergyGraph::DiffEnergy( IDIn, IDOut, rstats );
    }

};

void register_EnergyGraph_class(){

    { //::EnergyGraph
        typedef bp::class_< EnergyGraph_wrapper, boost::noncopyable > EnergyGraph_exposer_t;
        EnergyGraph_exposer_t EnergyGraph_exposer = EnergyGraph_exposer_t( "EnergyGraph" );
        bp::scope EnergyGraph_scope( EnergyGraph_exposer );
        EnergyGraph_exposer.def( bp::init< >() );
        { //::EnergyGraph::AddEdge
        
            typedef void ( ::EnergyGraph::*AddEdge_function_type )( int,int,::FLOAT ) ;
            
            EnergyGraph_exposer.def( 
                "AddEdge"
                , AddEdge_function_type( &::EnergyGraph::AddEdge )
                , ( bp::arg("ID1"), bp::arg("ID2"), bp::arg("energy") ) );
        
        }
        { //::EnergyGraph::AddVertex
        
            typedef void ( ::EnergyGraph::*AddVertex_function_type )( int,::FLOAT ) ;
            
            EnergyGraph_exposer.def( 
                "AddVertex"
                , AddVertex_function_type( &::EnergyGraph::AddVertex )
                , ( bp::arg("ID"), bp::arg("energy")=0.0 ) );
        
        }
        { //::EnergyGraph::CapGraphAt
        
            typedef void ( ::EnergyGraph::*CapGraphAt_function_type )( ::FLOAT ) ;
            
            EnergyGraph_exposer.def( 
                "CapGraphAt"
                , CapGraphAt_function_type( &::EnergyGraph::CapGraphAt )
                , ( bp::arg("cap") ) );
        
        }
        { //::EnergyGraph::ComputeEnergy
        
            typedef ::FLOAT ( ::EnergyGraph::*ComputeEnergy_function_type )( ::std::vector<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default>, std::allocator<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default> > > const &,bool ) ;
            typedef ::FLOAT ( EnergyGraph_wrapper::*default_ComputeEnergy_function_type )( ::std::vector<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default>, std::allocator<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default> > > const &,bool ) ;
            
            EnergyGraph_exposer.def( 
                "ComputeEnergy"
                , ComputeEnergy_function_type(&::EnergyGraph::ComputeEnergy)
                , default_ComputeEnergy_function_type(&EnergyGraph_wrapper::default_ComputeEnergy)
                , ( bp::arg("stateVector"), bp::arg("noActivate")=(bool)(false) ) );
        
        }
        { //::EnergyGraph::ComputeEnergy
        
            typedef ::FLOAT ( ::EnergyGraph::*ComputeEnergy_function_type )( ::std::vector<int, std::allocator<int> > const &,bool ) ;
            typedef ::FLOAT ( EnergyGraph_wrapper::*default_ComputeEnergy_function_type )( ::std::vector<int, std::allocator<int> > const &,bool ) ;
            
            EnergyGraph_exposer.def( 
                "ComputeEnergy"
                , ComputeEnergy_function_type(&::EnergyGraph::ComputeEnergy)
                , default_ComputeEnergy_function_type(&EnergyGraph_wrapper::default_ComputeEnergy)
                , ( bp::arg("stateVector"), bp::arg("noActivate")=(bool)(false) ) );
        
        }
        { //::EnergyGraph::DeleteNodes
        
            typedef void ( ::EnergyGraph::*DeleteNodes_function_type )( ::IDSet const & ) ;
            typedef void ( EnergyGraph_wrapper::*default_DeleteNodes_function_type )( ::IDSet const & ) ;
            
            EnergyGraph_exposer.def( 
                "DeleteNodes"
                , DeleteNodes_function_type(&::EnergyGraph::DeleteNodes)
                , default_DeleteNodes_function_type(&EnergyGraph_wrapper::default_DeleteNodes)
                , ( bp::arg("nodes") ) );
        
        }
        { //::EnergyGraph::DiffEnergy
        
            typedef ::FLOAT ( ::EnergyGraph::*DiffEnergy_function_type )( ::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default>,::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default>,::boost::shared_ptr<RuntimeStats> ) const;
            typedef ::FLOAT ( EnergyGraph_wrapper::*default_DiffEnergy_function_type )( ::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default>,::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default>,::boost::shared_ptr<RuntimeStats> ) const;
            
            EnergyGraph_exposer.def( 
                "DiffEnergy"
                , DiffEnergy_function_type(&::EnergyGraph::DiffEnergy)
                , default_DiffEnergy_function_type(&EnergyGraph_wrapper::default_DiffEnergy)
                , ( bp::arg("IDIn"), bp::arg("IDOut"), bp::arg("rstats")=boost::shared_ptr<RuntimeStats>() ) );
        
        }
        { //::EnergyGraph::GetEdgeEnergy
        
            typedef ::FLOAT ( ::EnergyGraph::*GetEdgeEnergy_function_type )( int,int ) const;
            
            EnergyGraph_exposer.def( 
                "GetEdgeEnergy"
                , GetEdgeEnergy_function_type( &::EnergyGraph::GetEdgeEnergy )
                , ( bp::arg("ID1"), bp::arg("ID2") ) );
        
        }
        { //::EnergyGraph::GetVertexEdges
        
            typedef ::std::vector<std::pair<int, float>, std::allocator<std::pair<int, float> > > ( ::EnergyGraph::*GetVertexEdges_function_type )( int ) const;
            
            EnergyGraph_exposer.def( 
                "GetVertexEdges"
                , GetVertexEdges_function_type( &::EnergyGraph::GetVertexEdges )
                , ( bp::arg("vertexID") ) );
        
        }
        { //::EnergyGraph::GetVertexEnergy
        
            typedef ::FLOAT ( ::EnergyGraph::*GetVertexEnergy_function_type )( int ) const;
            
            EnergyGraph_exposer.def( 
                "GetVertexEnergy"
                , GetVertexEnergy_function_type( &::EnergyGraph::GetVertexEnergy )
                , ( bp::arg("ID") ) );
        
        }
        { //::EnergyGraph::GetVertexIDs
        
            typedef ::std::vector<int, std::allocator<int> > ( ::EnergyGraph::*GetVertexIDs_function_type )(  ) const;
            
            EnergyGraph_exposer.def( 
                "GetVertexIDs"
                , GetVertexIDs_function_type( &::EnergyGraph::GetVertexIDs ) );
        
        }
        { //::EnergyGraph::IncludeEnergy
        
            typedef bool ( ::EnergyGraph::*IncludeEnergy_function_type )( ::FLOAT ) const;
            
            EnergyGraph_exposer.def( 
                "IncludeEnergy"
                , IncludeEnergy_function_type( &::EnergyGraph::IncludeEnergy )
                , ( bp::arg("value") ) );
        
        }
        { //::EnergyGraph::SetEdgeEnergy
        
            typedef void ( ::EnergyGraph::*SetEdgeEnergy_function_type )( int,int,::FLOAT ) ;
            
            EnergyGraph_exposer.def( 
                "SetEdgeEnergy"
                , SetEdgeEnergy_function_type( &::EnergyGraph::SetEdgeEnergy )
                , ( bp::arg("ID1"), bp::arg("ID2"), bp::arg("newEnergy") ) );
        
        }
        { //::EnergyGraph::SetVertexEnergy
        
            typedef void ( ::EnergyGraph::*SetVertexEnergy_function_type )( int,::FLOAT ) ;
            
            EnergyGraph_exposer.def( 
                "SetVertexEnergy"
                , SetVertexEnergy_function_type( &::EnergyGraph::SetVertexEnergy )
                , ( bp::arg("ID"), bp::arg("newEnergy") ) );
        
        }
        bp::register_ptr_to_python< boost::shared_ptr< EnergyGraph > >();
        bp::implicitly_convertible< boost::shared_ptr< EnergyGraph >, boost::shared_ptr< boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS> > >();
        bp::implicitly_convertible< boost::shared_ptr< EnergyGraph >, boost::shared_ptr< boost::vec_adj_list_impl<boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS>, boost::detail::adj_list_gen<boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS>, boost::vecS, boost::vecS, boost::undirectedS, boost::property<boost::vertex_bundle_t, EnergyGraphNode, boost::no_property>, boost::property<boost::edge_bundle_t, float, boost::no_property>, boost::no_property, boost::listS>::config, boost::undirected_graph_helper<boost::detail::adj_list_gen<boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS>, boost::vecS, boost::vecS, boost::undirectedS, boost::property<boost::vertex_bundle_t, EnergyGraphNode, boost::no_property>, boost::property<boost::edge_bundle_t, float, boost::no_property>, boost::no_property, boost::listS>::config> > > >();
        bp::implicitly_convertible< boost::shared_ptr< EnergyGraph >, boost::shared_ptr< boost::adj_list_helper<boost::detail::adj_list_gen<boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS>, boost::vecS, boost::vecS, boost::undirectedS, boost::property<boost::vertex_bundle_t, EnergyGraphNode, boost::no_property>, boost::property<boost::edge_bundle_t, float, boost::no_property>, boost::no_property, boost::listS>::config, boost::undirected_graph_helper<boost::detail::adj_list_gen<boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS>, boost::vecS, boost::vecS, boost::undirectedS, boost::property<boost::vertex_bundle_t, EnergyGraphNode, boost::no_property>, boost::property<boost::edge_bundle_t, float, boost::no_property>, boost::no_property, boost::listS>::config> > > >();
        bp::implicitly_convertible< boost::shared_ptr< EnergyGraph >, boost::shared_ptr< boost::undirected_graph_helper<boost::detail::adj_list_gen<boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS>, boost::vecS, boost::vecS, boost::undirectedS, boost::property<boost::vertex_bundle_t, EnergyGraphNode, boost::no_property>, boost::property<boost::edge_bundle_t, float, boost::no_property>, boost::no_property, boost::listS>::config> > >();
        bp::implicitly_convertible< boost::shared_ptr< EnergyHyperGraph >, boost::shared_ptr< EnergyGraph > >();
    }

}

