// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "EnergyHyperGraph.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "energy_graph.h"

namespace bp = boost::python;

struct EnergyHyperGraph_wrapper : EnergyHyperGraph, bp::wrapper< EnergyHyperGraph > {

    EnergyHyperGraph_wrapper( )
    : EnergyHyperGraph( )
      , bp::wrapper< EnergyHyperGraph >(){
        // null constructor
    
    }

    virtual ::FLOAT ComputeEnergy( ::std::vector<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default>, std::allocator<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default> > > const & stateVector, bool noActivate=false ) {
        if( bp::override func_ComputeEnergy = this->get_override( "ComputeEnergy" ) )
            return func_ComputeEnergy( boost::ref(stateVector), noActivate );
        else
            return this->EnergyHyperGraph::ComputeEnergy( boost::ref(stateVector), noActivate );
    }
    
    
    ::FLOAT default_ComputeEnergy( ::std::vector<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default>, std::allocator<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default> > > const & stateVector, bool noActivate=false ) {
        return EnergyHyperGraph::ComputeEnergy( boost::ref(stateVector), noActivate );
    }

    virtual ::FLOAT ComputeEnergy( ::std::vector<int, std::allocator<int> > const & stateVector, bool noActivate=false ) {
        if( bp::override func_ComputeEnergy = this->get_override( "ComputeEnergy" ) )
            return func_ComputeEnergy( boost::ref(stateVector), noActivate );
        else
            return this->EnergyHyperGraph::ComputeEnergy( boost::ref(stateVector), noActivate );
    }
    
    
    ::FLOAT default_ComputeEnergy( ::std::vector<int, std::allocator<int> > const & stateVector, bool noActivate=false ) {
        return EnergyHyperGraph::ComputeEnergy( boost::ref(stateVector), noActivate );
    }

    virtual void DeleteNodes( ::IDSet const & nodes ) {
        if( bp::override func_DeleteNodes = this->get_override( "DeleteNodes" ) )
            func_DeleteNodes( boost::ref(nodes) );
        else
            this->EnergyHyperGraph::DeleteNodes( boost::ref(nodes) );
    }
    
    
    void default_DeleteNodes( ::IDSet const & nodes ) {
        EnergyHyperGraph::DeleteNodes( boost::ref(nodes) );
    }

    virtual ::FLOAT DiffEnergy( ::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default> IDIn, ::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default> IDOut, ::boost::shared_ptr<RuntimeStats> rstats=boost::shared_ptr<RuntimeStats>() ) const  {
        if( bp::override func_DiffEnergy = this->get_override( "DiffEnergy" ) )
            return func_DiffEnergy( IDIn, IDOut, rstats );
        else
            return this->EnergyHyperGraph::DiffEnergy( IDIn, IDOut, rstats );
    }
    
    
    ::FLOAT default_DiffEnergy( ::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default> IDIn, ::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default> IDOut, ::boost::shared_ptr<RuntimeStats> rstats=boost::shared_ptr<RuntimeStats>() ) const  {
        return EnergyHyperGraph::DiffEnergy( IDIn, IDOut, rstats );
    }

};

void register_EnergyHyperGraph_class(){

    { //::EnergyHyperGraph
        typedef bp::class_< EnergyHyperGraph_wrapper, bp::bases< EnergyGraph >, boost::noncopyable > EnergyHyperGraph_exposer_t;
        EnergyHyperGraph_exposer_t EnergyHyperGraph_exposer = EnergyHyperGraph_exposer_t( "EnergyHyperGraph" );
        bp::scope EnergyHyperGraph_scope( EnergyHyperGraph_exposer );
        EnergyHyperGraph_exposer.def( bp::init< >() );
        { //::EnergyHyperGraph::AddEdge
        
            typedef void ( ::EnergyHyperGraph::*AddEdge_function_type )( ::std::vector<int, std::allocator<int> > const &,::FLOAT ) ;
            
            EnergyHyperGraph_exposer.def( 
                "AddEdge"
                , AddEdge_function_type( &::EnergyHyperGraph::AddEdge )
                , ( bp::arg("IDs"), bp::arg("energy") ) );
        
        }
        { //::EnergyHyperGraph::AddVertex
        
            typedef void ( ::EnergyHyperGraph::*AddVertex_function_type )( int,::FLOAT ) ;
            
            EnergyHyperGraph_exposer.def( 
                "AddVertex"
                , AddVertex_function_type( &::EnergyHyperGraph::AddVertex )
                , ( bp::arg("ID"), bp::arg("energy")=0.0 ) );
        
        }
        { //::EnergyHyperGraph::ComputeEnergy
        
            typedef ::FLOAT ( ::EnergyHyperGraph::*ComputeEnergy_function_type )( ::std::vector<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default>, std::allocator<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default> > > const &,bool ) ;
            typedef ::FLOAT ( EnergyHyperGraph_wrapper::*default_ComputeEnergy_function_type )( ::std::vector<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default>, std::allocator<boost::counting_iterator<std::size_t, boost::use_default, boost::use_default> > > const &,bool ) ;
            
            EnergyHyperGraph_exposer.def( 
                "ComputeEnergy"
                , ComputeEnergy_function_type(&::EnergyHyperGraph::ComputeEnergy)
                , default_ComputeEnergy_function_type(&EnergyHyperGraph_wrapper::default_ComputeEnergy)
                , ( bp::arg("stateVector"), bp::arg("noActivate")=(bool)(false) ) );
        
        }
        { //::EnergyHyperGraph::ComputeEnergy
        
            typedef ::FLOAT ( ::EnergyHyperGraph::*ComputeEnergy_function_type )( ::std::vector<int, std::allocator<int> > const &,bool ) ;
            typedef ::FLOAT ( EnergyHyperGraph_wrapper::*default_ComputeEnergy_function_type )( ::std::vector<int, std::allocator<int> > const &,bool ) ;
            
            EnergyHyperGraph_exposer.def( 
                "ComputeEnergy"
                , ComputeEnergy_function_type(&::EnergyHyperGraph::ComputeEnergy)
                , default_ComputeEnergy_function_type(&EnergyHyperGraph_wrapper::default_ComputeEnergy)
                , ( bp::arg("stateVector"), bp::arg("noActivate")=(bool)(false) ) );
        
        }
        { //::EnergyHyperGraph::DeleteNodes
        
            typedef void ( ::EnergyHyperGraph::*DeleteNodes_function_type )( ::IDSet const & ) ;
            typedef void ( EnergyHyperGraph_wrapper::*default_DeleteNodes_function_type )( ::IDSet const & ) ;
            
            EnergyHyperGraph_exposer.def( 
                "DeleteNodes"
                , DeleteNodes_function_type(&::EnergyHyperGraph::DeleteNodes)
                , default_DeleteNodes_function_type(&EnergyHyperGraph_wrapper::default_DeleteNodes)
                , ( bp::arg("nodes") ) );
        
        }
        { //::EnergyHyperGraph::DiffEnergy
        
            typedef ::FLOAT ( ::EnergyHyperGraph::*DiffEnergy_function_type )( ::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default>,::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default>,::boost::shared_ptr<RuntimeStats> ) const;
            typedef ::FLOAT ( EnergyHyperGraph_wrapper::*default_DiffEnergy_function_type )( ::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default>,::boost::counting_iterator<std::size_t,boost::use_default,boost::use_default>,::boost::shared_ptr<RuntimeStats> ) const;
            
            EnergyHyperGraph_exposer.def( 
                "DiffEnergy"
                , DiffEnergy_function_type(&::EnergyHyperGraph::DiffEnergy)
                , default_DiffEnergy_function_type(&EnergyHyperGraph_wrapper::default_DiffEnergy)
                , ( bp::arg("IDIn"), bp::arg("IDOut"), bp::arg("rstats")=boost::shared_ptr<RuntimeStats>() ) );
        
        }
        { //::EnergyHyperGraph::GetEdgeEnergy
        
            typedef ::FLOAT ( ::EnergyHyperGraph::*GetEdgeEnergy_function_type )( ::std::vector<int, std::allocator<int> > const & ) const;
            
            EnergyHyperGraph_exposer.def( 
                "GetEdgeEnergy"
                , GetEdgeEnergy_function_type( &::EnergyHyperGraph::GetEdgeEnergy )
                , ( bp::arg("IDs") ) );
        
        }
        { //::EnergyHyperGraph::GetVertexEdges
        
            typedef ::std::vector<std::pair<std::vector<int, std::allocator<int> >, float>, std::allocator<std::pair<std::vector<int, std::allocator<int> >, float> > > ( ::EnergyHyperGraph::*GetVertexEdges_function_type )( int ) const;
            
            EnergyHyperGraph_exposer.def( 
                "GetVertexEdges"
                , GetVertexEdges_function_type( &::EnergyHyperGraph::GetVertexEdges )
                , ( bp::arg("vertexID") ) );
        
        }
        { //::EnergyHyperGraph::GetVertexEnergy
        
            typedef ::FLOAT ( ::EnergyHyperGraph::*GetVertexEnergy_function_type )( int ) const;
            
            EnergyHyperGraph_exposer.def( 
                "GetVertexEnergy"
                , GetVertexEnergy_function_type( &::EnergyHyperGraph::GetVertexEnergy )
                , ( bp::arg("ID") ) );
        
        }
        { //::EnergyHyperGraph::GetVertexIDs
        
            typedef ::std::vector<int, std::allocator<int> > ( ::EnergyHyperGraph::*GetVertexIDs_function_type )(  ) const;
            
            EnergyHyperGraph_exposer.def( 
                "GetVertexIDs"
                , GetVertexIDs_function_type( &::EnergyHyperGraph::GetVertexIDs ) );
        
        }
        { //::EnergyHyperGraph::SetEdgeEnergy
        
            typedef void ( ::EnergyHyperGraph::*SetEdgeEnergy_function_type )( ::std::vector<int, std::allocator<int> > const &,::FLOAT ) ;
            
            EnergyHyperGraph_exposer.def( 
                "SetEdgeEnergy"
                , SetEdgeEnergy_function_type( &::EnergyHyperGraph::SetEdgeEnergy )
                , ( bp::arg("IDs"), bp::arg("newEnergy") ) );
        
        }
        { //::EnergyHyperGraph::SetVertexEnergy
        
            typedef void ( ::EnergyHyperGraph::*SetVertexEnergy_function_type )( int,::FLOAT ) ;
            
            EnergyHyperGraph_exposer.def( 
                "SetVertexEnergy"
                , SetVertexEnergy_function_type( &::EnergyHyperGraph::SetVertexEnergy )
                , ( bp::arg("ID"), bp::arg("newEnergy") ) );
        
        }
        bp::register_ptr_to_python< boost::shared_ptr< EnergyHyperGraph > >();
        bp::implicitly_convertible< boost::shared_ptr< EnergyHyperGraph >, boost::shared_ptr< boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS> > >();
        bp::implicitly_convertible< boost::shared_ptr< EnergyHyperGraph >, boost::shared_ptr< boost::vec_adj_list_impl<boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS>, boost::detail::adj_list_gen<boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS>, boost::vecS, boost::vecS, boost::undirectedS, boost::property<boost::vertex_bundle_t, EnergyGraphNode, boost::no_property>, boost::property<boost::edge_bundle_t, float, boost::no_property>, boost::no_property, boost::listS>::config, boost::undirected_graph_helper<boost::detail::adj_list_gen<boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS>, boost::vecS, boost::vecS, boost::undirectedS, boost::property<boost::vertex_bundle_t, EnergyGraphNode, boost::no_property>, boost::property<boost::edge_bundle_t, float, boost::no_property>, boost::no_property, boost::listS>::config> > > >();
        bp::implicitly_convertible< boost::shared_ptr< EnergyHyperGraph >, boost::shared_ptr< boost::adj_list_helper<boost::detail::adj_list_gen<boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS>, boost::vecS, boost::vecS, boost::undirectedS, boost::property<boost::vertex_bundle_t, EnergyGraphNode, boost::no_property>, boost::property<boost::edge_bundle_t, float, boost::no_property>, boost::no_property, boost::listS>::config, boost::undirected_graph_helper<boost::detail::adj_list_gen<boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS>, boost::vecS, boost::vecS, boost::undirectedS, boost::property<boost::vertex_bundle_t, EnergyGraphNode, boost::no_property>, boost::property<boost::edge_bundle_t, float, boost::no_property>, boost::no_property, boost::listS>::config> > > >();
        bp::implicitly_convertible< boost::shared_ptr< EnergyHyperGraph >, boost::shared_ptr< boost::undirected_graph_helper<boost::detail::adj_list_gen<boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, EnergyGraphNode, float, boost::no_property, boost::listS>, boost::vecS, boost::vecS, boost::undirectedS, boost::property<boost::vertex_bundle_t, EnergyGraphNode, boost::no_property>, boost::property<boost::edge_bundle_t, float, boost::no_property>, boost::no_property, boost::listS>::config> > >();
    }

}

