// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "MonteCarloPacker.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "opt_montecarlo.h"

namespace bp = boost::python;

struct MonteCarloPacker_wrapper : MonteCarloPacker, bp::wrapper< MonteCarloPacker > {

    MonteCarloPacker_wrapper( )
    : MonteCarloPacker( )
      , bp::wrapper< MonteCarloPacker >(){
        // null constructor
    
    }

    void InitState( ::EnergyGraph & graph, ::std::vector<int, std::allocator<int> > const & initialState ){
        OptimizationBase::InitState( boost::ref(graph), boost::ref(initialState) );
    }

    bool KeepChange( ::FLOAT prevEnergy, ::FLOAT diff, ::FLOAT temperature ){
        return OptimizationBaseMonteCarlo::KeepChange( prevEnergy, diff, temperature );
    }

    ::std::pair<int, int> PickMove(  ){
        return OptimizationBaseMonteCarlo::PickMove(  );
    }

};

void register_MonteCarloPacker_class(){

    bp::class_< MonteCarloPacker_wrapper, bp::bases< OptimizationBaseMonteCarlo >, boost::noncopyable >( "MonteCarloPacker" )    
        .def( bp::init< >() )    
        .def( 
            "Pack"
            , &::MonteCarloPacker::Pack
            , ( bp::arg("searchSpace"), bp::arg("graph"), bp::arg("initialState")=bp::object(), bp::arg("energyList")=boost::shared_ptr<EnergyCombList>(), bp::arg("listSize")=(int)(1) ) )    
        .def( 
            "InitState"
            , &MonteCarloPacker_wrapper::InitState
            , ( bp::arg("graph"), bp::arg("initialState") ) )    
        .def( 
            "KeepChange"
            , &MonteCarloPacker_wrapper::KeepChange
            , ( bp::arg("prevEnergy"), bp::arg("diff"), bp::arg("temperature") ) )    
        .def( 
            "PickMove"
            , &MonteCarloPacker_wrapper::PickMove );

}

