// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "NeighborMap.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "neighbor_map.h"

namespace bp = boost::python;

void register_NeighborMap_class(){

    { //::NeighborMap
        typedef bp::class_< NeighborMap, boost::noncopyable > NeighborMap_exposer_t;
        NeighborMap_exposer_t NeighborMap_exposer = NeighborMap_exposer_t( "NeighborMap", bp::init< std::vector<boost::shared_ptr<System const>, std::allocator<boost::shared_ptr<System const> > > const &, blitz::Array<float, 2> const & >(( bp::arg("systems"), bp::arg("cutoffs") )) );
        bp::scope NeighborMap_scope( NeighborMap_exposer );
        { //::NeighborMap::AreNeighbors
        
            typedef bool ( ::NeighborMap::*AreNeighbors_function_type )( ::Residue const &,::Residue const & ) const;
            
            NeighborMap_exposer.def( 
                "AreNeighbors"
                , AreNeighbors_function_type( &::NeighborMap::AreNeighbors )
                , ( bp::arg("res1"), bp::arg("res2") ) );
        
        }
        { //::NeighborMap::Create
        
            typedef ::boost::shared_ptr<NeighborMap> ( *Create_function_type )( ::boost::shared_ptr<System const>,::blitz::Array<float, 2> const & );
            
            NeighborMap_exposer.def( 
                "Create"
                , Create_function_type( &::NeighborMap::Create )
                , ( bp::arg("system"), bp::arg("cutoffs") ) );
        
        }
        { //::NeighborMap::Create
        
            typedef ::boost::shared_ptr<NeighborMap> ( *Create_function_type )( ::std::vector<boost::shared_ptr<System const>, std::allocator<boost::shared_ptr<System const> > > const &,::blitz::Array<float, 2> const & );
            
            NeighborMap_exposer.def( 
                "Create"
                , Create_function_type( &::NeighborMap::Create )
                , ( bp::arg("systems"), bp::arg("cutoffs") ) );
        
        }
        { //::NeighborMap::NumNeighbors
        
            typedef int ( ::NeighborMap::*NumNeighbors_function_type )( ::Residue const & ) const;
            
            NeighborMap_exposer.def( 
                "NumNeighbors"
                , NumNeighbors_function_type( &::NeighborMap::NumNeighbors )
                , ( bp::arg("res") ) );
        
        }
        NeighborMap_exposer.staticmethod( "Create" );
        bp::register_ptr_to_python< boost::shared_ptr< NeighborMap > >();
    }

}

