// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "OptimizationBaseMonteCarlo.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "opt_base_montecarlo.h"

namespace bp = boost::python;

struct OptimizationBaseMonteCarlo_wrapper : OptimizationBaseMonteCarlo, bp::wrapper< OptimizationBaseMonteCarlo > {

    OptimizationBaseMonteCarlo_wrapper( )
    : OptimizationBaseMonteCarlo( )
      , bp::wrapper< OptimizationBaseMonteCarlo >(){
        // null constructor
    
    }

    bool KeepChange( ::FLOAT prevEnergy, ::FLOAT diff, ::FLOAT temperature ){
        return OptimizationBaseMonteCarlo::KeepChange( prevEnergy, diff, temperature );
    }

    ::std::pair<int, int> PickMove(  ){
        return OptimizationBaseMonteCarlo::PickMove(  );
    }

    void InitState( ::EnergyGraph & graph, ::std::vector<int, std::allocator<int> > const & initialState ){
        OptimizationBase::InitState( boost::ref(graph), boost::ref(initialState) );
    }

};

void register_OptimizationBaseMonteCarlo_class(){

    bp::class_< OptimizationBaseMonteCarlo_wrapper, bp::bases< OptimizationBase >, boost::noncopyable >( "OptimizationBaseMonteCarlo" )    
        .def( bp::init< >() )    
        .def( 
            "GetIterationMultiplier"
            , &::OptimizationBaseMonteCarlo::GetIterationMultiplier )    
        .def( 
            "GetTemperature"
            , &::OptimizationBaseMonteCarlo::GetTemperature )    
        .def( 
            "KeepChange"
            , &OptimizationBaseMonteCarlo_wrapper::KeepChange
            , ( bp::arg("prevEnergy"), bp::arg("diff"), bp::arg("temperature") ) )    
        .def( 
            "PickMove"
            , &OptimizationBaseMonteCarlo_wrapper::PickMove )    
        .def( 
            "SetIterationMultiplier"
            , &::OptimizationBaseMonteCarlo::SetIterationMultiplier
            , ( bp::arg("multiplier") ) )    
        .def( 
            "SetTemperature"
            , &::OptimizationBaseMonteCarlo::SetTemperature
            , ( bp::arg("temperature") ) )    
        .def( 
            "InitState"
            , &OptimizationBaseMonteCarlo_wrapper::InitState
            , ( bp::arg("graph"), bp::arg("initialState") ) );

}

