// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "PoseLibrary.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "poses.h"

namespace bp = boost::python;

struct PoseLibrary_wrapper : PoseLibrary, bp::wrapper< PoseLibrary > {

    PoseLibrary_wrapper(int nBlocks )
    : PoseLibrary( nBlocks )
      , bp::wrapper< PoseLibrary >(){
        // constructor
    
    }

    virtual ::std::pair<int, int> DimensionIDRange( int dimension ) const  {
        if( bp::override func_DimensionIDRange = this->get_override( "DimensionIDRange" ) )
            return func_DimensionIDRange( dimension );
        else
            return this->PoseLibrary::DimensionIDRange( dimension );
    }
    
    
    ::std::pair<int, int> default_DimensionIDRange( int dimension ) const  {
        return PoseLibrary::DimensionIDRange( dimension );
    }

    virtual int NumDimensions(  ) const  {
        if( bp::override func_NumDimensions = this->get_override( "NumDimensions" ) )
            return func_NumDimensions(  );
        else
            return this->PoseLibrary::NumDimensions(  );
    }
    
    
    int default_NumDimensions(  ) const  {
        return PoseLibrary::NumDimensions( );
    }

    virtual int NumElements(  ) const  {
        if( bp::override func_NumElements = this->get_override( "NumElements" ) )
            return func_NumElements(  );
        else
            return this->PoseLibrary::NumElements(  );
    }
    
    
    int default_NumElements(  ) const  {
        return PoseLibrary::NumElements( );
    }

};

void register_PoseLibrary_class(){

    { //::PoseLibrary
        typedef bp::class_< PoseLibrary_wrapper, bp::bases< DiscreteSearchSpace >, boost::noncopyable > PoseLibrary_exposer_t;
        PoseLibrary_exposer_t PoseLibrary_exposer = PoseLibrary_exposer_t( "PoseLibrary", bp::init< int >(( bp::arg("nBlocks") )) );
        bp::scope PoseLibrary_scope( PoseLibrary_exposer );
        { //::PoseLibrary::Create
        
            typedef ::boost::shared_ptr<PoseLibrary> ( *Create_function_type )( int );
            
            PoseLibrary_exposer.def( 
                "Create"
                , Create_function_type( &::PoseLibrary::Create )
                , ( bp::arg("nBlocks") ) );
        
        }
        { //::PoseLibrary::DimensionIDRange
        
            typedef ::std::pair<int, int> ( ::PoseLibrary::*DimensionIDRange_function_type )( int ) const;
            typedef ::std::pair<int, int> ( PoseLibrary_wrapper::*default_DimensionIDRange_function_type )( int ) const;
            
            PoseLibrary_exposer.def( 
                "DimensionIDRange"
                , DimensionIDRange_function_type(&::PoseLibrary::DimensionIDRange)
                , default_DimensionIDRange_function_type(&PoseLibrary_wrapper::default_DimensionIDRange)
                , ( bp::arg("dimension") ) );
        
        }
        { //::PoseLibrary::GeneratePoseIDs
        
            typedef ::std::pair<int, int> ( ::PoseLibrary::*GeneratePoseIDs_function_type )( int,int ) ;
            
            PoseLibrary_exposer.def( 
                "GeneratePoseIDs"
                , GeneratePoseIDs_function_type( &::PoseLibrary::GeneratePoseIDs )
                , ( bp::arg("block"), bp::arg("nPoses") ) );
        
        }
        { //::PoseLibrary::GetBlockIDRange
        
            typedef ::std::pair<int, int> ( ::PoseLibrary::*GetBlockIDRange_function_type )( int ) const;
            
            PoseLibrary_exposer.def( 
                "GetBlockIDRange"
                , GetBlockIDRange_function_type( &::PoseLibrary::GetBlockIDRange )
                , ( bp::arg("block") ) );
        
        }
        { //::PoseLibrary::NumDimensions
        
            typedef int ( ::PoseLibrary::*NumDimensions_function_type )(  ) const;
            typedef int ( PoseLibrary_wrapper::*default_NumDimensions_function_type )(  ) const;
            
            PoseLibrary_exposer.def( 
                "NumDimensions"
                , NumDimensions_function_type(&::PoseLibrary::NumDimensions)
                , default_NumDimensions_function_type(&PoseLibrary_wrapper::default_NumDimensions) );
        
        }
        { //::PoseLibrary::NumElements
        
            typedef int ( ::PoseLibrary::*NumElements_function_type )(  ) const;
            typedef int ( PoseLibrary_wrapper::*default_NumElements_function_type )(  ) const;
            
            PoseLibrary_exposer.def( 
                "NumElements"
                , NumElements_function_type(&::PoseLibrary::NumElements)
                , default_NumElements_function_type(&PoseLibrary_wrapper::default_NumElements) );
        
        }
        PoseLibrary_exposer.staticmethod( "Create" );
        bp::register_ptr_to_python< boost::shared_ptr< PoseLibrary > >();
        bp::implicitly_convertible< boost::shared_ptr< PoseLibrary >, boost::shared_ptr< DiscreteSearchSpace > >();
    }

}

