// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "stdafx.h"

#include "boost/python.hpp"

#include "boost/python/suite/indexing/vector_indexing_suite.hpp"


#include "boost/python/register_ptr_to_python.hpp"


#include "array_wrapper.hpp"

#include "AminoAcid.pypp.hpp"

#include "AminoAcidDirectory.pypp.hpp"

#include "AtomTypes.pypp.hpp"

#include "BinaryInputArchive.pypp.hpp"

#include "BinaryOutputArchive.pypp.hpp"

#include "BinaryStringInputArchive.pypp.hpp"

#include "BinaryStringOutputArchive.pypp.hpp"

#include "BoolVector.pypp.hpp"

#include "BoolVector2.pypp.hpp"

#include "BruteForcePacker.pypp.hpp"

#include "CCDParameters.pypp.hpp"

#include "ConstSystemVector.pypp.hpp"

#include "CountPair.pypp.hpp"

#include "DataDirectory.pypp.hpp"

#include "DiscreteSearchSpace.pypp.hpp"

#include "DunbrackLibrary.pypp.hpp"

#include "EGVertexVector.pypp.hpp"

#include "EnergyComb.pypp.hpp"

#include "EnergyCombList.pypp.hpp"

#include "EnergyFunction.pypp.hpp"

#include "EnergyGraph.pypp.hpp"

#include "EnergyHyperGraph.pypp.hpp"

#include "FasterPacker.pypp.hpp"

#include "FloatVector.pypp.hpp"

#include "GenericBinaryInputArchive.pypp.hpp"

#include "GenericBinaryOutputArchive.pypp.hpp"

#include "GenericXMLInputArchive.pypp.hpp"

#include "GenericXMLOutputArchive.pypp.hpp"

#include "Hybridization.pypp.hpp"

#include "IVec2.pypp.hpp"

#include "IVec3.pypp.hpp"

#include "IVec4.pypp.hpp"

#include "IntFloatPair.pypp.hpp"

#include "IntFloatPairVector.pypp.hpp"

#include "IntPair.pypp.hpp"

#include "IntPairVector.pypp.hpp"

#include "IntVector.pypp.hpp"

#include "IntVector2.pypp.hpp"

#include "IntVectorFloatPair.pypp.hpp"

#include "IntVectorFloatPairVector.pypp.hpp"

#include "MGMonteCarloPacker.pypp.hpp"

#include "MonteCarloPacker.pypp.hpp"

#include "NeighborMap.pypp.hpp"

#include "OPLSaa.pypp.hpp"

#include "OPLSaa_Interaction.pypp.hpp"

#include "OptimizationBase.pypp.hpp"

#include "OptimizationBaseMonteCarlo.pypp.hpp"

#include "OptimizationBaseSimulatedAnnealing.pypp.hpp"

#include "PoseLibrary.pypp.hpp"

#include "PyCHOMP_enumerations.pypp.hpp"

#include "PyCHOMP_free_functions.pypp.hpp"

#include "Raw.pypp.hpp"

#include "Residue.pypp.hpp"

#include "Rosetta.pypp.hpp"

#include "RotamerGenerationParameters.pypp.hpp"

#include "RotamerGenerator.pypp.hpp"

#include "RotamerIterationMap.pypp.hpp"

#include "RotamerLibrary.pypp.hpp"

#include "RotamerNode.pypp.hpp"

#include "RotamerSet.pypp.hpp"

#include "RuntimeStats.pypp.hpp"

#include "SimulatedAnnealingPacker.pypp.hpp"

#include "SimulatedAnnealingPackerMS.pypp.hpp"

#include "MGMonteCarloPacker.pypp.hpp"

#include "BruteForcePacker.pypp.hpp"

#include "StrVector.pypp.hpp"

#include "StrVector2.pypp.hpp"

#include "System.pypp.hpp"

#include "SystemVector.pypp.hpp"

#include "Vec2.pypp.hpp"

#include "Vec3.pypp.hpp"

#include "Vec3Vector.pypp.hpp"

#include "Vec4.pypp.hpp"

#include "Vec4Vector.pypp.hpp"

#include "XMLInputArchive.pypp.hpp"

#include "XMLOutputArchive.pypp.hpp"

#include "XMLStringInputArchive.pypp.hpp"

#include "XMLStringOutputArchive.pypp.hpp"

#include "chomp_headers.h"

namespace bp = boost::python;

void str_exception(std::string const& exc)
		{
			if (exc == "EOF")
				PyErr_SetString( PyExc_EOFError, "" );
			else
				PyErr_SetString( PyExc_RuntimeError, ("CHOMP Error: " + exc).c_str() );
		}

BOOST_PYTHON_MODULE(PyCHOMP){
    register_enumerations();

    register_StrVector2_class();

    register_IntVector2_class();

    register_BoolVector2_class();

    register_StrVector_class();

    register_IntVectorFloatPairVector_class();

    register_IntPairVector_class();

    register_IntFloatPairVector_class();

    register_IntVector_class();

    register_FloatVector_class();

    register_SystemVector_class();

    register_ConstSystemVector_class();

    register_EGVertexVector_class();

    register_BoolVector_class();

    register_Vec4Vector_class();

    register_Vec3Vector_class();

    register_AminoAcid_class();

    register_AminoAcidDirectory_class();

    bp::implicitly_convertible< boost::shared_ptr<AtomTypes const>, AminoAcidDirectory >();

    register_CountPair_class();

    register_Hybridization_class();

    register_OPLSaa_class();

    register_OPLSaa_Interaction_class();

    register_Raw_class();

    register_Rosetta_class();

    register_AtomTypes_class();

    register_OptimizationBase_class();

    register_BruteForcePacker_class();

    register_CCDParameters_class();

    register_DataDirectory_class();

    bp::implicitly_convertible< std::string const &, DataDirectory >();

    register_DiscreteSearchSpace_class();

    register_DunbrackLibrary_class();

    register_EnergyComb_class();

    register_EnergyCombList_class();

    bp::implicitly_convertible< bool, EnergyCombList >();

    register_EnergyFunction_class();

    register_EnergyGraph_class();

    register_EnergyHyperGraph_class();

    register_FasterPacker_class();

    register_GenericBinaryInputArchive_class();

    register_GenericXMLInputArchive_class();

    register_GenericBinaryOutputArchive_class();

    register_GenericXMLOutputArchive_class();

    register_BinaryInputArchive_class();

    bp::implicitly_convertible< std::string const &, InputArchive<boost::archive::binary_iarchive> >();

    register_XMLInputArchive_class();

    bp::implicitly_convertible< std::string const &, InputArchive<boost::archive::xml_iarchive> >();

    register_OptimizationBaseMonteCarlo_class();

    register_MGMonteCarloPacker_class();

    register_MonteCarloPacker_class();

    register_NeighborMap_class();

    register_OptimizationBaseSimulatedAnnealing_class();

    register_BinaryOutputArchive_class();

    bp::implicitly_convertible< std::string const &, OutputArchive<boost::archive::binary_oarchive> >();

    register_XMLOutputArchive_class();

    bp::implicitly_convertible< std::string const &, OutputArchive<boost::archive::xml_oarchive> >();

    register_PoseLibrary_class();

    bp::implicitly_convertible< int, PoseLibrary >();

    register_Residue_class();

    register_RotamerGenerationParameters_class();

    register_RotamerGenerator_class();

    register_RotamerIterationMap_class();

    bp::implicitly_convertible< boost::shared_ptr<RotamerLibrary const>, RotamerIterationMap >();

    register_RotamerLibrary_class();

    bp::implicitly_convertible< std::vector<boost::shared_ptr<System const>, std::allocator<boost::shared_ptr<System const> > > const &, RotamerLibrary >();

    register_RotamerNode_class();

    register_RotamerSet_class();

    bp::implicitly_convertible< Residue const &, RotamerSet >();

    register_RuntimeStats_class();

    register_SimulatedAnnealingPacker_class();

    register_SimulatedAnnealingPackerMS_class();

    register_MGMonteCarloPacker_class();

    register_BruteForcePacker_class();

    register_BinaryStringInputArchive_class();

    bp::implicitly_convertible< std::string, StringInputArchive<boost::archive::binary_iarchive> >();

    register_XMLStringInputArchive_class();

    bp::implicitly_convertible< std::string, StringInputArchive<boost::archive::xml_iarchive> >();

    register_BinaryStringOutputArchive_class();

    register_XMLStringOutputArchive_class();

    register_System_class();

    register_Vec2_class();

    bp::implicitly_convertible< float const, blitz::TinyVector<float, 2> >();

    bp::implicitly_convertible< float const *, blitz::TinyVector<float, 2> >();

    register_Vec3_class();

    bp::implicitly_convertible< float const, blitz::TinyVector<float, 3> >();

    bp::implicitly_convertible< float const *, blitz::TinyVector<float, 3> >();

    register_Vec4_class();

    bp::implicitly_convertible< float const, blitz::TinyVector<float, 4> >();

    bp::implicitly_convertible< float const *, blitz::TinyVector<float, 4> >();

    register_IVec2_class();

    bp::implicitly_convertible< int const, blitz::TinyVector<int, 2> >();

    bp::implicitly_convertible< int const *, blitz::TinyVector<int, 2> >();

    register_IVec3_class();

    bp::implicitly_convertible< int const, blitz::TinyVector<int, 3> >();

    bp::implicitly_convertible< int const *, blitz::TinyVector<int, 3> >();

    register_IVec4_class();

    bp::implicitly_convertible< int const, blitz::TinyVector<int, 4> >();

    bp::implicitly_convertible< int const *, blitz::TinyVector<int, 4> >();

    register_IntFloatPair_class();

    register_IntPair_class();

    register_IntVectorFloatPair_class();

    boost::python::register_ptr_to_python< boost::shared_ptr<System const> >();

    boost::python::implicitly_convertible< boost::shared_ptr<System >, boost::shared_ptr<System const> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<DunbrackLibrary> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<DunbrackLibrary const> >();

    boost::python::implicitly_convertible< boost::shared_ptr<DunbrackLibrary >, boost::shared_ptr<DunbrackLibrary const> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<DataDirectory const> >();

    boost::python::implicitly_convertible< boost::shared_ptr<DataDirectory >, boost::shared_ptr<DataDirectory const> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<const RotamerIterationMap> >();

    boost::python::implicitly_convertible< boost::shared_ptr< RotamerIterationMap>, boost::shared_ptr<const RotamerIterationMap> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<RotamerLibrary const> >();

    boost::python::implicitly_convertible< boost::shared_ptr<RotamerLibrary >, boost::shared_ptr<RotamerLibrary const> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<NeighborMap const> >();

    boost::python::implicitly_convertible< boost::shared_ptr<NeighborMap >, boost::shared_ptr<NeighborMap const> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<AminoAcidDirectory const> >();

    boost::python::implicitly_convertible< boost::shared_ptr<AminoAcidDirectory >, boost::shared_ptr<AminoAcidDirectory const> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<AtomTypes const> >();

    boost::python::implicitly_convertible< boost::shared_ptr<AtomTypes >, boost::shared_ptr<AtomTypes const> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<DiscreteSearchSpace const> >();

    boost::python::implicitly_convertible< boost::shared_ptr<DiscreteSearchSpace >, boost::shared_ptr<DiscreteSearchSpace const> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<const PoseLibrary> >();

    boost::python::implicitly_convertible< boost::shared_ptr< PoseLibrary>, boost::shared_ptr<const PoseLibrary> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<const EnergyCombList> >();

    boost::python::implicitly_convertible< boost::shared_ptr< EnergyCombList>, boost::shared_ptr<const EnergyCombList> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<const RuntimeStats> >();

    boost::python::implicitly_convertible< boost::shared_ptr< RuntimeStats>, boost::shared_ptr<const RuntimeStats> >();

    boost::python::register_ptr_to_python< boost::shared_ptr<DiscreteSearchSpace> >();

    import_array();

    BLITZARRAY_CONVERT(FLOAT, 1);

    BLITZARRAY_CONVERT(FLOAT, 2);

    BLITZARRAY_CONVERT(FLOAT, 3);

    BLITZARRAY_CONVERT(FLOAT, 4);

    BLITZARRAY_CONVERT(FLOAT, 5);

    boost::python::register_exception_translator<std::string>(str_exception);

    register_free_functions();
}


