// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "PyCHOMP_enumerations.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "amino_acid.h"
#include "atom_type.h"
#include "runtime_stats.h"
#include "rotamer_generator.h"

namespace bp = boost::python;

void register_enumerations(){

    bp::enum_< AminoAcidIndex>("AminoAcidIndex")
        .value("ALA", ALA)
        .value("CYS", CYS)
        .value("ASP", ASP)
        .value("GLU", GLU)
        .value("PHE", PHE)
        .value("GLY", GLY)
        .value("HIS", HIS)
        .value("ILE", ILE)
        .value("LYS", LYS)
        .value("LEU", LEU)
        .value("MET", MET)
        .value("ASN", ASN)
        .value("PRO", PRO)
        .value("GLN", GLN)
        .value("ARG", ARG)
        .value("SER", SER)
        .value("THR", THR)
        .value("VAL", VAL)
        .value("TRP", TRP)
        .value("TYR", TYR)
        .value("NALA", NALA)
        .value("NCYS", NCYS)
        .value("NASP", NASP)
        .value("NGLU", NGLU)
        .value("NPHE", NPHE)
        .value("NGLY", NGLY)
        .value("NHIS", NHIS)
        .value("NILE", NILE)
        .value("NLYS", NLYS)
        .value("NLEU", NLEU)
        .value("NMET", NMET)
        .value("NASN", NASN)
        .value("NPRO", NPRO)
        .value("NGLN", NGLN)
        .value("NARG", NARG)
        .value("NSER", NSER)
        .value("NTHR", NTHR)
        .value("NVAL", NVAL)
        .value("NTRP", NTRP)
        .value("NTYR", NTYR)
        .value("CALA", CALA)
        .value("CCYS", CCYS)
        .value("CASP", CASP)
        .value("CGLU", CGLU)
        .value("CPHE", CPHE)
        .value("CGLY", CGLY)
        .value("CHIS", CHIS)
        .value("CILE", CILE)
        .value("CLYS", CLYS)
        .value("CLEU", CLEU)
        .value("CMET", CMET)
        .value("CASN", CASN)
        .value("CPRO", CPRO)
        .value("CGLN", CGLN)
        .value("CARG", CARG)
        .value("CSER", CSER)
        .value("CTHR", CTHR)
        .value("CVAL", CVAL)
        .value("CTRP", CTRP)
        .value("CTYR", CTYR)
        .export_values()
        ;

    bp::enum_< AtomOrderClass>("AtomOrderClass")
        .value("CHOMP_ATOM_ORDER", CHOMP_ATOM_ORDER)
        .value("PDB_ATOM_ORDER", PDB_ATOM_ORDER)
        .export_values()
        ;

    bp::enum_< ExtraChiType>("ExtraChiType")
        .value("EXTRA_CHI_1xSD", EXTRA_CHI_1xSD)
        .value("EXTRA_CHI_2xSD", EXTRA_CHI_2xSD)
        .value("EXTRA_CHI_ARO", EXTRA_CHI_ARO)
        .value("EXTRA_CHI_HALF_ARO", EXTRA_CHI_HALF_ARO)
        .value("EXTRA_CHI_CYS", EXTRA_CHI_CYS)
        .value("EXTRA_CHI_H", EXTRA_CHI_H)
        .value("EXTRA_CHI_CUSTOM", EXTRA_CHI_CUSTOM)
        .export_values()
        ;

    bp::enum_< ResidueBurialState>("ResidueBurialState")
        .value("SURFACE", SURFACE)
        .value("BURIED", BURIED)
        .export_values()
        ;

    bp::enum_< RuntimeStatType>("RuntimeStatType")
        .value("RSTATS_ATOM_PAIRWISE", RSTATS_ATOM_PAIRWISE)
        .value("RSTATS_ATOM_PAIRWISE_PASSED_CUTOFF", RSTATS_ATOM_PAIRWISE_PASSED_CUTOFF)
        .value("RSTATS_ATOM_PAIRWISE_HB", RSTATS_ATOM_PAIRWISE_HB)
        .value("RSTATS_SIMANNEAL_ITER", RSTATS_SIMANNEAL_ITER)
        .value("RSTATS_SIMANNEAL_DIFFENERGY", RSTATS_SIMANNEAL_DIFFENERGY)
        .value("RSTATS_SIMANNEAL_DIFFENERGY_HG", RSTATS_SIMANNEAL_DIFFENERGY_HG)
        .value("RSTATS_SIMANNEAL_LISTOP", RSTATS_SIMANNEAL_LISTOP)
        .value("RSTATS_MONTECARLO_ITER", RSTATS_MONTECARLO_ITER)
        .value("RSTATS_BRUTEFORCE_ITER", RSTATS_BRUTEFORCE_ITER)
        .value("RSTATS_ALL", RSTATS_ALL)
        .export_values()
        ;

    bp::enum_< AtomType::TypeSystem>("TypeSystem")
        .value("RAW_TYPE", AtomType::RAW_TYPE)
        .value("HYBRIDIZATION", AtomType::HYBRIDIZATION)
        .value("ROSETTA_TYPE", AtomType::ROSETTA_TYPE)
        .value("COUNT_PAIR_TYPE", AtomType::COUNT_PAIR_TYPE)
        .value("OPLSaa_INTERACTION_TYPE", AtomType::OPLSaa_INTERACTION_TYPE)
        .value("OPLSaa_TYPE", AtomType::OPLSaa_TYPE)
        .export_values()
        ;

}

