// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "PyCHOMP_free_functions.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "wrap_headers.h"

namespace bp = boost::python;

void register_free_functions(){

    { //::LoadBasicFromArchive
    
        typedef ::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > ( *LoadBasicFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadBasicFromArchive"
            , LoadBasicFromArchive_function_type( &::LoadBasicFromArchive )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive
    
        typedef ::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > ( *LoadBasicFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadBasicFromArchive"
            , LoadBasicFromArchive_function_type( &::LoadBasicFromArchive )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive
    
        typedef ::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > ( *LoadBasicFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadBasicFromArchive"
            , LoadBasicFromArchive_function_type( &::LoadBasicFromArchive )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive
    
        typedef ::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > ( *LoadBasicFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadBasicFromArchive"
            , LoadBasicFromArchive_function_type( &::LoadBasicFromArchive )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<AminoAcidDirectory>, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<AminoAcidDirectory> ( *LoadAminoAcidDirectoryFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadAminoAcidDirectoryFromArchive"
            , LoadAminoAcidDirectoryFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<AminoAcidDirectory>, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<AminoAcidDirectory>, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<AminoAcidDirectory> ( *LoadAminoAcidDirectoryFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadAminoAcidDirectoryFromArchive"
            , LoadAminoAcidDirectoryFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<AminoAcidDirectory>, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<AminoAcidDirectory>, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<AminoAcidDirectory> ( *LoadAminoAcidDirectoryFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadAminoAcidDirectoryFromArchive"
            , LoadAminoAcidDirectoryFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<AminoAcidDirectory>, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<AminoAcidDirectory>, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<AminoAcidDirectory> ( *LoadAminoAcidDirectoryFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadAminoAcidDirectoryFromArchive"
            , LoadAminoAcidDirectoryFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<AminoAcidDirectory>, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<AtomTypes>, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<AtomTypes> ( *LoadAtomTypesFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadAtomTypesFromArchive"
            , LoadAtomTypesFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<AtomTypes>, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<AtomTypes>, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<AtomTypes> ( *LoadAtomTypesFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadAtomTypesFromArchive"
            , LoadAtomTypesFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<AtomTypes>, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<AtomTypes>, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<AtomTypes> ( *LoadAtomTypesFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadAtomTypesFromArchive"
            , LoadAtomTypesFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<AtomTypes>, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<AtomTypes>, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<AtomTypes> ( *LoadAtomTypesFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadAtomTypesFromArchive"
            , LoadAtomTypesFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<AtomTypes>, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<NeighborMap>, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<NeighborMap> ( *LoadNeighborMapFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadNeighborMapFromArchive"
            , LoadNeighborMapFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<NeighborMap>, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<NeighborMap>, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<NeighborMap> ( *LoadNeighborMapFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadNeighborMapFromArchive"
            , LoadNeighborMapFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<NeighborMap>, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<NeighborMap>, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<NeighborMap> ( *LoadNeighborMapFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadNeighborMapFromArchive"
            , LoadNeighborMapFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<NeighborMap>, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<NeighborMap>, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<NeighborMap> ( *LoadNeighborMapFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadNeighborMapFromArchive"
            , LoadNeighborMapFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<NeighborMap>, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<PoseLibrary>, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<PoseLibrary> ( *LoadPoseLibraryFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadPoseLibraryFromArchive"
            , LoadPoseLibraryFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<PoseLibrary>, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<PoseLibrary>, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<PoseLibrary> ( *LoadPoseLibraryFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadPoseLibraryFromArchive"
            , LoadPoseLibraryFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<PoseLibrary>, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<PoseLibrary>, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<PoseLibrary> ( *LoadPoseLibraryFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadPoseLibraryFromArchive"
            , LoadPoseLibraryFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<PoseLibrary>, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<PoseLibrary>, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<PoseLibrary> ( *LoadPoseLibraryFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadPoseLibraryFromArchive"
            , LoadPoseLibraryFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<PoseLibrary>, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<RotamerIterationMap>, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<RotamerIterationMap> ( *LoadRotamerIterationMapFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadRotamerIterationMapFromArchive"
            , LoadRotamerIterationMapFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<RotamerIterationMap>, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<RotamerIterationMap>, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<RotamerIterationMap> ( *LoadRotamerIterationMapFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadRotamerIterationMapFromArchive"
            , LoadRotamerIterationMapFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<RotamerIterationMap>, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<RotamerIterationMap>, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<RotamerIterationMap> ( *LoadRotamerIterationMapFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadRotamerIterationMapFromArchive"
            , LoadRotamerIterationMapFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<RotamerIterationMap>, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<RotamerIterationMap>, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<RotamerIterationMap> ( *LoadRotamerIterationMapFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadRotamerIterationMapFromArchive"
            , LoadRotamerIterationMapFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<RotamerIterationMap>, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<RotamerLibrary>, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<RotamerLibrary> ( *LoadRotamerLibraryFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadRotamerLibraryFromArchive"
            , LoadRotamerLibraryFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<RotamerLibrary>, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<RotamerLibrary>, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<RotamerLibrary> ( *LoadRotamerLibraryFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadRotamerLibraryFromArchive"
            , LoadRotamerLibraryFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<RotamerLibrary>, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<RotamerLibrary>, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<RotamerLibrary> ( *LoadRotamerLibraryFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadRotamerLibraryFromArchive"
            , LoadRotamerLibraryFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<RotamerLibrary>, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<RotamerLibrary>, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<RotamerLibrary> ( *LoadRotamerLibraryFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadRotamerLibraryFromArchive"
            , LoadRotamerLibraryFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<RotamerLibrary>, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<RuntimeStats>, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<RuntimeStats> ( *LoadRuntimeStatsFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadRuntimeStatsFromArchive"
            , LoadRuntimeStatsFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<RuntimeStats>, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<RuntimeStats>, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<RuntimeStats> ( *LoadRuntimeStatsFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadRuntimeStatsFromArchive"
            , LoadRuntimeStatsFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<RuntimeStats>, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<RuntimeStats>, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<RuntimeStats> ( *LoadRuntimeStatsFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadRuntimeStatsFromArchive"
            , LoadRuntimeStatsFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<RuntimeStats>, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<RuntimeStats>, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<RuntimeStats> ( *LoadRuntimeStatsFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadRuntimeStatsFromArchive"
            , LoadRuntimeStatsFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<RuntimeStats>, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<System>, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<System> ( *LoadSystemFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadSystemFromArchive"
            , LoadSystemFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<System>, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<System>, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<System> ( *LoadSystemFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadSystemFromArchive"
            , LoadSystemFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<System>, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<System>, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<System> ( *LoadSystemFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadSystemFromArchive"
            , LoadSystemFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<System>, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadBasicFromArchive<boost::shared_ptr<System>, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<System> ( *LoadSystemFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadSystemFromArchive"
            , LoadSystemFromArchive_function_type( &::LoadBasicFromArchive<boost::shared_ptr<System>, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFloatFromArchive
    
        typedef ::FLOAT ( *LoadFloatFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadFloatFromArchive"
            , LoadFloatFromArchive_function_type( &::LoadFloatFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadFloatFromArchive
    
        typedef ::FLOAT ( *LoadFloatFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadFloatFromArchive"
            , LoadFloatFromArchive_function_type( &::LoadFloatFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadFloatFromArchive
    
        typedef ::FLOAT ( *LoadFloatFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadFloatFromArchive"
            , LoadFloatFromArchive_function_type( &::LoadFloatFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadFloatFromArchive
    
        typedef ::FLOAT ( *LoadFloatFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadFloatFromArchive"
            , LoadFloatFromArchive_function_type( &::LoadFloatFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadFromArchive<AminoAcid, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<AminoAcid> ( *LoadAminoAcidFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadAminoAcidFromArchive"
            , LoadAminoAcidFromArchive_function_type( &::LoadFromArchive<AminoAcid, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<AminoAcid, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<AminoAcid> ( *LoadAminoAcidFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadAminoAcidFromArchive"
            , LoadAminoAcidFromArchive_function_type( &::LoadFromArchive<AminoAcid, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<AminoAcid, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<AminoAcid> ( *LoadAminoAcidFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadAminoAcidFromArchive"
            , LoadAminoAcidFromArchive_function_type( &::LoadFromArchive<AminoAcid, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<AminoAcid, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<AminoAcid> ( *LoadAminoAcidFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadAminoAcidFromArchive"
            , LoadAminoAcidFromArchive_function_type( &::LoadFromArchive<AminoAcid, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<EnergyComb, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<EnergyComb> ( *LoadEnergyCombFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadEnergyCombFromArchive"
            , LoadEnergyCombFromArchive_function_type( &::LoadFromArchive<EnergyComb, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<EnergyComb, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<EnergyComb> ( *LoadEnergyCombFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadEnergyCombFromArchive"
            , LoadEnergyCombFromArchive_function_type( &::LoadFromArchive<EnergyComb, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<EnergyComb, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<EnergyComb> ( *LoadEnergyCombFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadEnergyCombFromArchive"
            , LoadEnergyCombFromArchive_function_type( &::LoadFromArchive<EnergyComb, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<EnergyComb, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<EnergyComb> ( *LoadEnergyCombFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadEnergyCombFromArchive"
            , LoadEnergyCombFromArchive_function_type( &::LoadFromArchive<EnergyComb, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<EnergyGraph, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<EnergyGraph> ( *LoadEnergyGraphFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadEnergyGraphFromArchive"
            , LoadEnergyGraphFromArchive_function_type( &::LoadFromArchive<EnergyGraph, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<EnergyGraph, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<EnergyGraph> ( *LoadEnergyGraphFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadEnergyGraphFromArchive"
            , LoadEnergyGraphFromArchive_function_type( &::LoadFromArchive<EnergyGraph, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<EnergyGraph, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<EnergyGraph> ( *LoadEnergyGraphFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadEnergyGraphFromArchive"
            , LoadEnergyGraphFromArchive_function_type( &::LoadFromArchive<EnergyGraph, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<EnergyGraph, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<EnergyGraph> ( *LoadEnergyGraphFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadEnergyGraphFromArchive"
            , LoadEnergyGraphFromArchive_function_type( &::LoadFromArchive<EnergyGraph, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<EnergyHyperGraph, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<EnergyHyperGraph> ( *LoadEnergyHyperGraphFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadEnergyHyperGraphFromArchive"
            , LoadEnergyHyperGraphFromArchive_function_type( &::LoadFromArchive<EnergyHyperGraph, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<EnergyHyperGraph, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<EnergyHyperGraph> ( *LoadEnergyHyperGraphFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadEnergyHyperGraphFromArchive"
            , LoadEnergyHyperGraphFromArchive_function_type( &::LoadFromArchive<EnergyHyperGraph, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<EnergyHyperGraph, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<EnergyHyperGraph> ( *LoadEnergyHyperGraphFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadEnergyHyperGraphFromArchive"
            , LoadEnergyHyperGraphFromArchive_function_type( &::LoadFromArchive<EnergyHyperGraph, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<EnergyHyperGraph, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<EnergyHyperGraph> ( *LoadEnergyHyperGraphFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadEnergyHyperGraphFromArchive"
            , LoadEnergyHyperGraphFromArchive_function_type( &::LoadFromArchive<EnergyHyperGraph, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<Residue, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<Residue> ( *LoadResidueFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadResidueFromArchive"
            , LoadResidueFromArchive_function_type( &::LoadFromArchive<Residue, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<Residue, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<Residue> ( *LoadResidueFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadResidueFromArchive"
            , LoadResidueFromArchive_function_type( &::LoadFromArchive<Residue, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<Residue, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<Residue> ( *LoadResidueFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadResidueFromArchive"
            , LoadResidueFromArchive_function_type( &::LoadFromArchive<Residue, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<Residue, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<Residue> ( *LoadResidueFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadResidueFromArchive"
            , LoadResidueFromArchive_function_type( &::LoadFromArchive<Residue, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<RotamerGenerationParameters, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<RotamerGenerationParameters> ( *LoadRotamerGenerationParametersFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadRotamerGenerationParametersFromArchive"
            , LoadRotamerGenerationParametersFromArchive_function_type( &::LoadFromArchive<RotamerGenerationParameters, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<RotamerGenerationParameters, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<RotamerGenerationParameters> ( *LoadRotamerGenerationParametersFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadRotamerGenerationParametersFromArchive"
            , LoadRotamerGenerationParametersFromArchive_function_type( &::LoadFromArchive<RotamerGenerationParameters, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<RotamerGenerationParameters, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<RotamerGenerationParameters> ( *LoadRotamerGenerationParametersFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadRotamerGenerationParametersFromArchive"
            , LoadRotamerGenerationParametersFromArchive_function_type( &::LoadFromArchive<RotamerGenerationParameters, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<RotamerGenerationParameters, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<RotamerGenerationParameters> ( *LoadRotamerGenerationParametersFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadRotamerGenerationParametersFromArchive"
            , LoadRotamerGenerationParametersFromArchive_function_type( &::LoadFromArchive<RotamerGenerationParameters, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<SimulatedAnnealingPacker, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<SimulatedAnnealingPacker> ( *LoadSimulatedAnnealingPackerFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadSimulatedAnnealingPackerFromArchive"
            , LoadSimulatedAnnealingPackerFromArchive_function_type( &::LoadFromArchive<SimulatedAnnealingPacker, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<SimulatedAnnealingPacker, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<SimulatedAnnealingPacker> ( *LoadSimulatedAnnealingPackerFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadSimulatedAnnealingPackerFromArchive"
            , LoadSimulatedAnnealingPackerFromArchive_function_type( &::LoadFromArchive<SimulatedAnnealingPacker, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<SimulatedAnnealingPacker, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<SimulatedAnnealingPacker> ( *LoadSimulatedAnnealingPackerFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadSimulatedAnnealingPackerFromArchive"
            , LoadSimulatedAnnealingPackerFromArchive_function_type( &::LoadFromArchive<SimulatedAnnealingPacker, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<SimulatedAnnealingPacker, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<SimulatedAnnealingPacker> ( *LoadSimulatedAnnealingPackerFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadSimulatedAnnealingPackerFromArchive"
            , LoadSimulatedAnnealingPackerFromArchive_function_type( &::LoadFromArchive<SimulatedAnnealingPacker, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<SimulatedAnnealingPackerMS, InputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<SimulatedAnnealingPackerMS> ( *LoadSimulatedAnnealingPackerMSFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadSimulatedAnnealingPackerMSFromArchive"
            , LoadSimulatedAnnealingPackerMSFromArchive_function_type( &::LoadFromArchive<SimulatedAnnealingPackerMS, InputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<SimulatedAnnealingPackerMS, InputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<SimulatedAnnealingPackerMS> ( *LoadSimulatedAnnealingPackerMSFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadSimulatedAnnealingPackerMSFromArchive"
            , LoadSimulatedAnnealingPackerMSFromArchive_function_type( &::LoadFromArchive<SimulatedAnnealingPackerMS, InputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<SimulatedAnnealingPackerMS, StringInputArchive<boost::archive::binary_iarchive> >
    
        typedef ::boost::shared_ptr<SimulatedAnnealingPackerMS> ( *LoadSimulatedAnnealingPackerMSFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadSimulatedAnnealingPackerMSFromArchive"
            , LoadSimulatedAnnealingPackerMSFromArchive_function_type( &::LoadFromArchive<SimulatedAnnealingPackerMS, StringInputArchive<boost::archive::binary_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadFromArchive<SimulatedAnnealingPackerMS, StringInputArchive<boost::archive::xml_iarchive> >
    
        typedef ::boost::shared_ptr<SimulatedAnnealingPackerMS> ( *LoadSimulatedAnnealingPackerMSFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadSimulatedAnnealingPackerMSFromArchive"
            , LoadSimulatedAnnealingPackerMSFromArchive_function_type( &::LoadFromArchive<SimulatedAnnealingPackerMS, StringInputArchive<boost::archive::xml_iarchive> > )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadIntFromArchive
    
        typedef int ( *LoadIntFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadIntFromArchive"
            , LoadIntFromArchive_function_type( &::LoadIntFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadIntFromArchive
    
        typedef int ( *LoadIntFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadIntFromArchive"
            , LoadIntFromArchive_function_type( &::LoadIntFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadIntFromArchive
    
        typedef int ( *LoadIntFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadIntFromArchive"
            , LoadIntFromArchive_function_type( &::LoadIntFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadIntFromArchive
    
        typedef int ( *LoadIntFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadIntFromArchive"
            , LoadIntFromArchive_function_type( &::LoadIntFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadIntVectorFromArchive
    
        typedef ::std::vector<int, std::allocator<int> > ( *LoadIntVectorFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadIntVectorFromArchive"
            , LoadIntVectorFromArchive_function_type( &::LoadIntVectorFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadIntVectorFromArchive
    
        typedef ::std::vector<int, std::allocator<int> > ( *LoadIntVectorFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadIntVectorFromArchive"
            , LoadIntVectorFromArchive_function_type( &::LoadIntVectorFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadIntVectorFromArchive
    
        typedef ::std::vector<int, std::allocator<int> > ( *LoadIntVectorFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadIntVectorFromArchive"
            , LoadIntVectorFromArchive_function_type( &::LoadIntVectorFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadIntVectorFromArchive
    
        typedef ::std::vector<int, std::allocator<int> > ( *LoadIntVectorFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadIntVectorFromArchive"
            , LoadIntVectorFromArchive_function_type( &::LoadIntVectorFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadStringFromArchive
    
        typedef ::std::string ( *LoadStringFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadStringFromArchive"
            , LoadStringFromArchive_function_type( &::LoadStringFromArchive )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadStringFromArchive
    
        typedef ::std::string ( *LoadStringFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadStringFromArchive"
            , LoadStringFromArchive_function_type( &::LoadStringFromArchive )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadStringFromArchive
    
        typedef ::std::string ( *LoadStringFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadStringFromArchive"
            , LoadStringFromArchive_function_type( &::LoadStringFromArchive )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadStringFromArchive
    
        typedef ::std::string ( *LoadStringFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadStringFromArchive"
            , LoadStringFromArchive_function_type( &::LoadStringFromArchive )
            , ( bp::arg("a") ) );
    
    }

    { //::LoadSystemVectorFromArchive
    
        typedef ::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > ( *LoadSystemVectorFromArchive_function_type )( ::BinaryStringInputArchive & );
        
        bp::def( 
            "LoadSystemVectorFromArchive"
            , LoadSystemVectorFromArchive_function_type( &::LoadSystemVectorFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadSystemVectorFromArchive
    
        typedef ::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > ( *LoadSystemVectorFromArchive_function_type )( ::XMLStringInputArchive & );
        
        bp::def( 
            "LoadSystemVectorFromArchive"
            , LoadSystemVectorFromArchive_function_type( &::LoadSystemVectorFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadSystemVectorFromArchive
    
        typedef ::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > ( *LoadSystemVectorFromArchive_function_type )( ::BinaryInputArchive & );
        
        bp::def( 
            "LoadSystemVectorFromArchive"
            , LoadSystemVectorFromArchive_function_type( &::LoadSystemVectorFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::LoadSystemVectorFromArchive
    
        typedef ::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > ( *LoadSystemVectorFromArchive_function_type )( ::XMLInputArchive & );
        
        bp::def( 
            "LoadSystemVectorFromArchive"
            , LoadSystemVectorFromArchive_function_type( &::LoadSystemVectorFromArchive )
            , ( bp::arg("ar") ) );
    
    }

    { //::RebuildLoopsCCD
    
        typedef ::boost::shared_ptr<System> ( *RebuildLoopsCCD_function_type )( ::boost::shared_ptr<System const>,::std::vector<int, std::allocator<int> > const &,::CCDParameters const & );
        
        bp::def( 
            "RebuildLoopsCCD"
            , RebuildLoopsCCD_function_type( &::RebuildLoopsCCD )
            , ( bp::arg("system"), bp::arg("chainbreaks"), bp::arg("parameters") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::std::string const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::std::string const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::std::string const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::std::string const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::boost::shared_ptr<System> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::boost::shared_ptr<System> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::boost::shared_ptr<System> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::boost::shared_ptr<System> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::SimulatedAnnealingPackerMS const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::SimulatedAnnealingPackerMS const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::SimulatedAnnealingPackerMS const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::SimulatedAnnealingPackerMS const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::SimulatedAnnealingPacker const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::SimulatedAnnealingPacker const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::SimulatedAnnealingPacker const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::SimulatedAnnealingPacker const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::boost::shared_ptr<RuntimeStats> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::boost::shared_ptr<RuntimeStats> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::boost::shared_ptr<RuntimeStats> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::boost::shared_ptr<RuntimeStats> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::boost::shared_ptr<RotamerLibrary> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::boost::shared_ptr<RotamerLibrary> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::boost::shared_ptr<RotamerLibrary> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::boost::shared_ptr<RotamerLibrary> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::boost::shared_ptr<RotamerIterationMap> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::boost::shared_ptr<RotamerIterationMap> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::boost::shared_ptr<RotamerIterationMap> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::boost::shared_ptr<RotamerIterationMap> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::RotamerGenerationParameters const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::RotamerGenerationParameters const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::RotamerGenerationParameters const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::RotamerGenerationParameters const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::Residue const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::Residue const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::Residue const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::Residue const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::boost::shared_ptr<PoseLibrary> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::boost::shared_ptr<PoseLibrary> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::boost::shared_ptr<PoseLibrary> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::boost::shared_ptr<PoseLibrary> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::boost::shared_ptr<NeighborMap> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::boost::shared_ptr<NeighborMap> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::boost::shared_ptr<NeighborMap> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::boost::shared_ptr<NeighborMap> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::EnergyHyperGraph const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::EnergyHyperGraph const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::EnergyHyperGraph const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::EnergyHyperGraph const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::EnergyGraph const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::EnergyGraph const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::EnergyGraph const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::EnergyGraph const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::EnergyComb const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::EnergyComb const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::EnergyComb const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::EnergyComb const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::boost::shared_ptr<AtomTypes> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::boost::shared_ptr<AtomTypes> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::boost::shared_ptr<AtomTypes> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::boost::shared_ptr<AtomTypes> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::boost::shared_ptr<AminoAcidDirectory> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::boost::shared_ptr<AminoAcidDirectory> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::boost::shared_ptr<AminoAcidDirectory> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::boost::shared_ptr<AminoAcidDirectory> const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::AminoAcid const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::AminoAcid const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::AminoAcid const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::AminoAcid const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::std::vector<int, std::allocator<int> > const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::std::vector<int, std::allocator<int> > const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::std::vector<int, std::allocator<int> > const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::std::vector<int, std::allocator<int> > const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::std::string const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::std::string const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::std::string const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::std::string const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,::FLOAT const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,::FLOAT const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,::FLOAT const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,::FLOAT const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryStringOutputArchive &,::std::string const &,int const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLStringOutputArchive &,::std::string const &,int const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::BinaryOutputArchive &,::std::string const &,int const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::SaveToArchive
    
        typedef void ( *SaveToArchive_function_type )( ::XMLOutputArchive &,::std::string const &,int const & );
        
        bp::def( 
            "SaveToArchive"
            , SaveToArchive_function_type( &::SaveToArchive )
            , ( bp::arg("a"), bp::arg("elementName"), bp::arg("object") ) );
    
    }

    { //::py_details::instantiate
    
        typedef void ( *instantiate_function_type )(  );
        
        bp::def( 
            "instantiate"
            , instantiate_function_type( &::py_details::instantiate ) );
    
    }

    { //::rotate_left
    
        typedef unsigned char ( *rotate_left_function_type )( unsigned char,unsigned char );
        
        bp::def( 
            "rotate_left"
            , rotate_left_function_type( &::rotate_left )
            , ( bp::arg("val"), bp::arg("shift")=(unsigned char)(1) ) );
    
    }

    { //::rotate_right
    
        typedef unsigned char ( *rotate_right_function_type )( unsigned char,unsigned char );
        
        bp::def( 
            "rotate_right"
            , rotate_right_function_type( &::rotate_right )
            , ( bp::arg("val"), bp::arg("shift")=(unsigned char)(1) ) );
    
    }

    { //::py_details::serialize_instantiate
    
        typedef void ( *serialize_instantiate_function_type )(  );
        
        bp::def( 
            "serialize_instantiate"
            , serialize_instantiate_function_type( &::py_details::serialize_instantiate ) );
    
    }

}

