// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "Residue.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "system.h"
#include "residue.h"

namespace bp = boost::python;

void register_Residue_class(){

    { //::Residue
        typedef bp::class_< Residue > Residue_exposer_t;
        Residue_exposer_t Residue_exposer = Residue_exposer_t( "Residue" );
        bp::scope Residue_scope( Residue_exposer );
        Residue_exposer.def( bp::init< >() );
        { //::Residue::AlignBackboneToResidue
        
            typedef void ( ::Residue::*AlignBackboneToResidue_function_type )( ::Residue const & ) ;
            
            Residue_exposer.def( 
                "AlignBackboneToResidue"
                , AlignBackboneToResidue_function_type( &::Residue::AlignBackboneToResidue )
                , ( bp::arg("target") ) );
        
        }
        { //::Residue::AtomIndex
        
            typedef int ( ::Residue::*AtomIndex_function_type )( ::std::string const & ) const;
            
            Residue_exposer.def( 
                "AtomIndex"
                , AtomIndex_function_type( &::Residue::AtomIndex )
                , ( bp::arg("atomName") ) );
        
        }
        { //::Residue::Clone
        
            typedef ::Residue ( ::Residue::*Clone_function_type )( ::SystemConstPtr ) const;
            
            Residue_exposer.def( 
                "Clone"
                , Clone_function_type( &::Residue::Clone )
                , ( bp::arg("owner") ) );
        
        }
        { //::Residue::CloneWithChi
        
            typedef ::Residue ( ::Residue::*CloneWithChi_function_type )( ::Vector4 const &,::SystemConstPtr ) const;
            
            Residue_exposer.def( 
                "CloneWithChi"
                , CloneWithChi_function_type( &::Residue::CloneWithChi )
                , ( bp::arg("chi"), bp::arg("owner") ) );
        
        }
        { //::Residue::GetBondAngle
        
            typedef ::FLOAT ( ::Residue::*GetBondAngle_function_type )( ::blitz::TinyVector<int, 3> ) const;
            
            Residue_exposer.def( 
                "GetBondAngle"
                , GetBondAngle_function_type( &::Residue::GetBondAngle )
                , ( bp::arg("angleAtoms") ) );
        
        }
        { //::Residue::GetCentroid
        
            typedef ::Vector3 const & ( ::Residue::*GetCentroid_function_type )(  ) ;
            
            Residue_exposer.def( 
                "GetCentroid"
                , GetCentroid_function_type( &::Residue::GetCentroid )
                , bp::return_value_policy< bp::copy_const_reference >() );
        
        }
        { //::Residue::GetCentroid
        
            typedef ::Vector3 const & ( ::Residue::*GetCentroid_function_type )(  ) const;
            
            Residue_exposer.def( 
                "GetCentroid"
                , GetCentroid_function_type( &::Residue::GetCentroid )
                , bp::return_value_policy< bp::copy_const_reference >() );
        
        }
        { //::Residue::GetChi
        
            typedef ::Vector4 const & ( ::Residue::*GetChi_function_type )(  ) ;
            
            Residue_exposer.def( 
                "GetChi"
                , GetChi_function_type( &::Residue::GetChi )
                , bp::return_value_policy< bp::copy_const_reference >() );
        
        }
        { //::Residue::GetChi
        
            typedef ::Vector4 const & ( ::Residue::*GetChi_function_type )(  ) const;
            
            Residue_exposer.def( 
                "GetChi"
                , GetChi_function_type( &::Residue::GetChi )
                , bp::return_value_policy< bp::copy_const_reference >() );
        
        }
        { //::Residue::GetImptorsAngle
        
            typedef ::FLOAT ( ::Residue::*GetImptorsAngle_function_type )( ::blitz::TinyVector<int, 4> ) const;
            
            Residue_exposer.def( 
                "GetImptorsAngle"
                , GetImptorsAngle_function_type( &::Residue::GetImptorsAngle )
                , ( bp::arg("imptorsAtoms") ) );
        
        }
        { //::Residue::GetOrientationVectors
        
            typedef ::std::vector<blitz::TinyVector<float, 3>, std::allocator<blitz::TinyVector<float, 3> > > const & ( ::Residue::*GetOrientationVectors_function_type )(  ) ;
            
            Residue_exposer.def( 
                "GetOrientationVectors"
                , GetOrientationVectors_function_type( &::Residue::GetOrientationVectors )
                , bp::return_value_policy< bp::copy_const_reference >() );
        
        }
        { //::Residue::GetOrientationVectors
        
            typedef ::std::vector<blitz::TinyVector<float, 3>, std::allocator<blitz::TinyVector<float, 3> > > const & ( ::Residue::*GetOrientationVectors_function_type )(  ) const;
            
            Residue_exposer.def( 
                "GetOrientationVectors"
                , GetOrientationVectors_function_type( &::Residue::GetOrientationVectors )
                , bp::return_value_policy< bp::copy_const_reference >() );
        
        }
        { //::Residue::GetPhiPsi
        
            typedef ::Vector2 ( ::Residue::*GetPhiPsi_function_type )(  ) ;
            
            Residue_exposer.def( 
                "GetPhiPsi"
                , GetPhiPsi_function_type( &::Residue::GetPhiPsi ) );
        
        }
        { //::Residue::GetPhiPsi
        
            typedef ::Vector2 ( ::Residue::*GetPhiPsi_function_type )(  ) const;
            
            Residue_exposer.def( 
                "GetPhiPsi"
                , GetPhiPsi_function_type( &::Residue::GetPhiPsi ) );
        
        }
        { //::Residue::GetTorsionAngle
        
            typedef ::FLOAT ( ::Residue::*GetTorsionAngle_function_type )( ::blitz::TinyVector<int, 4> ) const;
            
            Residue_exposer.def( 
                "GetTorsionAngle"
                , GetTorsionAngle_function_type( &::Residue::GetTorsionAngle )
                , ( bp::arg("torsionAtoms") ) );
        
        }
        { //::Residue::Mutate
        
            typedef void ( ::Residue::*Mutate_function_type )( ::AminoAcid const *,::Residue const * ) ;
            
            Residue_exposer.def( 
                "Mutate"
                , Mutate_function_type( &::Residue::Mutate )
                , ( bp::arg("newAminoAcid"), bp::arg("prevRes") ) );
        
        }
        { //::Residue::PlaceAtomFromTemplate
        
            typedef bool ( ::Residue::*PlaceAtomFromTemplate_function_type )( int ) ;
            
            Residue_exposer.def( 
                "PlaceAtomFromTemplate"
                , PlaceAtomFromTemplate_function_type( &::Residue::PlaceAtomFromTemplate )
                , ( bp::arg("atomIndex") ) );
        
        }
        { //::Residue::PlaceHN
        
            typedef bool ( ::Residue::*PlaceHN_function_type )( ::Residue const * ) ;
            
            Residue_exposer.def( 
                "PlaceHN"
                , PlaceHN_function_type( &::Residue::PlaceHN )
                , ( bp::arg("prevRes") ) );
        
        }
        { //::Residue::PlaceOXT
        
            typedef bool ( ::Residue::*PlaceOXT_function_type )(  ) ;
            
            Residue_exposer.def( 
                "PlaceOXT"
                , PlaceOXT_function_type( &::Residue::PlaceOXT ) );
        
        }
        { //::Residue::RMSD
        
            typedef ::FLOAT ( ::Residue::*RMSD_function_type )( ::Residue const & ) const;
            
            Residue_exposer.def( 
                "RMSD"
                , RMSD_function_type( &::Residue::RMSD )
                , ( bp::arg("rhs") ) );
        
        }
        { //::Residue::SetAtomCoords
        
            typedef void ( ::Residue::*SetAtomCoords_function_type )( int,::Vector3 const & ) ;
            
            Residue_exposer.def( 
                "SetAtomCoords"
                , SetAtomCoords_function_type( &::Residue::SetAtomCoords )
                , ( bp::arg("atomIndex"), bp::arg("coords") ) );
        
        }
        { //::Residue::SetChi
        
            typedef void ( ::Residue::*SetChi_function_type )( ::Vector4 const & ) ;
            
            Residue_exposer.def( 
                "SetChi"
                , SetChi_function_type( &::Residue::SetChi )
                , ( bp::arg("chi") ) );
        
        }
        { //::Residue::StandardizeChi
        
            typedef ::FLOAT ( ::Residue::*StandardizeChi_function_type )( ::FLOAT,int ) const;
            
            Residue_exposer.def( 
                "StandardizeChi"
                , StandardizeChi_function_type( &::Residue::StandardizeChi )
                , ( bp::arg("chi"), bp::arg("chiIndex") ) );
        
        }
        { //::Residue::StandardizeChis
        
            typedef void ( ::Residue::*StandardizeChis_function_type )(  ) ;
            
            Residue_exposer.def( 
                "StandardizeChis"
                , StandardizeChis_function_type( &::Residue::StandardizeChis ) );
        
        }
        { //::Residue::UpdateCoords
        
            typedef void ( ::Residue::*UpdateCoords_function_type )(  ) ;
            
            Residue_exposer.def( 
                "UpdateCoords"
                , UpdateCoords_function_type( &::Residue::UpdateCoords ) );
        
        }
        { //::Residue::UpdatePhiPsi
        
            typedef void ( ::Residue::*UpdatePhiPsi_function_type )(  ) ;
            
            Residue_exposer.def( 
                "UpdatePhiPsi"
                , UpdatePhiPsi_function_type( &::Residue::UpdatePhiPsi ) );
        
        }
        { //::Residue::UseTemplateSideChain
        
            typedef void ( ::Residue::*UseTemplateSideChain_function_type )(  ) ;
            
            Residue_exposer.def( 
                "UseTemplateSideChain"
                , UseTemplateSideChain_function_type( &::Residue::UseTemplateSideChain ) );
        
        }
        { //::Residue::WriteToPDB
        
            typedef void ( ::Residue::*WriteToPDB_function_type )( ::PDB::Writer & ) const;
            
            Residue_exposer.def( 
                "WriteToPDB"
                , WriteToPDB_function_type( &::Residue::WriteToPDB )
                , ( bp::arg("writer") ) );
        
        }
        Residue_exposer.def( bp::self == bp::self );
        { //property "ID"[fget=::Residue::GetID, fset=::Residue::SetID]
        
            typedef int ( ::Residue::*fget )(  ) const;
            typedef void ( ::Residue::*fset )( int ) ;
            
            Residue_exposer.add_property( 
                "ID"
                , fget( &::Residue::GetID )
                , fset( &::Residue::SetID )
                , "get\\set property, built on top of \"int Residue::GetID() const [member function]\" and \"void Residue::SetID(int id) [member function]\"" );
        
        }
        { //property "System"[fget=::Residue::GetSystem]
        
            typedef ::SystemConstPtr ( ::Residue::*fget )(  ) const;
            
            Residue_exposer.add_property( 
                "System"
                , fget( &::Residue::GetSystem )
                , "get property, built on top of \"SystemConstPtr Residue::GetSystem() const [member function]\"" );
        
        }
        { //property "AtomCoords"[fget=::Residue::GetAtomCoords]
        
            typedef ::std::vector<blitz::TinyVector<float, 3>, std::allocator<blitz::TinyVector<float, 3> > > const & ( ::Residue::*fget )(  ) const;
            
            Residue_exposer.add_property( 
                "AtomCoords"
                , bp::make_function( 
                      fget( &::Residue::GetAtomCoords )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , "get property, built on top of \"std::vector<blitz::TinyVector<float, 3>, std::allocator<blitz::TinyVector<float, 3> > > const & Residue::GetAtomCoords() const [member function]\"" );
        
        }
        { //property "AminoAcid"[fget=::Residue::GetAminoAcid]
        
            typedef ::AminoAcid const & ( ::Residue::*fget )(  ) const;
            
            Residue_exposer.add_property( 
                "AminoAcid"
                , bp::make_function( 
                      fget( &::Residue::GetAminoAcid )
                    , bp::return_value_policy< bp::copy_const_reference >() ) 
                , "get property, built on top of \"AminoAcid const & Residue::GetAminoAcid() const [member function]\"" );
        
        }
        { //property "Omega"[fget=::Residue::GetOmega]
        
            typedef ::FLOAT ( ::Residue::*fget )(  ) const;
            
            Residue_exposer.add_property( 
                "Omega"
                , fget( &::Residue::GetOmega )
                , "get property, built on top of \"FLOAT Residue::GetOmega() const [member function]\"" );
        
        }
        bp::register_ptr_to_python< boost::shared_ptr< Residue > >();
    }

}

