// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "RotamerGenerator.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "rotamer_generator.h"

namespace bp = boost::python;

void register_RotamerGenerator_class(){

    bp::class_< RotamerGenerator, boost::noncopyable >( "RotamerGenerator", bp::init< boost::shared_ptr<NeighborMap const>, boost::shared_ptr<DunbrackLibrary const> >(( bp::arg("nmap"), bp::arg("dunLib") )) )    
        .def( 
            "ClearExtraChiFlag"
            , &::RotamerGenerator::ClearExtraChiFlag
            , ( bp::arg("aa"), bp::arg("burial"), bp::arg("chiAngle"), bp::arg("flag") ) )    
        .def( 
            "GenerateRotamers"
            , &::RotamerGenerator::GenerateRotamers
            , ( bp::arg("baseResidue"), bp::arg("oldRotamers") ) )    
        .def( 
            "GetExtraChiFlags"
            , &::RotamerGenerator::GetExtraChiFlags
            , ( bp::arg("aa"), bp::arg("burial"), bp::arg("chiAngle") ) )    
        .def( 
            "GetParameters"
            , &::RotamerGenerator::GetParameters
            , bp::return_value_policy< bp::copy_const_reference >() )    
        .def( 
            "SetExtraChiFlag"
            , &::RotamerGenerator::SetExtraChiFlag
            , ( bp::arg("aa"), bp::arg("burial"), bp::arg("chiAngle"), bp::arg("flag") ) )    
        .def( 
            "SetParameters"
            , &::RotamerGenerator::SetParameters
            , ( bp::arg("params") ) );

}

