// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "RotamerIterationMap.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "rotamer_iteration_map.h"

namespace bp = boost::python;

void register_RotamerIterationMap_class(){

    { //::RotamerIterationMap
        typedef bp::class_< RotamerIterationMap, boost::noncopyable > RotamerIterationMap_exposer_t;
        RotamerIterationMap_exposer_t RotamerIterationMap_exposer = RotamerIterationMap_exposer_t( "RotamerIterationMap", bp::init< boost::shared_ptr<RotamerLibrary const> >(( bp::arg("rlib") )) );
        bp::scope RotamerIterationMap_scope( RotamerIterationMap_exposer );
        { //::RotamerIterationMap::CountPair
        
            typedef ::FLOAT ( ::RotamerIterationMap::*CountPair_function_type )( ::Residue const &,::Residue const & ) const;
            
            RotamerIterationMap_exposer.def( 
                "CountPair"
                , CountPair_function_type( &::RotamerIterationMap::CountPair )
                , ( bp::arg("res1"), bp::arg("res2") ) );
        
        }
        { //::RotamerIterationMap::CountSingle
        
            typedef ::FLOAT ( ::RotamerIterationMap::*CountSingle_function_type )( ::Residue const & ) const;
            
            RotamerIterationMap_exposer.def( 
                "CountSingle"
                , CountSingle_function_type( &::RotamerIterationMap::CountSingle )
                , ( bp::arg("res") ) );
        
        }
        { //::RotamerIterationMap::Create
        
            typedef ::boost::shared_ptr<RotamerIterationMap> ( *Create_function_type )( ::boost::shared_ptr<RotamerLibrary const> );
            
            RotamerIterationMap_exposer.def( 
                "Create"
                , Create_function_type( &::RotamerIterationMap::Create )
                , ( bp::arg("rlib") ) );
        
        }
        { //::RotamerIterationMap::DisableAll
        
            typedef void ( ::RotamerIterationMap::*DisableAll_function_type )(  ) ;
            
            RotamerIterationMap_exposer.def( 
                "DisableAll"
                , DisableAll_function_type( &::RotamerIterationMap::DisableAll ) );
        
        }
        { //::RotamerIterationMap::EnableAll
        
            typedef void ( ::RotamerIterationMap::*EnableAll_function_type )(  ) ;
            
            RotamerIterationMap_exposer.def( 
                "EnableAll"
                , EnableAll_function_type( &::RotamerIterationMap::EnableAll ) );
        
        }
        { //::RotamerIterationMap::GetRotamerLibrary
        
            typedef ::boost::shared_ptr<RotamerLibrary const> ( ::RotamerIterationMap::*GetRotamerLibrary_function_type )(  ) const;
            
            RotamerIterationMap_exposer.def( 
                "GetRotamerLibrary"
                , GetRotamerLibrary_function_type( &::RotamerIterationMap::GetRotamerLibrary ) );
        
        }
        { //::RotamerIterationMap::SetResiduePairWeight
        
            typedef void ( ::RotamerIterationMap::*SetResiduePairWeight_function_type )( ::Residue const &,::Residue const &,::FLOAT ) ;
            
            RotamerIterationMap_exposer.def( 
                "SetResiduePairWeight"
                , SetResiduePairWeight_function_type( &::RotamerIterationMap::SetResiduePairWeight )
                , ( bp::arg("res1"), bp::arg("res2"), bp::arg("weight") ) );
        
        }
        { //::RotamerIterationMap::SetResidueSingleWeight
        
            typedef void ( ::RotamerIterationMap::*SetResidueSingleWeight_function_type )( ::Residue const &,::FLOAT ) ;
            
            RotamerIterationMap_exposer.def( 
                "SetResidueSingleWeight"
                , SetResidueSingleWeight_function_type( &::RotamerIterationMap::SetResidueSingleWeight )
                , ( bp::arg("res"), bp::arg("weight") ) );
        
        }
        { //::RotamerIterationMap::SetSystemPairWeight
        
            typedef void ( ::RotamerIterationMap::*SetSystemPairWeight_function_type )( ::boost::shared_ptr<System const>,::boost::shared_ptr<System const>,::FLOAT ) ;
            
            RotamerIterationMap_exposer.def( 
                "SetSystemPairWeight"
                , SetSystemPairWeight_function_type( &::RotamerIterationMap::SetSystemPairWeight )
                , ( bp::arg("sys1"), bp::arg("sys2"), bp::arg("weight") ) );
        
        }
        { //::RotamerIterationMap::SetSystemSingleWeight
        
            typedef void ( ::RotamerIterationMap::*SetSystemSingleWeight_function_type )( ::boost::shared_ptr<System const>,::FLOAT ) ;
            
            RotamerIterationMap_exposer.def( 
                "SetSystemSingleWeight"
                , SetSystemSingleWeight_function_type( &::RotamerIterationMap::SetSystemSingleWeight )
                , ( bp::arg("sys"), bp::arg("weight") ) );
        
        }
        RotamerIterationMap_exposer.staticmethod( "Create" );
        bp::register_ptr_to_python< boost::shared_ptr< RotamerIterationMap > >();
    }

}

