// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "RotamerLibrary.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "rotamers.h"

namespace bp = boost::python;

struct RotamerLibrary_wrapper : RotamerLibrary, bp::wrapper< RotamerLibrary > {

    RotamerLibrary_wrapper(::std::vector<boost::shared_ptr<System const>, std::allocator<boost::shared_ptr<System const> > > const & systems )
    : RotamerLibrary( boost::ref(systems) )
      , bp::wrapper< RotamerLibrary >(){
        // constructor
    
    }

    virtual ::std::pair<int, int> DimensionIDRange( int dimension ) const  {
        if( bp::override func_DimensionIDRange = this->get_override( "DimensionIDRange" ) )
            return func_DimensionIDRange( dimension );
        else
            return this->RotamerLibrary::DimensionIDRange( dimension );
    }
    
    
    ::std::pair<int, int> default_DimensionIDRange( int dimension ) const  {
        return RotamerLibrary::DimensionIDRange( dimension );
    }

    virtual int NumDimensions(  ) const  {
        if( bp::override func_NumDimensions = this->get_override( "NumDimensions" ) )
            return func_NumDimensions(  );
        else
            return this->RotamerLibrary::NumDimensions(  );
    }
    
    
    int default_NumDimensions(  ) const  {
        return RotamerLibrary::NumDimensions( );
    }

    virtual int NumElements(  ) const  {
        if( bp::override func_NumElements = this->get_override( "NumElements" ) )
            return func_NumElements(  );
        else
            return this->RotamerLibrary::NumElements(  );
    }
    
    
    int default_NumElements(  ) const  {
        return RotamerLibrary::NumElements( );
    }

};

void register_RotamerLibrary_class(){

    { //::RotamerLibrary
        typedef bp::class_< RotamerLibrary_wrapper, bp::bases< DiscreteSearchSpace >, boost::noncopyable > RotamerLibrary_exposer_t;
        RotamerLibrary_exposer_t RotamerLibrary_exposer = RotamerLibrary_exposer_t( "RotamerLibrary", bp::init< std::vector<boost::shared_ptr<System const>, std::allocator<boost::shared_ptr<System const> > > const & >(( bp::arg("systems") )) );
        bp::scope RotamerLibrary_scope( RotamerLibrary_exposer );
        { //::RotamerLibrary::AddRotamers
        
            typedef ::RotamerIDSet ( ::RotamerLibrary::*AddRotamers_function_type )( ::Residue const &,::std::vector<blitz::TinyVector<float, 4>, std::allocator<blitz::TinyVector<float, 4> > > const & ) ;
            
            RotamerLibrary_exposer.def( 
                "AddRotamers"
                , AddRotamers_function_type( &::RotamerLibrary::AddRotamers )
                , ( bp::arg("res"), bp::arg("chi") ) );
        
        }
        { //::RotamerLibrary::AddRotamers
        
            typedef ::RotamerIDSet ( ::RotamerLibrary::*AddRotamers_function_type )( ::boost::shared_ptr<RotamerLibrary const>,::std::vector<int, std::allocator<int> > const & ) ;
            
            RotamerLibrary_exposer.def( 
                "AddRotamers"
                , AddRotamers_function_type( &::RotamerLibrary::AddRotamers )
                , ( bp::arg("rlib"), bp::arg("ids") ) );
        
        }
        { //::RotamerLibrary::Clone
        
            typedef ::boost::shared_ptr<RotamerLibrary> ( ::RotamerLibrary::*Clone_function_type )(  ) const;
            
            RotamerLibrary_exposer.def( 
                "Clone"
                , Clone_function_type( &::RotamerLibrary::Clone ) );
        
        }
        { //::RotamerLibrary::Create
        
            typedef ::boost::shared_ptr<RotamerLibrary> ( *Create_function_type )( ::boost::shared_ptr<System const> );
            
            RotamerLibrary_exposer.def( 
                "Create"
                , Create_function_type( &::RotamerLibrary::Create )
                , ( bp::arg("system") ) );
        
        }
        { //::RotamerLibrary::Create
        
            typedef ::boost::shared_ptr<RotamerLibrary> ( *Create_function_type )( ::std::vector<boost::shared_ptr<System const>, std::allocator<boost::shared_ptr<System const> > > const & );
            
            RotamerLibrary_exposer.def( 
                "Create"
                , Create_function_type( &::RotamerLibrary::Create )
                , ( bp::arg("systems") ) );
        
        }
        { //::RotamerLibrary::CreateSystem
        
            typedef ::boost::shared_ptr<System> ( ::RotamerLibrary::*CreateSystem_function_type )( ::boost::shared_ptr<System const>,::std::vector<int, std::allocator<int> > const & ) const;
            
            RotamerLibrary_exposer.def( 
                "CreateSystem"
                , CreateSystem_function_type( &::RotamerLibrary::CreateSystem )
                , ( bp::arg("baseSystem"), bp::arg("rotamerIDs") ) );
        
        }
        { //::RotamerLibrary::DeleteRotamers
        
            typedef ::RotamerIDSet ( ::RotamerLibrary::*DeleteRotamers_function_type )( ::Residue const &,::std::vector<int, std::allocator<int> > const & ) ;
            
            RotamerLibrary_exposer.def( 
                "DeleteRotamers"
                , DeleteRotamers_function_type( &::RotamerLibrary::DeleteRotamers )
                , ( bp::arg("res"), bp::arg("ids") ) );
        
        }
        { //::RotamerLibrary::DeleteRotamers
        
            typedef ::RotamerIDSet ( ::RotamerLibrary::*DeleteRotamers_function_type )( ::std::vector<int, std::allocator<int> > const & ) ;
            
            RotamerLibrary_exposer.def( 
                "DeleteRotamers"
                , DeleteRotamers_function_type( &::RotamerLibrary::DeleteRotamers )
                , ( bp::arg("ids") ) );
        
        }
        { //::RotamerLibrary::DimensionIDRange
        
            typedef ::std::pair<int, int> ( ::RotamerLibrary::*DimensionIDRange_function_type )( int ) const;
            typedef ::std::pair<int, int> ( RotamerLibrary_wrapper::*default_DimensionIDRange_function_type )( int ) const;
            
            RotamerLibrary_exposer.def( 
                "DimensionIDRange"
                , DimensionIDRange_function_type(&::RotamerLibrary::DimensionIDRange)
                , default_DimensionIDRange_function_type(&RotamerLibrary_wrapper::default_DimensionIDRange)
                , ( bp::arg("dimension") ) );
        
        }
        { //::RotamerLibrary::GenerateRotamers
        
            typedef void ( ::RotamerLibrary::*GenerateRotamers_function_type )( ::RotamerGenerator const &,bool ) ;
            
            RotamerLibrary_exposer.def( 
                "GenerateRotamers"
                , GenerateRotamers_function_type( &::RotamerLibrary::GenerateRotamers )
                , ( bp::arg("generator"), bp::arg("discardOld")=(bool)(false) ) );
        
        }
        { //::RotamerLibrary::GenerateRotamers
        
            typedef ::RotamerIDSet ( ::RotamerLibrary::*GenerateRotamers_function_type )( ::SystemConstPointer,::RotamerGenerator const &,bool ) ;
            
            RotamerLibrary_exposer.def( 
                "GenerateRotamers"
                , GenerateRotamers_function_type( &::RotamerLibrary::GenerateRotamers )
                , ( bp::arg("system"), bp::arg("generator"), bp::arg("discardOld")=(bool)(false) ) );
        
        }
        { //::RotamerLibrary::GenerateRotamers
        
            typedef ::RotamerIDSet ( ::RotamerLibrary::*GenerateRotamers_function_type )( ::Residue const &,::RotamerGenerator const &,bool ) ;
            
            RotamerLibrary_exposer.def( 
                "GenerateRotamers"
                , GenerateRotamers_function_type( &::RotamerLibrary::GenerateRotamers )
                , ( bp::arg("res"), bp::arg("generator"), bp::arg("discardOld")=(bool)(false) ) );
        
        }
        { //::RotamerLibrary::GetClosestChi
        
            typedef ::Vector4 ( ::RotamerLibrary::*GetClosestChi_function_type )( ::Residue const & ) const;
            
            RotamerLibrary_exposer.def( 
                "GetClosestChi"
                , GetClosestChi_function_type( &::RotamerLibrary::GetClosestChi )
                , ( bp::arg("res") ) );
        
        }
        { //::RotamerLibrary::GetRotamerChis
        
            typedef ::std::vector<blitz::TinyVector<float, 4>, std::allocator<blitz::TinyVector<float, 4> > > ( ::RotamerLibrary::*GetRotamerChis_function_type )( ::Residue const & ) const;
            
            RotamerLibrary_exposer.def( 
                "GetRotamerChis"
                , GetRotamerChis_function_type( &::RotamerLibrary::GetRotamerChis )
                , ( bp::arg("res") ) );
        
        }
        { //::RotamerLibrary::GetRotamerID
        
            typedef int ( ::RotamerLibrary::*GetRotamerID_function_type )( ::RotamerSet const &,int ) const;
            
            RotamerLibrary_exposer.def( 
                "GetRotamerID"
                , GetRotamerID_function_type( &::RotamerLibrary::GetRotamerID )
                , ( bp::arg("rset"), bp::arg("rotIndex") ) );
        
        }
        { //::RotamerLibrary::GetRotamerIDRange
        
            typedef ::std::pair<int, int> ( ::RotamerLibrary::*GetRotamerIDRange_function_type )( ::Residue const & ) const;
            
            RotamerLibrary_exposer.def( 
                "GetRotamerIDRange"
                , GetRotamerIDRange_function_type( &::RotamerLibrary::GetRotamerIDRange )
                , ( bp::arg("res") ) );
        
        }
        { //::RotamerLibrary::GetRotamerResidue
        
            typedef ::Residue ( ::RotamerLibrary::*GetRotamerResidue_function_type )( int ) const;
            
            RotamerLibrary_exposer.def( 
                "GetRotamerResidue"
                , GetRotamerResidue_function_type( &::RotamerLibrary::GetRotamerResidue )
                , ( bp::arg("rotamerID") ) );
        
        }
        { //::RotamerLibrary::GetStorageIndex
        
            typedef int ( ::RotamerLibrary::*GetStorageIndex_function_type )( ::RotamerSet const & ) const;
            
            RotamerLibrary_exposer.def( 
                "GetStorageIndex"
                , GetStorageIndex_function_type( &::RotamerLibrary::GetStorageIndex )
                , ( bp::arg("rset") ) );
        
        }
        { //::RotamerLibrary::GetSystems
        
            typedef ::std::vector<boost::shared_ptr<System const>, std::allocator<boost::shared_ptr<System const> > > const & ( ::RotamerLibrary::*GetSystems_function_type )(  ) const;
            
            RotamerLibrary_exposer.def( 
                "GetSystems"
                , GetSystems_function_type( &::RotamerLibrary::GetSystems )
                , bp::return_value_policy< bp::copy_const_reference >() );
        
        }
        { //::RotamerLibrary::NumDimensions
        
            typedef int ( ::RotamerLibrary::*NumDimensions_function_type )(  ) const;
            typedef int ( RotamerLibrary_wrapper::*default_NumDimensions_function_type )(  ) const;
            
            RotamerLibrary_exposer.def( 
                "NumDimensions"
                , NumDimensions_function_type(&::RotamerLibrary::NumDimensions)
                , default_NumDimensions_function_type(&RotamerLibrary_wrapper::default_NumDimensions) );
        
        }
        { //::RotamerLibrary::NumElements
        
            typedef int ( ::RotamerLibrary::*NumElements_function_type )(  ) const;
            typedef int ( RotamerLibrary_wrapper::*default_NumElements_function_type )(  ) const;
            
            RotamerLibrary_exposer.def( 
                "NumElements"
                , NumElements_function_type(&::RotamerLibrary::NumElements)
                , default_NumElements_function_type(&RotamerLibrary_wrapper::default_NumElements) );
        
        }
        { //::RotamerLibrary::NumRotamerSets
        
            typedef int ( ::RotamerLibrary::*NumRotamerSets_function_type )(  ) const;
            
            RotamerLibrary_exposer.def( 
                "NumRotamerSets"
                , NumRotamerSets_function_type( &::RotamerLibrary::NumRotamerSets ) );
        
        }
        { //::RotamerLibrary::NumRotamers
        
            typedef int ( ::RotamerLibrary::*NumRotamers_function_type )(  ) const;
            
            RotamerLibrary_exposer.def( 
                "NumRotamers"
                , NumRotamers_function_type( &::RotamerLibrary::NumRotamers ) );
        
        }
        { //::RotamerLibrary::PairResidues
        
            typedef ::std::pair<RotamerLibraryPairIterator,RotamerLibraryPairIterator> ( ::RotamerLibrary::*PairResidues_function_type )(  ) const;
            
            RotamerLibrary_exposer.def( 
                "PairResidues"
                , PairResidues_function_type( &::RotamerLibrary::PairResidues ) );
        
        }
        { //::RotamerLibrary::ReplaceSystem
        
            typedef ::RotamerIDSet ( ::RotamerLibrary::*ReplaceSystem_function_type )( ::boost::shared_ptr<System const>,::boost::shared_ptr<System const> ) ;
            
            RotamerLibrary_exposer.def( 
                "ReplaceSystem"
                , ReplaceSystem_function_type( &::RotamerLibrary::ReplaceSystem )
                , ( bp::arg("oldSystem"), bp::arg("newSystem") ) );
        
        }
        { //::RotamerLibrary::SingleResidues
        
            typedef ::std::pair<RotamerLibraryIterator,RotamerLibraryIterator> ( ::RotamerLibrary::*SingleResidues_function_type )(  ) const;
            
            RotamerLibrary_exposer.def( 
                "SingleResidues"
                , SingleResidues_function_type( &::RotamerLibrary::SingleResidues ) );
        
        }
        { //::RotamerLibrary::TranslateRotamerIDs
        
            typedef ::std::vector<int, std::allocator<int> > ( ::RotamerLibrary::*TranslateRotamerIDs_function_type )( ::boost::shared_ptr<RotamerLibrary const>,::std::vector<int, std::allocator<int> > const & ) const;
            
            RotamerLibrary_exposer.def( 
                "TranslateRotamerIDs"
                , TranslateRotamerIDs_function_type( &::RotamerLibrary::TranslateRotamerIDs )
                , ( bp::arg("sourceLib"), bp::arg("rotamerIDs") ) );
        
        }
        RotamerLibrary_exposer.staticmethod( "Create" );
        bp::register_ptr_to_python< boost::shared_ptr< RotamerLibrary > >();
        bp::implicitly_convertible< boost::shared_ptr< RotamerLibrary >, boost::shared_ptr< DiscreteSearchSpace > >();
    }

}

