// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "RotamerSet.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "rotamer_trie.h"

namespace bp = boost::python;

void register_RotamerSet_class(){

    { //::RotamerSet
        typedef bp::class_< RotamerSet, boost::noncopyable > RotamerSet_exposer_t;
        RotamerSet_exposer_t RotamerSet_exposer = RotamerSet_exposer_t( "RotamerSet", bp::init< Residue const &, std::list<Residue,std::allocator<Residue> > const & >(( bp::arg("baseResidue"), bp::arg("rotList") )) );
        bp::scope RotamerSet_scope( RotamerSet_exposer );
        RotamerSet_exposer.def( bp::init< Residue const & >(( bp::arg("residue") )) );
        { //::RotamerSet::GetBaseResidue
        
            typedef ::Residue const & ( ::RotamerSet::*GetBaseResidue_function_type )(  ) const;
            
            RotamerSet_exposer.def( 
                "GetBaseResidue"
                , GetBaseResidue_function_type( &::RotamerSet::GetBaseResidue )
                , bp::return_internal_reference< 1 >() );
        
        }
        { //::RotamerSet::GetCentroid
        
            typedef ::Vector3 const & ( ::RotamerSet::*GetCentroid_function_type )( int ) const;
            
            RotamerSet_exposer.def( 
                "GetCentroid"
                , GetCentroid_function_type( &::RotamerSet::GetCentroid )
                , ( bp::arg("rotIndex") )
                , bp::return_value_policy< bp::copy_const_reference >() );
        
        }
        { //::RotamerSet::GetChi
        
            typedef ::std::vector<blitz::TinyVector<float, 4>, std::allocator<blitz::TinyVector<float, 4> > > ( ::RotamerSet::*GetChi_function_type )(  ) const;
            
            RotamerSet_exposer.def( 
                "GetChi"
                , GetChi_function_type( &::RotamerSet::GetChi ) );
        
        }
        { //::RotamerSet::GetChi
        
            typedef ::Vector4 const & ( ::RotamerSet::*GetChi_function_type )( int ) const;
            
            RotamerSet_exposer.def( 
                "GetChi"
                , GetChi_function_type( &::RotamerSet::GetChi )
                , ( bp::arg("rotIndex") )
                , bp::return_value_policy< bp::copy_const_reference >() );
        
        }
        { //::RotamerSet::GetRotamer
        
            typedef ::Residue ( ::RotamerSet::*GetRotamer_function_type )( int ) const;
            
            RotamerSet_exposer.def( 
                "GetRotamer"
                , GetRotamer_function_type( &::RotamerSet::GetRotamer )
                , ( bp::arg("index") ) );
        
        }
        { //::RotamerSet::GetTrieNodes
        
            typedef ::blitz::Array<RotamerNode, 1> const & ( ::RotamerSet::*GetTrieNodes_function_type )(  ) const;
            
            RotamerSet_exposer.def( 
                "GetTrieNodes"
                , GetTrieNodes_function_type( &::RotamerSet::GetTrieNodes )
                , bp::return_value_policy< bp::copy_const_reference >() );
        
        }
        { //::RotamerSet::NumRotamers
        
            typedef int ( ::RotamerSet::*NumRotamers_function_type )(  ) const;
            
            RotamerSet_exposer.def( 
                "NumRotamers"
                , NumRotamers_function_type( &::RotamerSet::NumRotamers ) );
        
        }
        { //::RotamerSet::PrintRotamers
        
            typedef void ( ::RotamerSet::*PrintRotamers_function_type )(  ) const;
            
            RotamerSet_exposer.def( 
                "PrintRotamers"
                , PrintRotamers_function_type( &::RotamerSet::PrintRotamers ) );
        
        }
        bp::register_ptr_to_python< boost::shared_ptr< RotamerSet > >();
    }

}

