// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "SimulatedAnnealingPackerMS.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "opt_simanneal_ms.h"

namespace bp = boost::python;

struct SimulatedAnnealingPackerMS_wrapper : SimulatedAnnealingPackerMS, bp::wrapper< SimulatedAnnealingPackerMS > {

    SimulatedAnnealingPackerMS_wrapper( )
    : SimulatedAnnealingPackerMS( )
      , bp::wrapper< SimulatedAnnealingPackerMS >(){
        // null constructor
    
    }

    ::FLOAT GetTemperature( bool quench ){
        return OptimizationBaseSimulatedAnnealing::GetTemperature( quench );
    }

    void InitState( ::EnergyGraph & graph, ::std::vector<int, std::allocator<int> > const & initialState ){
        OptimizationBase::InitState( boost::ref(graph), boost::ref(initialState) );
    }

    bool KeepChange( ::FLOAT prevEnergy, ::FLOAT diff, ::FLOAT temperature, bool quench ){
        return OptimizationBaseSimulatedAnnealing::KeepChange( prevEnergy, diff, temperature, quench );
    }

    ::std::pair<int, int> PickMove( bool quench ){
        return OptimizationBaseSimulatedAnnealing::PickMove( quench );
    }

};

void register_SimulatedAnnealingPackerMS_class(){

    { //::SimulatedAnnealingPackerMS
        typedef bp::class_< SimulatedAnnealingPackerMS_wrapper, bp::bases< OptimizationBaseSimulatedAnnealing >, boost::noncopyable > SimulatedAnnealingPackerMS_exposer_t;
        SimulatedAnnealingPackerMS_exposer_t SimulatedAnnealingPackerMS_exposer = SimulatedAnnealingPackerMS_exposer_t( "SimulatedAnnealingPackerMS" );
        bp::scope SimulatedAnnealingPackerMS_scope( SimulatedAnnealingPackerMS_exposer );
        SimulatedAnnealingPackerMS_exposer.def( bp::init< >() );
        { //::SimulatedAnnealingPackerMS::GetLastTemperature
        
            typedef ::FLOAT ( ::SimulatedAnnealingPackerMS::*GetLastTemperature_function_type )(  ) ;
            
            SimulatedAnnealingPackerMS_exposer.def( 
                "GetLastTemperature"
                , GetLastTemperature_function_type( &::SimulatedAnnealingPackerMS::GetLastTemperature ) );
        
        }
        { //::SimulatedAnnealingPackerMS::GetMaxFrames
        
            typedef int ( ::SimulatedAnnealingPackerMS::*GetMaxFrames_function_type )(  ) ;
            
            SimulatedAnnealingPackerMS_exposer.def( 
                "GetMaxFrames"
                , GetMaxFrames_function_type( &::SimulatedAnnealingPackerMS::GetMaxFrames ) );
        
        }
        { //::SimulatedAnnealingPackerMS::Pack
        
            typedef ::std::pair<std::vector<int, std::allocator<int> >, float> ( ::SimulatedAnnealingPackerMS::*Pack_function_type )( ::boost::shared_ptr<DiscreteSearchSpace const>,::EnergyGraph *,::std::vector<int, std::allocator<int> > const *,::boost::shared_ptr<EnergyCombList>,int ) ;
            
            SimulatedAnnealingPackerMS_exposer.def( 
                "Pack"
                , Pack_function_type( &::SimulatedAnnealingPackerMS::Pack )
                , ( bp::arg("searchSpace"), bp::arg("graph"), bp::arg("initialState")=bp::object(), bp::arg("energyList")=boost::shared_ptr<EnergyCombList>(), bp::arg("listSize")=(int)(1) ) );
        
        }
        { //::SimulatedAnnealingPackerMS::SetMaxFrames
        
            typedef void ( ::SimulatedAnnealingPackerMS::*SetMaxFrames_function_type )( int ) ;
            
            SimulatedAnnealingPackerMS_exposer.def( 
                "SetMaxFrames"
                , SetMaxFrames_function_type( &::SimulatedAnnealingPackerMS::SetMaxFrames )
                , ( bp::arg("maxFrames") ) );
        
        }
        { //::OptimizationBaseSimulatedAnnealing::GetTemperature
        
            typedef ::FLOAT ( SimulatedAnnealingPackerMS_wrapper::*GetTemperature_function_type )( bool ) ;
            
            SimulatedAnnealingPackerMS_exposer.def( 
                "GetTemperature"
                , GetTemperature_function_type( &SimulatedAnnealingPackerMS_wrapper::GetTemperature )
                , ( bp::arg("quench") ) );
        
        }
        { //::OptimizationBase::InitState
        
            typedef void ( SimulatedAnnealingPackerMS_wrapper::*InitState_function_type )( ::EnergyGraph &,::std::vector<int, std::allocator<int> > const & ) ;
            
            SimulatedAnnealingPackerMS_exposer.def( 
                "InitState"
                , InitState_function_type( &SimulatedAnnealingPackerMS_wrapper::InitState )
                , ( bp::arg("graph"), bp::arg("initialState") ) );
        
        }
        { //::OptimizationBaseSimulatedAnnealing::KeepChange
        
            typedef bool ( SimulatedAnnealingPackerMS_wrapper::*KeepChange_function_type )( ::FLOAT,::FLOAT,::FLOAT,bool ) ;
            
            SimulatedAnnealingPackerMS_exposer.def( 
                "KeepChange"
                , KeepChange_function_type( &SimulatedAnnealingPackerMS_wrapper::KeepChange )
                , ( bp::arg("prevEnergy"), bp::arg("diff"), bp::arg("temperature"), bp::arg("quench") ) );
        
        }
        { //::OptimizationBaseSimulatedAnnealing::PickMove
        
            typedef ::std::pair<int, int> ( SimulatedAnnealingPackerMS_wrapper::*PickMove_function_type )( bool ) ;
            
            SimulatedAnnealingPackerMS_exposer.def( 
                "PickMove"
                , PickMove_function_type( &SimulatedAnnealingPackerMS_wrapper::PickMove )
                , ( bp::arg("quench") ) );
        
        }
        bp::register_ptr_to_python< boost::shared_ptr< SimulatedAnnealingPackerMS > >();
        bp::implicitly_convertible< boost::shared_ptr< SimulatedAnnealingPackerMS >, boost::shared_ptr< OptimizationBaseSimulatedAnnealing > >();
        bp::implicitly_convertible< boost::shared_ptr< SimulatedAnnealingPackerMS >, boost::shared_ptr< OptimizationBase > >();
    }

}

