// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

// This file has been generated by Py++.

#include "System.pypp.hpp"
#include "stdafx.h"
#include "boost/python.hpp"
#include "boost/python/register_ptr_to_python.hpp"
#include "array_wrapper.hpp"

#include "system.h"

namespace bp = boost::python;

void System_parse_0 (::boost::shared_ptr<System> & obj, std::string const& str)
{
	 std::istringstream ss(str);
 	 ss >> obj;
}

std::string System_print_0 (::boost::shared_ptr<System> obj)
{
	 std::ostringstream ss;
 	 ss << obj;
 	 return ss.str();
}

std::string System_print_1 (::boost::shared_ptr<System const> obj)
{
	 std::ostringstream ss;
 	 ss << obj;
 	 return ss.str();
}

void register_System_class(){

    { //::System
        typedef bp::class_< System, boost::noncopyable > System_exposer_t;
        System_exposer_t System_exposer = System_exposer_t( "System", bp::init< boost::shared_ptr<AtomTypes const>, boost::shared_ptr<AminoAcidDirectory const> >(( bp::arg("atypes"), bp::arg("aadir") )) );
        bp::scope System_scope( System_exposer );
        { //::System::Append
        
            typedef void ( ::System::*Append_function_type )( ::Residue const & ) ;
            
            System_exposer.def( 
                "Append"
                , Append_function_type( &::System::Append )
                , ( bp::arg("residue") ) );
        
        }
        { //::System::Clear
        
            typedef void ( ::System::*Clear_function_type )(  ) ;
            
            System_exposer.def( 
                "Clear"
                , Clear_function_type( &::System::Clear ) );
        
        }
        { //::System::Create
        
            typedef ::boost::shared_ptr<System> ( *Create_function_type )( ::boost::shared_ptr<AtomTypes const>,::boost::shared_ptr<AminoAcidDirectory const> );
            
            System_exposer.def( 
                "Create"
                , Create_function_type( &::System::Create )
                , ( bp::arg("atypes"), bp::arg("aadir") ) );
        
        }
        { //::System::GetResidue
        
            typedef ::Residue & ( ::System::*GetResidue_function_type )( int ) ;
            
            System_exposer.def( 
                "GetResidue"
                , GetResidue_function_type( &::System::GetResidue )
                , ( bp::arg("index") )
                , bp::return_internal_reference< 1 >() );
        
        }
        { //::System::GetResidue
        
            typedef ::Residue const & ( ::System::*GetResidue_function_type )( int ) const;
            
            System_exposer.def( 
                "GetResidue"
                , GetResidue_function_type( &::System::GetResidue )
                , ( bp::arg("index") )
                , bp::return_internal_reference< 1 >() );
        
        }
        { //::System::GetResidueByStorageIndex
        
            typedef ::Residue & ( ::System::*GetResidueByStorageIndex_function_type )( int ) ;
            
            System_exposer.def( 
                "GetResidueByStorageIndex"
                , GetResidueByStorageIndex_function_type( &::System::GetResidueByStorageIndex )
                , ( bp::arg("index") )
                , bp::return_internal_reference< 1 >() );
        
        }
        { //::System::GetResidueByStorageIndex
        
            typedef ::Residue const & ( ::System::*GetResidueByStorageIndex_function_type )( int ) const;
            
            System_exposer.def( 
                "GetResidueByStorageIndex"
                , GetResidueByStorageIndex_function_type( &::System::GetResidueByStorageIndex )
                , ( bp::arg("index") )
                , bp::return_internal_reference< 1 >() );
        
        }
        { //::System::GetStorageIndex
        
            typedef int ( ::System::*GetStorageIndex_function_type )( ::Residue const & ) const;
            
            System_exposer.def( 
                "GetStorageIndex"
                , GetStorageIndex_function_type( &::System::GetStorageIndex )
                , ( bp::arg("res") ) );
        
        }
        { //::System::IsFirstInChain
        
            typedef bool ( ::System::*IsFirstInChain_function_type )( ::Residue const & ) const;
            
            System_exposer.def( 
                "IsFirstInChain"
                , IsFirstInChain_function_type( &::System::IsFirstInChain )
                , ( bp::arg("res") ) );
        
        }
        { //::System::IsLastInChain
        
            typedef bool ( ::System::*IsLastInChain_function_type )( ::Residue const & ) const;
            
            System_exposer.def( 
                "IsLastInChain"
                , IsLastInChain_function_type( &::System::IsLastInChain )
                , ( bp::arg("res") ) );
        
        }
        { //::System::Join
        
            typedef ::boost::shared_ptr<System> ( *Join_function_type )( ::std::vector<boost::shared_ptr<System const>, std::allocator<boost::shared_ptr<System const> > > const & );
            
            System_exposer.def( 
                "Join"
                , Join_function_type( &::System::Join )
                , ( bp::arg("systems") ) );
        
        }
        { //::System::MutateResidue
        
            typedef void ( ::System::*MutateResidue_function_type )( int,::AminoAcid const * ) ;
            
            System_exposer.def( 
                "MutateResidue"
                , MutateResidue_function_type( &::System::MutateResidue )
                , ( bp::arg("id"), bp::arg("newAminoAcid") ) );
        
        }
        { //::System::NextResidue
        
            typedef ::Residue & ( ::System::*NextResidue_function_type )( ::Residue const & ) ;
            
            System_exposer.def( 
                "NextResidue"
                , NextResidue_function_type( &::System::NextResidue )
                , ( bp::arg("res") )
                , bp::return_internal_reference< 1 >() );
        
        }
        { //::System::NextResidue
        
            typedef ::Residue const & ( ::System::*NextResidue_function_type )( ::Residue const & ) const;
            
            System_exposer.def( 
                "NextResidue"
                , NextResidue_function_type( &::System::NextResidue )
                , ( bp::arg("res") )
                , bp::return_internal_reference< 1 >() );
        
        }
        { //::System::PrevResidue
        
            typedef ::Residue & ( ::System::*PrevResidue_function_type )( ::Residue const & ) ;
            
            System_exposer.def( 
                "PrevResidue"
                , PrevResidue_function_type( &::System::PrevResidue )
                , ( bp::arg("res") )
                , bp::return_internal_reference< 1 >() );
        
        }
        { //::System::PrevResidue
        
            typedef ::Residue const & ( ::System::*PrevResidue_function_type )( ::Residue const & ) const;
            
            System_exposer.def( 
                "PrevResidue"
                , PrevResidue_function_type( &::System::PrevResidue )
                , ( bp::arg("res") )
                , bp::return_internal_reference< 1 >() );
        
        }
        { //::System::Split
        
            typedef ::std::vector<boost::shared_ptr<System>, std::allocator<boost::shared_ptr<System> > > ( ::System::*Split_function_type )( ::std::vector<int, std::allocator<int> > const & ) const;
            
            System_exposer.def( 
                "Split"
                , Split_function_type( &::System::Split )
                , ( bp::arg("splitPoints") ) );
        
        }
        { //::System::begin
        
            typedef std::vector<Residue>::iterator ( ::System::*begin_function_type )(  ) ;
            
            System_exposer.def( 
                "begin"
                , begin_function_type( &::System::begin ) );
        
        }
        { //::System::begin
        
            typedef std::vector<Residue>::const_iterator ( ::System::*begin_function_type )(  ) const;
            
            System_exposer.def( 
                "begin"
                , begin_function_type( &::System::begin ) );
        
        }
        { //::System::end
        
            typedef std::vector<Residue>::iterator ( ::System::*end_function_type )(  ) ;
            
            System_exposer.def( 
                "end"
                , end_function_type( &::System::end ) );
        
        }
        { //::System::end
        
            typedef std::vector<Residue>::const_iterator ( ::System::*end_function_type )(  ) const;
            
            System_exposer.def( 
                "end"
                , end_function_type( &::System::end ) );
        
        }
        System_exposer.staticmethod( "Create" );
        System_exposer.staticmethod( "Join" );
        { //property "size"[fget=::System::size]
        
            typedef ::size_t ( ::System::*fget )(  ) const;
            
            System_exposer.add_property( 
                "size"
                , fget( &::System::size )
                , "get property, built on top of \"size_t System::size() const [member function]\"" );
        
        }
        { //property "AminoAcidData"[fget=::System::GetAminoAcidData]
        
            typedef ::boost::shared_ptr<AminoAcidDirectory const> ( ::System::*fget )(  ) const;
            
            System_exposer.add_property( 
                "AminoAcidData"
                , fget( &::System::GetAminoAcidData )
                , "get property, built on top of \"boost::shared_ptr<AminoAcidDirectory const> System::GetAminoAcidData() const [member function]\"" );
        
        }
        { //property "AtomTypes"[fget=::System::GetAtomTypes]
        
            typedef ::boost::shared_ptr<AtomTypes const> ( ::System::*fget )(  ) const;
            
            System_exposer.add_property( 
                "AtomTypes"
                , fget( &::System::GetAtomTypes )
                , "get property, built on top of \"boost::shared_ptr<AtomTypes const> System::GetAtomTypes() const [member function]\"" );
        
        }
        { //property "Clone"[fget=::System::Clone]
        
            typedef ::boost::shared_ptr<System> ( ::System::*fget )(  ) const;
            
            System_exposer.add_property( 
                "Clone"
                , fget( &::System::Clone )
                , "get property, built on top of \"boost::shared_ptr<System> System::Clone() const [member function]\"" );
        
        }
        bp::register_ptr_to_python< boost::shared_ptr< System > >();
        System_exposer.def( "Parse", System_parse_0 );
        System_exposer.def( "__str__", System_print_0 );
        System_exposer.def( "__str__", System_print_1 );
    }

}

