// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

#ifndef IVL_ALIASES_H
#define IVL_ALIASES_H

#include "general.h"

#include <vector>
#include <utility>
#include <map>

//////////////////////////////////////////////////////////////////////////
/////                             ALIASES                            /////
//////////////////////////////////////////////////////////////////////////

namespace pyplusplus
{
namespace aliases
{
	typedef blitz::TinyVector<FLOAT, 2>				Vec2;
	typedef blitz::TinyVector<FLOAT, 3>				Vec3;
	typedef blitz::TinyVector<FLOAT, 4>				Vec4;
	typedef blitz::TinyVector<int, 2>				IVec2;
	typedef blitz::TinyVector<int, 3>				IVec3;
	typedef blitz::TinyVector<int, 4>				IVec4;

	typedef	std::vector<int> 					IntVector;
	typedef std::vector<bool>					BoolVector;
	typedef	std::vector<std::string>				StrVector;
	typedef std::vector<Vector3>					Vec3Vector;
	typedef std::vector<Vector4>					Vec4Vector;
	typedef std::vector<FLOAT>					FloatVector;

	typedef	std::vector<IntVector> 					IntVector2;
	typedef std::vector<BoolVector>					BoolVector2;
	typedef	std::vector<StrVector> 					StrVector2;
	
	typedef std::pair<int, int>					IntPair;
	typedef std::pair<int, FLOAT>					IntFloatPair;
	typedef std::pair< std::vector<int>, FLOAT >			IntVectorFloatPair;

	typedef std::vector<IntPair>					IntPairVector;
	typedef std::vector<IntFloatPair>				IntFloatPairVector;
	typedef std::vector<IntVectorFloatPair>				IntVectorFloatPairVector;
	typedef std::map<int, Vector4>					RotamerChiMap;
}
}

#endif

