// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

#ifndef IVL_CHOMP_HEADERS_H
#define IVL_CHOMP_HEADERS_H

#include "general.h"
#include "atom_type.h"
#include "amino_acid.h"
#include "system.h"
#include "residue.h"
#include "data_table.h"
#include "dunbrack.h"
#include "neighbor_map.h"
#include "rotamer_trie.h"
#include "rotamer_generator.h"
#include "rotamer_iteration_map.h"
#include "rotamers.h"
#include "energy_graph.h"
#include "energy_function.h"
#include "energy_comb_list.h"
#include "ccd.h"
#include "poses.h"
#include "runtime_stats.h"
#include "serialization.h"

//inheritance tree for miscellaneous combinatorial optimization techniques
#include "opt_base.h"
#include "opt_bruteforce.h"
#include "opt_faster.h"

//inheritance tree for Monte Carlo combinatorial optimization techniques
#include "opt_base_montecarlo.h"
#include "opt_montecarlo.h"
#include "opt_montecarlo_mg.h"  //energy for any combination is max from multiple graphs

//inheritance tree for Simulated Annealing combinatorial optimization techniques
#include "opt_base_simanneal.h"
#include "opt_simanneal.h"
#include "opt_simanneal_ms.h"   //attempt to avoid local minimum with multiple starts

#endif

