# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

import os
from os import path

def load_db(filename):
	file = open(filename)

	db = {}
	for line in file:
		split = line.split()
		db[split[0]] = split[1:]

	return db

def fix_includes(filename, db):
	file = open(filename)

	fixed = []
	state = 'reading includes'

	for line in file:
		if state == 'reading includes':
			if line.startswith('#include'):
				if not 'stdafx' in line and not '.hpp' in line:
					continue

			if line.startswith('namespace'):
				for hdr in db[filename]:
					fixed.append('#include "%s"\n' % hdr)
				
				fixed.append('\n')
				state = 'copying file'

			fixed.append(line)
			
		elif state == 'copying file':
			fixed.append(line)

	file.close()
	file = open(filename, 'w')

	for line in fixed:
		file.write(line)
	
if __name__ == '__main__':
	db = load_db('header_db.txt')

	for f in os.listdir('.'):
		if path.splitext(f)[1] == '.cpp':
			fix_includes(f, db)
 

