# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 


from 
aa_list = [ 'ALA', 'CYS', 'ASP', 'GLU', 'PHE', 'GLY', 'HIS', 'ILE', 'LYS', 'LEU',  
	    'MET', 'ASN', 'PRO', 'GLN', 'ARG', 'SER', 'THR', 'VAL', 'TRP', 'TYR' ]

def generate_tables(revlookup_filename, maxrot_filename):
	f  = open(revlookup_filename, 'w')
	f2 = open(maxrot_filename, 'w')

	# output is [ aa, chi, variant, division, {angle/rotamer number} ]
	MAX_CHI		= 4
	MAX_DIVISIONS 	= 10
	MAX_VARIANTS 	= 3

	f.write('%d x %d x %d x %d x %d\n\n' % ( len(aa_list), MAX_CHI, MAX_VARIANTS, MAX_DIVISIONS, 2 ) )
	f.write('[\n')

	f2.write('%d x %d\n\n' % ( len(aa_list), MAX_CHI ) )
	f2.write('[\n')
	
	for aa in aa_list:
		for chi in xrange(MAX_CHI):
			max_rot = 0
	
			for variant in xrange(MAX_VARIANTS):
				for div in xrange(MAX_DIVISIONS):
				
					# first, grab the aa data for this chi
					aa_data = None
					for key, value in data[chi].items():
						if key == aa or isinstance(key, tuple) and aa in key:
							aa_data = value

					# if not found, use the default data
					if not aa_data:
						aa_data = data[chi]['DEFAULT']

					# now drill down into the appropriate variant
					if isinstance(aa_data, list):
						aa_data = aa_data[ min( variant, len(aa_data) - 1 ) ]
				
					# find the highest rotamer index number in the result
					this_max_rot = max( [ x[1] for x in aa_data.items() ] )
					if this_max_rot > max_rot:
						max_rot = this_max_rot
	
					# and grab the current division
					div_data = aa_data.items()
					div_data.sort()
					result = div_data[ min( div, len(div_data) - 1 ) ]

					# write it out!
					f.write('%d\n%d\n' % result)

			f2.write('%d\n' % max_rot)

	f.write(']\n')
	f2.write(']\n')
	
data = 		\
[

# chi 0
{
	'DEFAULT' :
	{
		-120	: 2,
		0	: 3,
		120	: 1,
		180	: 2
	},

	'PRO' :
	{
		0 	: 2,
		180 	: 1
	},

	( 'GLY', 'ALA' ) :
	{
		180	: 0
	}
},

# chi 1
{
	( 'ARG', 'GLU', 'HIS', 'ILE', 'LYS', 'LEU', 'MET', 'GLN' ) :
	{
		-120	: 2,
		0	: 3,
		120	: 1,
		180	: 2
	},

	'ASP' :
	{
		-150	: 2,
		-90	: 1,
		-30	: 3,
		 30	: 2,
		 90	: 1,
		 150	: 3,
		 180	: 2,
	},
	
	( 'PHE', 'TYR' ) :
	{
		-150	: 2,
		-30	: 1,
		 30	: 2,
		 150	: 1,
		 180	: 2
	},

	'TRP' :
	{
		-60	: 1,
		 60	: 2,
		 180 	: 3
	},

	'ASN' :
	[
		{
			-150	: 6,
			-90	: 1,
			-30	: 2,
			 30	: 3,
			 90	: 4,
			 150 	: 5,
			 180	: 6
		},
		{
			-90	: 1,
			-45	: 2,
			 0	: 3,
			 45	: 4,
			 90	: 5,
			 180	: 6,
		},
		{
			-105	: 1,
			-45	: 2,
			 15	: 3,
			 60	: 4,
			 120	: 5,
			 180	: 6
		}
	],

	'DEFAULT' :
	{
		180	: 0 
	}
},

# chi 2
{

	'GLU' :
	{
		-150	: 2,
		-90	: 1,
		-30	: 3,
		 30	: 2,
		 90	: 1,
		 150	: 3,
		 180	: 2
	},

	( 'ARG', 'LYS', 'MET' ) :
	{
		-120	: 2,
		 0	: 3,
		 120	: 1,
		 180	: 2
	},

	'GLN' :
	[
		{
			-135	: 1,
			-45	: 2,
			 45	: 3,
			 135	: 4,
			 180    : 1,
		},
		{
			-90	: 1,
			 0 	: 2,
			 90	: 3,
			 180	: 4
		}
	],

	'DEFAULT' :
	{
		180	: 0 
	}
},

# chi 3
{
	( 'ARG', 'LYS' ) :
	{
		-120	: 2,
		 0	: 3,
		 120	: 1,
		 180	: 2
	},

	'DEFAULT' :
	{
		180	: 0 
	}
}

]

