# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 


aa_list = [ 'ALA', 'CYS', 'ASP', 'GLU', 'PHE', 'GLY', 'HIS', 'ILE', 'LYS', 'LEU',  
	    'MET', 'ASN', 'PRO', 'GLN', 'ARG', 'SER', 'THR', 'VAL', 'TRP', 'TYR' ]

import pickle

def generate_table(source, filename):
	src = open(source)
	f = open(filename, 'w')

	CHOMP_order = pickle.load( open('trieorder.dict') )
	
	rosetta_order = {}
	aa_index = 0
	for line in src:
		if line == '\n': continue
		atoms = [item for item in line.strip(' \n\t').split(' ') if item != '']

		rosetta_order[aa_list[aa_index]] = atoms
		aa_index += 1

		if aa_index == len(aa_list): break
		
	map = {}
	for aa in aa_list:
		aa_map = []
		for index in xrange(len(rosetta_order[aa])):
			cindex = CHOMP_order[aa].index(rosetta_order[aa][index])
			aa_map.append(cindex)

		map[aa] = aa_map

	cp_tbls = {}
	max_atom = 24

	for aa in aa_list:
		result = [ [] for i in range(max_atom) ]
		index = 0

		for line in src:
			if line == '\n': continue
			result[index] = [ int(x) for x in line.strip(' \t\n').split(' ') ]
			index += 1

			if index == max_atom: break

		cp_tbls[aa] = result
		
	for aa in aa_list:
		new_table = [ [ x for x in row ] for row in cp_tbls[aa] ]

		for y in xrange(len(map[aa])):
			for x in xrange(len(map[aa])):
				new_table[map[aa][y]][map[aa][x]] = cp_tbls[aa][y][x]

		cp_tbls[aa] = new_table

	f.write('%d x %d x %d\n\n' % ( len(aa_list), max_atom, max_atom ) )
	f.write('[\n')

	for aa in aa_list:
		for i in xrange(len(cp_tbls[aa])):
			for j in xrange(len(cp_tbls[aa][0])):
				f.write(str(cp_tbls[aa][i][j]) + ' ')
			f.write('\n')
		f.write('\n')

	f.write(']\n')

