# SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
# (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
# merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions: 
# 
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
# THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
# 

dims = ( 20, 20, 2, 2, 5 )

def convert_pairlr(file1, file2):
	d = parse_pairlr(file1)
	correct_pairlr(d)
	write_pairlr(file2, d)

def index_pairlr(data, aa1, aa2, e1, e2, bin):
	s0 = dims[-1]
	s1 = s0 * dims[-2]
	s2 = s1 * dims[-3]
	s3 = s2 * dims[-4]

	return data[ (bin - 1) *  1 + 
		     (e2  - 1) * s0 + 
		     (e1  - 1) * s1 +
		     (aa2 - 1) * s2 + 
		     (aa1 - 1) * s3 ]

def parse_pairlr(filename):
	result = []
	for line in open(filename):
		data = line.strip(' \n\t').split(' ')
		data = [item for item in data if item != '']

		result.append( float(data[5]) )
	
	return result

def correct_pairlr(data):
	pass

def write_pairlr(filename, data):
	f = open(filename, 'w')

	f.write('\n---- DATA STARTS HERE ----\n\n')
	f.write('%d x %d x %d x %d x %d\n\n' % dims)

	f.write('[\n')

	for val in data:
		f.write('%f\n' % val)

	f.write(']\n')

