// SHARPEN is copyright (c) 2008  Ilya Loksha (primary author), Christopher Snow (project lead).
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
// (the "Software") to deal in the Software without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY 
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH 
// THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
// 

void LoadALA(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = ALA;
	data.name3Char = "ALA";

		{
			int _rs_6;
			istream >> _rs_6;

			for (int _rs_7 = 0; _rs_7 < _rs_6; _rs_7++)
			{
				int _rs_5;
						
				istream >> _rs_5;
			
						
				{
					int _rs_2;
					istream >> _rs_2;
		
					for (int _rs_1 = 0; _rs_1 < _rs_2; _rs_1++)
					{
								
						data.atomOrders[_rs_5][_rs_1] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_9;
			istream >> _rs_9;

			for (int _rs_8 = 0; _rs_8 < _rs_9; _rs_8++)
			{
						
				istream >> data.acceptorList[_rs_8];
			
			}
		}
	
		int _rs_10;
		istream >> _rs_10;
		data.polar = (bool)_rs_10;
		{
			int _rs_12;
			istream >> _rs_12;

			for (int _rs_13 = 0; _rs_13 < _rs_12; _rs_13++)
			{
				int _rs_11;
						
				istream >> _rs_11;
			
						
				data.templateCoords[_rs_11] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_17;
			istream >> _rs_17;

			for (int _rs_16 = 0; _rs_16 < _rs_17; _rs_16++)
			{
						
				{
					int _rs_15;
					istream >> _rs_15;
		
					for (int _rs_14 = 0; _rs_14 < _rs_15; _rs_14++)
					{
								
						istream >> data.acceptorBase[_rs_16][_rs_14];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_39;
			istream >> _rs_39;

			for (int _rs_40 = 0; _rs_40 < _rs_39; _rs_40++)
			{
				int _rs_38;
						
				istream >> _rs_38;
			
						
				{
					int _rs_19;
					istream >> _rs_19;
		
					for (int _rs_18 = 0; _rs_18 < _rs_19; _rs_18++)
					{
								
						istream >> data.templateAtom[_rs_38][_rs_18];
					
					}
				}
			
			}
		}
	
		{
			int _rs_42;
			istream >> _rs_42;

			for (int _rs_41 = 0; _rs_41 < _rs_42; _rs_41++)
			{
						
				istream >> data.centroidAtoms[_rs_41];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_64;
			istream >> _rs_64;

			for (int _rs_63 = 0; _rs_63 < _rs_64; _rs_63++)
			{
						
				{
					int _rs_44;
					istream >> _rs_44;
		
					for (int _rs_43 = 0; _rs_43 < _rs_44; _rs_43++)
					{
								
						istream >> data.bondLengths[_rs_63][_rs_43];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_126;
			istream >> _rs_126;

			for (int _rs_127 = 0; _rs_127 < _rs_126; _rs_127++)
			{
				int _rs_125;
						
				istream >> _rs_125;
			
						
				{
					int _rs_70;
					istream >> _rs_70;
		
					for (int _rs_69 = 0; _rs_69 < _rs_70; _rs_69++)
					{
								
						int _rs_65;
						istream >> _rs_65;
						data.chiDependent[_rs_125][_rs_69] = (bool)_rs_65;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCYS(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CYS;
	data.name3Char = "CYS";

		{
			int _rs_133;
			istream >> _rs_133;

			for (int _rs_134 = 0; _rs_134 < _rs_133; _rs_134++)
			{
				int _rs_132;
						
				istream >> _rs_132;
			
						
				{
					int _rs_129;
					istream >> _rs_129;
		
					for (int _rs_128 = 0; _rs_128 < _rs_129; _rs_128++)
					{
								
						data.atomOrders[_rs_132][_rs_128] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_136;
			istream >> _rs_136;

			for (int _rs_135 = 0; _rs_135 < _rs_136; _rs_135++)
			{
						
				istream >> data.acceptorList[_rs_135];
			
			}
		}
	
		int _rs_137;
		istream >> _rs_137;
		data.polar = (bool)_rs_137;
		{
			int _rs_139;
			istream >> _rs_139;

			for (int _rs_140 = 0; _rs_140 < _rs_139; _rs_140++)
			{
				int _rs_138;
						
				istream >> _rs_138;
			
						
				data.templateCoords[_rs_138] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_144;
			istream >> _rs_144;

			for (int _rs_143 = 0; _rs_143 < _rs_144; _rs_143++)
			{
						
				{
					int _rs_142;
					istream >> _rs_142;
		
					for (int _rs_141 = 0; _rs_141 < _rs_142; _rs_141++)
					{
								
						istream >> data.acceptorBase[_rs_143][_rs_141];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_168;
			istream >> _rs_168;

			for (int _rs_169 = 0; _rs_169 < _rs_168; _rs_169++)
			{
				int _rs_167;
						
				istream >> _rs_167;
			
						
				{
					int _rs_146;
					istream >> _rs_146;
		
					for (int _rs_145 = 0; _rs_145 < _rs_146; _rs_145++)
					{
								
						istream >> data.templateAtom[_rs_167][_rs_145];
					
					}
				}
			
			}
		}
	
		{
			int _rs_173;
			istream >> _rs_173;

			for (int _rs_172 = 0; _rs_172 < _rs_173; _rs_172++)
			{
						
				{
					int _rs_171;
					istream >> _rs_171;
		
					for (int _rs_170 = 0; _rs_170 < _rs_171; _rs_170++)
					{
								
						istream >> data.chiAtoms[_rs_172][_rs_170];
					
					}
				}
			
			}
		}
	
		{
			int _rs_175;
			istream >> _rs_175;

			for (int _rs_174 = 0; _rs_174 < _rs_175; _rs_174++)
			{
						
				istream >> data.centroidAtoms[_rs_174];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_199;
			istream >> _rs_199;

			for (int _rs_198 = 0; _rs_198 < _rs_199; _rs_198++)
			{
						
				{
					int _rs_177;
					istream >> _rs_177;
		
					for (int _rs_176 = 0; _rs_176 < _rs_177; _rs_176++)
					{
								
						istream >> data.bondLengths[_rs_198][_rs_176];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_267;
			istream >> _rs_267;

			for (int _rs_268 = 0; _rs_268 < _rs_267; _rs_268++)
			{
				int _rs_266;
						
				istream >> _rs_266;
			
						
				{
					int _rs_205;
					istream >> _rs_205;
		
					for (int _rs_204 = 0; _rs_204 < _rs_205; _rs_204++)
					{
								
						int _rs_200;
						istream >> _rs_200;
						data.chiDependent[_rs_266][_rs_204] = (bool)_rs_200;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadASP(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = ASP;
	data.name3Char = "ASP";

		{
			int _rs_274;
			istream >> _rs_274;

			for (int _rs_275 = 0; _rs_275 < _rs_274; _rs_275++)
			{
				int _rs_273;
						
				istream >> _rs_273;
			
						
				{
					int _rs_270;
					istream >> _rs_270;
		
					for (int _rs_269 = 0; _rs_269 < _rs_270; _rs_269++)
					{
								
						data.atomOrders[_rs_273][_rs_269] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_277;
			istream >> _rs_277;

			for (int _rs_276 = 0; _rs_276 < _rs_277; _rs_276++)
			{
						
				istream >> data.acceptorList[_rs_276];
			
			}
		}
	
		int _rs_278;
		istream >> _rs_278;
		data.polar = (bool)_rs_278;
		{
			int _rs_280;
			istream >> _rs_280;

			for (int _rs_281 = 0; _rs_281 < _rs_280; _rs_281++)
			{
				int _rs_279;
						
				istream >> _rs_279;
			
						
				data.templateCoords[_rs_279] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_289;
			istream >> _rs_289;

			for (int _rs_288 = 0; _rs_288 < _rs_289; _rs_288++)
			{
						
				{
					int _rs_283;
					istream >> _rs_283;
		
					for (int _rs_282 = 0; _rs_282 < _rs_283; _rs_282++)
					{
								
						istream >> data.acceptorBase[_rs_288][_rs_282];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_315;
			istream >> _rs_315;

			for (int _rs_316 = 0; _rs_316 < _rs_315; _rs_316++)
			{
				int _rs_314;
						
				istream >> _rs_314;
			
						
				{
					int _rs_291;
					istream >> _rs_291;
		
					for (int _rs_290 = 0; _rs_290 < _rs_291; _rs_290++)
					{
								
						istream >> data.templateAtom[_rs_314][_rs_290];
					
					}
				}
			
			}
		}
	
		{
			int _rs_322;
			istream >> _rs_322;

			for (int _rs_321 = 0; _rs_321 < _rs_322; _rs_321++)
			{
						
				{
					int _rs_318;
					istream >> _rs_318;
		
					for (int _rs_317 = 0; _rs_317 < _rs_318; _rs_317++)
					{
								
						istream >> data.chiAtoms[_rs_321][_rs_317];
					
					}
				}
			
			}
		}
	
		{
			int _rs_324;
			istream >> _rs_324;

			for (int _rs_323 = 0; _rs_323 < _rs_324; _rs_323++)
			{
						
				istream >> data.centroidAtoms[_rs_323];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_350;
			istream >> _rs_350;

			for (int _rs_349 = 0; _rs_349 < _rs_350; _rs_349++)
			{
						
				{
					int _rs_326;
					istream >> _rs_326;
		
					for (int _rs_325 = 0; _rs_325 < _rs_326; _rs_325++)
					{
								
						istream >> data.bondLengths[_rs_349][_rs_325];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_424;
			istream >> _rs_424;

			for (int _rs_425 = 0; _rs_425 < _rs_424; _rs_425++)
			{
				int _rs_423;
						
				istream >> _rs_423;
			
						
				{
					int _rs_356;
					istream >> _rs_356;
		
					for (int _rs_355 = 0; _rs_355 < _rs_356; _rs_355++)
					{
								
						int _rs_351;
						istream >> _rs_351;
						data.chiDependent[_rs_423][_rs_355] = (bool)_rs_351;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadGLU(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = GLU;
	data.name3Char = "GLU";

		{
			int _rs_431;
			istream >> _rs_431;

			for (int _rs_432 = 0; _rs_432 < _rs_431; _rs_432++)
			{
				int _rs_430;
						
				istream >> _rs_430;
			
						
				{
					int _rs_427;
					istream >> _rs_427;
		
					for (int _rs_426 = 0; _rs_426 < _rs_427; _rs_426++)
					{
								
						data.atomOrders[_rs_430][_rs_426] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_434;
			istream >> _rs_434;

			for (int _rs_433 = 0; _rs_433 < _rs_434; _rs_433++)
			{
						
				istream >> data.acceptorList[_rs_433];
			
			}
		}
	
		int _rs_435;
		istream >> _rs_435;
		data.polar = (bool)_rs_435;
		{
			int _rs_437;
			istream >> _rs_437;

			for (int _rs_438 = 0; _rs_438 < _rs_437; _rs_438++)
			{
				int _rs_436;
						
				istream >> _rs_436;
			
						
				data.templateCoords[_rs_436] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_446;
			istream >> _rs_446;

			for (int _rs_445 = 0; _rs_445 < _rs_446; _rs_445++)
			{
						
				{
					int _rs_440;
					istream >> _rs_440;
		
					for (int _rs_439 = 0; _rs_439 < _rs_440; _rs_439++)
					{
								
						istream >> data.acceptorBase[_rs_445][_rs_439];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_478;
			istream >> _rs_478;

			for (int _rs_479 = 0; _rs_479 < _rs_478; _rs_479++)
			{
				int _rs_477;
						
				istream >> _rs_477;
			
						
				{
					int _rs_448;
					istream >> _rs_448;
		
					for (int _rs_447 = 0; _rs_447 < _rs_448; _rs_447++)
					{
								
						istream >> data.templateAtom[_rs_477][_rs_447];
					
					}
				}
			
			}
		}
	
		{
			int _rs_487;
			istream >> _rs_487;

			for (int _rs_486 = 0; _rs_486 < _rs_487; _rs_486++)
			{
						
				{
					int _rs_481;
					istream >> _rs_481;
		
					for (int _rs_480 = 0; _rs_480 < _rs_481; _rs_480++)
					{
								
						istream >> data.chiAtoms[_rs_486][_rs_480];
					
					}
				}
			
			}
		}
	
		{
			int _rs_489;
			istream >> _rs_489;

			for (int _rs_488 = 0; _rs_488 < _rs_489; _rs_488++)
			{
						
				istream >> data.centroidAtoms[_rs_488];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_521;
			istream >> _rs_521;

			for (int _rs_520 = 0; _rs_520 < _rs_521; _rs_520++)
			{
						
				{
					int _rs_491;
					istream >> _rs_491;
		
					for (int _rs_490 = 0; _rs_490 < _rs_491; _rs_490++)
					{
								
						istream >> data.bondLengths[_rs_520][_rs_490];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_613;
			istream >> _rs_613;

			for (int _rs_614 = 0; _rs_614 < _rs_613; _rs_614++)
			{
				int _rs_612;
						
				istream >> _rs_612;
			
						
				{
					int _rs_527;
					istream >> _rs_527;
		
					for (int _rs_526 = 0; _rs_526 < _rs_527; _rs_526++)
					{
								
						int _rs_522;
						istream >> _rs_522;
						data.chiDependent[_rs_612][_rs_526] = (bool)_rs_522;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadPHE(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = PHE;
	data.name3Char = "PHE";

		{
			int _rs_620;
			istream >> _rs_620;

			for (int _rs_621 = 0; _rs_621 < _rs_620; _rs_621++)
			{
				int _rs_619;
						
				istream >> _rs_619;
			
						
				{
					int _rs_616;
					istream >> _rs_616;
		
					for (int _rs_615 = 0; _rs_615 < _rs_616; _rs_615++)
					{
								
						data.atomOrders[_rs_619][_rs_615] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_623;
			istream >> _rs_623;

			for (int _rs_622 = 0; _rs_622 < _rs_623; _rs_622++)
			{
						
				istream >> data.acceptorList[_rs_622];
			
			}
		}
	
		int _rs_624;
		istream >> _rs_624;
		data.polar = (bool)_rs_624;
		{
			int _rs_626;
			istream >> _rs_626;

			for (int _rs_627 = 0; _rs_627 < _rs_626; _rs_627++)
			{
				int _rs_625;
						
				istream >> _rs_625;
			
						
				data.templateCoords[_rs_625] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_631;
			istream >> _rs_631;

			for (int _rs_630 = 0; _rs_630 < _rs_631; _rs_630++)
			{
						
				{
					int _rs_629;
					istream >> _rs_629;
		
					for (int _rs_628 = 0; _rs_628 < _rs_629; _rs_628++)
					{
								
						istream >> data.acceptorBase[_rs_630][_rs_628];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_673;
			istream >> _rs_673;

			for (int _rs_674 = 0; _rs_674 < _rs_673; _rs_674++)
			{
				int _rs_672;
						
				istream >> _rs_672;
			
						
				{
					int _rs_633;
					istream >> _rs_633;
		
					for (int _rs_632 = 0; _rs_632 < _rs_633; _rs_632++)
					{
								
						istream >> data.templateAtom[_rs_672][_rs_632];
					
					}
				}
			
			}
		}
	
		{
			int _rs_680;
			istream >> _rs_680;

			for (int _rs_679 = 0; _rs_679 < _rs_680; _rs_679++)
			{
						
				{
					int _rs_676;
					istream >> _rs_676;
		
					for (int _rs_675 = 0; _rs_675 < _rs_676; _rs_675++)
					{
								
						istream >> data.chiAtoms[_rs_679][_rs_675];
					
					}
				}
			
			}
		}
	
		{
			int _rs_682;
			istream >> _rs_682;

			for (int _rs_681 = 0; _rs_681 < _rs_682; _rs_681++)
			{
						
				istream >> data.centroidAtoms[_rs_681];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_724;
			istream >> _rs_724;

			for (int _rs_723 = 0; _rs_723 < _rs_724; _rs_723++)
			{
						
				{
					int _rs_684;
					istream >> _rs_684;
		
					for (int _rs_683 = 0; _rs_683 < _rs_684; _rs_683++)
					{
								
						istream >> data.bondLengths[_rs_723][_rs_683];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_846;
			istream >> _rs_846;

			for (int _rs_847 = 0; _rs_847 < _rs_846; _rs_847++)
			{
				int _rs_845;
						
				istream >> _rs_845;
			
						
				{
					int _rs_730;
					istream >> _rs_730;
		
					for (int _rs_729 = 0; _rs_729 < _rs_730; _rs_729++)
					{
								
						int _rs_725;
						istream >> _rs_725;
						data.chiDependent[_rs_845][_rs_729] = (bool)_rs_725;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadGLY(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = GLY;
	data.name3Char = "GLY";

		{
			int _rs_853;
			istream >> _rs_853;

			for (int _rs_854 = 0; _rs_854 < _rs_853; _rs_854++)
			{
				int _rs_852;
						
				istream >> _rs_852;
			
						
				{
					int _rs_849;
					istream >> _rs_849;
		
					for (int _rs_848 = 0; _rs_848 < _rs_849; _rs_848++)
					{
								
						data.atomOrders[_rs_852][_rs_848] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_856;
			istream >> _rs_856;

			for (int _rs_855 = 0; _rs_855 < _rs_856; _rs_855++)
			{
						
				istream >> data.acceptorList[_rs_855];
			
			}
		}
	
		int _rs_857;
		istream >> _rs_857;
		data.polar = (bool)_rs_857;
		{
			int _rs_859;
			istream >> _rs_859;

			for (int _rs_860 = 0; _rs_860 < _rs_859; _rs_860++)
			{
				int _rs_858;
						
				istream >> _rs_858;
			
						
				data.templateCoords[_rs_858] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_864;
			istream >> _rs_864;

			for (int _rs_863 = 0; _rs_863 < _rs_864; _rs_863++)
			{
						
				{
					int _rs_862;
					istream >> _rs_862;
		
					for (int _rs_861 = 0; _rs_861 < _rs_862; _rs_861++)
					{
								
						istream >> data.acceptorBase[_rs_863][_rs_861];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_880;
			istream >> _rs_880;

			for (int _rs_881 = 0; _rs_881 < _rs_880; _rs_881++)
			{
				int _rs_879;
						
				istream >> _rs_879;
			
						
				{
					int _rs_866;
					istream >> _rs_866;
		
					for (int _rs_865 = 0; _rs_865 < _rs_866; _rs_865++)
					{
								
						istream >> data.templateAtom[_rs_879][_rs_865];
					
					}
				}
			
			}
		}
	
		{
			int _rs_883;
			istream >> _rs_883;

			for (int _rs_882 = 0; _rs_882 < _rs_883; _rs_882++)
			{
						
				istream >> data.centroidAtoms[_rs_882];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_899;
			istream >> _rs_899;

			for (int _rs_898 = 0; _rs_898 < _rs_899; _rs_898++)
			{
						
				{
					int _rs_885;
					istream >> _rs_885;
		
					for (int _rs_884 = 0; _rs_884 < _rs_885; _rs_884++)
					{
								
						istream >> data.bondLengths[_rs_898][_rs_884];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_943;
			istream >> _rs_943;

			for (int _rs_944 = 0; _rs_944 < _rs_943; _rs_944++)
			{
				int _rs_942;
						
				istream >> _rs_942;
			
						
				{
					int _rs_905;
					istream >> _rs_905;
		
					for (int _rs_904 = 0; _rs_904 < _rs_905; _rs_904++)
					{
								
						int _rs_900;
						istream >> _rs_900;
						data.chiDependent[_rs_942][_rs_904] = (bool)_rs_900;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadHIS(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = HIS;
	data.name3Char = "HIS";

		{
			int _rs_950;
			istream >> _rs_950;

			for (int _rs_951 = 0; _rs_951 < _rs_950; _rs_951++)
			{
				int _rs_949;
						
				istream >> _rs_949;
			
						
				{
					int _rs_946;
					istream >> _rs_946;
		
					for (int _rs_945 = 0; _rs_945 < _rs_946; _rs_945++)
					{
								
						data.atomOrders[_rs_949][_rs_945] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_953;
			istream >> _rs_953;

			for (int _rs_952 = 0; _rs_952 < _rs_953; _rs_952++)
			{
						
				istream >> data.acceptorList[_rs_952];
			
			}
		}
	
		int _rs_954;
		istream >> _rs_954;
		data.polar = (bool)_rs_954;
		{
			int _rs_956;
			istream >> _rs_956;

			for (int _rs_957 = 0; _rs_957 < _rs_956; _rs_957++)
			{
				int _rs_955;
						
				istream >> _rs_955;
			
						
				data.templateCoords[_rs_955] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_963;
			istream >> _rs_963;

			for (int _rs_962 = 0; _rs_962 < _rs_963; _rs_962++)
			{
						
				{
					int _rs_959;
					istream >> _rs_959;
		
					for (int _rs_958 = 0; _rs_958 < _rs_959; _rs_958++)
					{
								
						istream >> data.acceptorBase[_rs_962][_rs_958];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_999;
			istream >> _rs_999;

			for (int _rs_1000 = 0; _rs_1000 < _rs_999; _rs_1000++)
			{
				int _rs_998;
						
				istream >> _rs_998;
			
						
				{
					int _rs_965;
					istream >> _rs_965;
		
					for (int _rs_964 = 0; _rs_964 < _rs_965; _rs_964++)
					{
								
						istream >> data.templateAtom[_rs_998][_rs_964];
					
					}
				}
			
			}
		}
	
		{
			int _rs_1006;
			istream >> _rs_1006;

			for (int _rs_1005 = 0; _rs_1005 < _rs_1006; _rs_1005++)
			{
						
				{
					int _rs_1002;
					istream >> _rs_1002;
		
					for (int _rs_1001 = 0; _rs_1001 < _rs_1002; _rs_1001++)
					{
								
						istream >> data.chiAtoms[_rs_1005][_rs_1001];
					
					}
				}
			
			}
		}
	
		{
			int _rs_1008;
			istream >> _rs_1008;

			for (int _rs_1007 = 0; _rs_1007 < _rs_1008; _rs_1007++)
			{
						
				istream >> data.centroidAtoms[_rs_1007];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_1044;
			istream >> _rs_1044;

			for (int _rs_1043 = 0; _rs_1043 < _rs_1044; _rs_1043++)
			{
						
				{
					int _rs_1010;
					istream >> _rs_1010;
		
					for (int _rs_1009 = 0; _rs_1009 < _rs_1010; _rs_1009++)
					{
								
						istream >> data.bondLengths[_rs_1043][_rs_1009];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_1148;
			istream >> _rs_1148;

			for (int _rs_1149 = 0; _rs_1149 < _rs_1148; _rs_1149++)
			{
				int _rs_1147;
						
				istream >> _rs_1147;
			
						
				{
					int _rs_1050;
					istream >> _rs_1050;
		
					for (int _rs_1049 = 0; _rs_1049 < _rs_1050; _rs_1049++)
					{
								
						int _rs_1045;
						istream >> _rs_1045;
						data.chiDependent[_rs_1147][_rs_1049] = (bool)_rs_1045;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadILE(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = ILE;
	data.name3Char = "ILE";

		{
			int _rs_1155;
			istream >> _rs_1155;

			for (int _rs_1156 = 0; _rs_1156 < _rs_1155; _rs_1156++)
			{
				int _rs_1154;
						
				istream >> _rs_1154;
			
						
				{
					int _rs_1151;
					istream >> _rs_1151;
		
					for (int _rs_1150 = 0; _rs_1150 < _rs_1151; _rs_1150++)
					{
								
						data.atomOrders[_rs_1154][_rs_1150] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_1158;
			istream >> _rs_1158;

			for (int _rs_1157 = 0; _rs_1157 < _rs_1158; _rs_1157++)
			{
						
				istream >> data.acceptorList[_rs_1157];
			
			}
		}
	
		int _rs_1159;
		istream >> _rs_1159;
		data.polar = (bool)_rs_1159;
		{
			int _rs_1161;
			istream >> _rs_1161;

			for (int _rs_1162 = 0; _rs_1162 < _rs_1161; _rs_1162++)
			{
				int _rs_1160;
						
				istream >> _rs_1160;
			
						
				data.templateCoords[_rs_1160] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_1166;
			istream >> _rs_1166;

			for (int _rs_1165 = 0; _rs_1165 < _rs_1166; _rs_1165++)
			{
						
				{
					int _rs_1164;
					istream >> _rs_1164;
		
					for (int _rs_1163 = 0; _rs_1163 < _rs_1164; _rs_1163++)
					{
								
						istream >> data.acceptorBase[_rs_1165][_rs_1163];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_1206;
			istream >> _rs_1206;

			for (int _rs_1207 = 0; _rs_1207 < _rs_1206; _rs_1207++)
			{
				int _rs_1205;
						
				istream >> _rs_1205;
			
						
				{
					int _rs_1168;
					istream >> _rs_1168;
		
					for (int _rs_1167 = 0; _rs_1167 < _rs_1168; _rs_1167++)
					{
								
						istream >> data.templateAtom[_rs_1205][_rs_1167];
					
					}
				}
			
			}
		}
	
		{
			int _rs_1213;
			istream >> _rs_1213;

			for (int _rs_1212 = 0; _rs_1212 < _rs_1213; _rs_1212++)
			{
						
				{
					int _rs_1209;
					istream >> _rs_1209;
		
					for (int _rs_1208 = 0; _rs_1208 < _rs_1209; _rs_1208++)
					{
								
						istream >> data.chiAtoms[_rs_1212][_rs_1208];
					
					}
				}
			
			}
		}
	
		{
			int _rs_1215;
			istream >> _rs_1215;

			for (int _rs_1214 = 0; _rs_1214 < _rs_1215; _rs_1214++)
			{
						
				istream >> data.centroidAtoms[_rs_1214];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_1255;
			istream >> _rs_1255;

			for (int _rs_1254 = 0; _rs_1254 < _rs_1255; _rs_1254++)
			{
						
				{
					int _rs_1217;
					istream >> _rs_1217;
		
					for (int _rs_1216 = 0; _rs_1216 < _rs_1217; _rs_1216++)
					{
								
						istream >> data.bondLengths[_rs_1254][_rs_1216];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_1371;
			istream >> _rs_1371;

			for (int _rs_1372 = 0; _rs_1372 < _rs_1371; _rs_1372++)
			{
				int _rs_1370;
						
				istream >> _rs_1370;
			
						
				{
					int _rs_1261;
					istream >> _rs_1261;
		
					for (int _rs_1260 = 0; _rs_1260 < _rs_1261; _rs_1260++)
					{
								
						int _rs_1256;
						istream >> _rs_1256;
						data.chiDependent[_rs_1370][_rs_1260] = (bool)_rs_1256;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadLYS(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = LYS;
	data.name3Char = "LYS";

		{
			int _rs_1378;
			istream >> _rs_1378;

			for (int _rs_1379 = 0; _rs_1379 < _rs_1378; _rs_1379++)
			{
				int _rs_1377;
						
				istream >> _rs_1377;
			
						
				{
					int _rs_1374;
					istream >> _rs_1374;
		
					for (int _rs_1373 = 0; _rs_1373 < _rs_1374; _rs_1373++)
					{
								
						data.atomOrders[_rs_1377][_rs_1373] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_1381;
			istream >> _rs_1381;

			for (int _rs_1380 = 0; _rs_1380 < _rs_1381; _rs_1380++)
			{
						
				istream >> data.acceptorList[_rs_1380];
			
			}
		}
	
		int _rs_1382;
		istream >> _rs_1382;
		data.polar = (bool)_rs_1382;
		{
			int _rs_1384;
			istream >> _rs_1384;

			for (int _rs_1385 = 0; _rs_1385 < _rs_1384; _rs_1385++)
			{
				int _rs_1383;
						
				istream >> _rs_1383;
			
						
				data.templateCoords[_rs_1383] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_1389;
			istream >> _rs_1389;

			for (int _rs_1388 = 0; _rs_1388 < _rs_1389; _rs_1388++)
			{
						
				{
					int _rs_1387;
					istream >> _rs_1387;
		
					for (int _rs_1386 = 0; _rs_1386 < _rs_1387; _rs_1386++)
					{
								
						istream >> data.acceptorBase[_rs_1388][_rs_1386];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_1435;
			istream >> _rs_1435;

			for (int _rs_1436 = 0; _rs_1436 < _rs_1435; _rs_1436++)
			{
				int _rs_1434;
						
				istream >> _rs_1434;
			
						
				{
					int _rs_1391;
					istream >> _rs_1391;
		
					for (int _rs_1390 = 0; _rs_1390 < _rs_1391; _rs_1390++)
					{
								
						istream >> data.templateAtom[_rs_1434][_rs_1390];
					
					}
				}
			
			}
		}
	
		{
			int _rs_1446;
			istream >> _rs_1446;

			for (int _rs_1445 = 0; _rs_1445 < _rs_1446; _rs_1445++)
			{
						
				{
					int _rs_1438;
					istream >> _rs_1438;
		
					for (int _rs_1437 = 0; _rs_1437 < _rs_1438; _rs_1437++)
					{
								
						istream >> data.chiAtoms[_rs_1445][_rs_1437];
					
					}
				}
			
			}
		}
	
		{
			int _rs_1448;
			istream >> _rs_1448;

			for (int _rs_1447 = 0; _rs_1447 < _rs_1448; _rs_1447++)
			{
						
				istream >> data.centroidAtoms[_rs_1447];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_1494;
			istream >> _rs_1494;

			for (int _rs_1493 = 0; _rs_1493 < _rs_1494; _rs_1493++)
			{
						
				{
					int _rs_1450;
					istream >> _rs_1450;
		
					for (int _rs_1449 = 0; _rs_1449 < _rs_1450; _rs_1449++)
					{
								
						istream >> data.bondLengths[_rs_1493][_rs_1449];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_1628;
			istream >> _rs_1628;

			for (int _rs_1629 = 0; _rs_1629 < _rs_1628; _rs_1629++)
			{
				int _rs_1627;
						
				istream >> _rs_1627;
			
						
				{
					int _rs_1500;
					istream >> _rs_1500;
		
					for (int _rs_1499 = 0; _rs_1499 < _rs_1500; _rs_1499++)
					{
								
						int _rs_1495;
						istream >> _rs_1495;
						data.chiDependent[_rs_1627][_rs_1499] = (bool)_rs_1495;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadLEU(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = LEU;
	data.name3Char = "LEU";

		{
			int _rs_1635;
			istream >> _rs_1635;

			for (int _rs_1636 = 0; _rs_1636 < _rs_1635; _rs_1636++)
			{
				int _rs_1634;
						
				istream >> _rs_1634;
			
						
				{
					int _rs_1631;
					istream >> _rs_1631;
		
					for (int _rs_1630 = 0; _rs_1630 < _rs_1631; _rs_1630++)
					{
								
						data.atomOrders[_rs_1634][_rs_1630] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_1638;
			istream >> _rs_1638;

			for (int _rs_1637 = 0; _rs_1637 < _rs_1638; _rs_1637++)
			{
						
				istream >> data.acceptorList[_rs_1637];
			
			}
		}
	
		int _rs_1639;
		istream >> _rs_1639;
		data.polar = (bool)_rs_1639;
		{
			int _rs_1641;
			istream >> _rs_1641;

			for (int _rs_1642 = 0; _rs_1642 < _rs_1641; _rs_1642++)
			{
				int _rs_1640;
						
				istream >> _rs_1640;
			
						
				data.templateCoords[_rs_1640] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_1646;
			istream >> _rs_1646;

			for (int _rs_1645 = 0; _rs_1645 < _rs_1646; _rs_1645++)
			{
						
				{
					int _rs_1644;
					istream >> _rs_1644;
		
					for (int _rs_1643 = 0; _rs_1643 < _rs_1644; _rs_1643++)
					{
								
						istream >> data.acceptorBase[_rs_1645][_rs_1643];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_1686;
			istream >> _rs_1686;

			for (int _rs_1687 = 0; _rs_1687 < _rs_1686; _rs_1687++)
			{
				int _rs_1685;
						
				istream >> _rs_1685;
			
						
				{
					int _rs_1648;
					istream >> _rs_1648;
		
					for (int _rs_1647 = 0; _rs_1647 < _rs_1648; _rs_1647++)
					{
								
						istream >> data.templateAtom[_rs_1685][_rs_1647];
					
					}
				}
			
			}
		}
	
		{
			int _rs_1693;
			istream >> _rs_1693;

			for (int _rs_1692 = 0; _rs_1692 < _rs_1693; _rs_1692++)
			{
						
				{
					int _rs_1689;
					istream >> _rs_1689;
		
					for (int _rs_1688 = 0; _rs_1688 < _rs_1689; _rs_1688++)
					{
								
						istream >> data.chiAtoms[_rs_1692][_rs_1688];
					
					}
				}
			
			}
		}
	
		{
			int _rs_1695;
			istream >> _rs_1695;

			for (int _rs_1694 = 0; _rs_1694 < _rs_1695; _rs_1694++)
			{
						
				istream >> data.centroidAtoms[_rs_1694];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_1735;
			istream >> _rs_1735;

			for (int _rs_1734 = 0; _rs_1734 < _rs_1735; _rs_1734++)
			{
						
				{
					int _rs_1697;
					istream >> _rs_1697;
		
					for (int _rs_1696 = 0; _rs_1696 < _rs_1697; _rs_1696++)
					{
								
						istream >> data.bondLengths[_rs_1734][_rs_1696];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_1851;
			istream >> _rs_1851;

			for (int _rs_1852 = 0; _rs_1852 < _rs_1851; _rs_1852++)
			{
				int _rs_1850;
						
				istream >> _rs_1850;
			
						
				{
					int _rs_1741;
					istream >> _rs_1741;
		
					for (int _rs_1740 = 0; _rs_1740 < _rs_1741; _rs_1740++)
					{
								
						int _rs_1736;
						istream >> _rs_1736;
						data.chiDependent[_rs_1850][_rs_1740] = (bool)_rs_1736;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadMET(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = MET;
	data.name3Char = "MET";

		{
			int _rs_1858;
			istream >> _rs_1858;

			for (int _rs_1859 = 0; _rs_1859 < _rs_1858; _rs_1859++)
			{
				int _rs_1857;
						
				istream >> _rs_1857;
			
						
				{
					int _rs_1854;
					istream >> _rs_1854;
		
					for (int _rs_1853 = 0; _rs_1853 < _rs_1854; _rs_1853++)
					{
								
						data.atomOrders[_rs_1857][_rs_1853] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_1861;
			istream >> _rs_1861;

			for (int _rs_1860 = 0; _rs_1860 < _rs_1861; _rs_1860++)
			{
						
				istream >> data.acceptorList[_rs_1860];
			
			}
		}
	
		int _rs_1862;
		istream >> _rs_1862;
		data.polar = (bool)_rs_1862;
		{
			int _rs_1864;
			istream >> _rs_1864;

			for (int _rs_1865 = 0; _rs_1865 < _rs_1864; _rs_1865++)
			{
				int _rs_1863;
						
				istream >> _rs_1863;
			
						
				data.templateCoords[_rs_1863] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_1869;
			istream >> _rs_1869;

			for (int _rs_1868 = 0; _rs_1868 < _rs_1869; _rs_1868++)
			{
						
				{
					int _rs_1867;
					istream >> _rs_1867;
		
					for (int _rs_1866 = 0; _rs_1866 < _rs_1867; _rs_1866++)
					{
								
						istream >> data.acceptorBase[_rs_1868][_rs_1866];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_1905;
			istream >> _rs_1905;

			for (int _rs_1906 = 0; _rs_1906 < _rs_1905; _rs_1906++)
			{
				int _rs_1904;
						
				istream >> _rs_1904;
			
						
				{
					int _rs_1871;
					istream >> _rs_1871;
		
					for (int _rs_1870 = 0; _rs_1870 < _rs_1871; _rs_1870++)
					{
								
						istream >> data.templateAtom[_rs_1904][_rs_1870];
					
					}
				}
			
			}
		}
	
		{
			int _rs_1914;
			istream >> _rs_1914;

			for (int _rs_1913 = 0; _rs_1913 < _rs_1914; _rs_1913++)
			{
						
				{
					int _rs_1908;
					istream >> _rs_1908;
		
					for (int _rs_1907 = 0; _rs_1907 < _rs_1908; _rs_1907++)
					{
								
						istream >> data.chiAtoms[_rs_1913][_rs_1907];
					
					}
				}
			
			}
		}
	
		{
			int _rs_1916;
			istream >> _rs_1916;

			for (int _rs_1915 = 0; _rs_1915 < _rs_1916; _rs_1915++)
			{
						
				istream >> data.centroidAtoms[_rs_1915];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_1952;
			istream >> _rs_1952;

			for (int _rs_1951 = 0; _rs_1951 < _rs_1952; _rs_1951++)
			{
						
				{
					int _rs_1918;
					istream >> _rs_1918;
		
					for (int _rs_1917 = 0; _rs_1917 < _rs_1918; _rs_1917++)
					{
								
						istream >> data.bondLengths[_rs_1951][_rs_1917];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_2056;
			istream >> _rs_2056;

			for (int _rs_2057 = 0; _rs_2057 < _rs_2056; _rs_2057++)
			{
				int _rs_2055;
						
				istream >> _rs_2055;
			
						
				{
					int _rs_1958;
					istream >> _rs_1958;
		
					for (int _rs_1957 = 0; _rs_1957 < _rs_1958; _rs_1957++)
					{
								
						int _rs_1953;
						istream >> _rs_1953;
						data.chiDependent[_rs_2055][_rs_1957] = (bool)_rs_1953;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadASN(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = ASN;
	data.name3Char = "ASN";

		{
			int _rs_2063;
			istream >> _rs_2063;

			for (int _rs_2064 = 0; _rs_2064 < _rs_2063; _rs_2064++)
			{
				int _rs_2062;
						
				istream >> _rs_2062;
			
						
				{
					int _rs_2059;
					istream >> _rs_2059;
		
					for (int _rs_2058 = 0; _rs_2058 < _rs_2059; _rs_2058++)
					{
								
						data.atomOrders[_rs_2062][_rs_2058] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_2066;
			istream >> _rs_2066;

			for (int _rs_2065 = 0; _rs_2065 < _rs_2066; _rs_2065++)
			{
						
				istream >> data.acceptorList[_rs_2065];
			
			}
		}
	
		int _rs_2067;
		istream >> _rs_2067;
		data.polar = (bool)_rs_2067;
		{
			int _rs_2069;
			istream >> _rs_2069;

			for (int _rs_2070 = 0; _rs_2070 < _rs_2069; _rs_2070++)
			{
				int _rs_2068;
						
				istream >> _rs_2068;
			
						
				data.templateCoords[_rs_2068] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_2076;
			istream >> _rs_2076;

			for (int _rs_2075 = 0; _rs_2075 < _rs_2076; _rs_2075++)
			{
						
				{
					int _rs_2072;
					istream >> _rs_2072;
		
					for (int _rs_2071 = 0; _rs_2071 < _rs_2072; _rs_2071++)
					{
								
						istream >> data.acceptorBase[_rs_2075][_rs_2071];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_2106;
			istream >> _rs_2106;

			for (int _rs_2107 = 0; _rs_2107 < _rs_2106; _rs_2107++)
			{
				int _rs_2105;
						
				istream >> _rs_2105;
			
						
				{
					int _rs_2078;
					istream >> _rs_2078;
		
					for (int _rs_2077 = 0; _rs_2077 < _rs_2078; _rs_2077++)
					{
								
						istream >> data.templateAtom[_rs_2105][_rs_2077];
					
					}
				}
			
			}
		}
	
		{
			int _rs_2113;
			istream >> _rs_2113;

			for (int _rs_2112 = 0; _rs_2112 < _rs_2113; _rs_2112++)
			{
						
				{
					int _rs_2109;
					istream >> _rs_2109;
		
					for (int _rs_2108 = 0; _rs_2108 < _rs_2109; _rs_2108++)
					{
								
						istream >> data.chiAtoms[_rs_2112][_rs_2108];
					
					}
				}
			
			}
		}
	
		{
			int _rs_2115;
			istream >> _rs_2115;

			for (int _rs_2114 = 0; _rs_2114 < _rs_2115; _rs_2114++)
			{
						
				istream >> data.centroidAtoms[_rs_2114];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_2145;
			istream >> _rs_2145;

			for (int _rs_2144 = 0; _rs_2144 < _rs_2145; _rs_2144++)
			{
						
				{
					int _rs_2117;
					istream >> _rs_2117;
		
					for (int _rs_2116 = 0; _rs_2116 < _rs_2117; _rs_2116++)
					{
								
						istream >> data.bondLengths[_rs_2144][_rs_2116];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_2231;
			istream >> _rs_2231;

			for (int _rs_2232 = 0; _rs_2232 < _rs_2231; _rs_2232++)
			{
				int _rs_2230;
						
				istream >> _rs_2230;
			
						
				{
					int _rs_2151;
					istream >> _rs_2151;
		
					for (int _rs_2150 = 0; _rs_2150 < _rs_2151; _rs_2150++)
					{
								
						int _rs_2146;
						istream >> _rs_2146;
						data.chiDependent[_rs_2230][_rs_2150] = (bool)_rs_2146;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadPRO(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = PRO;
	data.name3Char = "PRO";

		{
			int _rs_2238;
			istream >> _rs_2238;

			for (int _rs_2239 = 0; _rs_2239 < _rs_2238; _rs_2239++)
			{
				int _rs_2237;
						
				istream >> _rs_2237;
			
						
				{
					int _rs_2234;
					istream >> _rs_2234;
		
					for (int _rs_2233 = 0; _rs_2233 < _rs_2234; _rs_2233++)
					{
								
						data.atomOrders[_rs_2237][_rs_2233] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_2241;
			istream >> _rs_2241;

			for (int _rs_2240 = 0; _rs_2240 < _rs_2241; _rs_2240++)
			{
						
				istream >> data.acceptorList[_rs_2240];
			
			}
		}
	
		int _rs_2242;
		istream >> _rs_2242;
		data.polar = (bool)_rs_2242;
		{
			int _rs_2244;
			istream >> _rs_2244;

			for (int _rs_2245 = 0; _rs_2245 < _rs_2244; _rs_2245++)
			{
				int _rs_2243;
						
				istream >> _rs_2243;
			
						
				data.templateCoords[_rs_2243] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_2249;
			istream >> _rs_2249;

			for (int _rs_2248 = 0; _rs_2248 < _rs_2249; _rs_2248++)
			{
						
				{
					int _rs_2247;
					istream >> _rs_2247;
		
					for (int _rs_2246 = 0; _rs_2246 < _rs_2247; _rs_2246++)
					{
								
						istream >> data.acceptorBase[_rs_2248][_rs_2246];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_2279;
			istream >> _rs_2279;

			for (int _rs_2280 = 0; _rs_2280 < _rs_2279; _rs_2280++)
			{
				int _rs_2278;
						
				istream >> _rs_2278;
			
						
				{
					int _rs_2251;
					istream >> _rs_2251;
		
					for (int _rs_2250 = 0; _rs_2250 < _rs_2251; _rs_2250++)
					{
								
						istream >> data.templateAtom[_rs_2278][_rs_2250];
					
					}
				}
			
			}
		}
	
		{
			int _rs_2284;
			istream >> _rs_2284;

			for (int _rs_2283 = 0; _rs_2283 < _rs_2284; _rs_2283++)
			{
						
				{
					int _rs_2282;
					istream >> _rs_2282;
		
					for (int _rs_2281 = 0; _rs_2281 < _rs_2282; _rs_2281++)
					{
								
						istream >> data.chiAtoms[_rs_2283][_rs_2281];
					
					}
				}
			
			}
		}
	
		{
			int _rs_2286;
			istream >> _rs_2286;

			for (int _rs_2285 = 0; _rs_2285 < _rs_2286; _rs_2285++)
			{
						
				istream >> data.centroidAtoms[_rs_2285];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_2316;
			istream >> _rs_2316;

			for (int _rs_2315 = 0; _rs_2315 < _rs_2316; _rs_2315++)
			{
						
				{
					int _rs_2288;
					istream >> _rs_2288;
		
					for (int _rs_2287 = 0; _rs_2287 < _rs_2288; _rs_2287++)
					{
								
						istream >> data.bondLengths[_rs_2315][_rs_2287];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_2402;
			istream >> _rs_2402;

			for (int _rs_2403 = 0; _rs_2403 < _rs_2402; _rs_2403++)
			{
				int _rs_2401;
						
				istream >> _rs_2401;
			
						
				{
					int _rs_2322;
					istream >> _rs_2322;
		
					for (int _rs_2321 = 0; _rs_2321 < _rs_2322; _rs_2321++)
					{
								
						int _rs_2317;
						istream >> _rs_2317;
						data.chiDependent[_rs_2401][_rs_2321] = (bool)_rs_2317;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadGLN(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = GLN;
	data.name3Char = "GLN";

		{
			int _rs_2409;
			istream >> _rs_2409;

			for (int _rs_2410 = 0; _rs_2410 < _rs_2409; _rs_2410++)
			{
				int _rs_2408;
						
				istream >> _rs_2408;
			
						
				{
					int _rs_2405;
					istream >> _rs_2405;
		
					for (int _rs_2404 = 0; _rs_2404 < _rs_2405; _rs_2404++)
					{
								
						data.atomOrders[_rs_2408][_rs_2404] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_2412;
			istream >> _rs_2412;

			for (int _rs_2411 = 0; _rs_2411 < _rs_2412; _rs_2411++)
			{
						
				istream >> data.acceptorList[_rs_2411];
			
			}
		}
	
		int _rs_2413;
		istream >> _rs_2413;
		data.polar = (bool)_rs_2413;
		{
			int _rs_2415;
			istream >> _rs_2415;

			for (int _rs_2416 = 0; _rs_2416 < _rs_2415; _rs_2416++)
			{
				int _rs_2414;
						
				istream >> _rs_2414;
			
						
				data.templateCoords[_rs_2414] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_2422;
			istream >> _rs_2422;

			for (int _rs_2421 = 0; _rs_2421 < _rs_2422; _rs_2421++)
			{
						
				{
					int _rs_2418;
					istream >> _rs_2418;
		
					for (int _rs_2417 = 0; _rs_2417 < _rs_2418; _rs_2417++)
					{
								
						istream >> data.acceptorBase[_rs_2421][_rs_2417];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_2458;
			istream >> _rs_2458;

			for (int _rs_2459 = 0; _rs_2459 < _rs_2458; _rs_2459++)
			{
				int _rs_2457;
						
				istream >> _rs_2457;
			
						
				{
					int _rs_2424;
					istream >> _rs_2424;
		
					for (int _rs_2423 = 0; _rs_2423 < _rs_2424; _rs_2423++)
					{
								
						istream >> data.templateAtom[_rs_2457][_rs_2423];
					
					}
				}
			
			}
		}
	
		{
			int _rs_2467;
			istream >> _rs_2467;

			for (int _rs_2466 = 0; _rs_2466 < _rs_2467; _rs_2466++)
			{
						
				{
					int _rs_2461;
					istream >> _rs_2461;
		
					for (int _rs_2460 = 0; _rs_2460 < _rs_2461; _rs_2460++)
					{
								
						istream >> data.chiAtoms[_rs_2466][_rs_2460];
					
					}
				}
			
			}
		}
	
		{
			int _rs_2469;
			istream >> _rs_2469;

			for (int _rs_2468 = 0; _rs_2468 < _rs_2469; _rs_2468++)
			{
						
				istream >> data.centroidAtoms[_rs_2468];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_2505;
			istream >> _rs_2505;

			for (int _rs_2504 = 0; _rs_2504 < _rs_2505; _rs_2504++)
			{
						
				{
					int _rs_2471;
					istream >> _rs_2471;
		
					for (int _rs_2470 = 0; _rs_2470 < _rs_2471; _rs_2470++)
					{
								
						istream >> data.bondLengths[_rs_2504][_rs_2470];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_2609;
			istream >> _rs_2609;

			for (int _rs_2610 = 0; _rs_2610 < _rs_2609; _rs_2610++)
			{
				int _rs_2608;
						
				istream >> _rs_2608;
			
						
				{
					int _rs_2511;
					istream >> _rs_2511;
		
					for (int _rs_2510 = 0; _rs_2510 < _rs_2511; _rs_2510++)
					{
								
						int _rs_2506;
						istream >> _rs_2506;
						data.chiDependent[_rs_2608][_rs_2510] = (bool)_rs_2506;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadARG(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = ARG;
	data.name3Char = "ARG";

		{
			int _rs_2616;
			istream >> _rs_2616;

			for (int _rs_2617 = 0; _rs_2617 < _rs_2616; _rs_2617++)
			{
				int _rs_2615;
						
				istream >> _rs_2615;
			
						
				{
					int _rs_2612;
					istream >> _rs_2612;
		
					for (int _rs_2611 = 0; _rs_2611 < _rs_2612; _rs_2611++)
					{
								
						data.atomOrders[_rs_2615][_rs_2611] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_2619;
			istream >> _rs_2619;

			for (int _rs_2618 = 0; _rs_2618 < _rs_2619; _rs_2618++)
			{
						
				istream >> data.acceptorList[_rs_2618];
			
			}
		}
	
		int _rs_2620;
		istream >> _rs_2620;
		data.polar = (bool)_rs_2620;
		{
			int _rs_2622;
			istream >> _rs_2622;

			for (int _rs_2623 = 0; _rs_2623 < _rs_2622; _rs_2623++)
			{
				int _rs_2621;
						
				istream >> _rs_2621;
			
						
				data.templateCoords[_rs_2621] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_2627;
			istream >> _rs_2627;

			for (int _rs_2626 = 0; _rs_2626 < _rs_2627; _rs_2626++)
			{
						
				{
					int _rs_2625;
					istream >> _rs_2625;
		
					for (int _rs_2624 = 0; _rs_2624 < _rs_2625; _rs_2624++)
					{
								
						istream >> data.acceptorBase[_rs_2626][_rs_2624];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_2677;
			istream >> _rs_2677;

			for (int _rs_2678 = 0; _rs_2678 < _rs_2677; _rs_2678++)
			{
				int _rs_2676;
						
				istream >> _rs_2676;
			
						
				{
					int _rs_2629;
					istream >> _rs_2629;
		
					for (int _rs_2628 = 0; _rs_2628 < _rs_2629; _rs_2628++)
					{
								
						istream >> data.templateAtom[_rs_2676][_rs_2628];
					
					}
				}
			
			}
		}
	
		{
			int _rs_2688;
			istream >> _rs_2688;

			for (int _rs_2687 = 0; _rs_2687 < _rs_2688; _rs_2687++)
			{
						
				{
					int _rs_2680;
					istream >> _rs_2680;
		
					for (int _rs_2679 = 0; _rs_2679 < _rs_2680; _rs_2679++)
					{
								
						istream >> data.chiAtoms[_rs_2687][_rs_2679];
					
					}
				}
			
			}
		}
	
		{
			int _rs_2690;
			istream >> _rs_2690;

			for (int _rs_2689 = 0; _rs_2689 < _rs_2690; _rs_2689++)
			{
						
				istream >> data.centroidAtoms[_rs_2689];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_2740;
			istream >> _rs_2740;

			for (int _rs_2739 = 0; _rs_2739 < _rs_2740; _rs_2739++)
			{
						
				{
					int _rs_2692;
					istream >> _rs_2692;
		
					for (int _rs_2691 = 0; _rs_2691 < _rs_2692; _rs_2691++)
					{
								
						istream >> data.bondLengths[_rs_2739][_rs_2691];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_2886;
			istream >> _rs_2886;

			for (int _rs_2887 = 0; _rs_2887 < _rs_2886; _rs_2887++)
			{
				int _rs_2885;
						
				istream >> _rs_2885;
			
						
				{
					int _rs_2746;
					istream >> _rs_2746;
		
					for (int _rs_2745 = 0; _rs_2745 < _rs_2746; _rs_2745++)
					{
								
						int _rs_2741;
						istream >> _rs_2741;
						data.chiDependent[_rs_2885][_rs_2745] = (bool)_rs_2741;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadSER(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = SER;
	data.name3Char = "SER";

		{
			int _rs_2893;
			istream >> _rs_2893;

			for (int _rs_2894 = 0; _rs_2894 < _rs_2893; _rs_2894++)
			{
				int _rs_2892;
						
				istream >> _rs_2892;
			
						
				{
					int _rs_2889;
					istream >> _rs_2889;
		
					for (int _rs_2888 = 0; _rs_2888 < _rs_2889; _rs_2888++)
					{
								
						data.atomOrders[_rs_2892][_rs_2888] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_2896;
			istream >> _rs_2896;

			for (int _rs_2895 = 0; _rs_2895 < _rs_2896; _rs_2895++)
			{
						
				istream >> data.acceptorList[_rs_2895];
			
			}
		}
	
		int _rs_2897;
		istream >> _rs_2897;
		data.polar = (bool)_rs_2897;
		{
			int _rs_2899;
			istream >> _rs_2899;

			for (int _rs_2900 = 0; _rs_2900 < _rs_2899; _rs_2900++)
			{
				int _rs_2898;
						
				istream >> _rs_2898;
			
						
				data.templateCoords[_rs_2898] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_2906;
			istream >> _rs_2906;

			for (int _rs_2905 = 0; _rs_2905 < _rs_2906; _rs_2905++)
			{
						
				{
					int _rs_2902;
					istream >> _rs_2902;
		
					for (int _rs_2901 = 0; _rs_2901 < _rs_2902; _rs_2901++)
					{
								
						istream >> data.acceptorBase[_rs_2905][_rs_2901];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_2930;
			istream >> _rs_2930;

			for (int _rs_2931 = 0; _rs_2931 < _rs_2930; _rs_2931++)
			{
				int _rs_2929;
						
				istream >> _rs_2929;
			
						
				{
					int _rs_2908;
					istream >> _rs_2908;
		
					for (int _rs_2907 = 0; _rs_2907 < _rs_2908; _rs_2907++)
					{
								
						istream >> data.templateAtom[_rs_2929][_rs_2907];
					
					}
				}
			
			}
		}
	
		{
			int _rs_2937;
			istream >> _rs_2937;

			for (int _rs_2936 = 0; _rs_2936 < _rs_2937; _rs_2936++)
			{
						
				{
					int _rs_2933;
					istream >> _rs_2933;
		
					for (int _rs_2932 = 0; _rs_2932 < _rs_2933; _rs_2932++)
					{
								
						istream >> data.chiAtoms[_rs_2936][_rs_2932];
					
					}
				}
			
			}
		}
	
		{
			int _rs_2939;
			istream >> _rs_2939;

			for (int _rs_2938 = 0; _rs_2938 < _rs_2939; _rs_2938++)
			{
						
				istream >> data.centroidAtoms[_rs_2938];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_2963;
			istream >> _rs_2963;

			for (int _rs_2962 = 0; _rs_2962 < _rs_2963; _rs_2962++)
			{
						
				{
					int _rs_2941;
					istream >> _rs_2941;
		
					for (int _rs_2940 = 0; _rs_2940 < _rs_2941; _rs_2940++)
					{
								
						istream >> data.bondLengths[_rs_2962][_rs_2940];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_3031;
			istream >> _rs_3031;

			for (int _rs_3032 = 0; _rs_3032 < _rs_3031; _rs_3032++)
			{
				int _rs_3030;
						
				istream >> _rs_3030;
			
						
				{
					int _rs_2969;
					istream >> _rs_2969;
		
					for (int _rs_2968 = 0; _rs_2968 < _rs_2969; _rs_2968++)
					{
								
						int _rs_2964;
						istream >> _rs_2964;
						data.chiDependent[_rs_3030][_rs_2968] = (bool)_rs_2964;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadTHR(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = THR;
	data.name3Char = "THR";

		{
			int _rs_3038;
			istream >> _rs_3038;

			for (int _rs_3039 = 0; _rs_3039 < _rs_3038; _rs_3039++)
			{
				int _rs_3037;
						
				istream >> _rs_3037;
			
						
				{
					int _rs_3034;
					istream >> _rs_3034;
		
					for (int _rs_3033 = 0; _rs_3033 < _rs_3034; _rs_3033++)
					{
								
						data.atomOrders[_rs_3037][_rs_3033] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_3041;
			istream >> _rs_3041;

			for (int _rs_3040 = 0; _rs_3040 < _rs_3041; _rs_3040++)
			{
						
				istream >> data.acceptorList[_rs_3040];
			
			}
		}
	
		int _rs_3042;
		istream >> _rs_3042;
		data.polar = (bool)_rs_3042;
		{
			int _rs_3044;
			istream >> _rs_3044;

			for (int _rs_3045 = 0; _rs_3045 < _rs_3044; _rs_3045++)
			{
				int _rs_3043;
						
				istream >> _rs_3043;
			
						
				data.templateCoords[_rs_3043] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_3051;
			istream >> _rs_3051;

			for (int _rs_3050 = 0; _rs_3050 < _rs_3051; _rs_3050++)
			{
						
				{
					int _rs_3047;
					istream >> _rs_3047;
		
					for (int _rs_3046 = 0; _rs_3046 < _rs_3047; _rs_3046++)
					{
								
						istream >> data.acceptorBase[_rs_3050][_rs_3046];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_3081;
			istream >> _rs_3081;

			for (int _rs_3082 = 0; _rs_3082 < _rs_3081; _rs_3082++)
			{
				int _rs_3080;
						
				istream >> _rs_3080;
			
						
				{
					int _rs_3053;
					istream >> _rs_3053;
		
					for (int _rs_3052 = 0; _rs_3052 < _rs_3053; _rs_3052++)
					{
								
						istream >> data.templateAtom[_rs_3080][_rs_3052];
					
					}
				}
			
			}
		}
	
		{
			int _rs_3088;
			istream >> _rs_3088;

			for (int _rs_3087 = 0; _rs_3087 < _rs_3088; _rs_3087++)
			{
						
				{
					int _rs_3084;
					istream >> _rs_3084;
		
					for (int _rs_3083 = 0; _rs_3083 < _rs_3084; _rs_3083++)
					{
								
						istream >> data.chiAtoms[_rs_3087][_rs_3083];
					
					}
				}
			
			}
		}
	
		{
			int _rs_3090;
			istream >> _rs_3090;

			for (int _rs_3089 = 0; _rs_3089 < _rs_3090; _rs_3089++)
			{
						
				istream >> data.centroidAtoms[_rs_3089];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_3120;
			istream >> _rs_3120;

			for (int _rs_3119 = 0; _rs_3119 < _rs_3120; _rs_3119++)
			{
						
				{
					int _rs_3092;
					istream >> _rs_3092;
		
					for (int _rs_3091 = 0; _rs_3091 < _rs_3092; _rs_3091++)
					{
								
						istream >> data.bondLengths[_rs_3119][_rs_3091];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_3206;
			istream >> _rs_3206;

			for (int _rs_3207 = 0; _rs_3207 < _rs_3206; _rs_3207++)
			{
				int _rs_3205;
						
				istream >> _rs_3205;
			
						
				{
					int _rs_3126;
					istream >> _rs_3126;
		
					for (int _rs_3125 = 0; _rs_3125 < _rs_3126; _rs_3125++)
					{
								
						int _rs_3121;
						istream >> _rs_3121;
						data.chiDependent[_rs_3205][_rs_3125] = (bool)_rs_3121;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadVAL(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = VAL;
	data.name3Char = "VAL";

		{
			int _rs_3213;
			istream >> _rs_3213;

			for (int _rs_3214 = 0; _rs_3214 < _rs_3213; _rs_3214++)
			{
				int _rs_3212;
						
				istream >> _rs_3212;
			
						
				{
					int _rs_3209;
					istream >> _rs_3209;
		
					for (int _rs_3208 = 0; _rs_3208 < _rs_3209; _rs_3208++)
					{
								
						data.atomOrders[_rs_3212][_rs_3208] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_3216;
			istream >> _rs_3216;

			for (int _rs_3215 = 0; _rs_3215 < _rs_3216; _rs_3215++)
			{
						
				istream >> data.acceptorList[_rs_3215];
			
			}
		}
	
		int _rs_3217;
		istream >> _rs_3217;
		data.polar = (bool)_rs_3217;
		{
			int _rs_3219;
			istream >> _rs_3219;

			for (int _rs_3220 = 0; _rs_3220 < _rs_3219; _rs_3220++)
			{
				int _rs_3218;
						
				istream >> _rs_3218;
			
						
				data.templateCoords[_rs_3218] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_3224;
			istream >> _rs_3224;

			for (int _rs_3223 = 0; _rs_3223 < _rs_3224; _rs_3223++)
			{
						
				{
					int _rs_3222;
					istream >> _rs_3222;
		
					for (int _rs_3221 = 0; _rs_3221 < _rs_3222; _rs_3221++)
					{
								
						istream >> data.acceptorBase[_rs_3223][_rs_3221];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_3258;
			istream >> _rs_3258;

			for (int _rs_3259 = 0; _rs_3259 < _rs_3258; _rs_3259++)
			{
				int _rs_3257;
						
				istream >> _rs_3257;
			
						
				{
					int _rs_3226;
					istream >> _rs_3226;
		
					for (int _rs_3225 = 0; _rs_3225 < _rs_3226; _rs_3225++)
					{
								
						istream >> data.templateAtom[_rs_3257][_rs_3225];
					
					}
				}
			
			}
		}
	
		{
			int _rs_3263;
			istream >> _rs_3263;

			for (int _rs_3262 = 0; _rs_3262 < _rs_3263; _rs_3262++)
			{
						
				{
					int _rs_3261;
					istream >> _rs_3261;
		
					for (int _rs_3260 = 0; _rs_3260 < _rs_3261; _rs_3260++)
					{
								
						istream >> data.chiAtoms[_rs_3262][_rs_3260];
					
					}
				}
			
			}
		}
	
		{
			int _rs_3265;
			istream >> _rs_3265;

			for (int _rs_3264 = 0; _rs_3264 < _rs_3265; _rs_3264++)
			{
						
				istream >> data.centroidAtoms[_rs_3264];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_3299;
			istream >> _rs_3299;

			for (int _rs_3298 = 0; _rs_3298 < _rs_3299; _rs_3298++)
			{
						
				{
					int _rs_3267;
					istream >> _rs_3267;
		
					for (int _rs_3266 = 0; _rs_3266 < _rs_3267; _rs_3266++)
					{
								
						istream >> data.bondLengths[_rs_3298][_rs_3266];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_3397;
			istream >> _rs_3397;

			for (int _rs_3398 = 0; _rs_3398 < _rs_3397; _rs_3398++)
			{
				int _rs_3396;
						
				istream >> _rs_3396;
			
						
				{
					int _rs_3305;
					istream >> _rs_3305;
		
					for (int _rs_3304 = 0; _rs_3304 < _rs_3305; _rs_3304++)
					{
								
						int _rs_3300;
						istream >> _rs_3300;
						data.chiDependent[_rs_3396][_rs_3304] = (bool)_rs_3300;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadTRP(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = TRP;
	data.name3Char = "TRP";

		{
			int _rs_3404;
			istream >> _rs_3404;

			for (int _rs_3405 = 0; _rs_3405 < _rs_3404; _rs_3405++)
			{
				int _rs_3403;
						
				istream >> _rs_3403;
			
						
				{
					int _rs_3400;
					istream >> _rs_3400;
		
					for (int _rs_3399 = 0; _rs_3399 < _rs_3400; _rs_3399++)
					{
								
						data.atomOrders[_rs_3403][_rs_3399] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_3407;
			istream >> _rs_3407;

			for (int _rs_3406 = 0; _rs_3406 < _rs_3407; _rs_3406++)
			{
						
				istream >> data.acceptorList[_rs_3406];
			
			}
		}
	
		int _rs_3408;
		istream >> _rs_3408;
		data.polar = (bool)_rs_3408;
		{
			int _rs_3410;
			istream >> _rs_3410;

			for (int _rs_3411 = 0; _rs_3411 < _rs_3410; _rs_3411++)
			{
				int _rs_3409;
						
				istream >> _rs_3409;
			
						
				data.templateCoords[_rs_3409] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_3415;
			istream >> _rs_3415;

			for (int _rs_3414 = 0; _rs_3414 < _rs_3415; _rs_3414++)
			{
						
				{
					int _rs_3413;
					istream >> _rs_3413;
		
					for (int _rs_3412 = 0; _rs_3412 < _rs_3413; _rs_3412++)
					{
								
						istream >> data.acceptorBase[_rs_3414][_rs_3412];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_3465;
			istream >> _rs_3465;

			for (int _rs_3466 = 0; _rs_3466 < _rs_3465; _rs_3466++)
			{
				int _rs_3464;
						
				istream >> _rs_3464;
			
						
				{
					int _rs_3417;
					istream >> _rs_3417;
		
					for (int _rs_3416 = 0; _rs_3416 < _rs_3417; _rs_3416++)
					{
								
						istream >> data.templateAtom[_rs_3464][_rs_3416];
					
					}
				}
			
			}
		}
	
		{
			int _rs_3472;
			istream >> _rs_3472;

			for (int _rs_3471 = 0; _rs_3471 < _rs_3472; _rs_3471++)
			{
						
				{
					int _rs_3468;
					istream >> _rs_3468;
		
					for (int _rs_3467 = 0; _rs_3467 < _rs_3468; _rs_3467++)
					{
								
						istream >> data.chiAtoms[_rs_3471][_rs_3467];
					
					}
				}
			
			}
		}
	
		{
			int _rs_3474;
			istream >> _rs_3474;

			for (int _rs_3473 = 0; _rs_3473 < _rs_3474; _rs_3473++)
			{
						
				istream >> data.centroidAtoms[_rs_3473];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_3524;
			istream >> _rs_3524;

			for (int _rs_3523 = 0; _rs_3523 < _rs_3524; _rs_3523++)
			{
						
				{
					int _rs_3476;
					istream >> _rs_3476;
		
					for (int _rs_3475 = 0; _rs_3475 < _rs_3476; _rs_3475++)
					{
								
						istream >> data.bondLengths[_rs_3523][_rs_3475];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_3670;
			istream >> _rs_3670;

			for (int _rs_3671 = 0; _rs_3671 < _rs_3670; _rs_3671++)
			{
				int _rs_3669;
						
				istream >> _rs_3669;
			
						
				{
					int _rs_3530;
					istream >> _rs_3530;
		
					for (int _rs_3529 = 0; _rs_3529 < _rs_3530; _rs_3529++)
					{
								
						int _rs_3525;
						istream >> _rs_3525;
						data.chiDependent[_rs_3669][_rs_3529] = (bool)_rs_3525;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadTYR(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = TYR;
	data.name3Char = "TYR";

		{
			int _rs_3677;
			istream >> _rs_3677;

			for (int _rs_3678 = 0; _rs_3678 < _rs_3677; _rs_3678++)
			{
				int _rs_3676;
						
				istream >> _rs_3676;
			
						
				{
					int _rs_3673;
					istream >> _rs_3673;
		
					for (int _rs_3672 = 0; _rs_3672 < _rs_3673; _rs_3672++)
					{
								
						data.atomOrders[_rs_3676][_rs_3672] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_3680;
			istream >> _rs_3680;

			for (int _rs_3679 = 0; _rs_3679 < _rs_3680; _rs_3679++)
			{
						
				istream >> data.acceptorList[_rs_3679];
			
			}
		}
	
		int _rs_3681;
		istream >> _rs_3681;
		data.polar = (bool)_rs_3681;
		{
			int _rs_3683;
			istream >> _rs_3683;

			for (int _rs_3684 = 0; _rs_3684 < _rs_3683; _rs_3684++)
			{
				int _rs_3682;
						
				istream >> _rs_3682;
			
						
				data.templateCoords[_rs_3682] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_3690;
			istream >> _rs_3690;

			for (int _rs_3689 = 0; _rs_3689 < _rs_3690; _rs_3689++)
			{
						
				{
					int _rs_3686;
					istream >> _rs_3686;
		
					for (int _rs_3685 = 0; _rs_3685 < _rs_3686; _rs_3685++)
					{
								
						istream >> data.acceptorBase[_rs_3689][_rs_3685];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_3734;
			istream >> _rs_3734;

			for (int _rs_3735 = 0; _rs_3735 < _rs_3734; _rs_3735++)
			{
				int _rs_3733;
						
				istream >> _rs_3733;
			
						
				{
					int _rs_3692;
					istream >> _rs_3692;
		
					for (int _rs_3691 = 0; _rs_3691 < _rs_3692; _rs_3691++)
					{
								
						istream >> data.templateAtom[_rs_3733][_rs_3691];
					
					}
				}
			
			}
		}
	
		{
			int _rs_3743;
			istream >> _rs_3743;

			for (int _rs_3742 = 0; _rs_3742 < _rs_3743; _rs_3742++)
			{
						
				{
					int _rs_3737;
					istream >> _rs_3737;
		
					for (int _rs_3736 = 0; _rs_3736 < _rs_3737; _rs_3736++)
					{
								
						istream >> data.chiAtoms[_rs_3742][_rs_3736];
					
					}
				}
			
			}
		}
	
		{
			int _rs_3745;
			istream >> _rs_3745;

			for (int _rs_3744 = 0; _rs_3744 < _rs_3745; _rs_3744++)
			{
						
				istream >> data.centroidAtoms[_rs_3744];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_3789;
			istream >> _rs_3789;

			for (int _rs_3788 = 0; _rs_3788 < _rs_3789; _rs_3788++)
			{
						
				{
					int _rs_3747;
					istream >> _rs_3747;
		
					for (int _rs_3746 = 0; _rs_3746 < _rs_3747; _rs_3746++)
					{
								
						istream >> data.bondLengths[_rs_3788][_rs_3746];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_3917;
			istream >> _rs_3917;

			for (int _rs_3918 = 0; _rs_3918 < _rs_3917; _rs_3918++)
			{
				int _rs_3916;
						
				istream >> _rs_3916;
			
						
				{
					int _rs_3795;
					istream >> _rs_3795;
		
					for (int _rs_3794 = 0; _rs_3794 < _rs_3795; _rs_3794++)
					{
								
						int _rs_3790;
						istream >> _rs_3790;
						data.chiDependent[_rs_3916][_rs_3794] = (bool)_rs_3790;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNALA(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NALA;
	data.name3Char = "NALA";

		{
			int _rs_3924;
			istream >> _rs_3924;

			for (int _rs_3925 = 0; _rs_3925 < _rs_3924; _rs_3925++)
			{
				int _rs_3923;
						
				istream >> _rs_3923;
			
						
				{
					int _rs_3920;
					istream >> _rs_3920;
		
					for (int _rs_3919 = 0; _rs_3919 < _rs_3920; _rs_3919++)
					{
								
						data.atomOrders[_rs_3923][_rs_3919] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_3927;
			istream >> _rs_3927;

			for (int _rs_3926 = 0; _rs_3926 < _rs_3927; _rs_3926++)
			{
						
				istream >> data.acceptorList[_rs_3926];
			
			}
		}
	
		int _rs_3928;
		istream >> _rs_3928;
		data.polar = (bool)_rs_3928;
		{
			int _rs_3930;
			istream >> _rs_3930;

			for (int _rs_3931 = 0; _rs_3931 < _rs_3930; _rs_3931++)
			{
				int _rs_3929;
						
				istream >> _rs_3929;
			
						
				data.templateCoords[_rs_3929] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_3935;
			istream >> _rs_3935;

			for (int _rs_3934 = 0; _rs_3934 < _rs_3935; _rs_3934++)
			{
						
				{
					int _rs_3933;
					istream >> _rs_3933;
		
					for (int _rs_3932 = 0; _rs_3932 < _rs_3933; _rs_3932++)
					{
								
						istream >> data.acceptorBase[_rs_3934][_rs_3932];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_3961;
			istream >> _rs_3961;

			for (int _rs_3962 = 0; _rs_3962 < _rs_3961; _rs_3962++)
			{
				int _rs_3960;
						
				istream >> _rs_3960;
			
						
				{
					int _rs_3937;
					istream >> _rs_3937;
		
					for (int _rs_3936 = 0; _rs_3936 < _rs_3937; _rs_3936++)
					{
								
						istream >> data.templateAtom[_rs_3960][_rs_3936];
					
					}
				}
			
			}
		}
	
		{
			int _rs_3964;
			istream >> _rs_3964;

			for (int _rs_3963 = 0; _rs_3963 < _rs_3964; _rs_3963++)
			{
						
				istream >> data.centroidAtoms[_rs_3963];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_3990;
			istream >> _rs_3990;

			for (int _rs_3989 = 0; _rs_3989 < _rs_3990; _rs_3989++)
			{
						
				{
					int _rs_3966;
					istream >> _rs_3966;
		
					for (int _rs_3965 = 0; _rs_3965 < _rs_3966; _rs_3965++)
					{
								
						istream >> data.bondLengths[_rs_3989][_rs_3965];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_4064;
			istream >> _rs_4064;

			for (int _rs_4065 = 0; _rs_4065 < _rs_4064; _rs_4065++)
			{
				int _rs_4063;
						
				istream >> _rs_4063;
			
						
				{
					int _rs_3996;
					istream >> _rs_3996;
		
					for (int _rs_3995 = 0; _rs_3995 < _rs_3996; _rs_3995++)
					{
								
						int _rs_3991;
						istream >> _rs_3991;
						data.chiDependent[_rs_4063][_rs_3995] = (bool)_rs_3991;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNCYS(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NCYS;
	data.name3Char = "NCYS";

		{
			int _rs_4071;
			istream >> _rs_4071;

			for (int _rs_4072 = 0; _rs_4072 < _rs_4071; _rs_4072++)
			{
				int _rs_4070;
						
				istream >> _rs_4070;
			
						
				{
					int _rs_4067;
					istream >> _rs_4067;
		
					for (int _rs_4066 = 0; _rs_4066 < _rs_4067; _rs_4066++)
					{
								
						data.atomOrders[_rs_4070][_rs_4066] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_4074;
			istream >> _rs_4074;

			for (int _rs_4073 = 0; _rs_4073 < _rs_4074; _rs_4073++)
			{
						
				istream >> data.acceptorList[_rs_4073];
			
			}
		}
	
		int _rs_4075;
		istream >> _rs_4075;
		data.polar = (bool)_rs_4075;
		{
			int _rs_4077;
			istream >> _rs_4077;

			for (int _rs_4078 = 0; _rs_4078 < _rs_4077; _rs_4078++)
			{
				int _rs_4076;
						
				istream >> _rs_4076;
			
						
				data.templateCoords[_rs_4076] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_4082;
			istream >> _rs_4082;

			for (int _rs_4081 = 0; _rs_4081 < _rs_4082; _rs_4081++)
			{
						
				{
					int _rs_4080;
					istream >> _rs_4080;
		
					for (int _rs_4079 = 0; _rs_4079 < _rs_4080; _rs_4079++)
					{
								
						istream >> data.acceptorBase[_rs_4081][_rs_4079];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_4110;
			istream >> _rs_4110;

			for (int _rs_4111 = 0; _rs_4111 < _rs_4110; _rs_4111++)
			{
				int _rs_4109;
						
				istream >> _rs_4109;
			
						
				{
					int _rs_4084;
					istream >> _rs_4084;
		
					for (int _rs_4083 = 0; _rs_4083 < _rs_4084; _rs_4083++)
					{
								
						istream >> data.templateAtom[_rs_4109][_rs_4083];
					
					}
				}
			
			}
		}
	
		{
			int _rs_4115;
			istream >> _rs_4115;

			for (int _rs_4114 = 0; _rs_4114 < _rs_4115; _rs_4114++)
			{
						
				{
					int _rs_4113;
					istream >> _rs_4113;
		
					for (int _rs_4112 = 0; _rs_4112 < _rs_4113; _rs_4112++)
					{
								
						istream >> data.chiAtoms[_rs_4114][_rs_4112];
					
					}
				}
			
			}
		}
	
		{
			int _rs_4117;
			istream >> _rs_4117;

			for (int _rs_4116 = 0; _rs_4116 < _rs_4117; _rs_4116++)
			{
						
				istream >> data.centroidAtoms[_rs_4116];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_4145;
			istream >> _rs_4145;

			for (int _rs_4144 = 0; _rs_4144 < _rs_4145; _rs_4144++)
			{
						
				{
					int _rs_4119;
					istream >> _rs_4119;
		
					for (int _rs_4118 = 0; _rs_4118 < _rs_4119; _rs_4118++)
					{
								
						istream >> data.bondLengths[_rs_4144][_rs_4118];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_4225;
			istream >> _rs_4225;

			for (int _rs_4226 = 0; _rs_4226 < _rs_4225; _rs_4226++)
			{
				int _rs_4224;
						
				istream >> _rs_4224;
			
						
				{
					int _rs_4151;
					istream >> _rs_4151;
		
					for (int _rs_4150 = 0; _rs_4150 < _rs_4151; _rs_4150++)
					{
								
						int _rs_4146;
						istream >> _rs_4146;
						data.chiDependent[_rs_4224][_rs_4150] = (bool)_rs_4146;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNASP(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NASP;
	data.name3Char = "NASP";

		{
			int _rs_4232;
			istream >> _rs_4232;

			for (int _rs_4233 = 0; _rs_4233 < _rs_4232; _rs_4233++)
			{
				int _rs_4231;
						
				istream >> _rs_4231;
			
						
				{
					int _rs_4228;
					istream >> _rs_4228;
		
					for (int _rs_4227 = 0; _rs_4227 < _rs_4228; _rs_4227++)
					{
								
						data.atomOrders[_rs_4231][_rs_4227] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_4235;
			istream >> _rs_4235;

			for (int _rs_4234 = 0; _rs_4234 < _rs_4235; _rs_4234++)
			{
						
				istream >> data.acceptorList[_rs_4234];
			
			}
		}
	
		int _rs_4236;
		istream >> _rs_4236;
		data.polar = (bool)_rs_4236;
		{
			int _rs_4238;
			istream >> _rs_4238;

			for (int _rs_4239 = 0; _rs_4239 < _rs_4238; _rs_4239++)
			{
				int _rs_4237;
						
				istream >> _rs_4237;
			
						
				data.templateCoords[_rs_4237] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_4247;
			istream >> _rs_4247;

			for (int _rs_4246 = 0; _rs_4246 < _rs_4247; _rs_4246++)
			{
						
				{
					int _rs_4241;
					istream >> _rs_4241;
		
					for (int _rs_4240 = 0; _rs_4240 < _rs_4241; _rs_4240++)
					{
								
						istream >> data.acceptorBase[_rs_4246][_rs_4240];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_4277;
			istream >> _rs_4277;

			for (int _rs_4278 = 0; _rs_4278 < _rs_4277; _rs_4278++)
			{
				int _rs_4276;
						
				istream >> _rs_4276;
			
						
				{
					int _rs_4249;
					istream >> _rs_4249;
		
					for (int _rs_4248 = 0; _rs_4248 < _rs_4249; _rs_4248++)
					{
								
						istream >> data.templateAtom[_rs_4276][_rs_4248];
					
					}
				}
			
			}
		}
	
		{
			int _rs_4284;
			istream >> _rs_4284;

			for (int _rs_4283 = 0; _rs_4283 < _rs_4284; _rs_4283++)
			{
						
				{
					int _rs_4280;
					istream >> _rs_4280;
		
					for (int _rs_4279 = 0; _rs_4279 < _rs_4280; _rs_4279++)
					{
								
						istream >> data.chiAtoms[_rs_4283][_rs_4279];
					
					}
				}
			
			}
		}
	
		{
			int _rs_4286;
			istream >> _rs_4286;

			for (int _rs_4285 = 0; _rs_4285 < _rs_4286; _rs_4285++)
			{
						
				istream >> data.centroidAtoms[_rs_4285];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_4316;
			istream >> _rs_4316;

			for (int _rs_4315 = 0; _rs_4315 < _rs_4316; _rs_4315++)
			{
						
				{
					int _rs_4288;
					istream >> _rs_4288;
		
					for (int _rs_4287 = 0; _rs_4287 < _rs_4288; _rs_4287++)
					{
								
						istream >> data.bondLengths[_rs_4315][_rs_4287];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_4402;
			istream >> _rs_4402;

			for (int _rs_4403 = 0; _rs_4403 < _rs_4402; _rs_4403++)
			{
				int _rs_4401;
						
				istream >> _rs_4401;
			
						
				{
					int _rs_4322;
					istream >> _rs_4322;
		
					for (int _rs_4321 = 0; _rs_4321 < _rs_4322; _rs_4321++)
					{
								
						int _rs_4317;
						istream >> _rs_4317;
						data.chiDependent[_rs_4401][_rs_4321] = (bool)_rs_4317;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNGLU(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NGLU;
	data.name3Char = "NGLU";

		{
			int _rs_4409;
			istream >> _rs_4409;

			for (int _rs_4410 = 0; _rs_4410 < _rs_4409; _rs_4410++)
			{
				int _rs_4408;
						
				istream >> _rs_4408;
			
						
				{
					int _rs_4405;
					istream >> _rs_4405;
		
					for (int _rs_4404 = 0; _rs_4404 < _rs_4405; _rs_4404++)
					{
								
						data.atomOrders[_rs_4408][_rs_4404] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_4412;
			istream >> _rs_4412;

			for (int _rs_4411 = 0; _rs_4411 < _rs_4412; _rs_4411++)
			{
						
				istream >> data.acceptorList[_rs_4411];
			
			}
		}
	
		int _rs_4413;
		istream >> _rs_4413;
		data.polar = (bool)_rs_4413;
		{
			int _rs_4415;
			istream >> _rs_4415;

			for (int _rs_4416 = 0; _rs_4416 < _rs_4415; _rs_4416++)
			{
				int _rs_4414;
						
				istream >> _rs_4414;
			
						
				data.templateCoords[_rs_4414] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_4424;
			istream >> _rs_4424;

			for (int _rs_4423 = 0; _rs_4423 < _rs_4424; _rs_4423++)
			{
						
				{
					int _rs_4418;
					istream >> _rs_4418;
		
					for (int _rs_4417 = 0; _rs_4417 < _rs_4418; _rs_4417++)
					{
								
						istream >> data.acceptorBase[_rs_4423][_rs_4417];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_4460;
			istream >> _rs_4460;

			for (int _rs_4461 = 0; _rs_4461 < _rs_4460; _rs_4461++)
			{
				int _rs_4459;
						
				istream >> _rs_4459;
			
						
				{
					int _rs_4426;
					istream >> _rs_4426;
		
					for (int _rs_4425 = 0; _rs_4425 < _rs_4426; _rs_4425++)
					{
								
						istream >> data.templateAtom[_rs_4459][_rs_4425];
					
					}
				}
			
			}
		}
	
		{
			int _rs_4469;
			istream >> _rs_4469;

			for (int _rs_4468 = 0; _rs_4468 < _rs_4469; _rs_4468++)
			{
						
				{
					int _rs_4463;
					istream >> _rs_4463;
		
					for (int _rs_4462 = 0; _rs_4462 < _rs_4463; _rs_4462++)
					{
								
						istream >> data.chiAtoms[_rs_4468][_rs_4462];
					
					}
				}
			
			}
		}
	
		{
			int _rs_4471;
			istream >> _rs_4471;

			for (int _rs_4470 = 0; _rs_4470 < _rs_4471; _rs_4470++)
			{
						
				istream >> data.centroidAtoms[_rs_4470];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_4507;
			istream >> _rs_4507;

			for (int _rs_4506 = 0; _rs_4506 < _rs_4507; _rs_4506++)
			{
						
				{
					int _rs_4473;
					istream >> _rs_4473;
		
					for (int _rs_4472 = 0; _rs_4472 < _rs_4473; _rs_4472++)
					{
								
						istream >> data.bondLengths[_rs_4506][_rs_4472];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_4611;
			istream >> _rs_4611;

			for (int _rs_4612 = 0; _rs_4612 < _rs_4611; _rs_4612++)
			{
				int _rs_4610;
						
				istream >> _rs_4610;
			
						
				{
					int _rs_4513;
					istream >> _rs_4513;
		
					for (int _rs_4512 = 0; _rs_4512 < _rs_4513; _rs_4512++)
					{
								
						int _rs_4508;
						istream >> _rs_4508;
						data.chiDependent[_rs_4610][_rs_4512] = (bool)_rs_4508;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNPHE(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NPHE;
	data.name3Char = "NPHE";

		{
			int _rs_4618;
			istream >> _rs_4618;

			for (int _rs_4619 = 0; _rs_4619 < _rs_4618; _rs_4619++)
			{
				int _rs_4617;
						
				istream >> _rs_4617;
			
						
				{
					int _rs_4614;
					istream >> _rs_4614;
		
					for (int _rs_4613 = 0; _rs_4613 < _rs_4614; _rs_4613++)
					{
								
						data.atomOrders[_rs_4617][_rs_4613] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_4621;
			istream >> _rs_4621;

			for (int _rs_4620 = 0; _rs_4620 < _rs_4621; _rs_4620++)
			{
						
				istream >> data.acceptorList[_rs_4620];
			
			}
		}
	
		int _rs_4622;
		istream >> _rs_4622;
		data.polar = (bool)_rs_4622;
		{
			int _rs_4624;
			istream >> _rs_4624;

			for (int _rs_4625 = 0; _rs_4625 < _rs_4624; _rs_4625++)
			{
				int _rs_4623;
						
				istream >> _rs_4623;
			
						
				data.templateCoords[_rs_4623] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_4629;
			istream >> _rs_4629;

			for (int _rs_4628 = 0; _rs_4628 < _rs_4629; _rs_4628++)
			{
						
				{
					int _rs_4627;
					istream >> _rs_4627;
		
					for (int _rs_4626 = 0; _rs_4626 < _rs_4627; _rs_4626++)
					{
								
						istream >> data.acceptorBase[_rs_4628][_rs_4626];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_4675;
			istream >> _rs_4675;

			for (int _rs_4676 = 0; _rs_4676 < _rs_4675; _rs_4676++)
			{
				int _rs_4674;
						
				istream >> _rs_4674;
			
						
				{
					int _rs_4631;
					istream >> _rs_4631;
		
					for (int _rs_4630 = 0; _rs_4630 < _rs_4631; _rs_4630++)
					{
								
						istream >> data.templateAtom[_rs_4674][_rs_4630];
					
					}
				}
			
			}
		}
	
		{
			int _rs_4682;
			istream >> _rs_4682;

			for (int _rs_4681 = 0; _rs_4681 < _rs_4682; _rs_4681++)
			{
						
				{
					int _rs_4678;
					istream >> _rs_4678;
		
					for (int _rs_4677 = 0; _rs_4677 < _rs_4678; _rs_4677++)
					{
								
						istream >> data.chiAtoms[_rs_4681][_rs_4677];
					
					}
				}
			
			}
		}
	
		{
			int _rs_4684;
			istream >> _rs_4684;

			for (int _rs_4683 = 0; _rs_4683 < _rs_4684; _rs_4683++)
			{
						
				istream >> data.centroidAtoms[_rs_4683];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_4730;
			istream >> _rs_4730;

			for (int _rs_4729 = 0; _rs_4729 < _rs_4730; _rs_4729++)
			{
						
				{
					int _rs_4686;
					istream >> _rs_4686;
		
					for (int _rs_4685 = 0; _rs_4685 < _rs_4686; _rs_4685++)
					{
								
						istream >> data.bondLengths[_rs_4729][_rs_4685];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_4864;
			istream >> _rs_4864;

			for (int _rs_4865 = 0; _rs_4865 < _rs_4864; _rs_4865++)
			{
				int _rs_4863;
						
				istream >> _rs_4863;
			
						
				{
					int _rs_4736;
					istream >> _rs_4736;
		
					for (int _rs_4735 = 0; _rs_4735 < _rs_4736; _rs_4735++)
					{
								
						int _rs_4731;
						istream >> _rs_4731;
						data.chiDependent[_rs_4863][_rs_4735] = (bool)_rs_4731;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNGLY(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NGLY;
	data.name3Char = "NGLY";

		{
			int _rs_4871;
			istream >> _rs_4871;

			for (int _rs_4872 = 0; _rs_4872 < _rs_4871; _rs_4872++)
			{
				int _rs_4870;
						
				istream >> _rs_4870;
			
						
				{
					int _rs_4867;
					istream >> _rs_4867;
		
					for (int _rs_4866 = 0; _rs_4866 < _rs_4867; _rs_4866++)
					{
								
						data.atomOrders[_rs_4870][_rs_4866] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_4874;
			istream >> _rs_4874;

			for (int _rs_4873 = 0; _rs_4873 < _rs_4874; _rs_4873++)
			{
						
				istream >> data.acceptorList[_rs_4873];
			
			}
		}
	
		int _rs_4875;
		istream >> _rs_4875;
		data.polar = (bool)_rs_4875;
		{
			int _rs_4877;
			istream >> _rs_4877;

			for (int _rs_4878 = 0; _rs_4878 < _rs_4877; _rs_4878++)
			{
				int _rs_4876;
						
				istream >> _rs_4876;
			
						
				data.templateCoords[_rs_4876] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_4882;
			istream >> _rs_4882;

			for (int _rs_4881 = 0; _rs_4881 < _rs_4882; _rs_4881++)
			{
						
				{
					int _rs_4880;
					istream >> _rs_4880;
		
					for (int _rs_4879 = 0; _rs_4879 < _rs_4880; _rs_4879++)
					{
								
						istream >> data.acceptorBase[_rs_4881][_rs_4879];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_4902;
			istream >> _rs_4902;

			for (int _rs_4903 = 0; _rs_4903 < _rs_4902; _rs_4903++)
			{
				int _rs_4901;
						
				istream >> _rs_4901;
			
						
				{
					int _rs_4884;
					istream >> _rs_4884;
		
					for (int _rs_4883 = 0; _rs_4883 < _rs_4884; _rs_4883++)
					{
								
						istream >> data.templateAtom[_rs_4901][_rs_4883];
					
					}
				}
			
			}
		}
	
		{
			int _rs_4905;
			istream >> _rs_4905;

			for (int _rs_4904 = 0; _rs_4904 < _rs_4905; _rs_4904++)
			{
						
				istream >> data.centroidAtoms[_rs_4904];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_4925;
			istream >> _rs_4925;

			for (int _rs_4924 = 0; _rs_4924 < _rs_4925; _rs_4924++)
			{
						
				{
					int _rs_4907;
					istream >> _rs_4907;
		
					for (int _rs_4906 = 0; _rs_4906 < _rs_4907; _rs_4906++)
					{
								
						istream >> data.bondLengths[_rs_4924][_rs_4906];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_4981;
			istream >> _rs_4981;

			for (int _rs_4982 = 0; _rs_4982 < _rs_4981; _rs_4982++)
			{
				int _rs_4980;
						
				istream >> _rs_4980;
			
						
				{
					int _rs_4931;
					istream >> _rs_4931;
		
					for (int _rs_4930 = 0; _rs_4930 < _rs_4931; _rs_4930++)
					{
								
						int _rs_4926;
						istream >> _rs_4926;
						data.chiDependent[_rs_4980][_rs_4930] = (bool)_rs_4926;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNHIS(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NHIS;
	data.name3Char = "NHIS";

		{
			int _rs_4988;
			istream >> _rs_4988;

			for (int _rs_4989 = 0; _rs_4989 < _rs_4988; _rs_4989++)
			{
				int _rs_4987;
						
				istream >> _rs_4987;
			
						
				{
					int _rs_4984;
					istream >> _rs_4984;
		
					for (int _rs_4983 = 0; _rs_4983 < _rs_4984; _rs_4983++)
					{
								
						data.atomOrders[_rs_4987][_rs_4983] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_4991;
			istream >> _rs_4991;

			for (int _rs_4990 = 0; _rs_4990 < _rs_4991; _rs_4990++)
			{
						
				istream >> data.acceptorList[_rs_4990];
			
			}
		}
	
		int _rs_4992;
		istream >> _rs_4992;
		data.polar = (bool)_rs_4992;
		{
			int _rs_4994;
			istream >> _rs_4994;

			for (int _rs_4995 = 0; _rs_4995 < _rs_4994; _rs_4995++)
			{
				int _rs_4993;
						
				istream >> _rs_4993;
			
						
				data.templateCoords[_rs_4993] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_5001;
			istream >> _rs_5001;

			for (int _rs_5000 = 0; _rs_5000 < _rs_5001; _rs_5000++)
			{
						
				{
					int _rs_4997;
					istream >> _rs_4997;
		
					for (int _rs_4996 = 0; _rs_4996 < _rs_4997; _rs_4996++)
					{
								
						istream >> data.acceptorBase[_rs_5000][_rs_4996];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_5041;
			istream >> _rs_5041;

			for (int _rs_5042 = 0; _rs_5042 < _rs_5041; _rs_5042++)
			{
				int _rs_5040;
						
				istream >> _rs_5040;
			
						
				{
					int _rs_5003;
					istream >> _rs_5003;
		
					for (int _rs_5002 = 0; _rs_5002 < _rs_5003; _rs_5002++)
					{
								
						istream >> data.templateAtom[_rs_5040][_rs_5002];
					
					}
				}
			
			}
		}
	
		{
			int _rs_5048;
			istream >> _rs_5048;

			for (int _rs_5047 = 0; _rs_5047 < _rs_5048; _rs_5047++)
			{
						
				{
					int _rs_5044;
					istream >> _rs_5044;
		
					for (int _rs_5043 = 0; _rs_5043 < _rs_5044; _rs_5043++)
					{
								
						istream >> data.chiAtoms[_rs_5047][_rs_5043];
					
					}
				}
			
			}
		}
	
		{
			int _rs_5050;
			istream >> _rs_5050;

			for (int _rs_5049 = 0; _rs_5049 < _rs_5050; _rs_5049++)
			{
						
				istream >> data.centroidAtoms[_rs_5049];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_5090;
			istream >> _rs_5090;

			for (int _rs_5089 = 0; _rs_5089 < _rs_5090; _rs_5089++)
			{
						
				{
					int _rs_5052;
					istream >> _rs_5052;
		
					for (int _rs_5051 = 0; _rs_5051 < _rs_5052; _rs_5051++)
					{
								
						istream >> data.bondLengths[_rs_5089][_rs_5051];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_5206;
			istream >> _rs_5206;

			for (int _rs_5207 = 0; _rs_5207 < _rs_5206; _rs_5207++)
			{
				int _rs_5205;
						
				istream >> _rs_5205;
			
						
				{
					int _rs_5096;
					istream >> _rs_5096;
		
					for (int _rs_5095 = 0; _rs_5095 < _rs_5096; _rs_5095++)
					{
								
						int _rs_5091;
						istream >> _rs_5091;
						data.chiDependent[_rs_5205][_rs_5095] = (bool)_rs_5091;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNILE(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NILE;
	data.name3Char = "NILE";

		{
			int _rs_5213;
			istream >> _rs_5213;

			for (int _rs_5214 = 0; _rs_5214 < _rs_5213; _rs_5214++)
			{
				int _rs_5212;
						
				istream >> _rs_5212;
			
						
				{
					int _rs_5209;
					istream >> _rs_5209;
		
					for (int _rs_5208 = 0; _rs_5208 < _rs_5209; _rs_5208++)
					{
								
						data.atomOrders[_rs_5212][_rs_5208] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_5216;
			istream >> _rs_5216;

			for (int _rs_5215 = 0; _rs_5215 < _rs_5216; _rs_5215++)
			{
						
				istream >> data.acceptorList[_rs_5215];
			
			}
		}
	
		int _rs_5217;
		istream >> _rs_5217;
		data.polar = (bool)_rs_5217;
		{
			int _rs_5219;
			istream >> _rs_5219;

			for (int _rs_5220 = 0; _rs_5220 < _rs_5219; _rs_5220++)
			{
				int _rs_5218;
						
				istream >> _rs_5218;
			
						
				data.templateCoords[_rs_5218] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_5224;
			istream >> _rs_5224;

			for (int _rs_5223 = 0; _rs_5223 < _rs_5224; _rs_5223++)
			{
						
				{
					int _rs_5222;
					istream >> _rs_5222;
		
					for (int _rs_5221 = 0; _rs_5221 < _rs_5222; _rs_5221++)
					{
								
						istream >> data.acceptorBase[_rs_5223][_rs_5221];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_5268;
			istream >> _rs_5268;

			for (int _rs_5269 = 0; _rs_5269 < _rs_5268; _rs_5269++)
			{
				int _rs_5267;
						
				istream >> _rs_5267;
			
						
				{
					int _rs_5226;
					istream >> _rs_5226;
		
					for (int _rs_5225 = 0; _rs_5225 < _rs_5226; _rs_5225++)
					{
								
						istream >> data.templateAtom[_rs_5267][_rs_5225];
					
					}
				}
			
			}
		}
	
		{
			int _rs_5275;
			istream >> _rs_5275;

			for (int _rs_5274 = 0; _rs_5274 < _rs_5275; _rs_5274++)
			{
						
				{
					int _rs_5271;
					istream >> _rs_5271;
		
					for (int _rs_5270 = 0; _rs_5270 < _rs_5271; _rs_5270++)
					{
								
						istream >> data.chiAtoms[_rs_5274][_rs_5270];
					
					}
				}
			
			}
		}
	
		{
			int _rs_5277;
			istream >> _rs_5277;

			for (int _rs_5276 = 0; _rs_5276 < _rs_5277; _rs_5276++)
			{
						
				istream >> data.centroidAtoms[_rs_5276];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_5321;
			istream >> _rs_5321;

			for (int _rs_5320 = 0; _rs_5320 < _rs_5321; _rs_5320++)
			{
						
				{
					int _rs_5279;
					istream >> _rs_5279;
		
					for (int _rs_5278 = 0; _rs_5278 < _rs_5279; _rs_5278++)
					{
								
						istream >> data.bondLengths[_rs_5320][_rs_5278];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_5449;
			istream >> _rs_5449;

			for (int _rs_5450 = 0; _rs_5450 < _rs_5449; _rs_5450++)
			{
				int _rs_5448;
						
				istream >> _rs_5448;
			
						
				{
					int _rs_5327;
					istream >> _rs_5327;
		
					for (int _rs_5326 = 0; _rs_5326 < _rs_5327; _rs_5326++)
					{
								
						int _rs_5322;
						istream >> _rs_5322;
						data.chiDependent[_rs_5448][_rs_5326] = (bool)_rs_5322;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNLYS(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NLYS;
	data.name3Char = "NLYS";

		{
			int _rs_5456;
			istream >> _rs_5456;

			for (int _rs_5457 = 0; _rs_5457 < _rs_5456; _rs_5457++)
			{
				int _rs_5455;
						
				istream >> _rs_5455;
			
						
				{
					int _rs_5452;
					istream >> _rs_5452;
		
					for (int _rs_5451 = 0; _rs_5451 < _rs_5452; _rs_5451++)
					{
								
						data.atomOrders[_rs_5455][_rs_5451] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_5459;
			istream >> _rs_5459;

			for (int _rs_5458 = 0; _rs_5458 < _rs_5459; _rs_5458++)
			{
						
				istream >> data.acceptorList[_rs_5458];
			
			}
		}
	
		int _rs_5460;
		istream >> _rs_5460;
		data.polar = (bool)_rs_5460;
		{
			int _rs_5462;
			istream >> _rs_5462;

			for (int _rs_5463 = 0; _rs_5463 < _rs_5462; _rs_5463++)
			{
				int _rs_5461;
						
				istream >> _rs_5461;
			
						
				data.templateCoords[_rs_5461] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_5467;
			istream >> _rs_5467;

			for (int _rs_5466 = 0; _rs_5466 < _rs_5467; _rs_5466++)
			{
						
				{
					int _rs_5465;
					istream >> _rs_5465;
		
					for (int _rs_5464 = 0; _rs_5464 < _rs_5465; _rs_5464++)
					{
								
						istream >> data.acceptorBase[_rs_5466][_rs_5464];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_5517;
			istream >> _rs_5517;

			for (int _rs_5518 = 0; _rs_5518 < _rs_5517; _rs_5518++)
			{
				int _rs_5516;
						
				istream >> _rs_5516;
			
						
				{
					int _rs_5469;
					istream >> _rs_5469;
		
					for (int _rs_5468 = 0; _rs_5468 < _rs_5469; _rs_5468++)
					{
								
						istream >> data.templateAtom[_rs_5516][_rs_5468];
					
					}
				}
			
			}
		}
	
		{
			int _rs_5528;
			istream >> _rs_5528;

			for (int _rs_5527 = 0; _rs_5527 < _rs_5528; _rs_5527++)
			{
						
				{
					int _rs_5520;
					istream >> _rs_5520;
		
					for (int _rs_5519 = 0; _rs_5519 < _rs_5520; _rs_5519++)
					{
								
						istream >> data.chiAtoms[_rs_5527][_rs_5519];
					
					}
				}
			
			}
		}
	
		{
			int _rs_5530;
			istream >> _rs_5530;

			for (int _rs_5529 = 0; _rs_5529 < _rs_5530; _rs_5529++)
			{
						
				istream >> data.centroidAtoms[_rs_5529];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_5580;
			istream >> _rs_5580;

			for (int _rs_5579 = 0; _rs_5579 < _rs_5580; _rs_5579++)
			{
						
				{
					int _rs_5532;
					istream >> _rs_5532;
		
					for (int _rs_5531 = 0; _rs_5531 < _rs_5532; _rs_5531++)
					{
								
						istream >> data.bondLengths[_rs_5579][_rs_5531];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_5726;
			istream >> _rs_5726;

			for (int _rs_5727 = 0; _rs_5727 < _rs_5726; _rs_5727++)
			{
				int _rs_5725;
						
				istream >> _rs_5725;
			
						
				{
					int _rs_5586;
					istream >> _rs_5586;
		
					for (int _rs_5585 = 0; _rs_5585 < _rs_5586; _rs_5585++)
					{
								
						int _rs_5581;
						istream >> _rs_5581;
						data.chiDependent[_rs_5725][_rs_5585] = (bool)_rs_5581;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNLEU(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NLEU;
	data.name3Char = "NLEU";

		{
			int _rs_5733;
			istream >> _rs_5733;

			for (int _rs_5734 = 0; _rs_5734 < _rs_5733; _rs_5734++)
			{
				int _rs_5732;
						
				istream >> _rs_5732;
			
						
				{
					int _rs_5729;
					istream >> _rs_5729;
		
					for (int _rs_5728 = 0; _rs_5728 < _rs_5729; _rs_5728++)
					{
								
						data.atomOrders[_rs_5732][_rs_5728] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_5736;
			istream >> _rs_5736;

			for (int _rs_5735 = 0; _rs_5735 < _rs_5736; _rs_5735++)
			{
						
				istream >> data.acceptorList[_rs_5735];
			
			}
		}
	
		int _rs_5737;
		istream >> _rs_5737;
		data.polar = (bool)_rs_5737;
		{
			int _rs_5739;
			istream >> _rs_5739;

			for (int _rs_5740 = 0; _rs_5740 < _rs_5739; _rs_5740++)
			{
				int _rs_5738;
						
				istream >> _rs_5738;
			
						
				data.templateCoords[_rs_5738] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_5744;
			istream >> _rs_5744;

			for (int _rs_5743 = 0; _rs_5743 < _rs_5744; _rs_5743++)
			{
						
				{
					int _rs_5742;
					istream >> _rs_5742;
		
					for (int _rs_5741 = 0; _rs_5741 < _rs_5742; _rs_5741++)
					{
								
						istream >> data.acceptorBase[_rs_5743][_rs_5741];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_5788;
			istream >> _rs_5788;

			for (int _rs_5789 = 0; _rs_5789 < _rs_5788; _rs_5789++)
			{
				int _rs_5787;
						
				istream >> _rs_5787;
			
						
				{
					int _rs_5746;
					istream >> _rs_5746;
		
					for (int _rs_5745 = 0; _rs_5745 < _rs_5746; _rs_5745++)
					{
								
						istream >> data.templateAtom[_rs_5787][_rs_5745];
					
					}
				}
			
			}
		}
	
		{
			int _rs_5795;
			istream >> _rs_5795;

			for (int _rs_5794 = 0; _rs_5794 < _rs_5795; _rs_5794++)
			{
						
				{
					int _rs_5791;
					istream >> _rs_5791;
		
					for (int _rs_5790 = 0; _rs_5790 < _rs_5791; _rs_5790++)
					{
								
						istream >> data.chiAtoms[_rs_5794][_rs_5790];
					
					}
				}
			
			}
		}
	
		{
			int _rs_5797;
			istream >> _rs_5797;

			for (int _rs_5796 = 0; _rs_5796 < _rs_5797; _rs_5796++)
			{
						
				istream >> data.centroidAtoms[_rs_5796];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_5841;
			istream >> _rs_5841;

			for (int _rs_5840 = 0; _rs_5840 < _rs_5841; _rs_5840++)
			{
						
				{
					int _rs_5799;
					istream >> _rs_5799;
		
					for (int _rs_5798 = 0; _rs_5798 < _rs_5799; _rs_5798++)
					{
								
						istream >> data.bondLengths[_rs_5840][_rs_5798];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_5969;
			istream >> _rs_5969;

			for (int _rs_5970 = 0; _rs_5970 < _rs_5969; _rs_5970++)
			{
				int _rs_5968;
						
				istream >> _rs_5968;
			
						
				{
					int _rs_5847;
					istream >> _rs_5847;
		
					for (int _rs_5846 = 0; _rs_5846 < _rs_5847; _rs_5846++)
					{
								
						int _rs_5842;
						istream >> _rs_5842;
						data.chiDependent[_rs_5968][_rs_5846] = (bool)_rs_5842;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNMET(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NMET;
	data.name3Char = "NMET";

		{
			int _rs_5976;
			istream >> _rs_5976;

			for (int _rs_5977 = 0; _rs_5977 < _rs_5976; _rs_5977++)
			{
				int _rs_5975;
						
				istream >> _rs_5975;
			
						
				{
					int _rs_5972;
					istream >> _rs_5972;
		
					for (int _rs_5971 = 0; _rs_5971 < _rs_5972; _rs_5971++)
					{
								
						data.atomOrders[_rs_5975][_rs_5971] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_5979;
			istream >> _rs_5979;

			for (int _rs_5978 = 0; _rs_5978 < _rs_5979; _rs_5978++)
			{
						
				istream >> data.acceptorList[_rs_5978];
			
			}
		}
	
		int _rs_5980;
		istream >> _rs_5980;
		data.polar = (bool)_rs_5980;
		{
			int _rs_5982;
			istream >> _rs_5982;

			for (int _rs_5983 = 0; _rs_5983 < _rs_5982; _rs_5983++)
			{
				int _rs_5981;
						
				istream >> _rs_5981;
			
						
				data.templateCoords[_rs_5981] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_5987;
			istream >> _rs_5987;

			for (int _rs_5986 = 0; _rs_5986 < _rs_5987; _rs_5986++)
			{
						
				{
					int _rs_5985;
					istream >> _rs_5985;
		
					for (int _rs_5984 = 0; _rs_5984 < _rs_5985; _rs_5984++)
					{
								
						istream >> data.acceptorBase[_rs_5986][_rs_5984];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_6027;
			istream >> _rs_6027;

			for (int _rs_6028 = 0; _rs_6028 < _rs_6027; _rs_6028++)
			{
				int _rs_6026;
						
				istream >> _rs_6026;
			
						
				{
					int _rs_5989;
					istream >> _rs_5989;
		
					for (int _rs_5988 = 0; _rs_5988 < _rs_5989; _rs_5988++)
					{
								
						istream >> data.templateAtom[_rs_6026][_rs_5988];
					
					}
				}
			
			}
		}
	
		{
			int _rs_6036;
			istream >> _rs_6036;

			for (int _rs_6035 = 0; _rs_6035 < _rs_6036; _rs_6035++)
			{
						
				{
					int _rs_6030;
					istream >> _rs_6030;
		
					for (int _rs_6029 = 0; _rs_6029 < _rs_6030; _rs_6029++)
					{
								
						istream >> data.chiAtoms[_rs_6035][_rs_6029];
					
					}
				}
			
			}
		}
	
		{
			int _rs_6038;
			istream >> _rs_6038;

			for (int _rs_6037 = 0; _rs_6037 < _rs_6038; _rs_6037++)
			{
						
				istream >> data.centroidAtoms[_rs_6037];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_6078;
			istream >> _rs_6078;

			for (int _rs_6077 = 0; _rs_6077 < _rs_6078; _rs_6077++)
			{
						
				{
					int _rs_6040;
					istream >> _rs_6040;
		
					for (int _rs_6039 = 0; _rs_6039 < _rs_6040; _rs_6039++)
					{
								
						istream >> data.bondLengths[_rs_6077][_rs_6039];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_6194;
			istream >> _rs_6194;

			for (int _rs_6195 = 0; _rs_6195 < _rs_6194; _rs_6195++)
			{
				int _rs_6193;
						
				istream >> _rs_6193;
			
						
				{
					int _rs_6084;
					istream >> _rs_6084;
		
					for (int _rs_6083 = 0; _rs_6083 < _rs_6084; _rs_6083++)
					{
								
						int _rs_6079;
						istream >> _rs_6079;
						data.chiDependent[_rs_6193][_rs_6083] = (bool)_rs_6079;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNASN(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NASN;
	data.name3Char = "NASN";

		{
			int _rs_6201;
			istream >> _rs_6201;

			for (int _rs_6202 = 0; _rs_6202 < _rs_6201; _rs_6202++)
			{
				int _rs_6200;
						
				istream >> _rs_6200;
			
						
				{
					int _rs_6197;
					istream >> _rs_6197;
		
					for (int _rs_6196 = 0; _rs_6196 < _rs_6197; _rs_6196++)
					{
								
						data.atomOrders[_rs_6200][_rs_6196] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_6204;
			istream >> _rs_6204;

			for (int _rs_6203 = 0; _rs_6203 < _rs_6204; _rs_6203++)
			{
						
				istream >> data.acceptorList[_rs_6203];
			
			}
		}
	
		int _rs_6205;
		istream >> _rs_6205;
		data.polar = (bool)_rs_6205;
		{
			int _rs_6207;
			istream >> _rs_6207;

			for (int _rs_6208 = 0; _rs_6208 < _rs_6207; _rs_6208++)
			{
				int _rs_6206;
						
				istream >> _rs_6206;
			
						
				data.templateCoords[_rs_6206] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_6214;
			istream >> _rs_6214;

			for (int _rs_6213 = 0; _rs_6213 < _rs_6214; _rs_6213++)
			{
						
				{
					int _rs_6210;
					istream >> _rs_6210;
		
					for (int _rs_6209 = 0; _rs_6209 < _rs_6210; _rs_6209++)
					{
								
						istream >> data.acceptorBase[_rs_6213][_rs_6209];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_6248;
			istream >> _rs_6248;

			for (int _rs_6249 = 0; _rs_6249 < _rs_6248; _rs_6249++)
			{
				int _rs_6247;
						
				istream >> _rs_6247;
			
						
				{
					int _rs_6216;
					istream >> _rs_6216;
		
					for (int _rs_6215 = 0; _rs_6215 < _rs_6216; _rs_6215++)
					{
								
						istream >> data.templateAtom[_rs_6247][_rs_6215];
					
					}
				}
			
			}
		}
	
		{
			int _rs_6255;
			istream >> _rs_6255;

			for (int _rs_6254 = 0; _rs_6254 < _rs_6255; _rs_6254++)
			{
						
				{
					int _rs_6251;
					istream >> _rs_6251;
		
					for (int _rs_6250 = 0; _rs_6250 < _rs_6251; _rs_6250++)
					{
								
						istream >> data.chiAtoms[_rs_6254][_rs_6250];
					
					}
				}
			
			}
		}
	
		{
			int _rs_6257;
			istream >> _rs_6257;

			for (int _rs_6256 = 0; _rs_6256 < _rs_6257; _rs_6256++)
			{
						
				istream >> data.centroidAtoms[_rs_6256];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_6291;
			istream >> _rs_6291;

			for (int _rs_6290 = 0; _rs_6290 < _rs_6291; _rs_6290++)
			{
						
				{
					int _rs_6259;
					istream >> _rs_6259;
		
					for (int _rs_6258 = 0; _rs_6258 < _rs_6259; _rs_6258++)
					{
								
						istream >> data.bondLengths[_rs_6290][_rs_6258];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_6389;
			istream >> _rs_6389;

			for (int _rs_6390 = 0; _rs_6390 < _rs_6389; _rs_6390++)
			{
				int _rs_6388;
						
				istream >> _rs_6388;
			
						
				{
					int _rs_6297;
					istream >> _rs_6297;
		
					for (int _rs_6296 = 0; _rs_6296 < _rs_6297; _rs_6296++)
					{
								
						int _rs_6292;
						istream >> _rs_6292;
						data.chiDependent[_rs_6388][_rs_6296] = (bool)_rs_6292;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNPRO(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NPRO;
	data.name3Char = "NPRO";

		{
			int _rs_6396;
			istream >> _rs_6396;

			for (int _rs_6397 = 0; _rs_6397 < _rs_6396; _rs_6397++)
			{
				int _rs_6395;
						
				istream >> _rs_6395;
			
						
				{
					int _rs_6392;
					istream >> _rs_6392;
		
					for (int _rs_6391 = 0; _rs_6391 < _rs_6392; _rs_6391++)
					{
								
						data.atomOrders[_rs_6395][_rs_6391] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_6399;
			istream >> _rs_6399;

			for (int _rs_6398 = 0; _rs_6398 < _rs_6399; _rs_6398++)
			{
						
				istream >> data.acceptorList[_rs_6398];
			
			}
		}
	
		int _rs_6400;
		istream >> _rs_6400;
		data.polar = (bool)_rs_6400;
		{
			int _rs_6402;
			istream >> _rs_6402;

			for (int _rs_6403 = 0; _rs_6403 < _rs_6402; _rs_6403++)
			{
				int _rs_6401;
						
				istream >> _rs_6401;
			
						
				data.templateCoords[_rs_6401] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_6407;
			istream >> _rs_6407;

			for (int _rs_6406 = 0; _rs_6406 < _rs_6407; _rs_6406++)
			{
						
				{
					int _rs_6405;
					istream >> _rs_6405;
		
					for (int _rs_6404 = 0; _rs_6404 < _rs_6405; _rs_6404++)
					{
								
						istream >> data.acceptorBase[_rs_6406][_rs_6404];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_6441;
			istream >> _rs_6441;

			for (int _rs_6442 = 0; _rs_6442 < _rs_6441; _rs_6442++)
			{
				int _rs_6440;
						
				istream >> _rs_6440;
			
						
				{
					int _rs_6409;
					istream >> _rs_6409;
		
					for (int _rs_6408 = 0; _rs_6408 < _rs_6409; _rs_6408++)
					{
								
						istream >> data.templateAtom[_rs_6440][_rs_6408];
					
					}
				}
			
			}
		}
	
		{
			int _rs_6446;
			istream >> _rs_6446;

			for (int _rs_6445 = 0; _rs_6445 < _rs_6446; _rs_6445++)
			{
						
				{
					int _rs_6444;
					istream >> _rs_6444;
		
					for (int _rs_6443 = 0; _rs_6443 < _rs_6444; _rs_6443++)
					{
								
						istream >> data.chiAtoms[_rs_6445][_rs_6443];
					
					}
				}
			
			}
		}
	
		{
			int _rs_6448;
			istream >> _rs_6448;

			for (int _rs_6447 = 0; _rs_6447 < _rs_6448; _rs_6447++)
			{
						
				istream >> data.centroidAtoms[_rs_6447];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_6482;
			istream >> _rs_6482;

			for (int _rs_6481 = 0; _rs_6481 < _rs_6482; _rs_6481++)
			{
						
				{
					int _rs_6450;
					istream >> _rs_6450;
		
					for (int _rs_6449 = 0; _rs_6449 < _rs_6450; _rs_6449++)
					{
								
						istream >> data.bondLengths[_rs_6481][_rs_6449];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_6580;
			istream >> _rs_6580;

			for (int _rs_6581 = 0; _rs_6581 < _rs_6580; _rs_6581++)
			{
				int _rs_6579;
						
				istream >> _rs_6579;
			
						
				{
					int _rs_6488;
					istream >> _rs_6488;
		
					for (int _rs_6487 = 0; _rs_6487 < _rs_6488; _rs_6487++)
					{
								
						int _rs_6483;
						istream >> _rs_6483;
						data.chiDependent[_rs_6579][_rs_6487] = (bool)_rs_6483;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNGLN(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NGLN;
	data.name3Char = "NGLN";

		{
			int _rs_6587;
			istream >> _rs_6587;

			for (int _rs_6588 = 0; _rs_6588 < _rs_6587; _rs_6588++)
			{
				int _rs_6586;
						
				istream >> _rs_6586;
			
						
				{
					int _rs_6583;
					istream >> _rs_6583;
		
					for (int _rs_6582 = 0; _rs_6582 < _rs_6583; _rs_6582++)
					{
								
						data.atomOrders[_rs_6586][_rs_6582] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_6590;
			istream >> _rs_6590;

			for (int _rs_6589 = 0; _rs_6589 < _rs_6590; _rs_6589++)
			{
						
				istream >> data.acceptorList[_rs_6589];
			
			}
		}
	
		int _rs_6591;
		istream >> _rs_6591;
		data.polar = (bool)_rs_6591;
		{
			int _rs_6593;
			istream >> _rs_6593;

			for (int _rs_6594 = 0; _rs_6594 < _rs_6593; _rs_6594++)
			{
				int _rs_6592;
						
				istream >> _rs_6592;
			
						
				data.templateCoords[_rs_6592] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_6600;
			istream >> _rs_6600;

			for (int _rs_6599 = 0; _rs_6599 < _rs_6600; _rs_6599++)
			{
						
				{
					int _rs_6596;
					istream >> _rs_6596;
		
					for (int _rs_6595 = 0; _rs_6595 < _rs_6596; _rs_6595++)
					{
								
						istream >> data.acceptorBase[_rs_6599][_rs_6595];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_6640;
			istream >> _rs_6640;

			for (int _rs_6641 = 0; _rs_6641 < _rs_6640; _rs_6641++)
			{
				int _rs_6639;
						
				istream >> _rs_6639;
			
						
				{
					int _rs_6602;
					istream >> _rs_6602;
		
					for (int _rs_6601 = 0; _rs_6601 < _rs_6602; _rs_6601++)
					{
								
						istream >> data.templateAtom[_rs_6639][_rs_6601];
					
					}
				}
			
			}
		}
	
		{
			int _rs_6649;
			istream >> _rs_6649;

			for (int _rs_6648 = 0; _rs_6648 < _rs_6649; _rs_6648++)
			{
						
				{
					int _rs_6643;
					istream >> _rs_6643;
		
					for (int _rs_6642 = 0; _rs_6642 < _rs_6643; _rs_6642++)
					{
								
						istream >> data.chiAtoms[_rs_6648][_rs_6642];
					
					}
				}
			
			}
		}
	
		{
			int _rs_6651;
			istream >> _rs_6651;

			for (int _rs_6650 = 0; _rs_6650 < _rs_6651; _rs_6650++)
			{
						
				istream >> data.centroidAtoms[_rs_6650];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_6691;
			istream >> _rs_6691;

			for (int _rs_6690 = 0; _rs_6690 < _rs_6691; _rs_6690++)
			{
						
				{
					int _rs_6653;
					istream >> _rs_6653;
		
					for (int _rs_6652 = 0; _rs_6652 < _rs_6653; _rs_6652++)
					{
								
						istream >> data.bondLengths[_rs_6690][_rs_6652];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_6807;
			istream >> _rs_6807;

			for (int _rs_6808 = 0; _rs_6808 < _rs_6807; _rs_6808++)
			{
				int _rs_6806;
						
				istream >> _rs_6806;
			
						
				{
					int _rs_6697;
					istream >> _rs_6697;
		
					for (int _rs_6696 = 0; _rs_6696 < _rs_6697; _rs_6696++)
					{
								
						int _rs_6692;
						istream >> _rs_6692;
						data.chiDependent[_rs_6806][_rs_6696] = (bool)_rs_6692;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNARG(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NARG;
	data.name3Char = "NARG";

		{
			int _rs_6814;
			istream >> _rs_6814;

			for (int _rs_6815 = 0; _rs_6815 < _rs_6814; _rs_6815++)
			{
				int _rs_6813;
						
				istream >> _rs_6813;
			
						
				{
					int _rs_6810;
					istream >> _rs_6810;
		
					for (int _rs_6809 = 0; _rs_6809 < _rs_6810; _rs_6809++)
					{
								
						data.atomOrders[_rs_6813][_rs_6809] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_6817;
			istream >> _rs_6817;

			for (int _rs_6816 = 0; _rs_6816 < _rs_6817; _rs_6816++)
			{
						
				istream >> data.acceptorList[_rs_6816];
			
			}
		}
	
		int _rs_6818;
		istream >> _rs_6818;
		data.polar = (bool)_rs_6818;
		{
			int _rs_6820;
			istream >> _rs_6820;

			for (int _rs_6821 = 0; _rs_6821 < _rs_6820; _rs_6821++)
			{
				int _rs_6819;
						
				istream >> _rs_6819;
			
						
				data.templateCoords[_rs_6819] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_6825;
			istream >> _rs_6825;

			for (int _rs_6824 = 0; _rs_6824 < _rs_6825; _rs_6824++)
			{
						
				{
					int _rs_6823;
					istream >> _rs_6823;
		
					for (int _rs_6822 = 0; _rs_6822 < _rs_6823; _rs_6822++)
					{
								
						istream >> data.acceptorBase[_rs_6824][_rs_6822];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_6879;
			istream >> _rs_6879;

			for (int _rs_6880 = 0; _rs_6880 < _rs_6879; _rs_6880++)
			{
				int _rs_6878;
						
				istream >> _rs_6878;
			
						
				{
					int _rs_6827;
					istream >> _rs_6827;
		
					for (int _rs_6826 = 0; _rs_6826 < _rs_6827; _rs_6826++)
					{
								
						istream >> data.templateAtom[_rs_6878][_rs_6826];
					
					}
				}
			
			}
		}
	
		{
			int _rs_6890;
			istream >> _rs_6890;

			for (int _rs_6889 = 0; _rs_6889 < _rs_6890; _rs_6889++)
			{
						
				{
					int _rs_6882;
					istream >> _rs_6882;
		
					for (int _rs_6881 = 0; _rs_6881 < _rs_6882; _rs_6881++)
					{
								
						istream >> data.chiAtoms[_rs_6889][_rs_6881];
					
					}
				}
			
			}
		}
	
		{
			int _rs_6892;
			istream >> _rs_6892;

			for (int _rs_6891 = 0; _rs_6891 < _rs_6892; _rs_6891++)
			{
						
				istream >> data.centroidAtoms[_rs_6891];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_6946;
			istream >> _rs_6946;

			for (int _rs_6945 = 0; _rs_6945 < _rs_6946; _rs_6945++)
			{
						
				{
					int _rs_6894;
					istream >> _rs_6894;
		
					for (int _rs_6893 = 0; _rs_6893 < _rs_6894; _rs_6893++)
					{
								
						istream >> data.bondLengths[_rs_6945][_rs_6893];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_7104;
			istream >> _rs_7104;

			for (int _rs_7105 = 0; _rs_7105 < _rs_7104; _rs_7105++)
			{
				int _rs_7103;
						
				istream >> _rs_7103;
			
						
				{
					int _rs_6952;
					istream >> _rs_6952;
		
					for (int _rs_6951 = 0; _rs_6951 < _rs_6952; _rs_6951++)
					{
								
						int _rs_6947;
						istream >> _rs_6947;
						data.chiDependent[_rs_7103][_rs_6951] = (bool)_rs_6947;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNSER(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NSER;
	data.name3Char = "NSER";

		{
			int _rs_7111;
			istream >> _rs_7111;

			for (int _rs_7112 = 0; _rs_7112 < _rs_7111; _rs_7112++)
			{
				int _rs_7110;
						
				istream >> _rs_7110;
			
						
				{
					int _rs_7107;
					istream >> _rs_7107;
		
					for (int _rs_7106 = 0; _rs_7106 < _rs_7107; _rs_7106++)
					{
								
						data.atomOrders[_rs_7110][_rs_7106] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_7114;
			istream >> _rs_7114;

			for (int _rs_7113 = 0; _rs_7113 < _rs_7114; _rs_7113++)
			{
						
				istream >> data.acceptorList[_rs_7113];
			
			}
		}
	
		int _rs_7115;
		istream >> _rs_7115;
		data.polar = (bool)_rs_7115;
		{
			int _rs_7117;
			istream >> _rs_7117;

			for (int _rs_7118 = 0; _rs_7118 < _rs_7117; _rs_7118++)
			{
				int _rs_7116;
						
				istream >> _rs_7116;
			
						
				data.templateCoords[_rs_7116] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_7124;
			istream >> _rs_7124;

			for (int _rs_7123 = 0; _rs_7123 < _rs_7124; _rs_7123++)
			{
						
				{
					int _rs_7120;
					istream >> _rs_7120;
		
					for (int _rs_7119 = 0; _rs_7119 < _rs_7120; _rs_7119++)
					{
								
						istream >> data.acceptorBase[_rs_7123][_rs_7119];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_7152;
			istream >> _rs_7152;

			for (int _rs_7153 = 0; _rs_7153 < _rs_7152; _rs_7153++)
			{
				int _rs_7151;
						
				istream >> _rs_7151;
			
						
				{
					int _rs_7126;
					istream >> _rs_7126;
		
					for (int _rs_7125 = 0; _rs_7125 < _rs_7126; _rs_7125++)
					{
								
						istream >> data.templateAtom[_rs_7151][_rs_7125];
					
					}
				}
			
			}
		}
	
		{
			int _rs_7159;
			istream >> _rs_7159;

			for (int _rs_7158 = 0; _rs_7158 < _rs_7159; _rs_7158++)
			{
						
				{
					int _rs_7155;
					istream >> _rs_7155;
		
					for (int _rs_7154 = 0; _rs_7154 < _rs_7155; _rs_7154++)
					{
								
						istream >> data.chiAtoms[_rs_7158][_rs_7154];
					
					}
				}
			
			}
		}
	
		{
			int _rs_7161;
			istream >> _rs_7161;

			for (int _rs_7160 = 0; _rs_7160 < _rs_7161; _rs_7160++)
			{
						
				istream >> data.centroidAtoms[_rs_7160];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_7189;
			istream >> _rs_7189;

			for (int _rs_7188 = 0; _rs_7188 < _rs_7189; _rs_7188++)
			{
						
				{
					int _rs_7163;
					istream >> _rs_7163;
		
					for (int _rs_7162 = 0; _rs_7162 < _rs_7163; _rs_7162++)
					{
								
						istream >> data.bondLengths[_rs_7188][_rs_7162];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_7269;
			istream >> _rs_7269;

			for (int _rs_7270 = 0; _rs_7270 < _rs_7269; _rs_7270++)
			{
				int _rs_7268;
						
				istream >> _rs_7268;
			
						
				{
					int _rs_7195;
					istream >> _rs_7195;
		
					for (int _rs_7194 = 0; _rs_7194 < _rs_7195; _rs_7194++)
					{
								
						int _rs_7190;
						istream >> _rs_7190;
						data.chiDependent[_rs_7268][_rs_7194] = (bool)_rs_7190;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNTHR(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NTHR;
	data.name3Char = "NTHR";

		{
			int _rs_7276;
			istream >> _rs_7276;

			for (int _rs_7277 = 0; _rs_7277 < _rs_7276; _rs_7277++)
			{
				int _rs_7275;
						
				istream >> _rs_7275;
			
						
				{
					int _rs_7272;
					istream >> _rs_7272;
		
					for (int _rs_7271 = 0; _rs_7271 < _rs_7272; _rs_7271++)
					{
								
						data.atomOrders[_rs_7275][_rs_7271] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_7279;
			istream >> _rs_7279;

			for (int _rs_7278 = 0; _rs_7278 < _rs_7279; _rs_7278++)
			{
						
				istream >> data.acceptorList[_rs_7278];
			
			}
		}
	
		int _rs_7280;
		istream >> _rs_7280;
		data.polar = (bool)_rs_7280;
		{
			int _rs_7282;
			istream >> _rs_7282;

			for (int _rs_7283 = 0; _rs_7283 < _rs_7282; _rs_7283++)
			{
				int _rs_7281;
						
				istream >> _rs_7281;
			
						
				data.templateCoords[_rs_7281] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_7289;
			istream >> _rs_7289;

			for (int _rs_7288 = 0; _rs_7288 < _rs_7289; _rs_7288++)
			{
						
				{
					int _rs_7285;
					istream >> _rs_7285;
		
					for (int _rs_7284 = 0; _rs_7284 < _rs_7285; _rs_7284++)
					{
								
						istream >> data.acceptorBase[_rs_7288][_rs_7284];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_7323;
			istream >> _rs_7323;

			for (int _rs_7324 = 0; _rs_7324 < _rs_7323; _rs_7324++)
			{
				int _rs_7322;
						
				istream >> _rs_7322;
			
						
				{
					int _rs_7291;
					istream >> _rs_7291;
		
					for (int _rs_7290 = 0; _rs_7290 < _rs_7291; _rs_7290++)
					{
								
						istream >> data.templateAtom[_rs_7322][_rs_7290];
					
					}
				}
			
			}
		}
	
		{
			int _rs_7330;
			istream >> _rs_7330;

			for (int _rs_7329 = 0; _rs_7329 < _rs_7330; _rs_7329++)
			{
						
				{
					int _rs_7326;
					istream >> _rs_7326;
		
					for (int _rs_7325 = 0; _rs_7325 < _rs_7326; _rs_7325++)
					{
								
						istream >> data.chiAtoms[_rs_7329][_rs_7325];
					
					}
				}
			
			}
		}
	
		{
			int _rs_7332;
			istream >> _rs_7332;

			for (int _rs_7331 = 0; _rs_7331 < _rs_7332; _rs_7331++)
			{
						
				istream >> data.centroidAtoms[_rs_7331];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_7366;
			istream >> _rs_7366;

			for (int _rs_7365 = 0; _rs_7365 < _rs_7366; _rs_7365++)
			{
						
				{
					int _rs_7334;
					istream >> _rs_7334;
		
					for (int _rs_7333 = 0; _rs_7333 < _rs_7334; _rs_7333++)
					{
								
						istream >> data.bondLengths[_rs_7365][_rs_7333];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_7464;
			istream >> _rs_7464;

			for (int _rs_7465 = 0; _rs_7465 < _rs_7464; _rs_7465++)
			{
				int _rs_7463;
						
				istream >> _rs_7463;
			
						
				{
					int _rs_7372;
					istream >> _rs_7372;
		
					for (int _rs_7371 = 0; _rs_7371 < _rs_7372; _rs_7371++)
					{
								
						int _rs_7367;
						istream >> _rs_7367;
						data.chiDependent[_rs_7463][_rs_7371] = (bool)_rs_7367;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNVAL(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NVAL;
	data.name3Char = "NVAL";

		{
			int _rs_7471;
			istream >> _rs_7471;

			for (int _rs_7472 = 0; _rs_7472 < _rs_7471; _rs_7472++)
			{
				int _rs_7470;
						
				istream >> _rs_7470;
			
						
				{
					int _rs_7467;
					istream >> _rs_7467;
		
					for (int _rs_7466 = 0; _rs_7466 < _rs_7467; _rs_7466++)
					{
								
						data.atomOrders[_rs_7470][_rs_7466] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_7474;
			istream >> _rs_7474;

			for (int _rs_7473 = 0; _rs_7473 < _rs_7474; _rs_7473++)
			{
						
				istream >> data.acceptorList[_rs_7473];
			
			}
		}
	
		int _rs_7475;
		istream >> _rs_7475;
		data.polar = (bool)_rs_7475;
		{
			int _rs_7477;
			istream >> _rs_7477;

			for (int _rs_7478 = 0; _rs_7478 < _rs_7477; _rs_7478++)
			{
				int _rs_7476;
						
				istream >> _rs_7476;
			
						
				data.templateCoords[_rs_7476] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_7482;
			istream >> _rs_7482;

			for (int _rs_7481 = 0; _rs_7481 < _rs_7482; _rs_7481++)
			{
						
				{
					int _rs_7480;
					istream >> _rs_7480;
		
					for (int _rs_7479 = 0; _rs_7479 < _rs_7480; _rs_7479++)
					{
								
						istream >> data.acceptorBase[_rs_7481][_rs_7479];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_7520;
			istream >> _rs_7520;

			for (int _rs_7521 = 0; _rs_7521 < _rs_7520; _rs_7521++)
			{
				int _rs_7519;
						
				istream >> _rs_7519;
			
						
				{
					int _rs_7484;
					istream >> _rs_7484;
		
					for (int _rs_7483 = 0; _rs_7483 < _rs_7484; _rs_7483++)
					{
								
						istream >> data.templateAtom[_rs_7519][_rs_7483];
					
					}
				}
			
			}
		}
	
		{
			int _rs_7525;
			istream >> _rs_7525;

			for (int _rs_7524 = 0; _rs_7524 < _rs_7525; _rs_7524++)
			{
						
				{
					int _rs_7523;
					istream >> _rs_7523;
		
					for (int _rs_7522 = 0; _rs_7522 < _rs_7523; _rs_7522++)
					{
								
						istream >> data.chiAtoms[_rs_7524][_rs_7522];
					
					}
				}
			
			}
		}
	
		{
			int _rs_7527;
			istream >> _rs_7527;

			for (int _rs_7526 = 0; _rs_7526 < _rs_7527; _rs_7526++)
			{
						
				istream >> data.centroidAtoms[_rs_7526];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_7565;
			istream >> _rs_7565;

			for (int _rs_7564 = 0; _rs_7564 < _rs_7565; _rs_7564++)
			{
						
				{
					int _rs_7529;
					istream >> _rs_7529;
		
					for (int _rs_7528 = 0; _rs_7528 < _rs_7529; _rs_7528++)
					{
								
						istream >> data.bondLengths[_rs_7564][_rs_7528];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_7675;
			istream >> _rs_7675;

			for (int _rs_7676 = 0; _rs_7676 < _rs_7675; _rs_7676++)
			{
				int _rs_7674;
						
				istream >> _rs_7674;
			
						
				{
					int _rs_7571;
					istream >> _rs_7571;
		
					for (int _rs_7570 = 0; _rs_7570 < _rs_7571; _rs_7570++)
					{
								
						int _rs_7566;
						istream >> _rs_7566;
						data.chiDependent[_rs_7674][_rs_7570] = (bool)_rs_7566;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNTRP(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NTRP;
	data.name3Char = "NTRP";

		{
			int _rs_7682;
			istream >> _rs_7682;

			for (int _rs_7683 = 0; _rs_7683 < _rs_7682; _rs_7683++)
			{
				int _rs_7681;
						
				istream >> _rs_7681;
			
						
				{
					int _rs_7678;
					istream >> _rs_7678;
		
					for (int _rs_7677 = 0; _rs_7677 < _rs_7678; _rs_7677++)
					{
								
						data.atomOrders[_rs_7681][_rs_7677] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_7685;
			istream >> _rs_7685;

			for (int _rs_7684 = 0; _rs_7684 < _rs_7685; _rs_7684++)
			{
						
				istream >> data.acceptorList[_rs_7684];
			
			}
		}
	
		int _rs_7686;
		istream >> _rs_7686;
		data.polar = (bool)_rs_7686;
		{
			int _rs_7688;
			istream >> _rs_7688;

			for (int _rs_7689 = 0; _rs_7689 < _rs_7688; _rs_7689++)
			{
				int _rs_7687;
						
				istream >> _rs_7687;
			
						
				data.templateCoords[_rs_7687] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_7693;
			istream >> _rs_7693;

			for (int _rs_7692 = 0; _rs_7692 < _rs_7693; _rs_7692++)
			{
						
				{
					int _rs_7691;
					istream >> _rs_7691;
		
					for (int _rs_7690 = 0; _rs_7690 < _rs_7691; _rs_7690++)
					{
								
						istream >> data.acceptorBase[_rs_7692][_rs_7690];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_7747;
			istream >> _rs_7747;

			for (int _rs_7748 = 0; _rs_7748 < _rs_7747; _rs_7748++)
			{
				int _rs_7746;
						
				istream >> _rs_7746;
			
						
				{
					int _rs_7695;
					istream >> _rs_7695;
		
					for (int _rs_7694 = 0; _rs_7694 < _rs_7695; _rs_7694++)
					{
								
						istream >> data.templateAtom[_rs_7746][_rs_7694];
					
					}
				}
			
			}
		}
	
		{
			int _rs_7754;
			istream >> _rs_7754;

			for (int _rs_7753 = 0; _rs_7753 < _rs_7754; _rs_7753++)
			{
						
				{
					int _rs_7750;
					istream >> _rs_7750;
		
					for (int _rs_7749 = 0; _rs_7749 < _rs_7750; _rs_7749++)
					{
								
						istream >> data.chiAtoms[_rs_7753][_rs_7749];
					
					}
				}
			
			}
		}
	
		{
			int _rs_7756;
			istream >> _rs_7756;

			for (int _rs_7755 = 0; _rs_7755 < _rs_7756; _rs_7755++)
			{
						
				istream >> data.centroidAtoms[_rs_7755];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_7810;
			istream >> _rs_7810;

			for (int _rs_7809 = 0; _rs_7809 < _rs_7810; _rs_7809++)
			{
						
				{
					int _rs_7758;
					istream >> _rs_7758;
		
					for (int _rs_7757 = 0; _rs_7757 < _rs_7758; _rs_7757++)
					{
								
						istream >> data.bondLengths[_rs_7809][_rs_7757];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_7968;
			istream >> _rs_7968;

			for (int _rs_7969 = 0; _rs_7969 < _rs_7968; _rs_7969++)
			{
				int _rs_7967;
						
				istream >> _rs_7967;
			
						
				{
					int _rs_7816;
					istream >> _rs_7816;
		
					for (int _rs_7815 = 0; _rs_7815 < _rs_7816; _rs_7815++)
					{
								
						int _rs_7811;
						istream >> _rs_7811;
						data.chiDependent[_rs_7967][_rs_7815] = (bool)_rs_7811;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadNTYR(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = NTYR;
	data.name3Char = "NTYR";

		{
			int _rs_7975;
			istream >> _rs_7975;

			for (int _rs_7976 = 0; _rs_7976 < _rs_7975; _rs_7976++)
			{
				int _rs_7974;
						
				istream >> _rs_7974;
			
						
				{
					int _rs_7971;
					istream >> _rs_7971;
		
					for (int _rs_7970 = 0; _rs_7970 < _rs_7971; _rs_7970++)
					{
								
						data.atomOrders[_rs_7974][_rs_7970] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_7978;
			istream >> _rs_7978;

			for (int _rs_7977 = 0; _rs_7977 < _rs_7978; _rs_7977++)
			{
						
				istream >> data.acceptorList[_rs_7977];
			
			}
		}
	
		int _rs_7979;
		istream >> _rs_7979;
		data.polar = (bool)_rs_7979;
		{
			int _rs_7981;
			istream >> _rs_7981;

			for (int _rs_7982 = 0; _rs_7982 < _rs_7981; _rs_7982++)
			{
				int _rs_7980;
						
				istream >> _rs_7980;
			
						
				data.templateCoords[_rs_7980] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_7988;
			istream >> _rs_7988;

			for (int _rs_7987 = 0; _rs_7987 < _rs_7988; _rs_7987++)
			{
						
				{
					int _rs_7984;
					istream >> _rs_7984;
		
					for (int _rs_7983 = 0; _rs_7983 < _rs_7984; _rs_7983++)
					{
								
						istream >> data.acceptorBase[_rs_7987][_rs_7983];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_8036;
			istream >> _rs_8036;

			for (int _rs_8037 = 0; _rs_8037 < _rs_8036; _rs_8037++)
			{
				int _rs_8035;
						
				istream >> _rs_8035;
			
						
				{
					int _rs_7990;
					istream >> _rs_7990;
		
					for (int _rs_7989 = 0; _rs_7989 < _rs_7990; _rs_7989++)
					{
								
						istream >> data.templateAtom[_rs_8035][_rs_7989];
					
					}
				}
			
			}
		}
	
		{
			int _rs_8045;
			istream >> _rs_8045;

			for (int _rs_8044 = 0; _rs_8044 < _rs_8045; _rs_8044++)
			{
						
				{
					int _rs_8039;
					istream >> _rs_8039;
		
					for (int _rs_8038 = 0; _rs_8038 < _rs_8039; _rs_8038++)
					{
								
						istream >> data.chiAtoms[_rs_8044][_rs_8038];
					
					}
				}
			
			}
		}
	
		{
			int _rs_8047;
			istream >> _rs_8047;

			for (int _rs_8046 = 0; _rs_8046 < _rs_8047; _rs_8046++)
			{
						
				istream >> data.centroidAtoms[_rs_8046];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_8095;
			istream >> _rs_8095;

			for (int _rs_8094 = 0; _rs_8094 < _rs_8095; _rs_8094++)
			{
						
				{
					int _rs_8049;
					istream >> _rs_8049;
		
					for (int _rs_8048 = 0; _rs_8048 < _rs_8049; _rs_8048++)
					{
								
						istream >> data.bondLengths[_rs_8094][_rs_8048];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_8235;
			istream >> _rs_8235;

			for (int _rs_8236 = 0; _rs_8236 < _rs_8235; _rs_8236++)
			{
				int _rs_8234;
						
				istream >> _rs_8234;
			
						
				{
					int _rs_8101;
					istream >> _rs_8101;
		
					for (int _rs_8100 = 0; _rs_8100 < _rs_8101; _rs_8100++)
					{
								
						int _rs_8096;
						istream >> _rs_8096;
						data.chiDependent[_rs_8234][_rs_8100] = (bool)_rs_8096;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCALA(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CALA;
	data.name3Char = "CALA";

		{
			int _rs_8242;
			istream >> _rs_8242;

			for (int _rs_8243 = 0; _rs_8243 < _rs_8242; _rs_8243++)
			{
				int _rs_8241;
						
				istream >> _rs_8241;
			
						
				{
					int _rs_8238;
					istream >> _rs_8238;
		
					for (int _rs_8237 = 0; _rs_8237 < _rs_8238; _rs_8237++)
					{
								
						data.atomOrders[_rs_8241][_rs_8237] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_8245;
			istream >> _rs_8245;

			for (int _rs_8244 = 0; _rs_8244 < _rs_8245; _rs_8244++)
			{
						
				istream >> data.acceptorList[_rs_8244];
			
			}
		}
	
		int _rs_8246;
		istream >> _rs_8246;
		data.polar = (bool)_rs_8246;
		{
			int _rs_8248;
			istream >> _rs_8248;

			for (int _rs_8249 = 0; _rs_8249 < _rs_8248; _rs_8249++)
			{
				int _rs_8247;
						
				istream >> _rs_8247;
			
						
				data.templateCoords[_rs_8247] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_8253;
			istream >> _rs_8253;

			for (int _rs_8252 = 0; _rs_8252 < _rs_8253; _rs_8252++)
			{
						
				{
					int _rs_8251;
					istream >> _rs_8251;
		
					for (int _rs_8250 = 0; _rs_8250 < _rs_8251; _rs_8250++)
					{
								
						istream >> data.acceptorBase[_rs_8252][_rs_8250];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_8277;
			istream >> _rs_8277;

			for (int _rs_8278 = 0; _rs_8278 < _rs_8277; _rs_8278++)
			{
				int _rs_8276;
						
				istream >> _rs_8276;
			
						
				{
					int _rs_8255;
					istream >> _rs_8255;
		
					for (int _rs_8254 = 0; _rs_8254 < _rs_8255; _rs_8254++)
					{
								
						istream >> data.templateAtom[_rs_8276][_rs_8254];
					
					}
				}
			
			}
		}
	
		{
			int _rs_8280;
			istream >> _rs_8280;

			for (int _rs_8279 = 0; _rs_8279 < _rs_8280; _rs_8279++)
			{
						
				istream >> data.centroidAtoms[_rs_8279];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_8304;
			istream >> _rs_8304;

			for (int _rs_8303 = 0; _rs_8303 < _rs_8304; _rs_8303++)
			{
						
				{
					int _rs_8282;
					istream >> _rs_8282;
		
					for (int _rs_8281 = 0; _rs_8281 < _rs_8282; _rs_8281++)
					{
								
						istream >> data.bondLengths[_rs_8303][_rs_8281];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_8372;
			istream >> _rs_8372;

			for (int _rs_8373 = 0; _rs_8373 < _rs_8372; _rs_8373++)
			{
				int _rs_8371;
						
				istream >> _rs_8371;
			
						
				{
					int _rs_8310;
					istream >> _rs_8310;
		
					for (int _rs_8309 = 0; _rs_8309 < _rs_8310; _rs_8309++)
					{
								
						int _rs_8305;
						istream >> _rs_8305;
						data.chiDependent[_rs_8371][_rs_8309] = (bool)_rs_8305;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCCYS(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CCYS;
	data.name3Char = "CCYS";

		{
			int _rs_8379;
			istream >> _rs_8379;

			for (int _rs_8380 = 0; _rs_8380 < _rs_8379; _rs_8380++)
			{
				int _rs_8378;
						
				istream >> _rs_8378;
			
						
				{
					int _rs_8375;
					istream >> _rs_8375;
		
					for (int _rs_8374 = 0; _rs_8374 < _rs_8375; _rs_8374++)
					{
								
						data.atomOrders[_rs_8378][_rs_8374] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_8382;
			istream >> _rs_8382;

			for (int _rs_8381 = 0; _rs_8381 < _rs_8382; _rs_8381++)
			{
						
				istream >> data.acceptorList[_rs_8381];
			
			}
		}
	
		int _rs_8383;
		istream >> _rs_8383;
		data.polar = (bool)_rs_8383;
		{
			int _rs_8385;
			istream >> _rs_8385;

			for (int _rs_8386 = 0; _rs_8386 < _rs_8385; _rs_8386++)
			{
				int _rs_8384;
						
				istream >> _rs_8384;
			
						
				data.templateCoords[_rs_8384] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_8390;
			istream >> _rs_8390;

			for (int _rs_8389 = 0; _rs_8389 < _rs_8390; _rs_8389++)
			{
						
				{
					int _rs_8388;
					istream >> _rs_8388;
		
					for (int _rs_8387 = 0; _rs_8387 < _rs_8388; _rs_8387++)
					{
								
						istream >> data.acceptorBase[_rs_8389][_rs_8387];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_8416;
			istream >> _rs_8416;

			for (int _rs_8417 = 0; _rs_8417 < _rs_8416; _rs_8417++)
			{
				int _rs_8415;
						
				istream >> _rs_8415;
			
						
				{
					int _rs_8392;
					istream >> _rs_8392;
		
					for (int _rs_8391 = 0; _rs_8391 < _rs_8392; _rs_8391++)
					{
								
						istream >> data.templateAtom[_rs_8415][_rs_8391];
					
					}
				}
			
			}
		}
	
		{
			int _rs_8421;
			istream >> _rs_8421;

			for (int _rs_8420 = 0; _rs_8420 < _rs_8421; _rs_8420++)
			{
						
				{
					int _rs_8419;
					istream >> _rs_8419;
		
					for (int _rs_8418 = 0; _rs_8418 < _rs_8419; _rs_8418++)
					{
								
						istream >> data.chiAtoms[_rs_8420][_rs_8418];
					
					}
				}
			
			}
		}
	
		{
			int _rs_8423;
			istream >> _rs_8423;

			for (int _rs_8422 = 0; _rs_8422 < _rs_8423; _rs_8422++)
			{
						
				istream >> data.centroidAtoms[_rs_8422];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_8449;
			istream >> _rs_8449;

			for (int _rs_8448 = 0; _rs_8448 < _rs_8449; _rs_8448++)
			{
						
				{
					int _rs_8425;
					istream >> _rs_8425;
		
					for (int _rs_8424 = 0; _rs_8424 < _rs_8425; _rs_8424++)
					{
								
						istream >> data.bondLengths[_rs_8448][_rs_8424];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_8523;
			istream >> _rs_8523;

			for (int _rs_8524 = 0; _rs_8524 < _rs_8523; _rs_8524++)
			{
				int _rs_8522;
						
				istream >> _rs_8522;
			
						
				{
					int _rs_8455;
					istream >> _rs_8455;
		
					for (int _rs_8454 = 0; _rs_8454 < _rs_8455; _rs_8454++)
					{
								
						int _rs_8450;
						istream >> _rs_8450;
						data.chiDependent[_rs_8522][_rs_8454] = (bool)_rs_8450;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCASP(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CASP;
	data.name3Char = "CASP";

		{
			int _rs_8530;
			istream >> _rs_8530;

			for (int _rs_8531 = 0; _rs_8531 < _rs_8530; _rs_8531++)
			{
				int _rs_8529;
						
				istream >> _rs_8529;
			
						
				{
					int _rs_8526;
					istream >> _rs_8526;
		
					for (int _rs_8525 = 0; _rs_8525 < _rs_8526; _rs_8525++)
					{
								
						data.atomOrders[_rs_8529][_rs_8525] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_8533;
			istream >> _rs_8533;

			for (int _rs_8532 = 0; _rs_8532 < _rs_8533; _rs_8532++)
			{
						
				istream >> data.acceptorList[_rs_8532];
			
			}
		}
	
		int _rs_8534;
		istream >> _rs_8534;
		data.polar = (bool)_rs_8534;
		{
			int _rs_8536;
			istream >> _rs_8536;

			for (int _rs_8537 = 0; _rs_8537 < _rs_8536; _rs_8537++)
			{
				int _rs_8535;
						
				istream >> _rs_8535;
			
						
				data.templateCoords[_rs_8535] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_8545;
			istream >> _rs_8545;

			for (int _rs_8544 = 0; _rs_8544 < _rs_8545; _rs_8544++)
			{
						
				{
					int _rs_8539;
					istream >> _rs_8539;
		
					for (int _rs_8538 = 0; _rs_8538 < _rs_8539; _rs_8538++)
					{
								
						istream >> data.acceptorBase[_rs_8544][_rs_8538];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_8573;
			istream >> _rs_8573;

			for (int _rs_8574 = 0; _rs_8574 < _rs_8573; _rs_8574++)
			{
				int _rs_8572;
						
				istream >> _rs_8572;
			
						
				{
					int _rs_8547;
					istream >> _rs_8547;
		
					for (int _rs_8546 = 0; _rs_8546 < _rs_8547; _rs_8546++)
					{
								
						istream >> data.templateAtom[_rs_8572][_rs_8546];
					
					}
				}
			
			}
		}
	
		{
			int _rs_8580;
			istream >> _rs_8580;

			for (int _rs_8579 = 0; _rs_8579 < _rs_8580; _rs_8579++)
			{
						
				{
					int _rs_8576;
					istream >> _rs_8576;
		
					for (int _rs_8575 = 0; _rs_8575 < _rs_8576; _rs_8575++)
					{
								
						istream >> data.chiAtoms[_rs_8579][_rs_8575];
					
					}
				}
			
			}
		}
	
		{
			int _rs_8582;
			istream >> _rs_8582;

			for (int _rs_8581 = 0; _rs_8581 < _rs_8582; _rs_8581++)
			{
						
				istream >> data.centroidAtoms[_rs_8581];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_8610;
			istream >> _rs_8610;

			for (int _rs_8609 = 0; _rs_8609 < _rs_8610; _rs_8609++)
			{
						
				{
					int _rs_8584;
					istream >> _rs_8584;
		
					for (int _rs_8583 = 0; _rs_8583 < _rs_8584; _rs_8583++)
					{
								
						istream >> data.bondLengths[_rs_8609][_rs_8583];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_8690;
			istream >> _rs_8690;

			for (int _rs_8691 = 0; _rs_8691 < _rs_8690; _rs_8691++)
			{
				int _rs_8689;
						
				istream >> _rs_8689;
			
						
				{
					int _rs_8616;
					istream >> _rs_8616;
		
					for (int _rs_8615 = 0; _rs_8615 < _rs_8616; _rs_8615++)
					{
								
						int _rs_8611;
						istream >> _rs_8611;
						data.chiDependent[_rs_8689][_rs_8615] = (bool)_rs_8611;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCGLU(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CGLU;
	data.name3Char = "CGLU";

		{
			int _rs_8697;
			istream >> _rs_8697;

			for (int _rs_8698 = 0; _rs_8698 < _rs_8697; _rs_8698++)
			{
				int _rs_8696;
						
				istream >> _rs_8696;
			
						
				{
					int _rs_8693;
					istream >> _rs_8693;
		
					for (int _rs_8692 = 0; _rs_8692 < _rs_8693; _rs_8692++)
					{
								
						data.atomOrders[_rs_8696][_rs_8692] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_8700;
			istream >> _rs_8700;

			for (int _rs_8699 = 0; _rs_8699 < _rs_8700; _rs_8699++)
			{
						
				istream >> data.acceptorList[_rs_8699];
			
			}
		}
	
		int _rs_8701;
		istream >> _rs_8701;
		data.polar = (bool)_rs_8701;
		{
			int _rs_8703;
			istream >> _rs_8703;

			for (int _rs_8704 = 0; _rs_8704 < _rs_8703; _rs_8704++)
			{
				int _rs_8702;
						
				istream >> _rs_8702;
			
						
				data.templateCoords[_rs_8702] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_8712;
			istream >> _rs_8712;

			for (int _rs_8711 = 0; _rs_8711 < _rs_8712; _rs_8711++)
			{
						
				{
					int _rs_8706;
					istream >> _rs_8706;
		
					for (int _rs_8705 = 0; _rs_8705 < _rs_8706; _rs_8705++)
					{
								
						istream >> data.acceptorBase[_rs_8711][_rs_8705];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_8746;
			istream >> _rs_8746;

			for (int _rs_8747 = 0; _rs_8747 < _rs_8746; _rs_8747++)
			{
				int _rs_8745;
						
				istream >> _rs_8745;
			
						
				{
					int _rs_8714;
					istream >> _rs_8714;
		
					for (int _rs_8713 = 0; _rs_8713 < _rs_8714; _rs_8713++)
					{
								
						istream >> data.templateAtom[_rs_8745][_rs_8713];
					
					}
				}
			
			}
		}
	
		{
			int _rs_8755;
			istream >> _rs_8755;

			for (int _rs_8754 = 0; _rs_8754 < _rs_8755; _rs_8754++)
			{
						
				{
					int _rs_8749;
					istream >> _rs_8749;
		
					for (int _rs_8748 = 0; _rs_8748 < _rs_8749; _rs_8748++)
					{
								
						istream >> data.chiAtoms[_rs_8754][_rs_8748];
					
					}
				}
			
			}
		}
	
		{
			int _rs_8757;
			istream >> _rs_8757;

			for (int _rs_8756 = 0; _rs_8756 < _rs_8757; _rs_8756++)
			{
						
				istream >> data.centroidAtoms[_rs_8756];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_8791;
			istream >> _rs_8791;

			for (int _rs_8790 = 0; _rs_8790 < _rs_8791; _rs_8790++)
			{
						
				{
					int _rs_8759;
					istream >> _rs_8759;
		
					for (int _rs_8758 = 0; _rs_8758 < _rs_8759; _rs_8758++)
					{
								
						istream >> data.bondLengths[_rs_8790][_rs_8758];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_8889;
			istream >> _rs_8889;

			for (int _rs_8890 = 0; _rs_8890 < _rs_8889; _rs_8890++)
			{
				int _rs_8888;
						
				istream >> _rs_8888;
			
						
				{
					int _rs_8797;
					istream >> _rs_8797;
		
					for (int _rs_8796 = 0; _rs_8796 < _rs_8797; _rs_8796++)
					{
								
						int _rs_8792;
						istream >> _rs_8792;
						data.chiDependent[_rs_8888][_rs_8796] = (bool)_rs_8792;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCPHE(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CPHE;
	data.name3Char = "CPHE";

		{
			int _rs_8896;
			istream >> _rs_8896;

			for (int _rs_8897 = 0; _rs_8897 < _rs_8896; _rs_8897++)
			{
				int _rs_8895;
						
				istream >> _rs_8895;
			
						
				{
					int _rs_8892;
					istream >> _rs_8892;
		
					for (int _rs_8891 = 0; _rs_8891 < _rs_8892; _rs_8891++)
					{
								
						data.atomOrders[_rs_8895][_rs_8891] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_8899;
			istream >> _rs_8899;

			for (int _rs_8898 = 0; _rs_8898 < _rs_8899; _rs_8898++)
			{
						
				istream >> data.acceptorList[_rs_8898];
			
			}
		}
	
		int _rs_8900;
		istream >> _rs_8900;
		data.polar = (bool)_rs_8900;
		{
			int _rs_8902;
			istream >> _rs_8902;

			for (int _rs_8903 = 0; _rs_8903 < _rs_8902; _rs_8903++)
			{
				int _rs_8901;
						
				istream >> _rs_8901;
			
						
				data.templateCoords[_rs_8901] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_8907;
			istream >> _rs_8907;

			for (int _rs_8906 = 0; _rs_8906 < _rs_8907; _rs_8906++)
			{
						
				{
					int _rs_8905;
					istream >> _rs_8905;
		
					for (int _rs_8904 = 0; _rs_8904 < _rs_8905; _rs_8904++)
					{
								
						istream >> data.acceptorBase[_rs_8906][_rs_8904];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_8951;
			istream >> _rs_8951;

			for (int _rs_8952 = 0; _rs_8952 < _rs_8951; _rs_8952++)
			{
				int _rs_8950;
						
				istream >> _rs_8950;
			
						
				{
					int _rs_8909;
					istream >> _rs_8909;
		
					for (int _rs_8908 = 0; _rs_8908 < _rs_8909; _rs_8908++)
					{
								
						istream >> data.templateAtom[_rs_8950][_rs_8908];
					
					}
				}
			
			}
		}
	
		{
			int _rs_8958;
			istream >> _rs_8958;

			for (int _rs_8957 = 0; _rs_8957 < _rs_8958; _rs_8957++)
			{
						
				{
					int _rs_8954;
					istream >> _rs_8954;
		
					for (int _rs_8953 = 0; _rs_8953 < _rs_8954; _rs_8953++)
					{
								
						istream >> data.chiAtoms[_rs_8957][_rs_8953];
					
					}
				}
			
			}
		}
	
		{
			int _rs_8960;
			istream >> _rs_8960;

			for (int _rs_8959 = 0; _rs_8959 < _rs_8960; _rs_8959++)
			{
						
				istream >> data.centroidAtoms[_rs_8959];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_9004;
			istream >> _rs_9004;

			for (int _rs_9003 = 0; _rs_9003 < _rs_9004; _rs_9003++)
			{
						
				{
					int _rs_8962;
					istream >> _rs_8962;
		
					for (int _rs_8961 = 0; _rs_8961 < _rs_8962; _rs_8961++)
					{
								
						istream >> data.bondLengths[_rs_9003][_rs_8961];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_9132;
			istream >> _rs_9132;

			for (int _rs_9133 = 0; _rs_9133 < _rs_9132; _rs_9133++)
			{
				int _rs_9131;
						
				istream >> _rs_9131;
			
						
				{
					int _rs_9010;
					istream >> _rs_9010;
		
					for (int _rs_9009 = 0; _rs_9009 < _rs_9010; _rs_9009++)
					{
								
						int _rs_9005;
						istream >> _rs_9005;
						data.chiDependent[_rs_9131][_rs_9009] = (bool)_rs_9005;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCGLY(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CGLY;
	data.name3Char = "CGLY";

		{
			int _rs_9139;
			istream >> _rs_9139;

			for (int _rs_9140 = 0; _rs_9140 < _rs_9139; _rs_9140++)
			{
				int _rs_9138;
						
				istream >> _rs_9138;
			
						
				{
					int _rs_9135;
					istream >> _rs_9135;
		
					for (int _rs_9134 = 0; _rs_9134 < _rs_9135; _rs_9134++)
					{
								
						data.atomOrders[_rs_9138][_rs_9134] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_9142;
			istream >> _rs_9142;

			for (int _rs_9141 = 0; _rs_9141 < _rs_9142; _rs_9141++)
			{
						
				istream >> data.acceptorList[_rs_9141];
			
			}
		}
	
		int _rs_9143;
		istream >> _rs_9143;
		data.polar = (bool)_rs_9143;
		{
			int _rs_9145;
			istream >> _rs_9145;

			for (int _rs_9146 = 0; _rs_9146 < _rs_9145; _rs_9146++)
			{
				int _rs_9144;
						
				istream >> _rs_9144;
			
						
				data.templateCoords[_rs_9144] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_9150;
			istream >> _rs_9150;

			for (int _rs_9149 = 0; _rs_9149 < _rs_9150; _rs_9149++)
			{
						
				{
					int _rs_9148;
					istream >> _rs_9148;
		
					for (int _rs_9147 = 0; _rs_9147 < _rs_9148; _rs_9147++)
					{
								
						istream >> data.acceptorBase[_rs_9149][_rs_9147];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_9168;
			istream >> _rs_9168;

			for (int _rs_9169 = 0; _rs_9169 < _rs_9168; _rs_9169++)
			{
				int _rs_9167;
						
				istream >> _rs_9167;
			
						
				{
					int _rs_9152;
					istream >> _rs_9152;
		
					for (int _rs_9151 = 0; _rs_9151 < _rs_9152; _rs_9151++)
					{
								
						istream >> data.templateAtom[_rs_9167][_rs_9151];
					
					}
				}
			
			}
		}
	
		{
			int _rs_9171;
			istream >> _rs_9171;

			for (int _rs_9170 = 0; _rs_9170 < _rs_9171; _rs_9170++)
			{
						
				istream >> data.centroidAtoms[_rs_9170];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_9189;
			istream >> _rs_9189;

			for (int _rs_9188 = 0; _rs_9188 < _rs_9189; _rs_9188++)
			{
						
				{
					int _rs_9173;
					istream >> _rs_9173;
		
					for (int _rs_9172 = 0; _rs_9172 < _rs_9173; _rs_9172++)
					{
								
						istream >> data.bondLengths[_rs_9188][_rs_9172];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_9239;
			istream >> _rs_9239;

			for (int _rs_9240 = 0; _rs_9240 < _rs_9239; _rs_9240++)
			{
				int _rs_9238;
						
				istream >> _rs_9238;
			
						
				{
					int _rs_9195;
					istream >> _rs_9195;
		
					for (int _rs_9194 = 0; _rs_9194 < _rs_9195; _rs_9194++)
					{
								
						int _rs_9190;
						istream >> _rs_9190;
						data.chiDependent[_rs_9238][_rs_9194] = (bool)_rs_9190;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCHIS(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CHIS;
	data.name3Char = "CHIS";

		{
			int _rs_9246;
			istream >> _rs_9246;

			for (int _rs_9247 = 0; _rs_9247 < _rs_9246; _rs_9247++)
			{
				int _rs_9245;
						
				istream >> _rs_9245;
			
						
				{
					int _rs_9242;
					istream >> _rs_9242;
		
					for (int _rs_9241 = 0; _rs_9241 < _rs_9242; _rs_9241++)
					{
								
						data.atomOrders[_rs_9245][_rs_9241] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_9249;
			istream >> _rs_9249;

			for (int _rs_9248 = 0; _rs_9248 < _rs_9249; _rs_9248++)
			{
						
				istream >> data.acceptorList[_rs_9248];
			
			}
		}
	
		int _rs_9250;
		istream >> _rs_9250;
		data.polar = (bool)_rs_9250;
		{
			int _rs_9252;
			istream >> _rs_9252;

			for (int _rs_9253 = 0; _rs_9253 < _rs_9252; _rs_9253++)
			{
				int _rs_9251;
						
				istream >> _rs_9251;
			
						
				data.templateCoords[_rs_9251] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_9259;
			istream >> _rs_9259;

			for (int _rs_9258 = 0; _rs_9258 < _rs_9259; _rs_9258++)
			{
						
				{
					int _rs_9255;
					istream >> _rs_9255;
		
					for (int _rs_9254 = 0; _rs_9254 < _rs_9255; _rs_9254++)
					{
								
						istream >> data.acceptorBase[_rs_9258][_rs_9254];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_9297;
			istream >> _rs_9297;

			for (int _rs_9298 = 0; _rs_9298 < _rs_9297; _rs_9298++)
			{
				int _rs_9296;
						
				istream >> _rs_9296;
			
						
				{
					int _rs_9261;
					istream >> _rs_9261;
		
					for (int _rs_9260 = 0; _rs_9260 < _rs_9261; _rs_9260++)
					{
								
						istream >> data.templateAtom[_rs_9296][_rs_9260];
					
					}
				}
			
			}
		}
	
		{
			int _rs_9304;
			istream >> _rs_9304;

			for (int _rs_9303 = 0; _rs_9303 < _rs_9304; _rs_9303++)
			{
						
				{
					int _rs_9300;
					istream >> _rs_9300;
		
					for (int _rs_9299 = 0; _rs_9299 < _rs_9300; _rs_9299++)
					{
								
						istream >> data.chiAtoms[_rs_9303][_rs_9299];
					
					}
				}
			
			}
		}
	
		{
			int _rs_9306;
			istream >> _rs_9306;

			for (int _rs_9305 = 0; _rs_9305 < _rs_9306; _rs_9305++)
			{
						
				istream >> data.centroidAtoms[_rs_9305];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_9344;
			istream >> _rs_9344;

			for (int _rs_9343 = 0; _rs_9343 < _rs_9344; _rs_9343++)
			{
						
				{
					int _rs_9308;
					istream >> _rs_9308;
		
					for (int _rs_9307 = 0; _rs_9307 < _rs_9308; _rs_9307++)
					{
								
						istream >> data.bondLengths[_rs_9343][_rs_9307];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_9454;
			istream >> _rs_9454;

			for (int _rs_9455 = 0; _rs_9455 < _rs_9454; _rs_9455++)
			{
				int _rs_9453;
						
				istream >> _rs_9453;
			
						
				{
					int _rs_9350;
					istream >> _rs_9350;
		
					for (int _rs_9349 = 0; _rs_9349 < _rs_9350; _rs_9349++)
					{
								
						int _rs_9345;
						istream >> _rs_9345;
						data.chiDependent[_rs_9453][_rs_9349] = (bool)_rs_9345;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCILE(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CILE;
	data.name3Char = "CILE";

		{
			int _rs_9461;
			istream >> _rs_9461;

			for (int _rs_9462 = 0; _rs_9462 < _rs_9461; _rs_9462++)
			{
				int _rs_9460;
						
				istream >> _rs_9460;
			
						
				{
					int _rs_9457;
					istream >> _rs_9457;
		
					for (int _rs_9456 = 0; _rs_9456 < _rs_9457; _rs_9456++)
					{
								
						data.atomOrders[_rs_9460][_rs_9456] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_9464;
			istream >> _rs_9464;

			for (int _rs_9463 = 0; _rs_9463 < _rs_9464; _rs_9463++)
			{
						
				istream >> data.acceptorList[_rs_9463];
			
			}
		}
	
		int _rs_9465;
		istream >> _rs_9465;
		data.polar = (bool)_rs_9465;
		{
			int _rs_9467;
			istream >> _rs_9467;

			for (int _rs_9468 = 0; _rs_9468 < _rs_9467; _rs_9468++)
			{
				int _rs_9466;
						
				istream >> _rs_9466;
			
						
				data.templateCoords[_rs_9466] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_9472;
			istream >> _rs_9472;

			for (int _rs_9471 = 0; _rs_9471 < _rs_9472; _rs_9471++)
			{
						
				{
					int _rs_9470;
					istream >> _rs_9470;
		
					for (int _rs_9469 = 0; _rs_9469 < _rs_9470; _rs_9469++)
					{
								
						istream >> data.acceptorBase[_rs_9471][_rs_9469];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_9514;
			istream >> _rs_9514;

			for (int _rs_9515 = 0; _rs_9515 < _rs_9514; _rs_9515++)
			{
				int _rs_9513;
						
				istream >> _rs_9513;
			
						
				{
					int _rs_9474;
					istream >> _rs_9474;
		
					for (int _rs_9473 = 0; _rs_9473 < _rs_9474; _rs_9473++)
					{
								
						istream >> data.templateAtom[_rs_9513][_rs_9473];
					
					}
				}
			
			}
		}
	
		{
			int _rs_9521;
			istream >> _rs_9521;

			for (int _rs_9520 = 0; _rs_9520 < _rs_9521; _rs_9520++)
			{
						
				{
					int _rs_9517;
					istream >> _rs_9517;
		
					for (int _rs_9516 = 0; _rs_9516 < _rs_9517; _rs_9516++)
					{
								
						istream >> data.chiAtoms[_rs_9520][_rs_9516];
					
					}
				}
			
			}
		}
	
		{
			int _rs_9523;
			istream >> _rs_9523;

			for (int _rs_9522 = 0; _rs_9522 < _rs_9523; _rs_9522++)
			{
						
				istream >> data.centroidAtoms[_rs_9522];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_9565;
			istream >> _rs_9565;

			for (int _rs_9564 = 0; _rs_9564 < _rs_9565; _rs_9564++)
			{
						
				{
					int _rs_9525;
					istream >> _rs_9525;
		
					for (int _rs_9524 = 0; _rs_9524 < _rs_9525; _rs_9524++)
					{
								
						istream >> data.bondLengths[_rs_9564][_rs_9524];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_9687;
			istream >> _rs_9687;

			for (int _rs_9688 = 0; _rs_9688 < _rs_9687; _rs_9688++)
			{
				int _rs_9686;
						
				istream >> _rs_9686;
			
						
				{
					int _rs_9571;
					istream >> _rs_9571;
		
					for (int _rs_9570 = 0; _rs_9570 < _rs_9571; _rs_9570++)
					{
								
						int _rs_9566;
						istream >> _rs_9566;
						data.chiDependent[_rs_9686][_rs_9570] = (bool)_rs_9566;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCLYS(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CLYS;
	data.name3Char = "CLYS";

		{
			int _rs_9694;
			istream >> _rs_9694;

			for (int _rs_9695 = 0; _rs_9695 < _rs_9694; _rs_9695++)
			{
				int _rs_9693;
						
				istream >> _rs_9693;
			
						
				{
					int _rs_9690;
					istream >> _rs_9690;
		
					for (int _rs_9689 = 0; _rs_9689 < _rs_9690; _rs_9689++)
					{
								
						data.atomOrders[_rs_9693][_rs_9689] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_9697;
			istream >> _rs_9697;

			for (int _rs_9696 = 0; _rs_9696 < _rs_9697; _rs_9696++)
			{
						
				istream >> data.acceptorList[_rs_9696];
			
			}
		}
	
		int _rs_9698;
		istream >> _rs_9698;
		data.polar = (bool)_rs_9698;
		{
			int _rs_9700;
			istream >> _rs_9700;

			for (int _rs_9701 = 0; _rs_9701 < _rs_9700; _rs_9701++)
			{
				int _rs_9699;
						
				istream >> _rs_9699;
			
						
				data.templateCoords[_rs_9699] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_9705;
			istream >> _rs_9705;

			for (int _rs_9704 = 0; _rs_9704 < _rs_9705; _rs_9704++)
			{
						
				{
					int _rs_9703;
					istream >> _rs_9703;
		
					for (int _rs_9702 = 0; _rs_9702 < _rs_9703; _rs_9702++)
					{
								
						istream >> data.acceptorBase[_rs_9704][_rs_9702];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_9753;
			istream >> _rs_9753;

			for (int _rs_9754 = 0; _rs_9754 < _rs_9753; _rs_9754++)
			{
				int _rs_9752;
						
				istream >> _rs_9752;
			
						
				{
					int _rs_9707;
					istream >> _rs_9707;
		
					for (int _rs_9706 = 0; _rs_9706 < _rs_9707; _rs_9706++)
					{
								
						istream >> data.templateAtom[_rs_9752][_rs_9706];
					
					}
				}
			
			}
		}
	
		{
			int _rs_9764;
			istream >> _rs_9764;

			for (int _rs_9763 = 0; _rs_9763 < _rs_9764; _rs_9763++)
			{
						
				{
					int _rs_9756;
					istream >> _rs_9756;
		
					for (int _rs_9755 = 0; _rs_9755 < _rs_9756; _rs_9755++)
					{
								
						istream >> data.chiAtoms[_rs_9763][_rs_9755];
					
					}
				}
			
			}
		}
	
		{
			int _rs_9766;
			istream >> _rs_9766;

			for (int _rs_9765 = 0; _rs_9765 < _rs_9766; _rs_9765++)
			{
						
				istream >> data.centroidAtoms[_rs_9765];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_9814;
			istream >> _rs_9814;

			for (int _rs_9813 = 0; _rs_9813 < _rs_9814; _rs_9813++)
			{
						
				{
					int _rs_9768;
					istream >> _rs_9768;
		
					for (int _rs_9767 = 0; _rs_9767 < _rs_9768; _rs_9767++)
					{
								
						istream >> data.bondLengths[_rs_9813][_rs_9767];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_9954;
			istream >> _rs_9954;

			for (int _rs_9955 = 0; _rs_9955 < _rs_9954; _rs_9955++)
			{
				int _rs_9953;
						
				istream >> _rs_9953;
			
						
				{
					int _rs_9820;
					istream >> _rs_9820;
		
					for (int _rs_9819 = 0; _rs_9819 < _rs_9820; _rs_9819++)
					{
								
						int _rs_9815;
						istream >> _rs_9815;
						data.chiDependent[_rs_9953][_rs_9819] = (bool)_rs_9815;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCLEU(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CLEU;
	data.name3Char = "CLEU";

		{
			int _rs_9961;
			istream >> _rs_9961;

			for (int _rs_9962 = 0; _rs_9962 < _rs_9961; _rs_9962++)
			{
				int _rs_9960;
						
				istream >> _rs_9960;
			
						
				{
					int _rs_9957;
					istream >> _rs_9957;
		
					for (int _rs_9956 = 0; _rs_9956 < _rs_9957; _rs_9956++)
					{
								
						data.atomOrders[_rs_9960][_rs_9956] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_9964;
			istream >> _rs_9964;

			for (int _rs_9963 = 0; _rs_9963 < _rs_9964; _rs_9963++)
			{
						
				istream >> data.acceptorList[_rs_9963];
			
			}
		}
	
		int _rs_9965;
		istream >> _rs_9965;
		data.polar = (bool)_rs_9965;
		{
			int _rs_9967;
			istream >> _rs_9967;

			for (int _rs_9968 = 0; _rs_9968 < _rs_9967; _rs_9968++)
			{
				int _rs_9966;
						
				istream >> _rs_9966;
			
						
				data.templateCoords[_rs_9966] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_9972;
			istream >> _rs_9972;

			for (int _rs_9971 = 0; _rs_9971 < _rs_9972; _rs_9971++)
			{
						
				{
					int _rs_9970;
					istream >> _rs_9970;
		
					for (int _rs_9969 = 0; _rs_9969 < _rs_9970; _rs_9969++)
					{
								
						istream >> data.acceptorBase[_rs_9971][_rs_9969];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_10014;
			istream >> _rs_10014;

			for (int _rs_10015 = 0; _rs_10015 < _rs_10014; _rs_10015++)
			{
				int _rs_10013;
						
				istream >> _rs_10013;
			
						
				{
					int _rs_9974;
					istream >> _rs_9974;
		
					for (int _rs_9973 = 0; _rs_9973 < _rs_9974; _rs_9973++)
					{
								
						istream >> data.templateAtom[_rs_10013][_rs_9973];
					
					}
				}
			
			}
		}
	
		{
			int _rs_10021;
			istream >> _rs_10021;

			for (int _rs_10020 = 0; _rs_10020 < _rs_10021; _rs_10020++)
			{
						
				{
					int _rs_10017;
					istream >> _rs_10017;
		
					for (int _rs_10016 = 0; _rs_10016 < _rs_10017; _rs_10016++)
					{
								
						istream >> data.chiAtoms[_rs_10020][_rs_10016];
					
					}
				}
			
			}
		}
	
		{
			int _rs_10023;
			istream >> _rs_10023;

			for (int _rs_10022 = 0; _rs_10022 < _rs_10023; _rs_10022++)
			{
						
				istream >> data.centroidAtoms[_rs_10022];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_10065;
			istream >> _rs_10065;

			for (int _rs_10064 = 0; _rs_10064 < _rs_10065; _rs_10064++)
			{
						
				{
					int _rs_10025;
					istream >> _rs_10025;
		
					for (int _rs_10024 = 0; _rs_10024 < _rs_10025; _rs_10024++)
					{
								
						istream >> data.bondLengths[_rs_10064][_rs_10024];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_10187;
			istream >> _rs_10187;

			for (int _rs_10188 = 0; _rs_10188 < _rs_10187; _rs_10188++)
			{
				int _rs_10186;
						
				istream >> _rs_10186;
			
						
				{
					int _rs_10071;
					istream >> _rs_10071;
		
					for (int _rs_10070 = 0; _rs_10070 < _rs_10071; _rs_10070++)
					{
								
						int _rs_10066;
						istream >> _rs_10066;
						data.chiDependent[_rs_10186][_rs_10070] = (bool)_rs_10066;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCMET(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CMET;
	data.name3Char = "CMET";

		{
			int _rs_10194;
			istream >> _rs_10194;

			for (int _rs_10195 = 0; _rs_10195 < _rs_10194; _rs_10195++)
			{
				int _rs_10193;
						
				istream >> _rs_10193;
			
						
				{
					int _rs_10190;
					istream >> _rs_10190;
		
					for (int _rs_10189 = 0; _rs_10189 < _rs_10190; _rs_10189++)
					{
								
						data.atomOrders[_rs_10193][_rs_10189] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_10197;
			istream >> _rs_10197;

			for (int _rs_10196 = 0; _rs_10196 < _rs_10197; _rs_10196++)
			{
						
				istream >> data.acceptorList[_rs_10196];
			
			}
		}
	
		int _rs_10198;
		istream >> _rs_10198;
		data.polar = (bool)_rs_10198;
		{
			int _rs_10200;
			istream >> _rs_10200;

			for (int _rs_10201 = 0; _rs_10201 < _rs_10200; _rs_10201++)
			{
				int _rs_10199;
						
				istream >> _rs_10199;
			
						
				data.templateCoords[_rs_10199] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_10205;
			istream >> _rs_10205;

			for (int _rs_10204 = 0; _rs_10204 < _rs_10205; _rs_10204++)
			{
						
				{
					int _rs_10203;
					istream >> _rs_10203;
		
					for (int _rs_10202 = 0; _rs_10202 < _rs_10203; _rs_10202++)
					{
								
						istream >> data.acceptorBase[_rs_10204][_rs_10202];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_10243;
			istream >> _rs_10243;

			for (int _rs_10244 = 0; _rs_10244 < _rs_10243; _rs_10244++)
			{
				int _rs_10242;
						
				istream >> _rs_10242;
			
						
				{
					int _rs_10207;
					istream >> _rs_10207;
		
					for (int _rs_10206 = 0; _rs_10206 < _rs_10207; _rs_10206++)
					{
								
						istream >> data.templateAtom[_rs_10242][_rs_10206];
					
					}
				}
			
			}
		}
	
		{
			int _rs_10252;
			istream >> _rs_10252;

			for (int _rs_10251 = 0; _rs_10251 < _rs_10252; _rs_10251++)
			{
						
				{
					int _rs_10246;
					istream >> _rs_10246;
		
					for (int _rs_10245 = 0; _rs_10245 < _rs_10246; _rs_10245++)
					{
								
						istream >> data.chiAtoms[_rs_10251][_rs_10245];
					
					}
				}
			
			}
		}
	
		{
			int _rs_10254;
			istream >> _rs_10254;

			for (int _rs_10253 = 0; _rs_10253 < _rs_10254; _rs_10253++)
			{
						
				istream >> data.centroidAtoms[_rs_10253];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_10292;
			istream >> _rs_10292;

			for (int _rs_10291 = 0; _rs_10291 < _rs_10292; _rs_10291++)
			{
						
				{
					int _rs_10256;
					istream >> _rs_10256;
		
					for (int _rs_10255 = 0; _rs_10255 < _rs_10256; _rs_10255++)
					{
								
						istream >> data.bondLengths[_rs_10291][_rs_10255];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_10402;
			istream >> _rs_10402;

			for (int _rs_10403 = 0; _rs_10403 < _rs_10402; _rs_10403++)
			{
				int _rs_10401;
						
				istream >> _rs_10401;
			
						
				{
					int _rs_10298;
					istream >> _rs_10298;
		
					for (int _rs_10297 = 0; _rs_10297 < _rs_10298; _rs_10297++)
					{
								
						int _rs_10293;
						istream >> _rs_10293;
						data.chiDependent[_rs_10401][_rs_10297] = (bool)_rs_10293;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCASN(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CASN;
	data.name3Char = "CASN";

		{
			int _rs_10409;
			istream >> _rs_10409;

			for (int _rs_10410 = 0; _rs_10410 < _rs_10409; _rs_10410++)
			{
				int _rs_10408;
						
				istream >> _rs_10408;
			
						
				{
					int _rs_10405;
					istream >> _rs_10405;
		
					for (int _rs_10404 = 0; _rs_10404 < _rs_10405; _rs_10404++)
					{
								
						data.atomOrders[_rs_10408][_rs_10404] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_10412;
			istream >> _rs_10412;

			for (int _rs_10411 = 0; _rs_10411 < _rs_10412; _rs_10411++)
			{
						
				istream >> data.acceptorList[_rs_10411];
			
			}
		}
	
		int _rs_10413;
		istream >> _rs_10413;
		data.polar = (bool)_rs_10413;
		{
			int _rs_10415;
			istream >> _rs_10415;

			for (int _rs_10416 = 0; _rs_10416 < _rs_10415; _rs_10416++)
			{
				int _rs_10414;
						
				istream >> _rs_10414;
			
						
				data.templateCoords[_rs_10414] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_10422;
			istream >> _rs_10422;

			for (int _rs_10421 = 0; _rs_10421 < _rs_10422; _rs_10421++)
			{
						
				{
					int _rs_10418;
					istream >> _rs_10418;
		
					for (int _rs_10417 = 0; _rs_10417 < _rs_10418; _rs_10417++)
					{
								
						istream >> data.acceptorBase[_rs_10421][_rs_10417];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_10454;
			istream >> _rs_10454;

			for (int _rs_10455 = 0; _rs_10455 < _rs_10454; _rs_10455++)
			{
				int _rs_10453;
						
				istream >> _rs_10453;
			
						
				{
					int _rs_10424;
					istream >> _rs_10424;
		
					for (int _rs_10423 = 0; _rs_10423 < _rs_10424; _rs_10423++)
					{
								
						istream >> data.templateAtom[_rs_10453][_rs_10423];
					
					}
				}
			
			}
		}
	
		{
			int _rs_10461;
			istream >> _rs_10461;

			for (int _rs_10460 = 0; _rs_10460 < _rs_10461; _rs_10460++)
			{
						
				{
					int _rs_10457;
					istream >> _rs_10457;
		
					for (int _rs_10456 = 0; _rs_10456 < _rs_10457; _rs_10456++)
					{
								
						istream >> data.chiAtoms[_rs_10460][_rs_10456];
					
					}
				}
			
			}
		}
	
		{
			int _rs_10463;
			istream >> _rs_10463;

			for (int _rs_10462 = 0; _rs_10462 < _rs_10463; _rs_10462++)
			{
						
				istream >> data.centroidAtoms[_rs_10462];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_10495;
			istream >> _rs_10495;

			for (int _rs_10494 = 0; _rs_10494 < _rs_10495; _rs_10494++)
			{
						
				{
					int _rs_10465;
					istream >> _rs_10465;
		
					for (int _rs_10464 = 0; _rs_10464 < _rs_10465; _rs_10464++)
					{
								
						istream >> data.bondLengths[_rs_10494][_rs_10464];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_10587;
			istream >> _rs_10587;

			for (int _rs_10588 = 0; _rs_10588 < _rs_10587; _rs_10588++)
			{
				int _rs_10586;
						
				istream >> _rs_10586;
			
						
				{
					int _rs_10501;
					istream >> _rs_10501;
		
					for (int _rs_10500 = 0; _rs_10500 < _rs_10501; _rs_10500++)
					{
								
						int _rs_10496;
						istream >> _rs_10496;
						data.chiDependent[_rs_10586][_rs_10500] = (bool)_rs_10496;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCPRO(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CPRO;
	data.name3Char = "CPRO";

		{
			int _rs_10594;
			istream >> _rs_10594;

			for (int _rs_10595 = 0; _rs_10595 < _rs_10594; _rs_10595++)
			{
				int _rs_10593;
						
				istream >> _rs_10593;
			
						
				{
					int _rs_10590;
					istream >> _rs_10590;
		
					for (int _rs_10589 = 0; _rs_10589 < _rs_10590; _rs_10589++)
					{
								
						data.atomOrders[_rs_10593][_rs_10589] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_10597;
			istream >> _rs_10597;

			for (int _rs_10596 = 0; _rs_10596 < _rs_10597; _rs_10596++)
			{
						
				istream >> data.acceptorList[_rs_10596];
			
			}
		}
	
		int _rs_10598;
		istream >> _rs_10598;
		data.polar = (bool)_rs_10598;
		{
			int _rs_10600;
			istream >> _rs_10600;

			for (int _rs_10601 = 0; _rs_10601 < _rs_10600; _rs_10601++)
			{
				int _rs_10599;
						
				istream >> _rs_10599;
			
						
				data.templateCoords[_rs_10599] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_10605;
			istream >> _rs_10605;

			for (int _rs_10604 = 0; _rs_10604 < _rs_10605; _rs_10604++)
			{
						
				{
					int _rs_10603;
					istream >> _rs_10603;
		
					for (int _rs_10602 = 0; _rs_10602 < _rs_10603; _rs_10602++)
					{
								
						istream >> data.acceptorBase[_rs_10604][_rs_10602];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_10637;
			istream >> _rs_10637;

			for (int _rs_10638 = 0; _rs_10638 < _rs_10637; _rs_10638++)
			{
				int _rs_10636;
						
				istream >> _rs_10636;
			
						
				{
					int _rs_10607;
					istream >> _rs_10607;
		
					for (int _rs_10606 = 0; _rs_10606 < _rs_10607; _rs_10606++)
					{
								
						istream >> data.templateAtom[_rs_10636][_rs_10606];
					
					}
				}
			
			}
		}
	
		{
			int _rs_10642;
			istream >> _rs_10642;

			for (int _rs_10641 = 0; _rs_10641 < _rs_10642; _rs_10641++)
			{
						
				{
					int _rs_10640;
					istream >> _rs_10640;
		
					for (int _rs_10639 = 0; _rs_10639 < _rs_10640; _rs_10639++)
					{
								
						istream >> data.chiAtoms[_rs_10641][_rs_10639];
					
					}
				}
			
			}
		}
	
		{
			int _rs_10644;
			istream >> _rs_10644;

			for (int _rs_10643 = 0; _rs_10643 < _rs_10644; _rs_10643++)
			{
						
				istream >> data.centroidAtoms[_rs_10643];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_10676;
			istream >> _rs_10676;

			for (int _rs_10675 = 0; _rs_10675 < _rs_10676; _rs_10675++)
			{
						
				{
					int _rs_10646;
					istream >> _rs_10646;
		
					for (int _rs_10645 = 0; _rs_10645 < _rs_10646; _rs_10645++)
					{
								
						istream >> data.bondLengths[_rs_10675][_rs_10645];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_10768;
			istream >> _rs_10768;

			for (int _rs_10769 = 0; _rs_10769 < _rs_10768; _rs_10769++)
			{
				int _rs_10767;
						
				istream >> _rs_10767;
			
						
				{
					int _rs_10682;
					istream >> _rs_10682;
		
					for (int _rs_10681 = 0; _rs_10681 < _rs_10682; _rs_10681++)
					{
								
						int _rs_10677;
						istream >> _rs_10677;
						data.chiDependent[_rs_10767][_rs_10681] = (bool)_rs_10677;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCGLN(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CGLN;
	data.name3Char = "CGLN";

		{
			int _rs_10775;
			istream >> _rs_10775;

			for (int _rs_10776 = 0; _rs_10776 < _rs_10775; _rs_10776++)
			{
				int _rs_10774;
						
				istream >> _rs_10774;
			
						
				{
					int _rs_10771;
					istream >> _rs_10771;
		
					for (int _rs_10770 = 0; _rs_10770 < _rs_10771; _rs_10770++)
					{
								
						data.atomOrders[_rs_10774][_rs_10770] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_10778;
			istream >> _rs_10778;

			for (int _rs_10777 = 0; _rs_10777 < _rs_10778; _rs_10777++)
			{
						
				istream >> data.acceptorList[_rs_10777];
			
			}
		}
	
		int _rs_10779;
		istream >> _rs_10779;
		data.polar = (bool)_rs_10779;
		{
			int _rs_10781;
			istream >> _rs_10781;

			for (int _rs_10782 = 0; _rs_10782 < _rs_10781; _rs_10782++)
			{
				int _rs_10780;
						
				istream >> _rs_10780;
			
						
				data.templateCoords[_rs_10780] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_10788;
			istream >> _rs_10788;

			for (int _rs_10787 = 0; _rs_10787 < _rs_10788; _rs_10787++)
			{
						
				{
					int _rs_10784;
					istream >> _rs_10784;
		
					for (int _rs_10783 = 0; _rs_10783 < _rs_10784; _rs_10783++)
					{
								
						istream >> data.acceptorBase[_rs_10787][_rs_10783];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_10826;
			istream >> _rs_10826;

			for (int _rs_10827 = 0; _rs_10827 < _rs_10826; _rs_10827++)
			{
				int _rs_10825;
						
				istream >> _rs_10825;
			
						
				{
					int _rs_10790;
					istream >> _rs_10790;
		
					for (int _rs_10789 = 0; _rs_10789 < _rs_10790; _rs_10789++)
					{
								
						istream >> data.templateAtom[_rs_10825][_rs_10789];
					
					}
				}
			
			}
		}
	
		{
			int _rs_10835;
			istream >> _rs_10835;

			for (int _rs_10834 = 0; _rs_10834 < _rs_10835; _rs_10834++)
			{
						
				{
					int _rs_10829;
					istream >> _rs_10829;
		
					for (int _rs_10828 = 0; _rs_10828 < _rs_10829; _rs_10828++)
					{
								
						istream >> data.chiAtoms[_rs_10834][_rs_10828];
					
					}
				}
			
			}
		}
	
		{
			int _rs_10837;
			istream >> _rs_10837;

			for (int _rs_10836 = 0; _rs_10836 < _rs_10837; _rs_10836++)
			{
						
				istream >> data.centroidAtoms[_rs_10836];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_10875;
			istream >> _rs_10875;

			for (int _rs_10874 = 0; _rs_10874 < _rs_10875; _rs_10874++)
			{
						
				{
					int _rs_10839;
					istream >> _rs_10839;
		
					for (int _rs_10838 = 0; _rs_10838 < _rs_10839; _rs_10838++)
					{
								
						istream >> data.bondLengths[_rs_10874][_rs_10838];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_10985;
			istream >> _rs_10985;

			for (int _rs_10986 = 0; _rs_10986 < _rs_10985; _rs_10986++)
			{
				int _rs_10984;
						
				istream >> _rs_10984;
			
						
				{
					int _rs_10881;
					istream >> _rs_10881;
		
					for (int _rs_10880 = 0; _rs_10880 < _rs_10881; _rs_10880++)
					{
								
						int _rs_10876;
						istream >> _rs_10876;
						data.chiDependent[_rs_10984][_rs_10880] = (bool)_rs_10876;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCARG(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CARG;
	data.name3Char = "CARG";

		{
			int _rs_10992;
			istream >> _rs_10992;

			for (int _rs_10993 = 0; _rs_10993 < _rs_10992; _rs_10993++)
			{
				int _rs_10991;
						
				istream >> _rs_10991;
			
						
				{
					int _rs_10988;
					istream >> _rs_10988;
		
					for (int _rs_10987 = 0; _rs_10987 < _rs_10988; _rs_10987++)
					{
								
						data.atomOrders[_rs_10991][_rs_10987] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_10995;
			istream >> _rs_10995;

			for (int _rs_10994 = 0; _rs_10994 < _rs_10995; _rs_10994++)
			{
						
				istream >> data.acceptorList[_rs_10994];
			
			}
		}
	
		int _rs_10996;
		istream >> _rs_10996;
		data.polar = (bool)_rs_10996;
		{
			int _rs_10998;
			istream >> _rs_10998;

			for (int _rs_10999 = 0; _rs_10999 < _rs_10998; _rs_10999++)
			{
				int _rs_10997;
						
				istream >> _rs_10997;
			
						
				data.templateCoords[_rs_10997] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_11003;
			istream >> _rs_11003;

			for (int _rs_11002 = 0; _rs_11002 < _rs_11003; _rs_11002++)
			{
						
				{
					int _rs_11001;
					istream >> _rs_11001;
		
					for (int _rs_11000 = 0; _rs_11000 < _rs_11001; _rs_11000++)
					{
								
						istream >> data.acceptorBase[_rs_11002][_rs_11000];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_11055;
			istream >> _rs_11055;

			for (int _rs_11056 = 0; _rs_11056 < _rs_11055; _rs_11056++)
			{
				int _rs_11054;
						
				istream >> _rs_11054;
			
						
				{
					int _rs_11005;
					istream >> _rs_11005;
		
					for (int _rs_11004 = 0; _rs_11004 < _rs_11005; _rs_11004++)
					{
								
						istream >> data.templateAtom[_rs_11054][_rs_11004];
					
					}
				}
			
			}
		}
	
		{
			int _rs_11066;
			istream >> _rs_11066;

			for (int _rs_11065 = 0; _rs_11065 < _rs_11066; _rs_11065++)
			{
						
				{
					int _rs_11058;
					istream >> _rs_11058;
		
					for (int _rs_11057 = 0; _rs_11057 < _rs_11058; _rs_11057++)
					{
								
						istream >> data.chiAtoms[_rs_11065][_rs_11057];
					
					}
				}
			
			}
		}
	
		{
			int _rs_11068;
			istream >> _rs_11068;

			for (int _rs_11067 = 0; _rs_11067 < _rs_11068; _rs_11067++)
			{
						
				istream >> data.centroidAtoms[_rs_11067];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_11120;
			istream >> _rs_11120;

			for (int _rs_11119 = 0; _rs_11119 < _rs_11120; _rs_11119++)
			{
						
				{
					int _rs_11070;
					istream >> _rs_11070;
		
					for (int _rs_11069 = 0; _rs_11069 < _rs_11070; _rs_11069++)
					{
								
						istream >> data.bondLengths[_rs_11119][_rs_11069];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_11272;
			istream >> _rs_11272;

			for (int _rs_11273 = 0; _rs_11273 < _rs_11272; _rs_11273++)
			{
				int _rs_11271;
						
				istream >> _rs_11271;
			
						
				{
					int _rs_11126;
					istream >> _rs_11126;
		
					for (int _rs_11125 = 0; _rs_11125 < _rs_11126; _rs_11125++)
					{
								
						int _rs_11121;
						istream >> _rs_11121;
						data.chiDependent[_rs_11271][_rs_11125] = (bool)_rs_11121;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCSER(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CSER;
	data.name3Char = "CSER";

		{
			int _rs_11279;
			istream >> _rs_11279;

			for (int _rs_11280 = 0; _rs_11280 < _rs_11279; _rs_11280++)
			{
				int _rs_11278;
						
				istream >> _rs_11278;
			
						
				{
					int _rs_11275;
					istream >> _rs_11275;
		
					for (int _rs_11274 = 0; _rs_11274 < _rs_11275; _rs_11274++)
					{
								
						data.atomOrders[_rs_11278][_rs_11274] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_11282;
			istream >> _rs_11282;

			for (int _rs_11281 = 0; _rs_11281 < _rs_11282; _rs_11281++)
			{
						
				istream >> data.acceptorList[_rs_11281];
			
			}
		}
	
		int _rs_11283;
		istream >> _rs_11283;
		data.polar = (bool)_rs_11283;
		{
			int _rs_11285;
			istream >> _rs_11285;

			for (int _rs_11286 = 0; _rs_11286 < _rs_11285; _rs_11286++)
			{
				int _rs_11284;
						
				istream >> _rs_11284;
			
						
				data.templateCoords[_rs_11284] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_11292;
			istream >> _rs_11292;

			for (int _rs_11291 = 0; _rs_11291 < _rs_11292; _rs_11291++)
			{
						
				{
					int _rs_11288;
					istream >> _rs_11288;
		
					for (int _rs_11287 = 0; _rs_11287 < _rs_11288; _rs_11287++)
					{
								
						istream >> data.acceptorBase[_rs_11291][_rs_11287];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_11318;
			istream >> _rs_11318;

			for (int _rs_11319 = 0; _rs_11319 < _rs_11318; _rs_11319++)
			{
				int _rs_11317;
						
				istream >> _rs_11317;
			
						
				{
					int _rs_11294;
					istream >> _rs_11294;
		
					for (int _rs_11293 = 0; _rs_11293 < _rs_11294; _rs_11293++)
					{
								
						istream >> data.templateAtom[_rs_11317][_rs_11293];
					
					}
				}
			
			}
		}
	
		{
			int _rs_11325;
			istream >> _rs_11325;

			for (int _rs_11324 = 0; _rs_11324 < _rs_11325; _rs_11324++)
			{
						
				{
					int _rs_11321;
					istream >> _rs_11321;
		
					for (int _rs_11320 = 0; _rs_11320 < _rs_11321; _rs_11320++)
					{
								
						istream >> data.chiAtoms[_rs_11324][_rs_11320];
					
					}
				}
			
			}
		}
	
		{
			int _rs_11327;
			istream >> _rs_11327;

			for (int _rs_11326 = 0; _rs_11326 < _rs_11327; _rs_11326++)
			{
						
				istream >> data.centroidAtoms[_rs_11326];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_11353;
			istream >> _rs_11353;

			for (int _rs_11352 = 0; _rs_11352 < _rs_11353; _rs_11352++)
			{
						
				{
					int _rs_11329;
					istream >> _rs_11329;
		
					for (int _rs_11328 = 0; _rs_11328 < _rs_11329; _rs_11328++)
					{
								
						istream >> data.bondLengths[_rs_11352][_rs_11328];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_11427;
			istream >> _rs_11427;

			for (int _rs_11428 = 0; _rs_11428 < _rs_11427; _rs_11428++)
			{
				int _rs_11426;
						
				istream >> _rs_11426;
			
						
				{
					int _rs_11359;
					istream >> _rs_11359;
		
					for (int _rs_11358 = 0; _rs_11358 < _rs_11359; _rs_11358++)
					{
								
						int _rs_11354;
						istream >> _rs_11354;
						data.chiDependent[_rs_11426][_rs_11358] = (bool)_rs_11354;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCTHR(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CTHR;
	data.name3Char = "CTHR";

		{
			int _rs_11434;
			istream >> _rs_11434;

			for (int _rs_11435 = 0; _rs_11435 < _rs_11434; _rs_11435++)
			{
				int _rs_11433;
						
				istream >> _rs_11433;
			
						
				{
					int _rs_11430;
					istream >> _rs_11430;
		
					for (int _rs_11429 = 0; _rs_11429 < _rs_11430; _rs_11429++)
					{
								
						data.atomOrders[_rs_11433][_rs_11429] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_11437;
			istream >> _rs_11437;

			for (int _rs_11436 = 0; _rs_11436 < _rs_11437; _rs_11436++)
			{
						
				istream >> data.acceptorList[_rs_11436];
			
			}
		}
	
		int _rs_11438;
		istream >> _rs_11438;
		data.polar = (bool)_rs_11438;
		{
			int _rs_11440;
			istream >> _rs_11440;

			for (int _rs_11441 = 0; _rs_11441 < _rs_11440; _rs_11441++)
			{
				int _rs_11439;
						
				istream >> _rs_11439;
			
						
				data.templateCoords[_rs_11439] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_11447;
			istream >> _rs_11447;

			for (int _rs_11446 = 0; _rs_11446 < _rs_11447; _rs_11446++)
			{
						
				{
					int _rs_11443;
					istream >> _rs_11443;
		
					for (int _rs_11442 = 0; _rs_11442 < _rs_11443; _rs_11442++)
					{
								
						istream >> data.acceptorBase[_rs_11446][_rs_11442];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_11479;
			istream >> _rs_11479;

			for (int _rs_11480 = 0; _rs_11480 < _rs_11479; _rs_11480++)
			{
				int _rs_11478;
						
				istream >> _rs_11478;
			
						
				{
					int _rs_11449;
					istream >> _rs_11449;
		
					for (int _rs_11448 = 0; _rs_11448 < _rs_11449; _rs_11448++)
					{
								
						istream >> data.templateAtom[_rs_11478][_rs_11448];
					
					}
				}
			
			}
		}
	
		{
			int _rs_11486;
			istream >> _rs_11486;

			for (int _rs_11485 = 0; _rs_11485 < _rs_11486; _rs_11485++)
			{
						
				{
					int _rs_11482;
					istream >> _rs_11482;
		
					for (int _rs_11481 = 0; _rs_11481 < _rs_11482; _rs_11481++)
					{
								
						istream >> data.chiAtoms[_rs_11485][_rs_11481];
					
					}
				}
			
			}
		}
	
		{
			int _rs_11488;
			istream >> _rs_11488;

			for (int _rs_11487 = 0; _rs_11487 < _rs_11488; _rs_11487++)
			{
						
				istream >> data.centroidAtoms[_rs_11487];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_11520;
			istream >> _rs_11520;

			for (int _rs_11519 = 0; _rs_11519 < _rs_11520; _rs_11519++)
			{
						
				{
					int _rs_11490;
					istream >> _rs_11490;
		
					for (int _rs_11489 = 0; _rs_11489 < _rs_11490; _rs_11489++)
					{
								
						istream >> data.bondLengths[_rs_11519][_rs_11489];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_11612;
			istream >> _rs_11612;

			for (int _rs_11613 = 0; _rs_11613 < _rs_11612; _rs_11613++)
			{
				int _rs_11611;
						
				istream >> _rs_11611;
			
						
				{
					int _rs_11526;
					istream >> _rs_11526;
		
					for (int _rs_11525 = 0; _rs_11525 < _rs_11526; _rs_11525++)
					{
								
						int _rs_11521;
						istream >> _rs_11521;
						data.chiDependent[_rs_11611][_rs_11525] = (bool)_rs_11521;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCVAL(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CVAL;
	data.name3Char = "CVAL";

		{
			int _rs_11619;
			istream >> _rs_11619;

			for (int _rs_11620 = 0; _rs_11620 < _rs_11619; _rs_11620++)
			{
				int _rs_11618;
						
				istream >> _rs_11618;
			
						
				{
					int _rs_11615;
					istream >> _rs_11615;
		
					for (int _rs_11614 = 0; _rs_11614 < _rs_11615; _rs_11614++)
					{
								
						data.atomOrders[_rs_11618][_rs_11614] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_11622;
			istream >> _rs_11622;

			for (int _rs_11621 = 0; _rs_11621 < _rs_11622; _rs_11621++)
			{
						
				istream >> data.acceptorList[_rs_11621];
			
			}
		}
	
		int _rs_11623;
		istream >> _rs_11623;
		data.polar = (bool)_rs_11623;
		{
			int _rs_11625;
			istream >> _rs_11625;

			for (int _rs_11626 = 0; _rs_11626 < _rs_11625; _rs_11626++)
			{
				int _rs_11624;
						
				istream >> _rs_11624;
			
						
				data.templateCoords[_rs_11624] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_11630;
			istream >> _rs_11630;

			for (int _rs_11629 = 0; _rs_11629 < _rs_11630; _rs_11629++)
			{
						
				{
					int _rs_11628;
					istream >> _rs_11628;
		
					for (int _rs_11627 = 0; _rs_11627 < _rs_11628; _rs_11627++)
					{
								
						istream >> data.acceptorBase[_rs_11629][_rs_11627];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_11666;
			istream >> _rs_11666;

			for (int _rs_11667 = 0; _rs_11667 < _rs_11666; _rs_11667++)
			{
				int _rs_11665;
						
				istream >> _rs_11665;
			
						
				{
					int _rs_11632;
					istream >> _rs_11632;
		
					for (int _rs_11631 = 0; _rs_11631 < _rs_11632; _rs_11631++)
					{
								
						istream >> data.templateAtom[_rs_11665][_rs_11631];
					
					}
				}
			
			}
		}
	
		{
			int _rs_11671;
			istream >> _rs_11671;

			for (int _rs_11670 = 0; _rs_11670 < _rs_11671; _rs_11670++)
			{
						
				{
					int _rs_11669;
					istream >> _rs_11669;
		
					for (int _rs_11668 = 0; _rs_11668 < _rs_11669; _rs_11668++)
					{
								
						istream >> data.chiAtoms[_rs_11670][_rs_11668];
					
					}
				}
			
			}
		}
	
		{
			int _rs_11673;
			istream >> _rs_11673;

			for (int _rs_11672 = 0; _rs_11672 < _rs_11673; _rs_11672++)
			{
						
				istream >> data.centroidAtoms[_rs_11672];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_11709;
			istream >> _rs_11709;

			for (int _rs_11708 = 0; _rs_11708 < _rs_11709; _rs_11708++)
			{
						
				{
					int _rs_11675;
					istream >> _rs_11675;
		
					for (int _rs_11674 = 0; _rs_11674 < _rs_11675; _rs_11674++)
					{
								
						istream >> data.bondLengths[_rs_11708][_rs_11674];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_11813;
			istream >> _rs_11813;

			for (int _rs_11814 = 0; _rs_11814 < _rs_11813; _rs_11814++)
			{
				int _rs_11812;
						
				istream >> _rs_11812;
			
						
				{
					int _rs_11715;
					istream >> _rs_11715;
		
					for (int _rs_11714 = 0; _rs_11714 < _rs_11715; _rs_11714++)
					{
								
						int _rs_11710;
						istream >> _rs_11710;
						data.chiDependent[_rs_11812][_rs_11714] = (bool)_rs_11710;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCTRP(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CTRP;
	data.name3Char = "CTRP";

		{
			int _rs_11820;
			istream >> _rs_11820;

			for (int _rs_11821 = 0; _rs_11821 < _rs_11820; _rs_11821++)
			{
				int _rs_11819;
						
				istream >> _rs_11819;
			
						
				{
					int _rs_11816;
					istream >> _rs_11816;
		
					for (int _rs_11815 = 0; _rs_11815 < _rs_11816; _rs_11815++)
					{
								
						data.atomOrders[_rs_11819][_rs_11815] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_11823;
			istream >> _rs_11823;

			for (int _rs_11822 = 0; _rs_11822 < _rs_11823; _rs_11822++)
			{
						
				istream >> data.acceptorList[_rs_11822];
			
			}
		}
	
		int _rs_11824;
		istream >> _rs_11824;
		data.polar = (bool)_rs_11824;
		{
			int _rs_11826;
			istream >> _rs_11826;

			for (int _rs_11827 = 0; _rs_11827 < _rs_11826; _rs_11827++)
			{
				int _rs_11825;
						
				istream >> _rs_11825;
			
						
				data.templateCoords[_rs_11825] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_11831;
			istream >> _rs_11831;

			for (int _rs_11830 = 0; _rs_11830 < _rs_11831; _rs_11830++)
			{
						
				{
					int _rs_11829;
					istream >> _rs_11829;
		
					for (int _rs_11828 = 0; _rs_11828 < _rs_11829; _rs_11828++)
					{
								
						istream >> data.acceptorBase[_rs_11830][_rs_11828];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_11883;
			istream >> _rs_11883;

			for (int _rs_11884 = 0; _rs_11884 < _rs_11883; _rs_11884++)
			{
				int _rs_11882;
						
				istream >> _rs_11882;
			
						
				{
					int _rs_11833;
					istream >> _rs_11833;
		
					for (int _rs_11832 = 0; _rs_11832 < _rs_11833; _rs_11832++)
					{
								
						istream >> data.templateAtom[_rs_11882][_rs_11832];
					
					}
				}
			
			}
		}
	
		{
			int _rs_11890;
			istream >> _rs_11890;

			for (int _rs_11889 = 0; _rs_11889 < _rs_11890; _rs_11889++)
			{
						
				{
					int _rs_11886;
					istream >> _rs_11886;
		
					for (int _rs_11885 = 0; _rs_11885 < _rs_11886; _rs_11885++)
					{
								
						istream >> data.chiAtoms[_rs_11889][_rs_11885];
					
					}
				}
			
			}
		}
	
		{
			int _rs_11892;
			istream >> _rs_11892;

			for (int _rs_11891 = 0; _rs_11891 < _rs_11892; _rs_11891++)
			{
						
				istream >> data.centroidAtoms[_rs_11891];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_11944;
			istream >> _rs_11944;

			for (int _rs_11943 = 0; _rs_11943 < _rs_11944; _rs_11943++)
			{
						
				{
					int _rs_11894;
					istream >> _rs_11894;
		
					for (int _rs_11893 = 0; _rs_11893 < _rs_11894; _rs_11893++)
					{
								
						istream >> data.bondLengths[_rs_11943][_rs_11893];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_12096;
			istream >> _rs_12096;

			for (int _rs_12097 = 0; _rs_12097 < _rs_12096; _rs_12097++)
			{
				int _rs_12095;
						
				istream >> _rs_12095;
			
						
				{
					int _rs_11950;
					istream >> _rs_11950;
		
					for (int _rs_11949 = 0; _rs_11949 < _rs_11950; _rs_11949++)
					{
								
						int _rs_11945;
						istream >> _rs_11945;
						data.chiDependent[_rs_12095][_rs_11949] = (bool)_rs_11945;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

void LoadCTYR(AminoAcid& data, std::istringstream& istream)
{
	data.aminoAcid = CTYR;
	data.name3Char = "CTYR";

		{
			int _rs_12103;
			istream >> _rs_12103;

			for (int _rs_12104 = 0; _rs_12104 < _rs_12103; _rs_12104++)
			{
				int _rs_12102;
						
				istream >> _rs_12102;
			
						
				{
					int _rs_12099;
					istream >> _rs_12099;
		
					for (int _rs_12098 = 0; _rs_12098 < _rs_12099; _rs_12098++)
					{
								
						data.atomOrders[_rs_12102][_rs_12098] = ReadString(istream);
					
					}
				}
			
			}
		}
	
		{
			int _rs_12106;
			istream >> _rs_12106;

			for (int _rs_12105 = 0; _rs_12105 < _rs_12106; _rs_12105++)
			{
						
				istream >> data.acceptorList[_rs_12105];
			
			}
		}
	
		int _rs_12107;
		istream >> _rs_12107;
		data.polar = (bool)_rs_12107;
		{
			int _rs_12109;
			istream >> _rs_12109;

			for (int _rs_12110 = 0; _rs_12110 < _rs_12109; _rs_12110++)
			{
				int _rs_12108;
						
				istream >> _rs_12108;
			
						
				data.templateCoords[_rs_12108] = ReadVector3(istream);
			
			}
		}
	
		{
			int _rs_12116;
			istream >> _rs_12116;

			for (int _rs_12115 = 0; _rs_12115 < _rs_12116; _rs_12115++)
			{
						
				{
					int _rs_12112;
					istream >> _rs_12112;
		
					for (int _rs_12111 = 0; _rs_12111 < _rs_12112; _rs_12111++)
					{
								
						istream >> data.acceptorBase[_rs_12115][_rs_12111];
					
					}
				}
			
			}
		}
	
		istream >> data.nHBAcceptors;
	
		{
			int _rs_12162;
			istream >> _rs_12162;

			for (int _rs_12163 = 0; _rs_12163 < _rs_12162; _rs_12163++)
			{
				int _rs_12161;
						
				istream >> _rs_12161;
			
						
				{
					int _rs_12118;
					istream >> _rs_12118;
		
					for (int _rs_12117 = 0; _rs_12117 < _rs_12118; _rs_12117++)
					{
								
						istream >> data.templateAtom[_rs_12161][_rs_12117];
					
					}
				}
			
			}
		}
	
		{
			int _rs_12171;
			istream >> _rs_12171;

			for (int _rs_12170 = 0; _rs_12170 < _rs_12171; _rs_12170++)
			{
						
				{
					int _rs_12165;
					istream >> _rs_12165;
		
					for (int _rs_12164 = 0; _rs_12164 < _rs_12165; _rs_12164++)
					{
								
						istream >> data.chiAtoms[_rs_12170][_rs_12164];
					
					}
				}
			
			}
		}
	
		{
			int _rs_12173;
			istream >> _rs_12173;

			for (int _rs_12172 = 0; _rs_12172 < _rs_12173; _rs_12172++)
			{
						
				istream >> data.centroidAtoms[_rs_12172];
			
			}
		}
	
		istream >> data.nHeavyAtoms;
	
		istream >> data.nCentroidAtoms;
	
		{
			int _rs_12219;
			istream >> _rs_12219;

			for (int _rs_12218 = 0; _rs_12218 < _rs_12219; _rs_12218++)
			{
						
				{
					int _rs_12175;
					istream >> _rs_12175;
		
					for (int _rs_12174 = 0; _rs_12174 < _rs_12175; _rs_12174++)
					{
								
						istream >> data.bondLengths[_rs_12218][_rs_12174];
					
					}
				}
			
			}
		}
	
		istream >> data.neighborAtom;
	
		istream >> data.AA_class;
	
		istream >> data.nChi;
	
		{
			int _rs_12353;
			istream >> _rs_12353;

			for (int _rs_12354 = 0; _rs_12354 < _rs_12353; _rs_12354++)
			{
				int _rs_12352;
						
				istream >> _rs_12352;
			
						
				{
					int _rs_12225;
					istream >> _rs_12225;
		
					for (int _rs_12224 = 0; _rs_12224 < _rs_12225; _rs_12224++)
					{
								
						int _rs_12220;
						istream >> _rs_12220;
						data.chiDependent[_rs_12352][_rs_12224] = (bool)_rs_12220;
					}
				}
			
			}
		}
	
		istream >> data.nTotalAtoms;
	
}

char* data_str =
"2 0  10 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  3!3HB   1  10 1!N  2!CA  1!C  1!O  2!CB  1!H  2!HA  3!1HB  3!2HB  3!3HB   "
"1 1  "
"0 "
"10 0  0.0 2.688 5.506  8  -1.147 3.806 2.455  6  -1.196 3.659 3.534  4  0.0 2.836 3.99  1  0.002 1.566 6.013  2  0.0 1.534 3.334  7  -1.181 4.628 4.033  9  -2.116 3.135 3.788  3  -0.047 0.707 3.912  5  0.912 3.366 3.715  "
"1 2 0  -1   "
"1 "
"10 0  3 -1  -1  -1   8  3 6  4  2   3  3 -1  -1  -1   4  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  2   9  3 6  4  2   6  3 -1  -1  -1   5  3 4  2  0   "
""
"1 6  "
"5 "
"1 "
"10 10 0  1  2  3  1  2  2  3  3  3   10 1  0  3  4  2  3  3  4  4  4   10 2  3  0  1  1  2  2  3  3  3   10 3  4  1  0  2  3  3  4  4  4   10 1  2  1  2  0  1  1  2  2  2   10 2  3  2  3  1  0  2  3  3  3   10 2  3  2  3  1  2  0  1  1  1   10 3  4  3  4  2  3  1  0  2  2   10 3  4  3  4  2  3  1  2  0  2   10 3  4  3  4  2  3  1  2  2  0   "
"6 "
"0 "
"0 "
"10 0  4 0  0  0  0   8  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 0  0  0  0   9  4 0  0  0  0   6  4 0  0  0  0   5  4 0  0  0  0   "
"10 "
"2 0  11 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!SG  2!HG   1  11 1!N  2!CA  1!C  1!O  2!CB  2!SG  1!H  2!HA  3!1HB  3!2HB  2!HG   "
"1 1  "
"0 "
"11 0  0.0 5.168 8.329  8  2.156 3.632 7.616  6  1.312 3.069 8.014  4  0.0 3.783 7.688  1  0.005 6.186 7.636  2  0.0 3.807 6.224  7  1.311 2.065 7.589  3  -0.025 4.704 5.76  5  -0.824 3.209 8.112  9  1.635 2.865 9.782  10  2.799 2.239 9.639  "
"1 2 0  -1   "
"1 "
"11 0  3 -1  -1  -1   8  3 6  4  9   3  3 -1  -1  -1   4  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   6  3 -1  -1  -1   5  3 4  2  0   9  3 -1  -1  -1   10  3 9  6  4   "
"1 4 2  4  6  9   "
"1 9  "
"6 "
"1 "
"11 11 0  1  2  3  1  2  2  3  3  3  4   11 1  0  3  4  2  3  3  4  4  4  5   11 2  3  0  1  1  2  2  3  3  3  4   11 3  4  1  0  2  3  3  4  4  4  5   11 1  2  1  2  0  1  1  2  2  2  3   11 2  3  2  3  1  0  2  3  3  3  4   11 2  3  2  3  1  2  0  1  1  1  2   11 3  4  3  4  2  3  1  0  2  2  3   11 3  4  3  4  2  3  1  2  0  2  3   11 3  4  3  4  2  3  1  2  2  0  1   11 4  5  4  5  3  4  2  3  3  1  0   "
"6 "
"1 "
"1 "
"11 0  4 0  0  0  0   8  4 1  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   6  4 0  0  0  0   5  4 0  0  0  0   9  4 1  0  0  0   10  4 1  0  0  0   "
"11 "
"2 0  12 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!OD1  3!OD2   1  12 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!OD1  3!OD2  1!H  2!HA  3!1HB  3!2HB   "
"3 10  11  1  "
"1 "
"12 0  0.0 6.216 11.898  8  -2.018 6.663 10.337  6  -1.208 7.31 9.999  4  0.0 6.457 10.394  9  -1.295 8.649 10.719  1  0.001 5.072 12.353  2  0.0 5.2 9.658  7  -1.294 7.47 8.924  3  -0.04 4.337 10.183  10  -2.221 9.381 10.461  5  0.909 7.016 10.17  11  -0.53 8.862 11.629  "
"3 2 9  -1   2 9  -1   2 0  -1   "
"3 "
"12 0  3 -1  -1  -1   8  3 6  4  9   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   10  3 -1  -1  -1   6  3 -1  -1  -1   5  3 4  2  0   11  3 -1  -1  -1   "
"2 4 2  4  6  9   4 4  6  9  10   "
"3 9  10  11  "
"8 "
"3 "
"12 12 0  1  2  3  1  2  2  3  3  3  4  4   12 1  0  3  4  2  3  3  4  4  4  5  5   12 2  3  0  1  1  2  2  3  3  3  4  4   12 3  4  1  0  2  3  3  4  4  4  5  5   12 1  2  1  2  0  1  1  2  2  2  3  3   12 2  3  2  3  1  0  2  3  3  3  4  4   12 2  3  2  3  1  2  0  1  1  1  2  2   12 3  4  3  4  2  3  1  0  2  2  3  3   12 3  4  3  4  2  3  1  2  0  2  3  3   12 3  4  3  4  2  3  1  2  2  0  1  1   12 4  5  4  5  3  4  2  3  3  1  0  2   12 4  5  4  5  3  4  2  3  3  1  2  0   "
"6 "
"2 "
"2 "
"12 0  4 0  0  0  0   8  4 1  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   10  4 1  1  0  0   6  4 0  0  0  0   5  4 0  0  0  0   11  4 1  1  0  0   "
"12 "
"2 0  15 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!OE1  3!OE2   1  15 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  3!OE1  3!OE2  1!H  2!HA  3!1HB  3!2HB  3!1HG  3!2HG   "
"3 14  13  1  "
"1 "
"15 0  0.0 8.591 14.761  5  -0.909 6.71 14.46  8  2.099 6.915 14.242  6  1.208 6.404 14.607  4  0.0 7.208 14.121  9  1.295 6.252 16.119  1  -0.003 9.607 14.066  2  0.0 7.3 12.666  7  1.14 5.418 14.147  10  1.297 7.203 16.651  3  0.04 8.217 12.244  14  3.171 4.946 15.648  12  2.504 5.453 16.519  13  2.699 5.254 17.694  11  0.393 5.697 16.373  "
"3 2 12  -1   2 12  -1   2 0  -1   "
"3 "
"15 0  3 -1  -1  -1   8  3 6  4  9   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   12  3 -1  -1  -1   10  3 9  6  12   6  3 -1  -1  -1   5  3 4  2  0   14  3 -1  -1  -1   13  3 -1  -1  -1   11  3 9  6  12   "
"3 4 2  4  6  9   4 4  6  9  12   4 6  9  12  13   "
"3 12  13  14  "
"9 "
"3 "
"15 15 0  1  2  3  1  2  2  3  3  3  4  4  4  5  5   15 1  0  3  4  2  3  3  4  4  4  5  5  5  6  6   15 2  3  0  1  1  2  2  3  3  3  4  4  4  5  5   15 3  4  1  0  2  3  3  4  4  4  5  5  5  6  6   15 1  2  1  2  0  1  1  2  2  2  3  3  3  4  4   15 2  3  2  3  1  0  2  3  3  3  4  4  4  5  5   15 2  3  2  3  1  2  0  1  1  1  2  2  2  3  3   15 3  4  3  4  2  3  1  0  2  2  3  3  3  4  4   15 3  4  3  4  2  3  1  2  0  2  3  3  3  4  4   15 3  4  3  4  2  3  1  2  2  0  1  1  1  2  2   15 4  5  4  5  3  4  2  3  3  1  0  2  2  3  3   15 4  5  4  5  3  4  2  3  3  1  2  0  2  3  3   15 4  5  4  5  3  4  2  3  3  1  2  2  0  1  1   15 5  6  5  6  4  5  3  4  4  2  3  3  1  0  2   15 5  6  5  6  4  5  3  4  4  2  3  3  1  2  0   "
"6 "
"3 "
"3 "
"15 0  4 0  0  0  0   8  4 1  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   12  4 1  1  0  0   10  4 1  1  0  0   6  4 0  0  0  0   5  4 0  0  0  0   14  4 1  1  1  0   13  4 1  1  1  0   11  4 1  1  0  0   "
"15 "
"2 0  20 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!CD1  3!HD1  3!CD2  3!HD2  3!CE1  3!HE1  3!CE2  3!HE2  2!CZ  2!HZ   1  20 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!CD1  3!CD2  3!CE1  3!CE2  2!CZ  1!H  3!HD1  3!HE1  2!HZ  3!HE2  3!HD2  2!HA  3!1HB  3!2HB   "
"1 1  "
"0 "
"20 19  -1.473 15.446 18.993  0  0.0 9.639 18.33  17  0.386 13.888 19.46  14  -2.389 14.148 17.555  11  -3.087 12.664 16.17  6  -1.208 10.732 16.43  4  0.0 9.881 16.826  8  -2.131 10.201 16.659  9  -1.282 12.05 17.147  1  0.002 8.494 18.783  2  0.0 8.622 16.089  7  -1.175 10.958 15.365  18  -1.42 14.49 18.474  13  0.507 11.72 18.278  10  -2.32 12.935 16.896  12  -0.314 12.408 18.073  3  -0.04 7.76 16.614  15  -3.21 14.834 17.348  5  0.909 10.441 16.602  16  -0.381 13.619 18.734  "
"1 2 0  -1   "
"1 "
"20 19  3 18  14  16   0  3 -1  -1  -1   8  3 6  4  9   15  3 14  10  18   17  3 16  12  18   18  3 -1  -1  -1   14  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   11  3 10  9  14   16  3 -1  -1  -1   10  3 -1  -1  -1   12  3 -1  -1  -1   6  3 -1  -1  -1   5  3 4  2  0   13  3 12  9  16   "
"2 4 2  4  6  9   4 4  6  9  10   "
"2 9  18  "
"11 "
"2 "
"20 20 0  1  2  3  1  2  2  3  3  3  4  5  4  5  5  6  5  6  6  7   20 1  0  3  4  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8   20 2  3  0  1  1  2  2  3  3  3  4  5  4  5  5  6  5  6  6  7   20 3  4  1  0  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8   20 1  2  1  2  0  1  1  2  2  2  3  4  3  4  4  5  4  5  5  6   20 2  3  2  3  1  0  2  3  3  3  4  5  4  5  5  6  5  6  6  7   20 2  3  2  3  1  2  0  1  1  1  2  3  2  3  3  4  3  4  4  5   20 3  4  3  4  2  3  1  0  2  2  3  4  3  4  4  5  4  5  5  6   20 3  4  3  4  2  3  1  2  0  2  3  4  3  4  4  5  4  5  5  6   20 3  4  3  4  2  3  1  2  2  0  1  2  1  2  2  3  2  3  3  4   20 4  5  4  5  3  4  2  3  3  1  0  1  2  3  1  2  3  4  2  3   20 5  6  5  6  4  5  3  4  4  2  1  0  3  4  2  3  4  5  3  4   20 4  5  4  5  3  4  2  3  3  1  2  3  0  1  3  4  1  2  2  3   20 5  6  5  6  4  5  3  4  4  2  3  4  1  0  4  5  2  3  3  4   20 5  6  5  6  4  5  3  4  4  2  1  2  3  4  0  1  2  3  1  2   20 6  7  6  7  5  6  4  5  5  3  2  3  4  5  1  0  3  4  2  3   20 5  6  5  6  4  5  3  4  4  2  3  4  1  2  2  3  0  1  1  2   20 6  7  6  7  5  6  4  5  5  3  4  5  2  3  3  4  1  0  2  3   20 6  7  6  7  5  6  4  5  5  3  2  3  2  3  1  2  1  2  0  1   20 7  8  7  8  6  7  5  6  6  4  3  4  3  4  2  3  2  3  1  0   "
"6 "
"4 "
"2 "
"20 19  4 1  1  0  0   0  4 0  0  0  0   8  4 1  0  0  0   13  4 1  1  0  0   11  4 1  1  0  0   17  4 1  1  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   18  4 1  1  0  0   16  4 1  1  0  0   10  4 1  1  0  0   12  4 1  1  0  0   6  4 0  0  0  0   15  4 1  1  0  0   5  4 0  0  0  0   14  4 1  1  0  0   "
"20 "
"2 0  7 1!C  1!O  1!N  1!H  2!CA  3!1HA  3!2HA   1  7 1!N  2!CA  1!C  1!O  1!H  3!1HA  3!2HA   "
"1 1  "
"0 "
"7 0  0.0 12.009 21.196  3  0.0 11.64 18.679  4  0.0 10.628 20.554  1  -0.003 13.039 20.521  2  0.0 10.722 19.099  5  -0.89 10.087 20.876  6  0.889 10.087 20.876  "
"1 2 0  -1   "
"1 "
"7 0  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   5  3 4  2  0   6  3 4  2  0   "
""
"1 4  "
"4 "
"1 "
"7 7 0  1  2  3  1  2  2   7 1  0  3  4  2  3  3   7 2  3  0  1  1  2  2   7 3  4  1  0  2  3  3   7 1  2  1  2  0  1  1   7 2  3  2  3  1  0  2   7 2  3  2  3  1  2  0   "
"4 "
"5 "
"0 "
"7 0  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   5  4 0  0  0  0   6  4 0  0  0  0   "
"7 "
"2 0  17 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!ND1  3!CD2  3!HD2  3!CE1  3!HE1  3!NE2  3!HE2   1  17 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!ND1  3!CD2  3!CE1  3!NE2  1!H  3!HE2  2!HA  3!1HB  3!2HB  3!HE1  3!HD2   "
"2 10  1  "
"1 "
"17 0  0.0 12.636 24.731  8  -2.133 13.566 23.169  13  -2.084 17.323 24.398  16  -0.583 17.701 25.789  6  -1.208 14.105 22.966  4  0.0 13.23 23.316  9  -1.274 15.38 23.748  1  0.154 11.426 24.913  2  0.0 12.014 22.522  7  -1.176 14.387 21.913  12  0.462 15.517 25.16  11  -0.456 15.885 24.701  3  -0.041 11.127 23.003  10  -2.284 16.304 23.58  5  0.91 13.796 23.119  15  -0.982 17.093 25.088  14  -2.778 18.163 24.418  "
"2 2 9  13   2 0  -1   "
"2 "
"17 0  3 -1  -1  -1   5  3 4  2  0   14  3 13  10  15   16  3 15  11  13   13  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   11  3 -1  -1  -1   6  3 -1  -1  -1   10  3 -1  -1  -1   8  3 6  4  9   15  3 -1  -1  -1   12  3 11  9  15   "
"2 4 2  4  6  9   4 4  6  9  10   "
"2 10  11  "
"10 "
"2 "
"17 17 0  1  2  3  1  2  2  3  3  3  4  4  5  5  6  5  6   17 1  0  3  4  2  3  3  4  4  4  5  5  6  6  7  6  7   17 2  3  0  1  1  2  2  3  3  3  4  4  5  5  6  5  6   17 3  4  1  0  2  3  3  4  4  4  5  5  6  6  7  6  7   17 1  2  1  2  0  1  1  2  2  2  3  3  4  4  5  4  5   17 2  3  2  3  1  0  2  3  3  3  4  4  5  5  6  5  6   17 2  3  2  3  1  2  0  1  1  1  2  2  3  3  4  3  4   17 3  4  3  4  2  3  1  0  2  2  3  3  4  4  5  4  5   17 3  4  3  4  2  3  1  2  0  2  3  3  4  4  5  4  5   17 3  4  3  4  2  3  1  2  2  0  1  1  2  2  3  2  3   17 4  5  4  5  3  4  2  3  3  1  0  2  3  1  2  2  3   17 4  5  4  5  3  4  2  3  3  1  2  0  1  2  3  1  2   17 5  6  5  6  4  5  3  4  4  2  3  1  0  3  4  2  3   17 5  6  5  6  4  5  3  4  4  2  1  2  3  0  1  1  2   17 6  7  6  7  5  6  4  5  5  3  2  3  4  1  0  2  3   17 5  6  5  6  4  5  3  4  4  2  2  1  2  1  2  0  1   17 6  7  6  7  5  6  4  5  5  3  3  2  3  2  3  1  0   "
"6 "
"6 "
"2 "
"17 0  4 0  0  0  0   8  4 1  0  0  0   12  4 1  1  0  0   16  4 1  1  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   11  4 1  1  0  0   6  4 0  0  0  0   10  4 1  1  0  0   14  4 1  1  0  0   5  4 0  0  0  0   15  4 1  1  0  0   13  4 1  1  0  0   "
"17 "
"2 0  19 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  2!HB  3!CG2  4!1HG2  4!2HG2  4!3HG2  3!CG1  4!1HG1  4!2HG1  3!CD1  4!1HD1  4!2HD1  4!3HD1   1  19 1!N  2!CA  1!C  1!O  2!CB  3!CG1  3!CG2  3!CD1  1!H  2!HA  2!HB  4!1HG2  4!2HG2  4!3HG2  4!1HG1  4!2HG1  4!1HD1  4!2HD1  4!3HD1   "
"1 1  "
"0 "
"19 10  2.528 13.179 26.064  0  0.0 14.267 28.087  5  -0.917 12.54 27.36  6  1.214 12.186 27.44  4  0.0 13.079 27.125  13  1.197 12.653 29.515  14  0.254 11.212 29.069  1  0.068 15.423 27.661  2  0.0 13.51 25.733  18  3.286 11.401 29.141  7  1.152 11.278 26.841  9  3.357 12.272 27.35  15  2.351 10.866 29.301  17  2.343 9.96 28.694  3  0.031 14.501 25.539  12  1.189 11.749 28.907  8  2.509 12.917 27.121  11  2.572 13.825 27.721  16  2.264 10.597 30.354  "
"1 2 0  -1   "
"1 "
"19 10  3 8  6  4   14  3 12  6  15   8  3 -1  -1  -1   3  3 -1  -1  -1   11  3 8  6  4   0  3 -1  -1  -1   1  3 -1  -1  -1   17  3 15  12  6   18  3 15  12  6   12  3 -1  -1  -1   2  3 -1  -1  -1   9  3 8  6  4   15  3 -1  -1  -1   13  3 12  6  15   7  3 6  4  12   5  3 4  2  0   4  3 -1  -1  -1   16  3 15  12  6   6  3 -1  -1  -1   "
"2 4 2  4  6  12   4 4  6  12  15   "
"3 12  8  15  "
"8 "
"3 "
"19 19 0  1  2  3  1  2  2  3  3  4  4  4  3  4  4  4  5  5  5   19 1  0  3  4  2  3  3  4  4  5  5  5  4  5  5  5  6  6  6   19 2  3  0  1  1  2  2  3  3  4  4  4  3  4  4  4  5  5  5   19 3  4  1  0  2  3  3  4  4  5  5  5  4  5  5  5  6  6  6   19 1  2  1  2  0  1  1  2  2  3  3  3  2  3  3  3  4  4  4   19 2  3  2  3  1  0  2  3  3  4  4  4  3  4  4  4  5  5  5   19 2  3  2  3  1  2  0  1  1  2  2  2  1  2  2  2  3  3  3   19 3  4  3  4  2  3  1  0  2  3  3  3  2  3  3  3  4  4  4   19 3  4  3  4  2  3  1  2  0  1  1  1  2  3  3  3  4  4  4   19 4  5  4  5  3  4  2  3  1  0  2  2  3  4  4  4  5  5  5   19 4  5  4  5  3  4  2  3  1  2  0  2  3  4  4  4  5  5  5   19 4  5  4  5  3  4  2  3  1  2  2  0  3  4  4  4  5  5  5   19 3  4  3  4  2  3  1  2  2  3  3  3  0  1  1  1  2  2  2   19 4  5  4  5  3  4  2  3  3  4  4  4  1  0  2  2  3  3  3   19 4  5  4  5  3  4  2  3  3  4  4  4  1  2  0  2  3  3  3   19 4  5  4  5  3  4  2  3  3  4  4  4  1  2  2  0  1  1  1   19 5  6  5  6  4  5  3  4  4  5  5  5  2  3  3  1  0  2  2   19 5  6  5  6  4  5  3  4  4  5  5  5  2  3  3  1  2  0  2   19 5  6  5  6  4  5  3  4  4  5  5  5  2  3  3  1  2  2  0   "
"6 "
"7 "
"2 "
"19 10  4 1  0  0  0   0  4 0  0  0  0   8  4 1  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   13  4 1  1  0  0   14  4 1  1  0  0   1  4 0  0  0  0   2  4 0  0  0  0   18  4 1  1  0  0   12  4 1  0  0  0   9  4 1  0  0  0   15  4 1  1  0  0   17  4 1  1  0  0   6  4 0  0  0  0   7  4 1  0  0  0   5  4 0  0  0  0   11  4 1  0  0  0   16  4 1  1  0  0   "
"19 "
"2 0  22 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!1HD  3!2HD  2!CE  3!1HE  3!2HE  2!NZ  3!1HZ  3!2HZ  3!3HZ   1  22 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  2!CE  2!NZ  1!H  3!1HZ  3!2HZ  3!3HZ  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  3!1HD  3!2HD  3!1HE  3!2HE   "
"1 1  "
"1 "
"22 5  0.909 15.61 30.323  21  -4.635 19.358 31.891  18  -3.797 19.917 31.819  3  -0.04 13.009 29.68  0  0.0 14.411 31.803  20  -3.747 20.332 30.899  19  -3.818 20.647 32.517  6  -1.207 15.936 30.229  4  0.0 15.013 30.404  9  -1.294 17.059 31.254  1  0.003 13.189 31.954  2  0.0 13.973 29.382  7  -1.14 16.363 29.228  15  -2.605 19.054 32.04  13  -2.45 18.358 30.014  16  -2.659 18.608 33.032  8  -2.099 15.313 30.298  17  -1.701 19.658 31.963  14  -3.408 17.308 31.085  11  -0.393 17.667 31.179  12  -2.517 17.932 31.016  10  -1.351 16.616 32.249  "
"1 2 0  -1   "
"1 "
"22 5  3 4  2  0   21  3 18  15  12   18  3 -1  -1  -1   3  3 -1  -1  -1   0  3 -1  -1  -1   20  3 18  15  12   19  3 18  15  12   6  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   15  3 -1  -1  -1   13  3 12  9  15   16  3 15  12  18   8  3 6  4  9   17  3 15  12  18   14  3 12  9  15   11  3 9  6  12   12  3 -1  -1  -1   10  3 9  6  12   "
"4 4 2  4  6  9   4 4  6  9  12   4 6  9  12  15   4 9  12  15  18   "
"1 18  "
"9 "
"1 "
"22 22 0  1  2  3  1  2  2  3  3  3  4  4  4  5  5  5  6  6  6  7  7  7   22 1  0  3  4  2  3  3  4  4  4  5  5  5  6  6  6  7  7  7  8  8  8   22 2  3  0  1  1  2  2  3  3  3  4  4  4  5  5  5  6  6  6  7  7  7   22 3  4  1  0  2  3  3  4  4  4  5  5  5  6  6  6  7  7  7  8  8  8   22 1  2  1  2  0  1  1  2  2  2  3  3  3  4  4  4  5  5  5  6  6  6   22 2  3  2  3  1  0  2  3  3  3  4  4  4  5  5  5  6  6  6  7  7  7   22 2  3  2  3  1  2  0  1  1  1  2  2  2  3  3  3  4  4  4  5  5  5   22 3  4  3  4  2  3  1  0  2  2  3  3  3  4  4  4  5  5  5  6  6  6   22 3  4  3  4  2  3  1  2  0  2  3  3  3  4  4  4  5  5  5  6  6  6   22 3  4  3  4  2  3  1  2  2  0  1  1  1  2  2  2  3  3  3  4  4  4   22 4  5  4  5  3  4  2  3  3  1  0  2  2  3  3  3  4  4  4  5  5  5   22 4  5  4  5  3  4  2  3  3  1  2  0  2  3  3  3  4  4  4  5  5  5   22 4  5  4  5  3  4  2  3  3  1  2  2  0  1  1  1  2  2  2  3  3  3   22 5  6  5  6  4  5  3  4  4  2  3  3  1  0  2  2  3  3  3  4  4  4   22 5  6  5  6  4  5  3  4  4  2  3  3  1  2  0  2  3  3  3  4  4  4   22 5  6  5  6  4  5  3  4  4  2  3  3  1  2  2  0  1  1  1  2  2  2   22 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  0  2  2  3  3  3   22 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  2  0  2  3  3  3   22 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  2  2  0  1  1  1   22 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  3  1  0  2  2   22 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  3  1  2  0  2   22 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  3  1  2  2  0   "
"6 "
"8 "
"4 "
"22 5  4 0  0  0  0   21  4 1  1  1  1   18  4 1  1  1  1   6  4 0  0  0  0   0  4 0  0  0  0   20  4 1  1  1  1   19  4 1  1  1  1   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   15  4 1  1  1  0   13  4 1  1  1  0   16  4 1  1  1  1   8  4 1  0  0  0   17  4 1  1  1  1   14  4 1  1  1  0   11  4 1  1  0  0   12  4 1  1  0  0   10  4 1  1  0  0   "
"22 "
"2 0  19 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  2!HG  3!CD1  4!1HD1  4!2HD1  4!3HD1  3!CD2  4!1HD2  4!2HD2  4!3HD2   1  19 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!CD1  3!CD2  1!H  2!HA  3!1HB  3!2HB  2!HG  4!1HD1  4!2HD1  4!3HD1  4!1HD2  4!2HD2  4!3HD2   "
"1 1  "
"0 "
"19 12  -0.518 -3.996 2.46  0  -0.559 1.422 0.0  8  -1.583 -0.567 1.397  16  -0.894 -3.98 -0.007  6  -0.53 -0.778 1.211  4  0.0 0.0 0.0  17  -2.133 -2.712 0.16  9  -0.286 -2.292 1.172  1  -1.545 1.703 -0.678  2  1.46 0.0 0.0  7  0.075 -0.322 1.993  18  -0.741 -2.46 -0.92  13  -0.106 -2.485 3.304  11  -0.695 -2.921 2.497  15  -1.069 -2.904 0.02  3  2.424 -0.301 0.0  5  -0.365 -0.473 -0.911  14  -1.753 -2.734 2.677  10  0.775 -2.444 0.972  "
"1 2 0  -1   "
"1 "
"19 14  3 11  9  6   0  3 -1  -1  -1   8  3 6  4  9   16  3 15  9  6   12  3 11  9  6   17  3 15  9  6   1  3 -1  -1  -1   13  3 11  9  6   7  3 6  4  9   2  3 -1  -1  -1   18  3 15  9  6   11  3 -1  -1  -1   15  3 -1  -1  -1   3  3 -1  -1  -1   9  3 -1  -1  -1   5  3 4  2  0   4  3 -1  -1  -1   10  3 9  6  11   6  3 -1  -1  -1   "
"2 4 2  4  6  9   4 4  6  9  11   "
"3 9  11  15  "
"8 "
"3 "
"19 19 0  1  2  3  1  2  2  3  3  3  4  4  5  5  5  4  5  5  5   19 1  0  3  4  2  3  3  4  4  4  5  5  6  6  6  5  6  6  6   19 2  3  0  1  1  2  2  3  3  3  4  4  5  5  5  4  5  5  5   19 3  4  1  0  2  3  3  4  4  4  5  5  6  6  6  5  6  6  6   19 1  2  1  2  0  1  1  2  2  2  3  3  4  4  4  3  4  4  4   19 2  3  2  3  1  0  2  3  3  3  4  4  5  5  5  4  5  5  5   19 2  3  2  3  1  2  0  1  1  1  2  2  3  3  3  2  3  3  3   19 3  4  3  4  2  3  1  0  2  2  3  3  4  4  4  3  4  4  4   19 3  4  3  4  2  3  1  2  0  2  3  3  4  4  4  3  4  4  4   19 3  4  3  4  2  3  1  2  2  0  1  1  2  2  2  1  2  2  2   19 4  5  4  5  3  4  2  3  3  1  0  2  3  3  3  2  3  3  3   19 4  5  4  5  3  4  2  3  3  1  2  0  1  1  1  2  3  3  3   19 5  6  5  6  4  5  3  4  4  2  3  1  0  2  2  3  4  4  4   19 5  6  5  6  4  5  3  4  4  2  3  1  2  0  2  3  4  4  4   19 5  6  5  6  4  5  3  4  4  2  3  1  2  2  0  3  4  4  4   19 4  5  4  5  3  4  2  3  3  1  2  2  3  3  3  0  1  1  1   19 5  6  5  6  4  5  3  4  4  2  3  3  4  4  4  1  0  2  2   19 5  6  5  6  4  5  3  4  4  2  3  3  4  4  4  1  2  0  2   19 5  6  5  6  4  5  3  4  4  2  3  3  4  4  4  1  2  2  0   "
"6 "
"9 "
"2 "
"19 12  4 1  1  0  0   0  4 0  0  0  0   8  4 1  0  0  0   16  4 1  1  0  0   3  4 0  0  0  0   4  4 0  0  0  0   17  4 1  1  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   18  4 1  1  0  0   13  4 1  1  0  0   11  4 1  1  0  0   15  4 1  1  0  0   6  4 0  0  0  0   5  4 0  0  0  0   14  4 1  1  0  0   10  4 1  1  0  0   "
"19 "
"2 0  17 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!SD  2!CE  3!1HE  3!2HE  3!3HE   1  17 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!SD  2!CE  1!H  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  3!1HE  3!2HE  3!3HE   "
"1 1  "
"0 "
"17 16  -1.598 21.045 39.919  0  0.0 15.585 38.861  8  -2.097 16.764 37.541  6  -1.208 17.396 37.539  4  0.0 16.465 37.622  14  -3.365 21.23 40.03  9  -1.303 18.407 38.673  1  0.063 14.361 38.757  2  0.0 15.533 36.49  7  -1.138 17.922 36.588  13  -2.547 20.511 39.979  3  -0.04 14.543 36.685  10  -1.358 17.859 39.613  5  0.907 17.069 37.606  15  -2.556 19.886 40.873  11  -0.4 19.017 38.66  12  -2.745 19.481 38.528  "
"1 2 0  -1   "
"1 "
"17 0  3 -1  -1  -1   8  3 6  4  9   6  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   12  3 -1  -1  -1   13  3 -1  -1  -1   10  3 9  6  12   14  3 13  12  9   5  3 4  2  0   15  3 13  12  9   11  3 9  6  12   16  3 13  12  9   "
"3 4 2  4  6  9   4 4  6  9  12   4 6  9  12  13   "
"1 12  "
"8 "
"1 "
"17 17 0  1  2  3  1  2  2  3  3  3  4  4  4  5  6  6  6   17 1  0  3  4  2  3  3  4  4  4  5  5  5  6  7  7  7   17 2  3  0  1  1  2  2  3  3  3  4  4  4  5  6  6  6   17 3  4  1  0  2  3  3  4  4  4  5  5  5  6  7  7  7   17 1  2  1  2  0  1  1  2  2  2  3  3  3  4  5  5  5   17 2  3  2  3  1  0  2  3  3  3  4  4  4  5  6  6  6   17 2  3  2  3  1  2  0  1  1  1  2  2  2  3  4  4  4   17 3  4  3  4  2  3  1  0  2  2  3  3  3  4  5  5  5   17 3  4  3  4  2  3  1  2  0  2  3  3  3  4  5  5  5   17 3  4  3  4  2  3  1  2  2  0  1  1  1  2  3  3  3   17 4  5  4  5  3  4  2  3  3  1  0  2  2  3  4  4  4   17 4  5  4  5  3  4  2  3  3  1  2  0  2  3  4  4  4   17 4  5  4  5  3  4  2  3  3  1  2  2  0  1  2  2  2   17 5  6  5  6  4  5  3  4  4  2  3  3  1  0  1  1  1   17 6  7  6  7  5  6  4  5  5  3  4  4  2  1  0  2  2   17 6  7  6  7  5  6  4  5  5  3  4  4  2  1  2  0  2   17 6  7  6  7  5  6  4  5  5  3  4  4  2  1  2  2  0   "
"6 "
"10 "
"3 "
"17 0  4 0  0  0  0   8  4 1  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   14  4 1  1  1  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   13  4 1  1  1  0   10  4 1  1  0  0   6  4 0  0  0  0   16  4 1  1  1  0   5  4 0  0  0  0   15  4 1  1  1  0   11  4 1  1  0  0   12  4 1  1  0  0   "
"17 "
"2 0  14 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!OD1  3!ND2  4!1HD2  4!2HD2   1  14 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!OD1  3!ND2  1!H  4!1HD2  4!2HD2  2!HA  3!1HB  3!2HB   "
"2 10  1  "
"1 "
"14 13  -0.825 -2.442 3.033  0  -0.565 1.411 0.0  5  -0.37 -0.475 -0.91  12  -0.338 -3.907 2.247  8  -1.591 -0.599 0.891  6  -0.555 -0.778 1.179  4  0.0 0.0 0.0  9  -0.282 -2.255 1.112  1  -1.619 1.666 -0.603  2  1.463 0.0 0.0  7  -0.397 -0.431 2.201  3  2.425 -0.306 0.0  10  0.05 -2.798 0.052  11  -0.499 -2.92 2.218  "
"2 2 9  -1   2 0  -1   "
"2 "
"14 0  3 -1  -1  -1   8  3 6  4  9   12  3 11  9  6   4  3 -1  -1  -1   13  3 11  9  6   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   10  3 -1  -1  -1   3  3 -1  -1  -1   9  3 -1  -1  -1   11  3 -1  -1  -1   5  3 4  2  0   6  3 -1  -1  -1   "
"2 4 2  4  6  9   4 4  6  9  10   "
"3 9  10  11  "
"8 "
"3 "
"14 14 0  1  2  3  1  2  2  3  3  3  4  4  5  5   14 1  0  3  4  2  3  3  4  4  4  5  5  6  6   14 2  3  0  1  1  2  2  3  3  3  4  4  5  5   14 3  4  1  0  2  3  3  4  4  4  5  5  6  6   14 1  2  1  2  0  1  1  2  2  2  3  3  4  4   14 2  3  2  3  1  0  2  3  3  3  4  4  5  5   14 2  3  2  3  1  2  0  1  1  1  2  2  3  3   14 3  4  3  4  2  3  1  0  2  2  3  3  4  4   14 3  4  3  4  2  3  1  2  0  2  3  3  4  4   14 3  4  3  4  2  3  1  2  2  0  1  1  2  2   14 4  5  4  5  3  4  2  3  3  1  0  2  3  3   14 4  5  4  5  3  4  2  3  3  1  2  0  1  1   14 5  6  5  6  4  5  3  4  4  2  3  1  0  2   14 5  6  5  6  4  5  3  4  4  2  3  1  2  0   "
"6 "
"11 "
"2 "
"14 13  4 1  1  0  0   0  4 0  0  0  0   8  4 1  0  0  0   12  4 1  1  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   10  4 1  1  0  0   6  4 0  0  0  0   11  4 1  1  0  0   5  4 0  0  0  0   "
"14 "
"2 0  14 1!C  1!O  1!N  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!1HD  3!2HD   1  14 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  3!1HD  3!2HD  3!1HG  3!2HG  3!1HB  3!2HB  2!HA   "
"1 1  "
"0 "
"14 0  15.959 1.321 8.222  7  15.782 3.034 10.843  4  15.27 3.16 8.805  5  15.927 2.223 10.577  3  15.259 2.242 9.192  8  15.069 1.31 11.409  1  15.702 0.132 8.143  2  13.895 1.827 9.451  6  16.695 1.763 10.389  9  15.229 0.51 11.182  12  13.189 0.65 10.821  11  13.672 1.471 10.862  13  13.219 2.235 11.206  10  14.957 1.715 12.247  "
"1 2 0  -1   "
"1 "
"14 0  3 -1  -1  -1   4  3 3  2  0   5  3 -1  -1  -1   3  3 -1  -1  -1   8  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   6  3 5  3  8   11  3 -1  -1  -1   9  3 8  5  11   12  3 11  2  8   7  3 5  3  8   13  3 11  2  8   10  3 8  5  11   "
"1 4 2  3  5  8   "
"3 5  8  11  "
"7 "
"3 "
"14 14 0  1  2  1  2  2  3  3  3  4  4  3  4  4   14 1  0  3  2  3  3  4  4  4  5  5  4  5  5   14 2  3  0  1  2  2  3  3  2  3  3  1  2  2   14 1  2  1  0  1  1  2  2  2  3  3  2  3  3   14 2  3  2  1  0  2  3  3  3  4  4  3  4  4   14 2  3  2  1  2  0  1  1  1  2  2  2  3  3   14 3  4  3  2  3  1  0  2  2  3  3  3  4  4   14 3  4  3  2  3  1  2  0  2  3  3  3  4  4   14 3  4  2  2  3  1  2  2  0  1  1  1  2  2   14 4  5  3  3  4  2  3  3  1  0  2  2  3  3   14 4  5  3  3  4  2  3  3  1  2  0  2  3  3   14 3  4  1  2  3  2  3  3  1  2  2  0  1  1   14 4  5  2  3  4  3  4  4  2  3  3  1  0  2   14 4  5  2  3  4  3  4  4  2  3  3  1  2  0   "
"5 "
"12 "
"1 "
"14 0  4 0  0  0  0   7  4 1  0  0  0   5  4 0  0  0  0   3  4 0  0  0  0   8  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   6  4 1  0  0  0   11  4 0  0  0  0   9  4 1  0  0  0   12  4 0  0  0  0   4  4 0  0  0  0   13  4 0  0  0  0   10  4 1  0  0  0   "
"14 "
"2 0  17 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!OE1  3!NE2  4!1HE2  4!2HE2   1  17 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  3!OE1  3!NE2  1!H  4!1HE2  4!2HE2  2!HA  3!1HB  3!2HB  3!1HG  3!2HG   "
"2 13  1  "
"1 "
"17 7  -0.034 -0.351 2.091  0  -0.553 1.42 0.0  5  -0.365 -0.474 -0.911  8  -1.603 -0.548 1.275  6  -0.536 -0.762 1.215  4  0.0 0.0 0.0  16  0.93 -3.747 -0.506  9  -0.317 -2.264 1.154  1  -1.607 1.682 -0.58  2  1.458 0.0 0.0  15  -0.307 -4.048 -1.681  10  0.645 -2.729 1.368  3  2.424 -0.294 0.0  12  -0.856 -2.876 -0.125  14  -0.008 -3.618 -0.828  13  -2.024 -2.687 -0.476  11  -1.014 -2.486 1.963  "
"2 2 12  -1   2 0  -1   "
"2 "
"17 0  3 -1  -1  -1   8  3 6  4  9   3  3 -1  -1  -1   15  3 14  12  9   16  3 14  12  9   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   12  3 -1  -1  -1   10  3 9  6  12   6  3 -1  -1  -1   13  3 -1  -1  -1   5  3 4  2  0   14  3 -1  -1  -1   4  3 -1  -1  -1   11  3 9  6  12   "
"3 4 2  4  6  9   4 4  6  9  12   4 6  9  12  13   "
"3 12  13  14  "
"9 "
"3 "
"17 17 0  1  2  3  1  2  2  3  3  3  4  4  4  5  5  6  6   17 1  0  3  4  2  3  3  4  4  4  5  5  5  6  6  7  7   17 2  3  0  1  1  2  2  3  3  3  4  4  4  5  5  6  6   17 3  4  1  0  2  3  3  4  4  4  5  5  5  6  6  7  7   17 1  2  1  2  0  1  1  2  2  2  3  3  3  4  4  5  5   17 2  3  2  3  1  0  2  3  3  3  4  4  4  5  5  6  6   17 2  3  2  3  1  2  0  1  1  1  2  2  2  3  3  4  4   17 3  4  3  4  2  3  1  0  2  2  3  3  3  4  4  5  5   17 3  4  3  4  2  3  1  2  0  2  3  3  3  4  4  5  5   17 3  4  3  4  2  3  1  2  2  0  1  1  1  2  2  3  3   17 4  5  4  5  3  4  2  3  3  1  0  2  2  3  3  4  4   17 4  5  4  5  3  4  2  3  3  1  2  0  2  3  3  4  4   17 4  5  4  5  3  4  2  3  3  1  2  2  0  1  1  2  2   17 5  6  5  6  4  5  3  4  4  2  3  3  1  0  2  3  3   17 5  6  5  6  4  5  3  4  4  2  3  3  1  2  0  1  1   17 6  7  6  7  5  6  4  5  5  3  4  4  2  3  1  0  2   17 6  7  6  7  5  6  4  5  5  3  4  4  2  3  1  2  0   "
"6 "
"13 "
"3 "
"17 0  4 0  0  0  0   8  4 1  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   16  4 1  1  1  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   12  4 1  1  0  0   10  4 1  1  0  0   15  4 1  1  1  0   6  4 0  0  0  0   5  4 0  0  0  0   14  4 1  1  1  0   13  4 1  1  1  0   11  4 1  1  0  0   "
"17 "
"2 0  24 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!1HD  3!2HD  2!NE  2!HE  2!CZ  3!NH1  4!1HH1  4!2HH1  3!NH2  4!1HH2  4!2HH2   1  24 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  2!NE  2!CZ  3!NH1  3!NH2  1!H  4!1HH1  4!2HH1  4!1HH2  4!2HH2  2!HE  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  3!1HD  3!2HD   "
"1 1  "
"1 "
"24 5  -0.369 -0.476 -0.909  16  -3.323 -2.333 -0.146  15  -2.624 -2.901 0.314  3  2.418 -0.306 0.0  23  -5.092 -3.876 2.121  0  -0.569 1.399 0.0  20  -3.16 -4.953 2.749  6  -0.574 -0.82 1.146  4  0.0 0.0 0.0  9  -0.335 -2.318 1.043  1  -1.568 1.674 -0.695  2  1.455 0.0 0.0  7  -0.121 -0.446 2.063  17  -3.279 -3.584 1.273  18  -2.651 -4.451 2.036  10  0.704 -2.485 0.758  13  -1.015 -2.583 -0.935  21  -4.577 -3.377 1.411  8  -1.647 -0.629 1.167  14  -0.947 -4.069 0.041  11  -0.52 -2.766 2.02  12  -1.198 -3.009 0.051  22  -5.048 -2.72 0.804  19  -1.662 -4.611 1.906  "
"1 2 0  -1   "
"1 "
"24 5  3 4  2  0   16  3 15  12  17   15  3 -1  -1  -1   6  3 -1  -1  -1   23  3 21  17  15   0  3 -1  -1  -1   20  3 18  17  15   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   17  3 -1  -1  -1   18  3 -1  -1  -1   10  3 9  6  12   13  3 12  9  15   21  3 -1  -1  -1   8  3 6  4  9   14  3 12  9  15   11  3 9  6  12   12  3 -1  -1  -1   22  3 21  17  15   19  3 18  17  15   "
"4 4 2  4  6  9   4 4  6  9  12   4 6  9  12  15   4 9  12  15  17   "
"1 17  "
"11 "
"1 "
"24 24 0  1  2  3  1  2  2  3  3  3  4  4  4  5  5  5  6  6  7  8  8  7  8  8   24 1  0  3  4  2  3  3  4  4  4  5  5  5  6  6  6  7  7  8  9  9  8  9  9   24 2  3  0  1  1  2  2  3  3  3  4  4  4  5  5  5  6  6  7  8  8  7  8  8   24 3  4  1  0  2  3  3  4  4  4  5  5  5  6  6  6  7  7  8  9  9  8  9  9   24 1  2  1  2  0  1  1  2  2  2  3  3  3  4  4  4  5  5  6  7  7  6  7  7   24 2  3  2  3  1  0  2  3  3  3  4  4  4  5  5  5  6  6  7  8  8  7  8  8   24 2  3  2  3  1  2  0  1  1  1  2  2  2  3  3  3  4  4  5  6  6  5  6  6   24 3  4  3  4  2  3  1  0  2  2  3  3  3  4  4  4  5  5  6  7  7  6  7  7   24 3  4  3  4  2  3  1  2  0  2  3  3  3  4  4  4  5  5  6  7  7  6  7  7   24 3  4  3  4  2  3  1  2  2  0  1  1  1  2  2  2  3  3  4  5  5  4  5  5   24 4  5  4  5  3  4  2  3  3  1  0  2  2  3  3  3  4  4  5  6  6  5  6  6   24 4  5  4  5  3  4  2  3  3  1  2  0  2  3  3  3  4  4  5  6  6  5  6  6   24 4  5  4  5  3  4  2  3  3  1  2  2  0  1  1  1  2  2  3  4  4  3  4  4   24 5  6  5  6  4  5  3  4  4  2  3  3  1  0  2  2  3  3  4  5  5  4  5  5   24 5  6  5  6  4  5  3  4  4  2  3  3  1  2  0  2  3  3  4  5  5  4  5  5   24 5  6  5  6  4  5  3  4  4  2  3  3  1  2  2  0  1  1  2  3  3  2  3  3   24 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  0  2  3  4  4  3  4  4   24 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  2  0  1  2  2  1  2  2   24 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  1  0  1  1  2  3  3   24 8  9  8  9  7  8  6  7  7  5  6  6  4  5  5  3  4  2  1  0  2  3  4  4   24 8  9  8  9  7  8  6  7  7  5  6  6  4  5  5  3  4  2  1  2  0  3  4  4   24 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  1  2  3  3  0  1  1   24 8  9  8  9  7  8  6  7  7  5  6  6  4  5  5  3  4  2  3  4  4  1  0  2   24 8  9  8  9  7  8  6  7  7  5  6  6  4  5  5  3  4  2  3  4  4  1  2  0   "
"6 "
"14 "
"4 "
"24 5  4 0  0  0  0   16  4 1  1  1  1   15  4 1  1  1  0   6  4 0  0  0  0   23  4 1  1  1  1   0  4 0  0  0  0   20  4 1  1  1  1   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   17  4 1  1  1  1   18  4 1  1  1  1   10  4 1  1  0  0   13  4 1  1  1  0   21  4 1  1  1  1   8  4 1  0  0  0   14  4 1  1  1  0   11  4 1  1  0  0   12  4 1  1  0  0   22  4 1  1  1  1   19  4 1  1  1  1   "
"24 "
"2 0  11 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!OG  2!HG   1  11 1!N  2!CA  1!C  1!O  2!CB  2!OG  1!H  2!HG  2!HA  3!1HB  3!2HB   "
"2 9  1  "
"1 "
"11 0  -0.572 1.422 0.0  8  -1.602 -0.639 1.253  9  -0.231 -2.137 1.113  6  -0.522 -0.769 1.198  4  0.0 0.0 0.0  1  -1.553 1.698 -0.675  2  1.47 0.0 0.0  7  -0.062 -0.364 2.099  3  2.435 -0.299 0.0  5  -0.433 -0.566 -0.826  10  -0.577 -2.586 1.888  "
"2 2 10  -1   2 0  -1   "
"2 "
"11 0  3 -1  -1  -1   8  3 6  4  9   9  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   6  3 -1  -1  -1   5  3 4  2  0   10  3 9  6  4   "
"2 4 2  4  6  9   4 4  6  9  10   "
"1 9  "
"6 "
"1 "
"11 11 0  1  2  3  1  2  2  3  3  3  4   11 1  0  3  4  2  3  3  4  4  4  5   11 2  3  0  1  1  2  2  3  3  3  4   11 3  4  1  0  2  3  3  4  4  4  5   11 1  2  1  2  0  1  1  2  2  2  3   11 2  3  2  3  1  0  2  3  3  3  4   11 2  3  2  3  1  2  0  1  1  1  2   11 3  4  3  4  2  3  1  0  2  2  3   11 3  4  3  4  2  3  1  2  0  2  3   11 3  4  3  4  2  3  1  2  2  0  1   11 4  5  4  5  3  4  2  3  3  1  0   "
"6 "
"15 "
"2 "
"11 0  4 0  0  0  0   8  4 1  0  0  0   9  4 1  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   6  4 0  0  0  0   5  4 0  0  0  0   10  4 1  1  0  0   "
"11 "
"2 0  14 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  2!HB  3!CG2  4!1HG2  4!2HG2  4!3HG2  3!OG1  3!HG1   1  14 1!N  2!CA  1!C  1!O  2!CB  3!OG1  3!CG2  1!H  3!HG1  2!HA  2!HB  4!1HG2  4!2HG2  4!3HG2   "
"2 12  1  "
"1 "
"14 10  -2.55 17.297 58.568  0  0.0 16.858 60.734  5  0.91 18.329 59.526  6  -1.215 18.675 59.53  4  0.0 17.73 59.484  12  -1.174 19.452 60.734  1  0.003 15.63 60.645  2  0.0 16.917 58.274  9  -3.358 18.565 59.521  13  -1.932 20.041 60.76  3  -0.031 15.912 58.372  7  -1.174 19.347 58.673  8  -2.511 17.88 59.488  11  -2.553 17.209 60.345  "
"2 2 13  -1   2 0  -1   "
"2 "
"14 10  3 8  6  4   0  3 -1  -1  -1   8  3 -1  -1  -1   3  3 -1  -1  -1   11  3 8  6  4   12  3 -1  -1  -1   1  3 -1  -1  -1   13  3 12  6  4   2  3 -1  -1  -1   9  3 8  6  4   6  3 -1  -1  -1   7  3 6  4  12   5  3 4  2  0   4  3 -1  -1  -1   "
"2 4 2  4  6  12   4 4  6  12  13   "
"1 12  "
"7 "
"1 "
"14 14 0  1  2  3  1  2  2  3  3  4  4  4  3  4   14 1  0  3  4  2  3  3  4  4  5  5  5  4  5   14 2  3  0  1  1  2  2  3  3  4  4  4  3  4   14 3  4  1  0  2  3  3  4  4  5  5  5  4  5   14 1  2  1  2  0  1  1  2  2  3  3  3  2  3   14 2  3  2  3  1  0  2  3  3  4  4  4  3  4   14 2  3  2  3  1  2  0  1  1  2  2  2  1  2   14 3  4  3  4  2  3  1  0  2  3  3  3  2  3   14 3  4  3  4  2  3  1  2  0  1  1  1  2  3   14 4  5  4  5  3  4  2  3  1  0  2  2  3  4   14 4  5  4  5  3  4  2  3  1  2  0  2  3  4   14 4  5  4  5  3  4  2  3  1  2  2  0  3  4   14 3  4  3  4  2  3  1  2  2  3  3  3  0  1   14 4  5  4  5  3  4  2  3  3  4  4  4  1  0   "
"6 "
"16 "
"2 "
"14 10  4 1  0  0  0   0  4 0  0  0  0   8  4 1  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   12  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   9  4 1  0  0  0   13  4 1  1  0  0   6  4 0  0  0  0   7  4 1  0  0  0   5  4 0  0  0  0   11  4 1  0  0  0   "
"14 "
"2 0  16 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  2!HB  3!CG1  4!1HG1  4!2HG1  4!3HG1  3!CG2  4!1HG2  4!2HG2  4!3HG2   1  16 1!N  2!CA  1!C  1!O  2!CB  3!CG1  3!CG2  1!H  2!HA  2!HB  4!1HG1  4!2HG1  4!3HG1  4!1HG2  4!2HG2  4!3HG2   "
"1 1  "
"0 "
"16 14  0.325 14.257 62.153  0  0.0 17.753 64.344  5  -0.909 16.196 63.29  6  1.215 15.847 63.287  4  0.0 16.786 63.167  9  2.058 14.455 64.688  10  1.223 15.838 65.434  1  -0.002 18.97 64.16  2  0.0 17.501 61.897  7  2.128 16.438 63.213  13  2.102 14.199 62.235  11  0.28 14.522 64.694  3  0.031 18.51 61.915  8  1.192 15.114 64.62  12  1.237 14.854 62.135  15  1.299 15.394 61.19  "
"1 2 0  -1   "
"1 "
"16 14  3 12  6  4   10  3 8  6  4   12  3 -1  -1  -1   11  3 8  6  4   15  3 12  6  4   0  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   8  3 -1  -1  -1   13  3 12  6  4   3  3 -1  -1  -1   9  3 8  6  4   7  3 6  4  8   5  3 4  2  0   4  3 -1  -1  -1   6  3 -1  -1  -1   "
"1 4 2  4  6  8   "
"3 6  8  12  "
"7 "
"3 "
"16 16 0  1  2  3  1  2  2  3  3  4  4  4  3  4  4  4   16 1  0  3  4  2  3  3  4  4  5  5  5  4  5  5  5   16 2  3  0  1  1  2  2  3  3  4  4  4  3  4  4  4   16 3  4  1  0  2  3  3  4  4  5  5  5  4  5  5  5   16 1  2  1  2  0  1  1  2  2  3  3  3  2  3  3  3   16 2  3  2  3  1  0  2  3  3  4  4  4  3  4  4  4   16 2  3  2  3  1  2  0  1  1  2  2  2  1  2  2  2   16 3  4  3  4  2  3  1  0  2  3  3  3  2  3  3  3   16 3  4  3  4  2  3  1  2  0  1  1  1  2  3  3  3   16 4  5  4  5  3  4  2  3  1  0  2  2  3  4  4  4   16 4  5  4  5  3  4  2  3  1  2  0  2  3  4  4  4   16 4  5  4  5  3  4  2  3  1  2  2  0  3  4  4  4   16 3  4  3  4  2  3  1  2  2  3  3  3  0  1  1  1   16 4  5  4  5  3  4  2  3  3  4  4  4  1  0  2  2   16 4  5  4  5  3  4  2  3  3  4  4  4  1  2  0  2   16 4  5  4  5  3  4  2  3  3  4  4  4  1  2  2  0   "
"6 "
"17 "
"1 "
"16 14  4 1  0  0  0   0  4 0  0  0  0   12  4 1  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   10  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   8  4 1  0  0  0   13  4 1  0  0  0   11  4 1  0  0  0   6  4 0  0  0  0   7  4 1  0  0  0   5  4 0  0  0  0   15  4 1  0  0  0   "
"16 "
"2 0  24 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!CD1  3!HD1  3!CD2  3!NE1  3!HE1  3!CE2  3!CE3  3!HE3  3!CZ2  3!HZ2  3!CZ3  3!HZ3  3!CH2  3!HH2   1  24 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!CD1  3!CD2  3!NE1  3!CE2  3!CE3  3!CZ2  3!CZ3  3!CH2  1!H  3!HE1  3!HD1  3!HZ2  3!HH2  3!HZ3  3!HE3  2!HA  3!1HB  3!2HB   "
"1 1  "
"0 "
"24 23  1.572 20.577 72.361  18  -0.148 21.104 71.181  20  1.489 19.436 70.569  10  -2.237 20.752 68.28  12  -0.354 19.853 69.088  5  0.907 18.621 66.804  14  -2.524 22.078 69.917  17  1.237 18.387 68.728  22  1.018 20.384 71.442  21  2.403 18.883 70.787  19  -0.557 21.865 71.846  0  0.0 17.148 68.014  6  -1.21 18.954 66.777  4  0.0 18.018 66.764  9  -1.279 19.826 67.994  1  0.002 15.921 67.927  2  0.0 17.204 65.554  7  -1.18 19.622 65.916  16  0.821 19.151 69.384  15  -0.815 20.819 70.0  8  -2.133 18.375 66.755  11  -3.037 20.874 67.552  3  -0.038 16.199 65.653  13  -1.967 21.356 69.483  "
"1 2 0  -1   "
"1 "
"24 23  3 22  18  20   18  3 -1  -1  -1   20  3 -1  -1  -1   10  3 -1  -1  -1   12  3 -1  -1  -1   5  3 4  2  0   14  3 13  10  15   17  3 16  12  20   22  3 -1  -1  -1   21  3 20  16  22   19  3 18  15  22   6  3 -1  -1  -1   0  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   16  3 -1  -1  -1   15  3 -1  -1  -1   8  3 6  4  9   11  3 10  9  13   13  3 -1  -1  -1   "
"2 4 2  4  6  9   4 4  6  9  10   "
"2 12  15  "
"14 "
"2 "
"24 24 0  1  2  3  1  2  2  3  3  3  4  5  4  5  6  5  5  6  6  7  6  7  7  8   24 1  0  3  4  2  3  3  4  4  4  5  6  5  6  7  6  6  7  7  8  7  8  8  9   24 2  3  0  1  1  2  2  3  3  3  4  5  4  5  6  5  5  6  6  7  6  7  7  8   24 3  4  1  0  2  3  3  4  4  4  5  6  5  6  7  6  6  7  7  8  7  8  8  9   24 1  2  1  2  0  1  1  2  2  2  3  4  3  4  5  4  4  5  5  6  5  6  6  7   24 2  3  2  3  1  0  2  3  3  3  4  5  4  5  6  5  5  6  6  7  6  7  7  8   24 2  3  2  3  1  2  0  1  1  1  2  3  2  3  4  3  3  4  4  5  4  5  5  6   24 3  4  3  4  2  3  1  0  2  2  3  4  3  4  5  4  4  5  5  6  5  6  6  7   24 3  4  3  4  2  3  1  2  0  2  3  4  3  4  5  4  4  5  5  6  5  6  6  7   24 3  4  3  4  2  3  1  2  2  0  1  2  1  2  3  2  2  3  3  4  3  4  4  5   24 4  5  4  5  3  4  2  3  3  1  0  1  2  1  2  2  3  4  3  4  4  5  4  5   24 5  6  5  6  4  5  3  4  4  2  1  0  3  2  3  3  4  5  4  5  5  6  5  6   24 4  5  4  5  3  4  2  3  3  1  2  3  0  2  3  1  1  2  2  3  2  3  3  4   24 5  6  5  6  4  5  3  4  4  2  1  2  2  0  1  1  3  4  2  3  4  5  3  4   24 6  7  6  7  5  6  4  5  5  3  2  3  3  1  0  2  4  5  3  4  5  6  4  5   24 5  6  5  6  4  5  3  4  4  2  2  3  1  1  2  0  2  3  1  2  3  4  2  3   24 5  6  5  6  4  5  3  4  4  2  3  4  1  3  4  2  0  1  3  4  1  2  2  3   24 6  7  6  7  5  6  4  5  5  3  4  5  2  4  5  3  1  0  4  5  2  3  3  4   24 6  7  6  7  5  6  4  5  5  3  3  4  2  2  3  1  3  4  0  1  2  3  1  2   24 7  8  7  8  6  7  5  6  6  4  4  5  3  3  4  2  4  5  1  0  3  4  2  3   24 6  7  6  7  5  6  4  5  5  3  4  5  2  4  5  3  1  2  2  3  0  1  1  2   24 7  8  7  8  6  7  5  6  6  4  5  6  3  5  6  4  2  3  3  4  1  0  2  3   24 7  8  7  8  6  7  5  6  6  4  5  6  3  3  4  2  2  3  1  2  1  2  0  1   24 8  9  8  9  7  8  6  7  7  5  6  7  4  4  5  3  3  4  2  3  2  3  1  0   "
"6 "
"18 "
"2 "
"24 23  4 1  1  0  0   18  4 1  1  0  0   20  4 1  1  0  0   10  4 1  1  0  0   12  4 1  1  0  0   5  4 0  0  0  0   14  4 1  1  0  0   17  4 1  1  0  0   22  4 1  1  0  0   21  4 1  1  0  0   19  4 1  1  0  0   6  4 0  0  0  0   0  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   16  4 1  1  0  0   15  4 1  1  0  0   8  4 1  0  0  0   11  4 1  1  0  0   13  4 1  1  0  0   "
"24 "
"2 0  21 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!CD1  3!HD1  3!CD2  3!HD2  3!CE1  3!HE1  3!CE2  3!HE2  2!CZ  2!OH  2!HH   1  21 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!CD1  3!CD2  3!CE1  3!CE2  2!CZ  2!OH  1!H  2!HH  3!HD1  3!HE1  3!HE2  3!HD2  2!HA  3!1HB  3!2HB   "
"2 1  19  "
"0 "
"21 0  0.0 18.044 71.623  17  -0.387 14.938 74.753  14  2.397 13.752 73.24  11  3.088 14.341 71.296  19  1.493 13.211 75.38  6  1.209 16.143 70.536  4  0.0 17.077 70.447  8  2.101 16.76 70.432  9  1.285 15.36 71.828  1  -0.001 19.261 71.438  2  0.0 17.791 69.177  7  1.145 15.451 69.695  18  1.424 13.922 74.204  20  0.768 13.405 75.979  13  -0.501 16.212 72.638  10  2.323 14.47 72.062  12  0.319 15.515 72.811  3  0.039 18.801 69.195  15  3.218 13.056 73.41  5  -0.908 16.48 70.536  16  0.383 14.803 73.993  "
"2 2 0  -1   2 20  -1   "
"2 "
"21 0  3 -1  -1  -1   8  3 6  4  9   15  3 14  10  18   17  3 16  12  18   18  3 -1  -1  -1   14  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   19  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   11  3 10  9  14   20  3 19  18  14   10  3 -1  -1  -1   12  3 -1  -1  -1   6  3 -1  -1  -1   16  3 -1  -1  -1   5  3 4  2  0   13  3 12  9  16   "
"3 4 2  4  6  9   4 4  6  9  10   4 16  18  19  20   "
"2 9  18  "
"12 "
"2 "
"21 21 0  1  2  3  1  2  2  3  3  3  4  5  4  5  5  6  5  6  6  7  8   21 1  0  3  4  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  9   21 2  3  0  1  1  2  2  3  3  3  4  5  4  5  5  6  5  6  6  7  8   21 3  4  1  0  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  9   21 1  2  1  2  0  1  1  2  2  2  3  4  3  4  4  5  4  5  5  6  7   21 2  3  2  3  1  0  2  3  3  3  4  5  4  5  5  6  5  6  6  7  8   21 2  3  2  3  1  2  0  1  1  1  2  3  2  3  3  4  3  4  4  5  6   21 3  4  3  4  2  3  1  0  2  2  3  4  3  4  4  5  4  5  5  6  7   21 3  4  3  4  2  3  1  2  0  2  3  4  3  4  4  5  4  5  5  6  7   21 3  4  3  4  2  3  1  2  2  0  1  2  1  2  2  3  2  3  3  4  5   21 4  5  4  5  3  4  2  3  3  1  0  1  2  3  1  2  3  4  2  3  4   21 5  6  5  6  4  5  3  4  4  2  1  0  3  4  2  3  4  5  3  4  5   21 4  5  4  5  3  4  2  3  3  1  2  3  0  1  3  4  1  2  2  3  4   21 5  6  5  6  4  5  3  4  4  2  3  4  1  0  4  5  2  3  3  4  5   21 5  6  5  6  4  5  3  4  4  2  1  2  3  4  0  1  2  3  1  2  3   21 6  7  6  7  5  6  4  5  5  3  2  3  4  5  1  0  3  4  2  3  4   21 5  6  5  6  4  5  3  4  4  2  3  4  1  2  2  3  0  1  1  2  3   21 6  7  6  7  5  6  4  5  5  3  4  5  2  3  3  4  1  0  2  3  4   21 6  7  6  7  5  6  4  5  5  3  2  3  2  3  1  2  1  2  0  1  2   21 7  8  7  8  6  7  5  6  6  4  3  4  3  4  2  3  2  3  1  0  1   21 8  9  8  9  7  8  6  7  7  5  4  5  4  5  3  4  3  4  2  1  0   "
"6 "
"19 "
"3 "
"21 0  4 0  0  0  0   8  4 1  0  0  0   13  4 1  1  0  0   11  4 1  1  0  0   17  4 1  1  0  0   3  4 0  0  0  0   4  4 0  0  0  0   19  4 1  1  0  0   9  4 1  0  0  0   20  4 1  1  1  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   18  4 1  1  0  0   16  4 1  1  0  0   10  4 1  1  0  0   12  4 1  1  0  0   6  4 0  0  0  0   15  4 1  1  0  0   5  4 0  0  0  0   14  4 1  1  0  0   "
"21 "
"2 0  12 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  3!3HB  2!H2  2!H3   1  12 1!N  2!CA  1!C  1!O  2!CB  2!H1  2!HA  3!1HB  3!2HB  3!3HB  2!H2  2!H3   "
"1 1  "
"0 "
"12 0  1.499 -0.11 -0.491  8  -0.285 0.342 1.681  10  -0.103 -1.911 -0.968  6  -0.509 0.856 0.727  4  -0.001 0.064 -0.491  3  -0.833 -1.529 0.462  1  2.03 -1.227 -0.502  2  -0.677 -1.23 -0.491  7  -1.605 1.006 0.691  9  -0.053 1.861 0.784  11  -1.564 -1.146 -0.966  5  -0.269 0.603 -1.418  "
"1 2 0  -1   "
"1 "
"12 0  3 -1  -1  -1   8  3 6  4  2   10  3 -1  -1  -1   6  3 -1  -1  -1   4  3 -1  -1  -1   3  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  2   9  3 6  4  2   11  3 -1  -1  -1   5  3 4  2  0   "
""
"1 6  "
"5 "
"1 "
"12 12 0  1  2  3  1  2  2  3  3  3  3  3   12 1  0  3  4  2  3  3  4  4  4  4  4   12 2  3  0  1  1  2  2  3  3  3  1  1   12 3  4  1  0  2  3  3  4  4  4  2  2   12 1  2  1  2  0  1  1  2  2  2  2  2   12 2  3  2  3  1  0  2  3  3  3  3  3   12 2  3  2  3  1  2  0  1  1  1  3  3   12 3  4  3  4  2  3  1  0  2  2  4  4   12 3  4  3  4  2  3  1  2  0  2  4  4   12 3  4  3  4  2  3  1  2  2  0  4  4   12 3  4  1  2  2  3  3  4  4  4  0  2   12 3  4  1  2  2  3  3  4  4  4  2  0   "
"6 "
"0 "
"0 "
"12 0  4 0  0  0  0   8  4 0  0  0  0   10  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 0  0  0  0   9  4 0  0  0  0   11  4 0  0  0  0   5  4 0  0  0  0   "
"12 "
"2 0  13 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!SG  2!HG  2!H2  2!H3   1  13 1!N  2!CA  1!C  1!O  2!CB  2!SG  2!H1  2!HA  3!1HB  3!2HB  2!HG  2!H2  2!H3   "
"1 1  "
"0 "
"13 0  1.405 -0.269 -0.633  8  -1.778 0.509 0.585  11  -0.032 -2.205 -1.111  6  -0.674 0.537 0.577  4  -0.105 -0.229 -0.633  3  -0.793 -1.889 0.319  1  2.034 -1.337 -0.633  2  -0.664 -1.578 -0.633  7  -0.349 0.082 1.535  12  -1.555 -1.572 -1.109  5  -0.42 0.277 -1.564  9  -0.163 2.27 0.535  10  0.749 2.191 1.501  "
"1 2 0  -1   "
"1 "
"13 0  3 -1  -1  -1   8  3 6  4  9   11  3 -1  -1  -1   6  3 -1  -1  -1   4  3 -1  -1  -1   3  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   12  3 -1  -1  -1   5  3 4  2  0   9  3 -1  -1  -1   10  3 9  6  4   "
"1 4 2  4  6  9   "
"1 9  "
"6 "
"1 "
"13 13 0  1  2  3  1  2  2  3  3  3  4  3  3   13 1  0  3  4  2  3  3  4  4  4  5  4  4   13 2  3  0  1  1  2  2  3  3  3  4  1  1   13 3  4  1  0  2  3  3  4  4  4  5  2  2   13 1  2  1  2  0  1  1  2  2  2  3  2  2   13 2  3  2  3  1  0  2  3  3  3  4  3  3   13 2  3  2  3  1  2  0  1  1  1  2  3  3   13 3  4  3  4  2  3  1  0  2  2  3  4  4   13 3  4  3  4  2  3  1  2  0  2  3  4  4   13 3  4  3  4  2  3  1  2  2  0  1  4  4   13 4  5  4  5  3  4  2  3  3  1  0  5  5   13 3  4  1  2  2  3  3  4  4  4  5  0  2   13 3  4  1  2  2  3  3  4  4  4  5  2  0   "
"6 "
"1 "
"1 "
"13 0  4 0  0  0  0   8  4 1  0  0  0   11  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   12  4 0  0  0  0   5  4 0  0  0  0   9  4 1  0  0  0   10  4 1  0  0  0   "
"13 "
"2 0  14 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!OD1  3!OD2  2!H2  2!H3   1  14 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!OD1  3!OD2  2!H1  2!HA  3!1HB  3!2HB  2!H2  2!H3   "
"3 10  11  1  "
"1 "
"14 0  1.458 -0.515 -0.63  8  -1.688 0.354 0.586  12  0.022 -2.451 -1.107  6  -0.586 0.337 0.582  4  -0.051 -0.476 -0.63  3  -0.74 -2.136 0.322  9  -0.124 1.801 0.652  1  2.088 -1.584 -0.63  2  -0.61 -1.825 -0.63  7  -0.291 -0.154 1.527  13  -1.501 -1.819 -1.105  10  -0.007 2.453 -0.406  5  -0.366 0.03 -1.563  11  0.165 2.283 1.767  "
"3 2 9  -1   2 9  -1   2 0  -1   "
"3 "
"14 0  3 -1  -1  -1   8  3 6  4  9   12  3 -1  -1  -1   6  3 -1  -1  -1   4  3 -1  -1  -1   3  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   13  3 -1  -1  -1   10  3 -1  -1  -1   5  3 4  2  0   11  3 -1  -1  -1   "
"2 4 2  4  6  9   4 4  6  9  10   "
"3 9  10  11  "
"8 "
"3 "
"14 14 0  1  2  3  1  2  2  3  3  3  4  4  3  3   14 1  0  3  4  2  3  3  4  4  4  5  5  4  4   14 2  3  0  1  1  2  2  3  3  3  4  4  1  1   14 3  4  1  0  2  3  3  4  4  4  5  5  2  2   14 1  2  1  2  0  1  1  2  2  2  3  3  2  2   14 2  3  2  3  1  0  2  3  3  3  4  4  3  3   14 2  3  2  3  1  2  0  1  1  1  2  2  3  3   14 3  4  3  4  2  3  1  0  2  2  3  3  4  4   14 3  4  3  4  2  3  1  2  0  2  3  3  4  4   14 3  4  3  4  2  3  1  2  2  0  1  1  4  4   14 4  5  4  5  3  4  2  3  3  1  0  2  5  5   14 4  5  4  5  3  4  2  3  3  1  2  0  5  5   14 3  4  1  2  2  3  3  4  4  4  5  5  0  2   14 3  4  1  2  2  3  3  4  4  4  5  5  2  0   "
"6 "
"2 "
"2 "
"14 0  4 0  0  0  0   8  4 1  0  0  0   12  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   13  4 0  0  0  0   10  4 1  1  0  0   5  4 0  0  0  0   11  4 1  1  0  0   "
"14 "
"2 0  17 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!OE1  3!OE2  2!H2  2!H3   1  17 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  3!OE1  3!OE2  2!H1  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  2!H2  2!H3   "
"3 14  13  1  "
"1 "
"17 0  1.551 -1.037 -1.038  5  -0.284 0.479 -1.958  8  -1.588 -0.222 0.212  15  0.115 -2.973 -1.515  6  -0.481 -0.212 0.199  4  0.042 -0.997 -1.038  3  -0.646 -2.658 -0.086  9  -0.006 1.273 0.31  1  2.18 -2.105 -1.038  2  -0.517 -2.346 -1.038  7  -0.192 -0.743 1.129  16  -1.408 -2.341 -1.513  10  -0.316 1.858 -0.571  14  -0.0 3.247 1.597  12  -0.43 2.077 1.525  13  -1.158 1.575 2.403  11  1.094 1.34 0.339  "
"3 2 12  -1   2 12  -1   2 0  -1   "
"3 "
"17 0  3 -1  -1  -1   8  3 6  4  9   15  3 -1  -1  -1   6  3 -1  -1  -1   4  3 -1  -1  -1   3  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   16  3 -1  -1  -1   12  3 -1  -1  -1   10  3 9  6  12   14  3 -1  -1  -1   5  3 4  2  0   13  3 -1  -1  -1   11  3 9  6  12   "
"3 4 2  4  6  9   4 4  6  9  12   4 6  9  12  13   "
"3 12  13  14  "
"9 "
"3 "
"17 17 0  1  2  3  1  2  2  3  3  3  4  4  4  5  5  3  3   17 1  0  3  4  2  3  3  4  4  4  5  5  5  6  6  4  4   17 2  3  0  1  1  2  2  3  3  3  4  4  4  5  5  1  1   17 3  4  1  0  2  3  3  4  4  4  5  5  5  6  6  2  2   17 1  2  1  2  0  1  1  2  2  2  3  3  3  4  4  2  2   17 2  3  2  3  1  0  2  3  3  3  4  4  4  5  5  3  3   17 2  3  2  3  1  2  0  1  1  1  2  2  2  3  3  3  3   17 3  4  3  4  2  3  1  0  2  2  3  3  3  4  4  4  4   17 3  4  3  4  2  3  1  2  0  2  3  3  3  4  4  4  4   17 3  4  3  4  2  3  1  2  2  0  1  1  1  2  2  4  4   17 4  5  4  5  3  4  2  3  3  1  0  2  2  3  3  5  5   17 4  5  4  5  3  4  2  3  3  1  2  0  2  3  3  5  5   17 4  5  4  5  3  4  2  3  3  1  2  2  0  1  1  5  5   17 5  6  5  6  4  5  3  4  4  2  3  3  1  0  2  6  6   17 5  6  5  6  4  5  3  4  4  2  3  3  1  2  0  6  6   17 3  4  1  2  2  3  3  4  4  4  5  5  5  6  6  0  2   17 3  4  1  2  2  3  3  4  4  4  5  5  5  6  6  2  0   "
"6 "
"3 "
"3 "
"17 0  4 0  0  0  0   8  4 1  0  0  0   15  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   16  4 0  0  0  0   12  4 1  1  0  0   10  4 1  1  0  0   14  4 1  1  1  0   5  4 0  0  0  0   13  4 1  1  1  0   11  4 1  1  0  0   "
"17 "
"2 0  22 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!CD1  3!HD1  3!CD2  3!HD2  3!CE1  3!HE1  3!CE2  3!HE2  2!CZ  2!HZ  2!H2  2!H3   1  22 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!CD1  3!CD2  3!CE1  3!CE2  2!CZ  2!H1  3!HD1  3!HE1  2!HZ  3!HE2  3!HD2  2!HA  3!1HB  3!2HB  2!H2  2!H3   "
"1 1  "
"0 "
"22 19  -3.998 0.515 0.675  10  -0.821 -0.586 1.074  12  -0.86 1.483 -0.173  5  1.547 0.085 -1.96  15  -2.727 -1.36 1.672  17  -2.802 2.331 -0.512  0  3.403 -0.419 -1.043  6  1.385 0.334 0.218  4  1.893 -0.429 -1.043  9  -0.139 0.429 0.393  1  4.078 -1.486 -1.043  2  1.378 -1.795 -1.043  7  1.801 1.361 0.219  18  -2.921 0.497 0.603  16  -2.248 1.518 -0.066  14  -2.208 -0.556 1.171  8  1.822 -0.122 1.13  13  -0.346 2.267 -0.712  11  -0.276 -1.423 1.49  20  2.03 -2.401 -1.521  21  0.488 -1.818 -1.519  3  1.259 -2.11 -0.091  "
"1 2 0  -1   "
"1 "
"22 19  3 18  14  16   10  3 -1  -1  -1   12  3 -1  -1  -1   5  3 4  2  0   15  3 14  10  18   17  3 16  12  18   0  3 -1  -1  -1   6  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   18  3 -1  -1  -1   16  3 -1  -1  -1   14  3 -1  -1  -1   8  3 6  4  9   13  3 12  9  16   11  3 10  9  14   20  3 -1  -1  -1   21  3 -1  -1  -1   3  3 -1  -1  -1   "
"2 4 2  4  6  9   4 4  6  9  10   "
"2 9  18  "
"11 "
"2 "
"22 22 0  1  2  3  1  2  2  3  3  3  4  5  4  5  5  6  5  6  6  7  3  3   22 1  0  3  4  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  4  4   22 2  3  0  1  1  2  2  3  3  3  4  5  4  5  5  6  5  6  6  7  1  1   22 3  4  1  0  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  2  2   22 1  2  1  2  0  1  1  2  2  2  3  4  3  4  4  5  4  5  5  6  2  2   22 2  3  2  3  1  0  2  3  3  3  4  5  4  5  5  6  5  6  6  7  3  3   22 2  3  2  3  1  2  0  1  1  1  2  3  2  3  3  4  3  4  4  5  3  3   22 3  4  3  4  2  3  1  0  2  2  3  4  3  4  4  5  4  5  5  6  4  4   22 3  4  3  4  2  3  1  2  0  2  3  4  3  4  4  5  4  5  5  6  4  4   22 3  4  3  4  2  3  1  2  2  0  1  2  1  2  2  3  2  3  3  4  4  4   22 4  5  4  5  3  4  2  3  3  1  0  1  2  3  1  2  3  4  2  3  5  5   22 5  6  5  6  4  5  3  4  4  2  1  0  3  4  2  3  4  5  3  4  6  6   22 4  5  4  5  3  4  2  3  3  1  2  3  0  1  3  4  1  2  2  3  5  5   22 5  6  5  6  4  5  3  4  4  2  3  4  1  0  4  5  2  3  3  4  6  6   22 5  6  5  6  4  5  3  4  4  2  1  2  3  4  0  1  2  3  1  2  6  6   22 6  7  6  7  5  6  4  5  5  3  2  3  4  5  1  0  3  4  2  3  7  7   22 5  6  5  6  4  5  3  4  4  2  3  4  1  2  2  3  0  1  1  2  6  6   22 6  7  6  7  5  6  4  5  5  3  4  5  2  3  3  4  1  0  2  3  7  7   22 6  7  6  7  5  6  4  5  5  3  2  3  2  3  1  2  1  2  0  1  7  7   22 7  8  7  8  6  7  5  6  6  4  3  4  3  4  2  3  2  3  1  0  8  8   22 3  4  1  2  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  0  2   22 3  4  1  2  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  2  0   "
"6 "
"4 "
"2 "
"22 19  4 1  1  0  0   10  4 1  1  0  0   12  4 1  1  0  0   5  4 0  0  0  0   15  4 1  1  0  0   17  4 1  1  0  0   0  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   18  4 1  1  0  0   16  4 1  1  0  0   14  4 1  1  0  0   8  4 1  0  0  0   13  4 1  1  0  0   11  4 1  1  0  0   20  4 0  0  0  0   21  4 0  0  0  0   3  4 0  0  0  0   "
"22 "
"2 0  9 1!C  1!O  1!N  2!H1  2!CA  3!1HA  3!2HA  2!H2  2!H3   1  9 1!N  2!CA  1!C  1!O  2!H1  3!1HA  3!2HA  2!H2  2!H3   "
"1 1  "
"0 "
"9 0  1.059 -0.39 0.542  7  -1.368 -0.668 0.278  8  -1.719 0.216 -1.069  4  0.23 0.318 -0.502  3  -1.483 0.975 0.376  1  0.545 -0.975 1.499  2  -1.195 0.201 -0.206  5  0.482 1.337 -0.514  6  0.434 -0.159 -1.479  "
"1 2 0  -1   "
"1 "
"9 0  3 -1  -1  -1   7  3 -1  -1  -1   8  3 -1  -1  -1   4  3 -1  -1  -1   3  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   5  3 4  2  0   6  3 4  2  0   "
""
"1 4  "
"4 "
"1 "
"9 9 0  1  2  3  1  2  2  3  3   9 1  0  3  4  2  3  3  4  4   9 2  3  0  1  1  2  2  1  1   9 3  4  1  0  2  3  3  2  2   9 1  2  1  2  0  1  1  2  2   9 2  3  2  3  1  0  2  3  3   9 2  3  2  3  1  2  0  3  3   9 3  4  1  2  2  3  3  0  2   9 3  4  1  2  2  3  3  2  0   "
"4 "
"5 "
"0 "
"9 0  4 0  0  0  0   7  4 0  0  0  0   8  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   5  4 0  0  0  0   6  4 0  0  0  0   "
"9 "
"2 0  19 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!ND1  3!CD2  3!HD2  3!CE1  3!HE1  3!NE2  3!HE2  2!H2  2!H3   1  19 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!ND1  3!CD2  3!CE1  3!NE2  2!H1  3!HE2  2!HA  3!1HB  3!2HB  3!HE1  3!HD2  2!H2  2!H3   "
"2 10  1  "
"1 "
"19 0  2.561 -1.08 -0.865  8  -0.059 -1.483 1.027  13  -0.959 2.556 0.62  16  -3.075 2.194 0.348  17  1.145 -2.888 -1.706  6  0.551 -0.676 0.57  4  1.052 -1.053 -0.834  3  0.344 -2.872 -0.264  9  -0.281 0.573 0.562  1  3.195 -2.117 -1.112  2  0.498 -2.372 -1.127  7  1.397 -0.517 1.268  12  -2.252 -0.346 0.268  11  -1.66 0.555 0.4  18  -0.38 -2.267 -1.616  10  0.197 1.873 0.711  5  0.732 -0.37 -1.639  15  -2.108 1.85 0.438  14  -0.912 3.634 0.7  "
"2 2 9  13   2 0  -1   "
"2 "
"19 0  3 -1  -1  -1   5  3 4  2  0   14  3 13  10  15   16  3 15  11  13   13  3 -1  -1  -1   6  3 -1  -1  -1   4  3 -1  -1  -1   3  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   17  3 -1  -1  -1   11  3 -1  -1  -1   18  3 -1  -1  -1   10  3 -1  -1  -1   8  3 6  4  9   15  3 -1  -1  -1   12  3 11  9  15   "
"2 4 2  4  6  9   4 4  6  9  10   "
"2 10  11  "
"10 "
"2 "
"19 19 0  1  2  3  1  2  2  3  3  3  4  4  5  5  6  5  6  3  3   19 1  0  3  4  2  3  3  4  4  4  5  5  6  6  7  6  7  4  4   19 2  3  0  1  1  2  2  3  3  3  4  4  5  5  6  5  6  1  1   19 3  4  1  0  2  3  3  4  4  4  5  5  6  6  7  6  7  2  2   19 1  2  1  2  0  1  1  2  2  2  3  3  4  4  5  4  5  2  2   19 2  3  2  3  1  0  2  3  3  3  4  4  5  5  6  5  6  3  3   19 2  3  2  3  1  2  0  1  1  1  2  2  3  3  4  3  4  3  3   19 3  4  3  4  2  3  1  0  2  2  3  3  4  4  5  4  5  4  4   19 3  4  3  4  2  3  1  2  0  2  3  3  4  4  5  4  5  4  4   19 3  4  3  4  2  3  1  2  2  0  1  1  2  2  3  2  3  4  4   19 4  5  4  5  3  4  2  3  3  1  0  2  3  1  2  2  3  5  5   19 4  5  4  5  3  4  2  3  3  1  2  0  1  2  3  1  2  5  5   19 5  6  5  6  4  5  3  4  4  2  3  1  0  3  4  2  3  6  6   19 5  6  5  6  4  5  3  4  4  2  1  2  3  0  1  1  2  6  6   19 6  7  6  7  5  6  4  5  5  3  2  3  4  1  0  2  3  7  7   19 5  6  5  6  4  5  3  4  4  2  2  1  2  1  2  0  1  6  6   19 6  7  6  7  5  6  4  5  5  3  3  2  3  2  3  1  0  7  7   19 3  4  1  2  2  3  3  4  4  4  5  5  6  6  7  6  7  0  2   19 3  4  1  2  2  3  3  4  4  4  5  5  6  6  7  6  7  2  0   "
"6 "
"6 "
"2 "
"19 0  4 0  0  0  0   8  4 1  0  0  0   12  4 1  1  0  0   16  4 1  1  0  0   17  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   11  4 1  1  0  0   18  4 0  0  0  0   10  4 1  1  0  0   14  4 1  1  0  0   5  4 0  0  0  0   15  4 1  1  0  0   13  4 1  1  0  0   "
"19 "
"2 0  21 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  2!HB  3!CG2  4!1HG2  4!2HG2  4!3HG2  3!CG1  4!1HG1  4!2HG1  3!CD1  4!1HD1  4!2HD1  4!3HD1  2!H2  2!H3   1  21 1!N  2!CA  1!C  1!O  2!CB  3!CG1  3!CG2  3!CD1  2!H1  2!HA  2!HB  4!1HG2  4!2HG2  4!3HG2  4!1HG1  4!2HG1  4!1HD1  4!2HD1  4!3HD1  2!H2  2!H3   "
"1 1  "
"0 "
"21 10  0.366 2.063 -0.861  0  2.4 -0.765 -1.142  5  0.568 -0.322 -2.088  19  1.054 -2.765 -1.619  6  0.286 0.038 0.061  4  0.891 -0.794 -1.142  3  0.279 -2.484 -0.19  14  -1.732 0.515 -0.692  1  3.077 -1.804 -1.142  2  0.394 -2.167 -1.142  18  -2.969 0.373 1.513  7  0.684 -0.416 0.993  9  1.82 1.668 0.087  15  -1.872 0.51 1.491  17  -1.686 1.588 1.646  13  -1.618 -1.056 0.07  12  -1.272 -0.01 0.168  20  -0.497 -2.203 -1.618  8  0.725 1.535 0.043  11  0.345 2.096 0.916  16  -1.461 -0.027 2.367  "
"1 2 0  -1   "
"1 "
"21 10  3 8  6  4   14  3 12  6  15   8  3 -1  -1  -1   19  3 -1  -1  -1   6  3 -1  -1  -1   11  3 8  6  4   3  3 -1  -1  -1   0  3 -1  -1  -1   1  3 -1  -1  -1   17  3 15  12  6   18  3 15  12  6   12  3 -1  -1  -1   2  3 -1  -1  -1   9  3 8  6  4   15  3 -1  -1  -1   13  3 12  6  15   7  3 6  4  12   20  3 -1  -1  -1   5  3 4  2  0   4  3 -1  -1  -1   16  3 15  12  6   "
"2 4 2  4  6  12   4 4  6  12  15   "
"3 12  8  15  "
"8 "
"3 "
"21 21 0  1  2  3  1  2  2  3  3  4  4  4  3  4  4  4  5  5  5  3  3   21 1  0  3  4  2  3  3  4  4  5  5  5  4  5  5  5  6  6  6  4  4   21 2  3  0  1  1  2  2  3  3  4  4  4  3  4  4  4  5  5  5  1  1   21 3  4  1  0  2  3  3  4  4  5  5  5  4  5  5  5  6  6  6  2  2   21 1  2  1  2  0  1  1  2  2  3  3  3  2  3  3  3  4  4  4  2  2   21 2  3  2  3  1  0  2  3  3  4  4  4  3  4  4  4  5  5  5  3  3   21 2  3  2  3  1  2  0  1  1  2  2  2  1  2  2  2  3  3  3  3  3   21 3  4  3  4  2  3  1  0  2  3  3  3  2  3  3  3  4  4  4  4  4   21 3  4  3  4  2  3  1  2  0  1  1  1  2  3  3  3  4  4  4  4  4   21 4  5  4  5  3  4  2  3  1  0  2  2  3  4  4  4  5  5  5  5  5   21 4  5  4  5  3  4  2  3  1  2  0  2  3  4  4  4  5  5  5  5  5   21 4  5  4  5  3  4  2  3  1  2  2  0  3  4  4  4  5  5  5  5  5   21 3  4  3  4  2  3  1  2  2  3  3  3  0  1  1  1  2  2  2  4  4   21 4  5  4  5  3  4  2  3  3  4  4  4  1  0  2  2  3  3  3  5  5   21 4  5  4  5  3  4  2  3  3  4  4  4  1  2  0  2  3  3  3  5  5   21 4  5  4  5  3  4  2  3  3  4  4  4  1  2  2  0  1  1  1  5  5   21 5  6  5  6  4  5  3  4  4  5  5  5  2  3  3  1  0  2  2  6  6   21 5  6  5  6  4  5  3  4  4  5  5  5  2  3  3  1  2  0  2  6  6   21 5  6  5  6  4  5  3  4  4  5  5  5  2  3  3  1  2  2  0  6  6   21 3  4  1  2  2  3  3  4  4  5  5  5  4  5  5  5  6  6  6  0  2   21 3  4  1  2  2  3  3  4  4  5  5  5  4  5  5  5  6  6  6  2  0   "
"6 "
"7 "
"2 "
"21 10  4 1  0  0  0   0  4 0  0  0  0   8  4 1  0  0  0   19  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   14  4 1  1  0  0   1  4 0  0  0  0   2  4 0  0  0  0   18  4 1  1  0  0   12  4 1  0  0  0   9  4 1  0  0  0   15  4 1  1  0  0   17  4 1  1  0  0   13  4 1  1  0  0   7  4 1  0  0  0   20  4 0  0  0  0   5  4 0  0  0  0   11  4 1  0  0  0   16  4 1  1  0  0   "
"21 "
"2 0  24 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!1HD  3!2HD  2!CE  3!1HE  3!2HE  2!NZ  3!1HZ  3!2HZ  3!3HZ  2!H2  2!H3   1  24 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  2!CE  2!NZ  2!H1  3!1HZ  3!2HZ  3!3HZ  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  3!1HD  3!2HD  3!1HE  3!2HE  2!H2  2!H3   "
"1 1  "
"1 "
"24 5  -0.209 -1.713 -2.594  21  -1.247 3.402 1.548  18  -0.372 3.036 1.894  0  1.62 -2.263 -1.666  20  0.261 3.796 2.164  19  -0.508 2.465 2.737  6  -0.425 -1.442 -0.435  4  0.11 -2.223 -1.666  9  0.052 0.031 -0.385  1  2.249 -3.331 -1.666  2  -0.449 -3.572 -1.666  7  -0.128 -1.966 0.497  15  0.198 2.225 0.804  13  -0.075 0.288 1.77  16  -0.007 2.716 -0.17  8  -1.533 -1.464 -0.432  17  1.304 2.179 0.893  14  -1.509 0.846 0.887  11  1.157 0.075 -0.392  22  0.183 -4.199 -2.143  23  -1.34 -3.567 -2.142  3  -0.578 -3.884 -0.714  12  -0.403 0.814 0.85  10  -0.27 0.557 -1.305  "
"1 2 0  -1   "
"1 "
"24 5  3 4  2  0   21  3 18  15  12   18  3 -1  -1  -1   0  3 -1  -1  -1   20  3 18  15  12   19  3 18  15  12   6  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   15  3 -1  -1  -1   13  3 12  9  15   16  3 15  12  18   8  3 6  4  9   17  3 15  12  18   14  3 12  9  15   11  3 -1  -1  -1   22  3 -1  -1  -1   23  3 -1  -1  -1   3  3 -1  -1  -1   12  3 -1  -1  -1   10  3 -1  -1  -1   "
"4 4 2  4  6  9   4 4  6  9  12   4 6  9  12  15   4 9  12  15  18   "
"1 18  "
"9 "
"1 "
"24 24 0  1  2  3  1  2  2  3  3  3  4  4  4  5  5  5  6  6  6  7  7  7  3  3   24 1  0  3  4  2  3  3  4  4  4  5  5  5  6  6  6  7  7  7  8  8  8  4  4   24 2  3  0  1  1  2  2  3  3  3  4  4  4  5  5  5  6  6  6  7  7  7  1  1   24 3  4  1  0  2  3  3  4  4  4  5  5  5  6  6  6  7  7  7  8  8  8  2  2   24 1  2  1  2  0  1  1  2  2  2  3  3  3  4  4  4  5  5  5  6  6  6  2  2   24 2  3  2  3  1  0  2  3  3  3  4  4  4  5  5  5  6  6  6  7  7  7  3  3   24 2  3  2  3  1  2  0  1  1  1  2  2  2  3  3  3  4  4  4  5  5  5  3  3   24 3  4  3  4  2  3  1  0  2  2  3  3  3  4  4  4  5  5  5  6  6  6  4  4   24 3  4  3  4  2  3  1  2  0  2  3  3  3  4  4  4  5  5  5  6  6  6  4  4   24 3  4  3  4  2  3  1  2  2  0  1  1  1  2  2  2  3  3  3  4  4  4  4  4   24 4  5  4  5  3  4  2  3  3  1  0  2  2  3  3  3  4  4  4  5  5  5  5  5   24 4  5  4  5  3  4  2  3  3  1  2  0  2  3  3  3  4  4  4  5  5  5  5  5   24 4  5  4  5  3  4  2  3  3  1  2  2  0  1  1  1  2  2  2  3  3  3  5  5   24 5  6  5  6  4  5  3  4  4  2  3  3  1  0  2  2  3  3  3  4  4  4  6  6   24 5  6  5  6  4  5  3  4  4  2  3  3  1  2  0  2  3  3  3  4  4  4  6  6   24 5  6  5  6  4  5  3  4  4  2  3  3  1  2  2  0  1  1  1  2  2  2  6  6   24 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  0  2  2  3  3  3  7  7   24 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  2  0  2  3  3  3  7  7   24 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  2  2  0  1  1  1  7  7   24 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  3  1  0  2  2  8  8   24 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  3  1  2  0  2  8  8   24 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  3  1  2  2  0  8  8   24 3  4  1  2  2  3  3  4  4  4  5  5  5  6  6  6  7  7  7  8  8  8  0  2   24 3  4  1  2  2  3  3  4  4  4  5  5  5  6  6  6  7  7  7  8  8  8  2  0   "
"6 "
"8 "
"4 "
"24 5  4 0  0  0  0   21  4 1  1  1  1   18  4 1  1  1  1   0  4 0  0  0  0   20  4 1  1  1  1   19  4 1  1  1  1   6  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   15  4 1  1  1  0   13  4 1  1  1  0   16  4 1  1  1  1   8  4 1  0  0  0   17  4 1  1  1  1   14  4 1  1  1  0   11  4 1  1  0  0   22  4 0  0  0  0   23  4 0  0  0  0   3  4 0  0  0  0   12  4 1  1  0  0   10  4 1  1  0  0   "
"24 "
"2 0  21 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  2!HG  3!CD1  4!1HD1  4!2HD1  4!3HD1  3!CD2  4!1HD2  4!2HD2  4!3HD2  2!H2  2!H3   1  21 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!CD1  3!CD2  2!H1  2!HA  3!1HB  3!2HB  2!HG  4!1HD1  4!2HD1  4!3HD1  4!1HD2  4!2HD2  4!3HD2  2!H2  2!H3   "
"1 1  "
"0 "
"21 12  -0.71 0.746 2.598  0  2.755 -0.834 -0.894  8  1.097 -0.432 1.252  17  -1.371 0.071 -1.656  19  1.305 -2.759 -1.371  6  0.718 0.033 0.32  4  1.246 -0.783 -0.894  3  0.546 -2.439 0.058  9  -0.817 0.218 0.464  1  3.377 -1.907 -0.894  2  0.678 -2.128 -0.894  7  1.188 1.036 0.3  20  -0.213 -2.117 -1.37  18  -2.555 0.947 -0.68  13  -0.719 2.157 1.512  11  -1.129 1.139 1.652  15  -1.47 0.778 -0.811  16  -1.017 1.735 -1.128  5  0.953 -0.28 -1.833  14  -2.218 1.245 1.81  10  -1.266 -0.775 0.676  "
"1 2 0  -1   "
"1 "
"21 14  3 11  9  6   0  3 -1  -1  -1   8  3 6  4  9   19  3 -1  -1  -1   16  3 15  9  6   12  3 11  9  6   3  3 -1  -1  -1   17  3 15  9  6   1  3 -1  -1  -1   13  3 11  9  6   7  3 6  4  9   20  3 -1  -1  -1   2  3 -1  -1  -1   18  3 15  9  6   11  3 -1  -1  -1   15  3 -1  -1  -1   6  3 -1  -1  -1   9  3 -1  -1  -1   5  3 4  2  0   4  3 -1  -1  -1   10  3 9  6  11   "
"2 4 2  4  6  9   4 4  6  9  11   "
"3 9  11  15  "
"8 "
"3 "
"21 21 0  1  2  3  1  2  2  3  3  3  4  4  5  5  5  4  5  5  5  3  3   21 1  0  3  4  2  3  3  4  4  4  5  5  6  6  6  5  6  6  6  4  4   21 2  3  0  1  1  2  2  3  3  3  4  4  5  5  5  4  5  5  5  1  1   21 3  4  1  0  2  3  3  4  4  4  5  5  6  6  6  5  6  6  6  2  2   21 1  2  1  2  0  1  1  2  2  2  3  3  4  4  4  3  4  4  4  2  2   21 2  3  2  3  1  0  2  3  3  3  4  4  5  5  5  4  5  5  5  3  3   21 2  3  2  3  1  2  0  1  1  1  2  2  3  3  3  2  3  3  3  3  3   21 3  4  3  4  2  3  1  0  2  2  3  3  4  4  4  3  4  4  4  4  4   21 3  4  3  4  2  3  1  2  0  2  3  3  4  4  4  3  4  4  4  4  4   21 3  4  3  4  2  3  1  2  2  0  1  1  2  2  2  1  2  2  2  4  4   21 4  5  4  5  3  4  2  3  3  1  0  2  3  3  3  2  3  3  3  5  5   21 4  5  4  5  3  4  2  3  3  1  2  0  1  1  1  2  3  3  3  5  5   21 5  6  5  6  4  5  3  4  4  2  3  1  0  2  2  3  4  4  4  6  6   21 5  6  5  6  4  5  3  4  4  2  3  1  2  0  2  3  4  4  4  6  6   21 5  6  5  6  4  5  3  4  4  2  3  1  2  2  0  3  4  4  4  6  6   21 4  5  4  5  3  4  2  3  3  1  2  2  3  3  3  0  1  1  1  5  5   21 5  6  5  6  4  5  3  4  4  2  3  3  4  4  4  1  0  2  2  6  6   21 5  6  5  6  4  5  3  4  4  2  3  3  4  4  4  1  2  0  2  6  6   21 5  6  5  6  4  5  3  4  4  2  3  3  4  4  4  1  2  2  0  6  6   21 3  4  1  2  2  3  3  4  4  4  5  5  6  6  6  5  6  6  6  0  2   21 3  4  1  2  2  3  3  4  4  4  5  5  6  6  6  5  6  6  6  2  0   "
"6 "
"9 "
"2 "
"21 12  4 1  1  0  0   0  4 0  0  0  0   8  4 1  0  0  0   17  4 1  1  0  0   19  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   20  4 0  0  0  0   18  4 1  1  0  0   13  4 1  1  0  0   11  4 1  1  0  0   15  4 1  1  0  0   16  4 1  1  0  0   5  4 0  0  0  0   14  4 1  1  0  0   10  4 1  1  0  0   "
"21 "
"2 0  19 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!SD  2!CE  3!1HE  3!2HE  3!3HE  2!H2  2!H3   1  19 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!SD  2!CE  2!H1  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  3!1HE  3!2HE  3!3HE  2!H2  2!H3   "
"1 1  "
"0 "
"19 16  -3.31 1.813 2.169  0  3.049 -0.521 -1.166  8  1.3 -0.285 0.997  17  1.716 -2.53 -1.643  6  0.965 0.202 0.059  4  1.54 -0.561 -1.166  3  0.939 -2.255 -0.214  9  -0.571 0.352 0.1  1  3.733 -1.556 -1.166  2  1.052 -1.937 -1.166  7  1.403 1.218 0.096  18  0.162 -1.978 -1.642  13  -2.801 1.147 1.451  14  -3.258 1.295 0.456  10  -1.043 -0.631 0.287  5  1.202 -0.067 -2.096  15  -2.979 0.103 1.764  11  -0.97 0.718 -0.864  12  -1.038 1.496 1.409  "
"1 2 0  -1   "
"1 "
"19 0  3 -1  -1  -1   8  3 6  4  9   17  3 -1  -1  -1   6  3 -1  -1  -1   4  3 -1  -1  -1   3  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   18  3 -1  -1  -1   12  3 -1  -1  -1   13  3 -1  -1  -1   10  3 9  6  12   14  3 13  12  9   5  3 4  2  0   15  3 13  12  9   11  3 9  6  12   16  3 13  12  9   "
"3 4 2  4  6  9   4 4  6  9  12   4 6  9  12  13   "
"1 12  "
"8 "
"1 "
"19 19 0  1  2  3  1  2  2  3  3  3  4  4  4  5  6  6  6  3  3   19 1  0  3  4  2  3  3  4  4  4  5  5  5  6  7  7  7  4  4   19 2  3  0  1  1  2  2  3  3  3  4  4  4  5  6  6  6  1  1   19 3  4  1  0  2  3  3  4  4  4  5  5  5  6  7  7  7  2  2   19 1  2  1  2  0  1  1  2  2  2  3  3  3  4  5  5  5  2  2   19 2  3  2  3  1  0  2  3  3  3  4  4  4  5  6  6  6  3  3   19 2  3  2  3  1  2  0  1  1  1  2  2  2  3  4  4  4  3  3   19 3  4  3  4  2  3  1  0  2  2  3  3  3  4  5  5  5  4  4   19 3  4  3  4  2  3  1  2  0  2  3  3  3  4  5  5  5  4  4   19 3  4  3  4  2  3  1  2  2  0  1  1  1  2  3  3  3  4  4   19 4  5  4  5  3  4  2  3  3  1  0  2  2  3  4  4  4  5  5   19 4  5  4  5  3  4  2  3  3  1  2  0  2  3  4  4  4  5  5   19 4  5  4  5  3  4  2  3  3  1  2  2  0  1  2  2  2  5  5   19 5  6  5  6  4  5  3  4  4  2  3  3  1  0  1  1  1  6  6   19 6  7  6  7  5  6  4  5  5  3  4  4  2  1  0  2  2  7  7   19 6  7  6  7  5  6  4  5  5  3  4  4  2  1  2  0  2  7  7   19 6  7  6  7  5  6  4  5  5  3  4  4  2  1  2  2  0  7  7   19 3  4  1  2  2  3  3  4  4  4  5  5  5  6  7  7  7  0  2   19 3  4  1  2  2  3  3  4  4  4  5  5  5  6  7  7  7  2  0   "
"6 "
"10 "
"3 "
"19 0  4 0  0  0  0   8  4 1  0  0  0   17  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   18  4 0  0  0  0   13  4 1  1  1  0   10  4 1  1  0  0   14  4 1  1  1  0   16  4 1  1  1  0   5  4 0  0  0  0   15  4 1  1  1  0   11  4 1  1  0  0   12  4 1  1  0  0   "
"19 "
"2 0  16 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!OD1  3!ND2  4!1HD2  4!2HD2  2!H2  2!H3   1  16 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!OD1  3!ND2  2!H1  4!1HD2  4!2HD2  2!HA  3!1HB  3!2HB  2!H2  2!H3   "
"2 10  1  "
"1 "
"16 13  -1.296 1.927 -0.647  0  2.302 -0.479 -0.613  5  0.489 0.105 -1.543  12  -2.875 1.338 0.098  8  0.639 -0.106 1.551  14  0.829 -2.386 -1.09  6  0.278 0.381 0.624  4  0.793 -0.41 -0.613  3  0.074 -2.057 0.339  9  -1.24 0.532 0.768  1  2.906 -1.551 -0.613  2  0.209 -1.748 -0.613  7  0.73 1.39 0.652  15  -0.682 -1.726 -1.089  10  -1.895 -0.168 1.526  11  -1.857 1.423 0.039  "
"2 2 9  -1   2 0  -1   "
"2 "
"16 0  3 -1  -1  -1   8  3 6  4  9   14  3 -1  -1  -1   12  3 11  9  6   4  3 -1  -1  -1   3  3 -1  -1  -1   13  3 11  9  6   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   15  3 -1  -1  -1   10  3 -1  -1  -1   6  3 -1  -1  -1   9  3 -1  -1  -1   11  3 -1  -1  -1   5  3 4  2  0   "
"2 4 2  4  6  9   4 4  6  9  10   "
"3 9  10  11  "
"8 "
"3 "
"16 16 0  1  2  3  1  2  2  3  3  3  4  4  5  5  3  3   16 1  0  3  4  2  3  3  4  4  4  5  5  6  6  4  4   16 2  3  0  1  1  2  2  3  3  3  4  4  5  5  1  1   16 3  4  1  0  2  3  3  4  4  4  5  5  6  6  2  2   16 1  2  1  2  0  1  1  2  2  2  3  3  4  4  2  2   16 2  3  2  3  1  0  2  3  3  3  4  4  5  5  3  3   16 2  3  2  3  1  2  0  1  1  1  2  2  3  3  3  3   16 3  4  3  4  2  3  1  0  2  2  3  3  4  4  4  4   16 3  4  3  4  2  3  1  2  0  2  3  3  4  4  4  4   16 3  4  3  4  2  3  1  2  2  0  1  1  2  2  4  4   16 4  5  4  5  3  4  2  3  3  1  0  2  3  3  5  5   16 4  5  4  5  3  4  2  3  3  1  2  0  1  1  5  5   16 5  6  5  6  4  5  3  4  4  2  3  1  0  2  6  6   16 5  6  5  6  4  5  3  4  4  2  3  1  2  0  6  6   16 3  4  1  2  2  3  3  4  4  4  5  5  6  6  0  2   16 3  4  1  2  2  3  3  4  4  4  5  5  6  6  2  0   "
"6 "
"11 "
"2 "
"16 13  4 1  1  0  0   0  4 0  0  0  0   8  4 1  0  0  0   12  4 1  1  0  0   14  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   15  4 0  0  0  0   10  4 1  1  0  0   11  4 1  1  0  0   5  4 0  0  0  0   "
"16 "
"2 0  16 1!C  1!O  1!N  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!1HD  3!2HD  2!H1  2!H2   1  16 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  3!1HD  3!2HD  3!1HG  3!2HG  3!1HB  3!2HB  2!HA  2!H1  2!H2   "
"1 1  "
"0 "
"16 0  15.959 1.321 8.222  7  15.782 3.034 10.843  4  15.27 3.16 8.805  15  13.714 1.003 8.895  5  15.927 2.223 10.577  3  15.259 2.242 9.192  14  13.273 2.584 9.205  8  15.069 1.31 11.409  1  15.702 0.132 8.143  2  13.895 1.827 9.451  6  16.695 1.763 10.389  9  15.229 0.51 11.182  12  13.189 0.65 10.821  11  13.672 1.471 10.862  13  13.219 2.235 11.206  10  14.957 1.715 12.247  "
"1 2 0  -1   "
"1 "
"16 0  3 -1  -1  -1   4  3 3  2  0   15  3 -1  -1  -1   5  3 -1  -1  -1   3  3 -1  -1  -1   14  3 -1  -1  -1   8  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   6  3 5  3  8   11  3 -1  -1  -1   9  3 8  5  11   12  3 11  2  8   7  3 5  3  8   13  3 11  2  8   10  3 8  5  11   "
"1 4 2  3  5  8   "
"3 5  8  11  "
"7 "
"3 "
"16 16 0  1  2  1  2  2  3  3  3  4  4  3  4  4  3  3   16 1  0  3  2  3  3  4  4  4  5  5  4  5  5  4  4   16 2  3  0  1  2  2  3  3  2  3  3  1  2  2  1  1   16 1  2  1  0  1  1  2  2  2  3  3  2  3  3  2  2   16 2  3  2  1  0  2  3  3  3  4  4  3  4  4  3  3   16 2  3  2  1  2  0  1  1  1  2  2  2  3  3  3  3   16 3  4  3  2  3  1  0  2  2  3  3  3  4  4  4  4   16 3  4  3  2  3  1  2  0  2  3  3  3  4  4  4  4   16 3  4  2  2  3  1  2  2  0  1  1  1  2  2  3  3   16 4  5  3  3  4  2  3  3  1  0  2  2  3  3  4  4   16 4  5  3  3  4  2  3  3  1  2  0  2  3  3  4  4   16 3  4  1  2  3  2  3  3  1  2  2  0  1  1  2  2   16 4  5  2  3  4  3  4  4  2  3  3  1  0  2  3  3   16 4  5  2  3  4  3  4  4  2  3  3  1  2  0  3  3   16 3  4  1  2  3  3  4  4  3  4  4  2  3  3  0  2   16 3  4  1  2  3  3  4  4  3  4  4  2  3  3  2  0   "
"5 "
"12 "
"1 "
"16 0  4 0  0  0  0   7  4 1  0  0  0   15  4 0  0  0  0   5  4 0  0  0  0   3  4 0  0  0  0   14  4 0  0  0  0   8  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   6  4 1  0  0  0   11  4 0  0  0  0   9  4 1  0  0  0   12  4 0  0  0  0   4  4 0  0  0  0   13  4 0  0  0  0   10  4 1  0  0  0   "
"16 "
"2 0  19 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!OE1  3!NE2  4!1HE2  4!2HE2  2!H2  2!H3   1  19 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  3!OE1  3!NE2  2!H1  4!1HE2  4!2HE2  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  2!H2  2!H3   "
"2 13  1  "
"1 "
"19 7  0.002 -0.934 0.761  0  1.751 -1.162 -1.387  16  -1.262 0.359 1.967  5  -0.083 -0.615 -2.31  8  -1.404 -0.411 -0.164  17  0.324 -3.106 -1.864  6  -0.297 -0.376 -0.151  4  0.241 -1.131 -1.387  3  -0.439 -2.794 -0.435  9  0.152 1.115 -0.003  1  2.38 -2.218 -1.387  2  -0.311 -2.482 -1.387  15  -1.249 1.921 2.955  10  -0.15 1.693 -0.896  18  -1.202 -2.481 -1.863  12  -0.293 1.91 1.231  14  -1.052 1.345 2.135  13  0.069 3.064 1.402  11  1.255 1.185 0.008  "
"2 2 12  -1   2 0  -1   "
"2 "
"19 0  3 -1  -1  -1   8  3 6  4  9   3  3 -1  -1  -1   17  3 -1  -1  -1   6  3 -1  -1  -1   15  3 14  12  9   16  3 14  12  9   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   12  3 -1  -1  -1   10  3 9  6  12   18  3 -1  -1  -1   13  3 -1  -1  -1   5  3 4  2  0   14  3 -1  -1  -1   4  3 -1  -1  -1   11  3 9  6  12   "
"3 4 2  4  6  9   4 4  6  9  12   4 6  9  12  13   "
"3 12  13  14  "
"9 "
"3 "
"19 19 0  1  2  3  1  2  2  3  3  3  4  4  4  5  5  6  6  3  3   19 1  0  3  4  2  3  3  4  4  4  5  5  5  6  6  7  7  4  4   19 2  3  0  1  1  2  2  3  3  3  4  4  4  5  5  6  6  1  1   19 3  4  1  0  2  3  3  4  4  4  5  5  5  6  6  7  7  2  2   19 1  2  1  2  0  1  1  2  2  2  3  3  3  4  4  5  5  2  2   19 2  3  2  3  1  0  2  3  3  3  4  4  4  5  5  6  6  3  3   19 2  3  2  3  1  2  0  1  1  1  2  2  2  3  3  4  4  3  3   19 3  4  3  4  2  3  1  0  2  2  3  3  3  4  4  5  5  4  4   19 3  4  3  4  2  3  1  2  0  2  3  3  3  4  4  5  5  4  4   19 3  4  3  4  2  3  1  2  2  0  1  1  1  2  2  3  3  4  4   19 4  5  4  5  3  4  2  3  3  1  0  2  2  3  3  4  4  5  5   19 4  5  4  5  3  4  2  3  3  1  2  0  2  3  3  4  4  5  5   19 4  5  4  5  3  4  2  3  3  1  2  2  0  1  1  2  2  5  5   19 5  6  5  6  4  5  3  4  4  2  3  3  1  0  2  3  3  6  6   19 5  6  5  6  4  5  3  4  4  2  3  3  1  2  0  1  1  6  6   19 6  7  6  7  5  6  4  5  5  3  4  4  2  3  1  0  2  7  7   19 6  7  6  7  5  6  4  5  5  3  4  4  2  3  1  2  0  7  7   19 3  4  1  2  2  3  3  4  4  4  5  5  5  6  6  7  7  0  2   19 3  4  1  2  2  3  3  4  4  4  5  5  5  6  6  7  7  2  0   "
"6 "
"13 "
"3 "
"19 0  4 0  0  0  0   8  4 1  0  0  0   17  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   9  4 1  0  0  0   16  4 1  1  1  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   12  4 1  1  0  0   10  4 1  1  0  0   15  4 1  1  1  0   18  4 0  0  0  0   5  4 0  0  0  0   14  4 1  1  1  0   13  4 1  1  1  0   11  4 1  1  0  0   "
"19 "
"2 0  26 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!1HD  3!2HD  2!NE  2!HE  2!CZ  3!NH1  4!1HH1  4!2HH1  3!NH2  4!1HH2  4!2HH2  2!H2  2!H3   1  26 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  2!NE  2!CZ  3!NH1  3!NH2  2!H1  4!1HH1  4!2HH1  4!1HH2  4!2HH2  2!HE  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  3!1HD  3!2HD  2!H2  2!H3   "
"1 1  "
"1 "
"26 5  0.211 -3.538 0.443  16  0.348 0.865 -2.071  15  -0.136 1.349 -1.308  23  -0.502 4.005 -3.0  0  2.029 -2.951 1.374  20  -1.365 4.326 -1.087  6  -0.063 -1.527 1.282  4  0.519 -2.968 1.34  9  0.188 -0.757 -0.045  1  2.666 -3.478 2.283  2  -0.022 -3.647 2.514  7  0.336 -0.947 2.14  17  -0.497 2.593 -1.608  18  -1.121 3.383 -0.78  10  -0.252 -1.33 -0.887  13  0.08 1.23 0.834  21  -0.215 3.048 -2.788  8  -1.156 -1.569 1.465  14  -1.476 0.622 0.217  11  1.276 -0.706 -0.255  24  0.558 -4.442 2.741  25  -0.961 -3.963 2.316  3  -0.04 -3.007 3.295  12  -0.388 0.668 -0.004  22  0.275 2.415 -3.423  19  -1.312 2.964 0.133  "
"1 2 0  -1   "
"1 "
"26 5  3 4  2  0   16  3 15  12  17   15  3 -1  -1  -1   23  3 21  17  15   0  3 -1  -1  -1   20  3 18  17  15   6  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   17  3 -1  -1  -1   18  3 -1  -1  -1   10  3 9  6  12   13  3 12  9  15   21  3 -1  -1  -1   8  3 6  4  9   14  3 12  9  15   11  3 9  6  12   24  3 -1  -1  -1   25  3 -1  -1  -1   3  3 -1  -1  -1   12  3 -1  -1  -1   22  3 21  17  15   19  3 18  17  15   "
"4 4 2  4  6  9   4 4  6  9  12   4 6  9  12  15   4 9  12  15  17   "
"1 17  "
"11 "
"1 "
"26 26 0  1  2  3  1  2  2  3  3  3  4  4  4  5  5  5  6  6  7  8  8  7  8  8  3  3   26 1  0  3  4  2  3  3  4  4  4  5  5  5  6  6  6  7  7  8  9  9  8  9  9  4  4   26 2  3  0  1  1  2  2  3  3  3  4  4  4  5  5  5  6  6  7  8  8  7  8  8  1  1   26 3  4  1  0  2  3  3  4  4  4  5  5  5  6  6  6  7  7  8  9  9  8  9  9  2  2   26 1  2  1  2  0  1  1  2  2  2  3  3  3  4  4  4  5  5  6  7  7  6  7  7  2  2   26 2  3  2  3  1  0  2  3  3  3  4  4  4  5  5  5  6  6  7  8  8  7  8  8  3  3   26 2  3  2  3  1  2  0  1  1  1  2  2  2  3  3  3  4  4  5  6  6  5  6  6  3  3   26 3  4  3  4  2  3  1  0  2  2  3  3  3  4  4  4  5  5  6  7  7  6  7  7  4  4   26 3  4  3  4  2  3  1  2  0  2  3  3  3  4  4  4  5  5  6  7  7  6  7  7  4  4   26 3  4  3  4  2  3  1  2  2  0  1  1  1  2  2  2  3  3  4  5  5  4  5  5  4  4   26 4  5  4  5  3  4  2  3  3  1  0  2  2  3  3  3  4  4  5  6  6  5  6  6  5  5   26 4  5  4  5  3  4  2  3  3  1  2  0  2  3  3  3  4  4  5  6  6  5  6  6  5  5   26 4  5  4  5  3  4  2  3  3  1  2  2  0  1  1  1  2  2  3  4  4  3  4  4  5  5   26 5  6  5  6  4  5  3  4  4  2  3  3  1  0  2  2  3  3  4  5  5  4  5  5  6  6   26 5  6  5  6  4  5  3  4  4  2  3  3  1  2  0  2  3  3  4  5  5  4  5  5  6  6   26 5  6  5  6  4  5  3  4  4  2  3  3  1  2  2  0  1  1  2  3  3  2  3  3  6  6   26 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  0  2  3  4  4  3  4  4  7  7   26 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  2  0  1  2  2  1  2  2  7  7   26 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  1  0  1  1  2  3  3  8  8   26 8  9  8  9  7  8  6  7  7  5  6  6  4  5  5  3  4  2  1  0  2  3  4  4  9  9   26 8  9  8  9  7  8  6  7  7  5  6  6  4  5  5  3  4  2  1  2  0  3  4  4  9  9   26 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  1  2  3  3  0  1  1  8  8   26 8  9  8  9  7  8  6  7  7  5  6  6  4  5  5  3  4  2  3  4  4  1  0  2  9  9   26 8  9  8  9  7  8  6  7  7  5  6  6  4  5  5  3  4  2  3  4  4  1  2  0  9  9   26 3  4  1  2  2  3  3  4  4  4  5  5  5  6  6  6  7  7  8  9  9  8  9  9  0  2   26 3  4  1  2  2  3  3  4  4  4  5  5  5  6  6  6  7  7  8  9  9  8  9  9  2  0   "
"6 "
"14 "
"4 "
"26 5  4 0  0  0  0   16  4 1  1  1  1   15  4 1  1  1  0   23  4 1  1  1  1   0  4 0  0  0  0   20  4 1  1  1  1   6  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   17  4 1  1  1  1   18  4 1  1  1  1   10  4 1  1  0  0   13  4 1  1  1  0   21  4 1  1  1  1   8  4 1  0  0  0   14  4 1  1  1  0   11  4 1  1  0  0   24  4 0  0  0  0   25  4 0  0  0  0   3  4 0  0  0  0   12  4 1  1  0  0   22  4 1  1  1  1   19  4 1  1  1  1   "
"26 "
"2 0  13 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!OG  2!HG  2!H2  2!H3   1  13 1!N  2!CA  1!C  1!O  2!CB  2!OG  2!H1  2!HG  2!HA  3!1HB  3!2HB  2!H2  2!H3   "
"2 9  1  "
"1 "
"13 0  1.515 -0.044 -0.688  8  -0.153 1.976 0.384  9  -0.029 0.446 1.769  6  -0.494 0.929 0.504  4  0.009 0.077 -0.688  3  -0.767 -1.544 0.264  1  2.081 -1.137 -0.688  2  -0.621 -1.24 -0.688  7  -1.599 0.989 0.515  11  -0.024 -1.9 -1.165  12  -1.511 -1.187 -1.163  5  -0.271 0.589 -1.627  10  -0.393 -0.434 1.892  "
"2 2 10  -1   2 0  -1   "
"2 "
"13 0  3 -1  -1  -1   8  3 6  4  9   9  3 -1  -1  -1   6  3 -1  -1  -1   4  3 -1  -1  -1   3  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   11  3 -1  -1  -1   12  3 -1  -1  -1   5  3 4  2  0   10  3 9  6  4   "
"2 4 2  4  6  9   4 4  6  9  10   "
"1 9  "
"6 "
"1 "
"13 13 0  1  2  3  1  2  2  3  3  3  4  3  3   13 1  0  3  4  2  3  3  4  4  4  5  4  4   13 2  3  0  1  1  2  2  3  3  3  4  1  1   13 3  4  1  0  2  3  3  4  4  4  5  2  2   13 1  2  1  2  0  1  1  2  2  2  3  2  2   13 2  3  2  3  1  0  2  3  3  3  4  3  3   13 2  3  2  3  1  2  0  1  1  1  2  3  3   13 3  4  3  4  2  3  1  0  2  2  3  4  4   13 3  4  3  4  2  3  1  2  0  2  3  4  4   13 3  4  3  4  2  3  1  2  2  0  1  4  4   13 4  5  4  5  3  4  2  3  3  1  0  5  5   13 3  4  1  2  2  3  3  4  4  4  5  0  2   13 3  4  1  2  2  3  3  4  4  4  5  2  0   "
"6 "
"15 "
"2 "
"13 0  4 0  0  0  0   8  4 1  0  0  0   9  4 1  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   11  4 0  0  0  0   12  4 0  0  0  0   5  4 0  0  0  0   10  4 1  1  0  0   "
"13 "
"2 0  16 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  2!HB  3!CG2  4!1HG2  4!2HG2  4!3HG2  3!OG1  3!HG1  2!H2  2!H3   1  16 1!N  2!CA  1!C  1!O  2!CB  3!OG1  3!CG2  2!H1  3!HG1  2!HA  2!HB  4!1HG2  4!2HG2  4!3HG2  2!H2  2!H3   "
"2 12  1  "
"1 "
"16 10  1.279 1.581 0.706  0  1.603 -0.786 -0.796  5  -0.197 -0.158 -1.725  14  0.082 -2.657 -1.274  6  -0.399 0.159 0.429  4  0.097 -0.68 -0.796  3  -0.664 -2.308 0.156  12  -1.806 0.353 0.365  1  2.172 -1.859 -0.796  2  -0.521 -2.002 -0.796  9  -0.231 2.12 1.438  13  -2.05 0.808 1.177  15  -1.411 -1.957 -1.272  7  -0.161 -0.405 1.358  8  0.182 1.583 0.564  11  -0.03 2.199 -0.329  "
"2 2 13  -1   2 0  -1   "
"2 "
"16 10  3 8  6  4   0  3 -1  -1  -1   8  3 -1  -1  -1   14  3 -1  -1  -1   6  3 -1  -1  -1   11  3 8  6  4   3  3 -1  -1  -1   12  3 -1  -1  -1   1  3 -1  -1  -1   13  3 12  6  4   2  3 -1  -1  -1   9  3 8  6  4   15  3 -1  -1  -1   7  3 6  4  12   5  3 4  2  0   4  3 -1  -1  -1   "
"2 4 2  4  6  12   4 4  6  12  13   "
"1 12  "
"7 "
"1 "
"16 16 0  1  2  3  1  2  2  3  3  4  4  4  3  4  3  3   16 1  0  3  4  2  3  3  4  4  5  5  5  4  5  4  4   16 2  3  0  1  1  2  2  3  3  4  4  4  3  4  1  1   16 3  4  1  0  2  3  3  4  4  5  5  5  4  5  2  2   16 1  2  1  2  0  1  1  2  2  3  3  3  2  3  2  2   16 2  3  2  3  1  0  2  3  3  4  4  4  3  4  3  3   16 2  3  2  3  1  2  0  1  1  2  2  2  1  2  3  3   16 3  4  3  4  2  3  1  0  2  3  3  3  2  3  4  4   16 3  4  3  4  2  3  1  2  0  1  1  1  2  3  4  4   16 4  5  4  5  3  4  2  3  1  0  2  2  3  4  5  5   16 4  5  4  5  3  4  2  3  1  2  0  2  3  4  5  5   16 4  5  4  5  3  4  2  3  1  2  2  0  3  4  5  5   16 3  4  3  4  2  3  1  2  2  3  3  3  0  1  4  4   16 4  5  4  5  3  4  2  3  3  4  4  4  1  0  5  5   16 3  4  1  2  2  3  3  4  4  5  5  5  4  5  0  2   16 3  4  1  2  2  3  3  4  4  5  5  5  4  5  2  0   "
"6 "
"16 "
"2 "
"16 10  4 1  0  0  0   0  4 0  0  0  0   8  4 1  0  0  0   14  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   12  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   9  4 1  0  0  0   13  4 1  1  0  0   15  4 0  0  0  0   7  4 1  0  0  0   5  4 0  0  0  0   11  4 1  0  0  0   "
"16 "
"2 0  18 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  2!HB  3!CG1  4!1HG1  4!2HG1  4!3HG1  3!CG2  4!1HG2  4!2HG2  4!3HG2  2!H2  2!H3   1  18 1!N  2!CA  1!C  1!O  2!CB  3!CG1  3!CG2  2!H1  2!HA  2!HB  4!1HG1  4!2HG1  4!3HG1  4!1HG2  4!2HG2  4!3HG2  2!H2  2!H3   "
"1 1  "
"0 "
"18 14  -2.037 0.772 1.307  0  1.941 -0.681 -0.848  5  0.107 -0.178 -1.776  16  0.559 -2.656 -1.325  6  -0.132 0.106 0.4  4  0.431 -0.683 -0.848  3  -0.21 -2.362 0.104  10  0.036 2.003 1.548  1  2.599 -1.729 -0.848  2  -0.09 -2.047 -0.848  7  0.097 -0.501 1.302  13  -2.209 -0.64 0.259  11  1.558 1.482 0.848  9  0.314 2.202 -0.201  8  0.469 1.516 0.653  17  -0.981 -2.067 -1.324  12  -1.665 0.316 0.369  15  -1.983 0.971 -0.464  "
"1 2 0  -1   "
"1 "
"18 14  3 12  6  4   10  3 8  6  4   12  3 -1  -1  -1   16  3 -1  -1  -1   11  3 8  6  4   15  3 12  6  4   3  3 -1  -1  -1   0  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   8  3 -1  -1  -1   13  3 12  6  4   9  3 8  6  4   7  3 6  4  8   17  3 -1  -1  -1   5  3 4  2  0   4  3 -1  -1  -1   6  3 -1  -1  -1   "
"1 4 2  4  6  8   "
"3 6  8  12  "
"7 "
"3 "
"18 18 0  1  2  3  1  2  2  3  3  4  4  4  3  4  4  4  3  3   18 1  0  3  4  2  3  3  4  4  5  5  5  4  5  5  5  4  4   18 2  3  0  1  1  2  2  3  3  4  4  4  3  4  4  4  1  1   18 3  4  1  0  2  3  3  4  4  5  5  5  4  5  5  5  2  2   18 1  2  1  2  0  1  1  2  2  3  3  3  2  3  3  3  2  2   18 2  3  2  3  1  0  2  3  3  4  4  4  3  4  4  4  3  3   18 2  3  2  3  1  2  0  1  1  2  2  2  1  2  2  2  3  3   18 3  4  3  4  2  3  1  0  2  3  3  3  2  3  3  3  4  4   18 3  4  3  4  2  3  1  2  0  1  1  1  2  3  3  3  4  4   18 4  5  4  5  3  4  2  3  1  0  2  2  3  4  4  4  5  5   18 4  5  4  5  3  4  2  3  1  2  0  2  3  4  4  4  5  5   18 4  5  4  5  3  4  2  3  1  2  2  0  3  4  4  4  5  5   18 3  4  3  4  2  3  1  2  2  3  3  3  0  1  1  1  4  4   18 4  5  4  5  3  4  2  3  3  4  4  4  1  0  2  2  5  5   18 4  5  4  5  3  4  2  3  3  4  4  4  1  2  0  2  5  5   18 4  5  4  5  3  4  2  3  3  4  4  4  1  2  2  0  5  5   18 3  4  1  2  2  3  3  4  4  5  5  5  4  5  5  5  0  2   18 3  4  1  2  2  3  3  4  4  5  5  5  4  5  5  5  2  0   "
"6 "
"17 "
"1 "
"18 14  4 1  0  0  0   0  4 0  0  0  0   12  4 1  0  0  0   16  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   3  4 0  0  0  0   10  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   8  4 1  0  0  0   13  4 1  0  0  0   11  4 1  0  0  0   9  4 1  0  0  0   7  4 1  0  0  0   17  4 0  0  0  0   5  4 0  0  0  0   15  4 1  0  0  0   "
"18 "
"2 0  26 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!CD1  3!HD1  3!CD2  3!NE1  3!HE1  3!CE2  3!CE3  3!HE3  3!CZ2  3!HZ2  3!CZ3  3!HZ3  3!CH2  3!HH2  2!H2  2!H3   1  26 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!CD1  3!CD2  3!NE1  3!CE2  3!CE3  3!CZ2  3!CZ3  3!CH2  2!H1  3!HE1  3!HD1  3!HZ2  3!HH2  3!HZ3  3!HE3  2!HA  3!1HB  3!2HB  2!H2  2!H3   "
"1 1  "
"0 "
"26 23  -3.125 3.014 -1.515  18  -2.849 1.335 -0.209  20  -1.04 2.53 -1.322  10  -0.79 -1.06 1.502  12  -0.515 0.672 0.13  5  1.873 -0.855 -1.36  14  -2.984 -0.976 1.575  17  0.971 1.839 -0.961  22  -2.405 2.353 -1.057  21  -0.724 3.323 -1.985  19  -3.902 1.197 -0.013  0  3.702 -1.404 -0.428  6  1.688 -0.573 0.812  4  2.192 -1.361 -0.429  9  0.182 -0.294 0.826  1  4.323 -2.465 -0.405  2  1.63 -2.708 -0.4  7  2.208 0.401 0.884  16  -0.079 1.7 -0.745  15  -1.895 0.486 0.393  8  1.972 -1.104 1.742  11  -0.561 -1.932 2.101  24  2.26 -3.346 -0.866  25  0.738 -2.711 -0.873  3  1.503 -3.0 0.558  13  -2.092 -0.588 1.248  "
"1 2 0  -1   "
"1 "
"26 23  3 22  18  20   18  3 -1  -1  -1   20  3 -1  -1  -1   10  3 -1  -1  -1   12  3 -1  -1  -1   5  3 4  2  0   14  3 13  10  15   17  3 16  12  20   22  3 -1  -1  -1   21  3 20  16  22   19  3 18  15  22   0  3 -1  -1  -1   6  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   16  3 -1  -1  -1   15  3 -1  -1  -1   8  3 6  4  9   11  3 10  9  13   24  3 -1  -1  -1   25  3 -1  -1  -1   3  3 -1  -1  -1   13  3 -1  -1  -1   "
"2 4 2  4  6  9   4 4  6  9  10   "
"2 12  15  "
"14 "
"2 "
"26 26 0  1  2  3  1  2  2  3  3  3  4  5  4  5  6  5  5  6  6  7  6  7  7  8  3  3   26 1  0  3  4  2  3  3  4  4  4  5  6  5  6  7  6  6  7  7  8  7  8  8  9  4  4   26 2  3  0  1  1  2  2  3  3  3  4  5  4  5  6  5  5  6  6  7  6  7  7  8  1  1   26 3  4  1  0  2  3  3  4  4  4  5  6  5  6  7  6  6  7  7  8  7  8  8  9  2  2   26 1  2  1  2  0  1  1  2  2  2  3  4  3  4  5  4  4  5  5  6  5  6  6  7  2  2   26 2  3  2  3  1  0  2  3  3  3  4  5  4  5  6  5  5  6  6  7  6  7  7  8  3  3   26 2  3  2  3  1  2  0  1  1  1  2  3  2  3  4  3  3  4  4  5  4  5  5  6  3  3   26 3  4  3  4  2  3  1  0  2  2  3  4  3  4  5  4  4  5  5  6  5  6  6  7  4  4   26 3  4  3  4  2  3  1  2  0  2  3  4  3  4  5  4  4  5  5  6  5  6  6  7  4  4   26 3  4  3  4  2  3  1  2  2  0  1  2  1  2  3  2  2  3  3  4  3  4  4  5  4  4   26 4  5  4  5  3  4  2  3  3  1  0  1  2  1  2  2  3  4  3  4  4  5  4  5  5  5   26 5  6  5  6  4  5  3  4  4  2  1  0  3  2  3  3  4  5  4  5  5  6  5  6  6  6   26 4  5  4  5  3  4  2  3  3  1  2  3  0  2  3  1  1  2  2  3  2  3  3  4  5  5   26 5  6  5  6  4  5  3  4  4  2  1  2  2  0  1  1  3  4  2  3  4  5  3  4  6  6   26 6  7  6  7  5  6  4  5  5  3  2  3  3  1  0  2  4  5  3  4  5  6  4  5  7  7   26 5  6  5  6  4  5  3  4  4  2  2  3  1  1  2  0  2  3  1  2  3  4  2  3  6  6   26 5  6  5  6  4  5  3  4  4  2  3  4  1  3  4  2  0  1  3  4  1  2  2  3  6  6   26 6  7  6  7  5  6  4  5  5  3  4  5  2  4  5  3  1  0  4  5  2  3  3  4  7  7   26 6  7  6  7  5  6  4  5  5  3  3  4  2  2  3  1  3  4  0  1  2  3  1  2  7  7   26 7  8  7  8  6  7  5  6  6  4  4  5  3  3  4  2  4  5  1  0  3  4  2  3  8  8   26 6  7  6  7  5  6  4  5  5  3  4  5  2  4  5  3  1  2  2  3  0  1  1  2  7  7   26 7  8  7  8  6  7  5  6  6  4  5  6  3  5  6  4  2  3  3  4  1  0  2  3  8  8   26 7  8  7  8  6  7  5  6  6  4  5  6  3  3  4  2  2  3  1  2  1  2  0  1  8  8   26 8  9  8  9  7  8  6  7  7  5  6  7  4  4  5  3  3  4  2  3  2  3  1  0  9  9   26 3  4  1  2  2  3  3  4  4  4  5  6  5  6  7  6  6  7  7  8  7  8  8  9  0  2   26 3  4  1  2  2  3  3  4  4  4  5  6  5  6  7  6  6  7  7  8  7  8  8  9  2  0   "
"6 "
"18 "
"2 "
"26 23  4 1  1  0  0   18  4 1  1  0  0   20  4 1  1  0  0   10  4 1  1  0  0   12  4 1  1  0  0   5  4 0  0  0  0   14  4 1  1  0  0   17  4 1  1  0  0   22  4 1  1  0  0   21  4 1  1  0  0   19  4 1  1  0  0   0  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   16  4 1  1  0  0   15  4 1  1  0  0   8  4 1  0  0  0   11  4 1  1  0  0   24  4 0  0  0  0   25  4 0  0  0  0   3  4 0  0  0  0   13  4 1  1  0  0   "
"26 "
"2 0  23 1!C  1!O  1!N  2!H1  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!CD1  3!HD1  3!CD2  3!HD2  3!CE1  3!HE1  3!CE2  3!HE2  2!CZ  2!OH  2!HH  2!H2  2!H3   1  23 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!CD1  3!CD2  3!CE1  3!CE2  2!CZ  2!OH  2!H1  2!HH  3!HD1  3!HE1  3!HE2  3!HD2  2!HA  3!1HB  3!2HB  2!H2  2!H3   "
"2 1  19  "
"0 "
"23 20  -2.136 3.213 -2.386  10  0.807 0.254 -1.296  12  -0.647 1.164 0.406  5  0.816 -2.559 0.15  15  0.504 1.017 -3.282  17  -2.068 2.623 -0.253  0  1.441 -2.79 2.171  6  1.052 -0.589 1.096  4  0.612 -2.082 1.127  9  0.39 0.302 0.038  1  0.927 -3.375 3.128  2  -0.813 -2.199 1.423  7  2.148 -0.527 0.945  18  -0.846 1.912 -1.877  16  -1.264 1.966 -0.549  14  0.188 1.057 -2.25  8  0.905 -0.142 2.101  13  -0.984 1.203 1.433  11  1.605 -0.411 -1.596  19  -1.452 2.696 -2.817  21  -0.987 -3.068 1.907  22  -1.338 -2.184 0.56  3  -1.102 -1.426 2.005  "
"2 2 0  -1   2 20  -1   "
"2 "
"23 20  3 19  18  14   10  3 -1  -1  -1   12  3 -1  -1  -1   5  3 4  2  0   15  3 14  10  18   17  3 16  12  18   0  3 -1  -1  -1   6  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   18  3 -1  -1  -1   16  3 -1  -1  -1   14  3 -1  -1  -1   8  3 6  4  9   13  3 12  9  16   11  3 10  9  14   19  3 -1  -1  -1   21  3 -1  -1  -1   22  3 -1  -1  -1   3  3 -1  -1  -1   "
"3 4 2  4  6  9   4 4  6  9  10   4 16  18  19  20   "
"2 9  18  "
"12 "
"2 "
"23 23 0  1  2  3  1  2  2  3  3  3  4  5  4  5  5  6  5  6  6  7  8  3  3   23 1  0  3  4  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  9  4  4   23 2  3  0  1  1  2  2  3  3  3  4  5  4  5  5  6  5  6  6  7  8  1  1   23 3  4  1  0  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  9  2  2   23 1  2  1  2  0  1  1  2  2  2  3  4  3  4  4  5  4  5  5  6  7  2  2   23 2  3  2  3  1  0  2  3  3  3  4  5  4  5  5  6  5  6  6  7  8  3  3   23 2  3  2  3  1  2  0  1  1  1  2  3  2  3  3  4  3  4  4  5  6  3  3   23 3  4  3  4  2  3  1  0  2  2  3  4  3  4  4  5  4  5  5  6  7  4  4   23 3  4  3  4  2  3  1  2  0  2  3  4  3  4  4  5  4  5  5  6  7  4  4   23 3  4  3  4  2  3  1  2  2  0  1  2  1  2  2  3  2  3  3  4  5  4  4   23 4  5  4  5  3  4  2  3  3  1  0  1  2  3  1  2  3  4  2  3  4  5  5   23 5  6  5  6  4  5  3  4  4  2  1  0  3  4  2  3  4  5  3  4  5  6  6   23 4  5  4  5  3  4  2  3  3  1  2  3  0  1  3  4  1  2  2  3  4  5  5   23 5  6  5  6  4  5  3  4  4  2  3  4  1  0  4  5  2  3  3  4  5  6  6   23 5  6  5  6  4  5  3  4  4  2  1  2  3  4  0  1  2  3  1  2  3  6  6   23 6  7  6  7  5  6  4  5  5  3  2  3  4  5  1  0  3  4  2  3  4  7  7   23 5  6  5  6  4  5  3  4  4  2  3  4  1  2  2  3  0  1  1  2  3  6  6   23 6  7  6  7  5  6  4  5  5  3  4  5  2  3  3  4  1  0  2  3  4  7  7   23 6  7  6  7  5  6  4  5  5  3  2  3  2  3  1  2  1  2  0  1  2  7  7   23 7  8  7  8  6  7  5  6  6  4  3  4  3  4  2  3  2  3  1  0  1  8  8   23 8  9  8  9  7  8  6  7  7  5  4  5  4  5  3  4  3  4  2  1  0  9  9   23 3  4  1  2  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  9  0  2   23 3  4  1  2  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  9  2  0   "
"6 "
"19 "
"3 "
"23 20  4 1  1  1  0   10  4 1  1  0  0   12  4 1  1  0  0   5  4 0  0  0  0   15  4 1  1  0  0   17  4 1  1  0  0   0  4 0  0  0  0   6  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   18  4 1  1  0  0   16  4 1  1  0  0   14  4 1  1  0  0   8  4 1  0  0  0   13  4 1  1  0  0   11  4 1  1  0  0   19  4 1  1  0  0   21  4 0  0  0  0   22  4 0  0  0  0   3  4 0  0  0  0   "
"23 "
"2 0  11 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  3!3HB  3!OXT   1  11 1!N  2!CA  1!C  1!O  2!CB  1!H  2!HA  3!1HB  3!2HB  3!3HB  3!OXT   "
"1 1  "
"0 "
"11 0  0.0 2.688 5.506  8  -1.147 3.806 2.455  10  0.0 3.741 6.179  6  -1.196 3.659 3.534  4  0.0 2.836 3.99  1  0.0 1.55 6.0229  2  0.0 1.534 3.334  7  -1.181 4.628 4.033  9  -2.116 3.135 3.788  3  -0.047 0.707 3.912  5  0.912 3.366 3.715  "
"1 2 0  -1   "
"1 "
"11 0  3 -1  -1  -1   8  3 6  4  2   10  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  2   9  3 6  4  2   6  3 -1  -1  -1   5  3 4  2  0   "
""
"1 6  "
"6 "
"1 "
"11 11 0  1  2  3  1  2  2  3  3  3  1   11 1  0  3  4  2  3  3  4  4  4  2   11 2  3  0  1  1  2  2  3  3  3  3   11 3  4  1  0  2  3  3  4  4  4  4   11 1  2  1  2  0  1  1  2  2  2  2   11 2  3  2  3  1  0  2  3  3  3  3   11 2  3  2  3  1  2  0  1  1  1  3   11 3  4  3  4  2  3  1  0  2  2  4   11 3  4  3  4  2  3  1  2  0  2  4   11 3  4  3  4  2  3  1  2  2  0  4   11 1  2  3  4  2  3  3  4  4  4  0   "
"6 "
"0 "
"0 "
"11 0  4 0  0  0  0   8  4 0  0  0  0   10  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 0  0  0  0   9  4 0  0  0  0   6  4 0  0  0  0   5  4 0  0  0  0   "
"11 "
"2 0  12 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!SG  2!HG  3!OXT   1  12 1!N  2!CA  1!C  1!O  2!CB  2!SG  1!H  2!HA  3!1HB  3!2HB  2!HG  3!OXT   "
"1 1  "
"0 "
"12 0  0.0 5.168 8.329  8  2.156 3.632 7.616  11  0.0 5.215 9.578  6  1.312 3.069 8.014  4  0.0 3.783 7.688  1  0.0 6.1899 7.6091  2  0.0 3.807 6.224  7  1.311 2.065 7.589  3  -0.025 4.704 5.76  5  -0.824 3.209 8.112  9  1.635 2.865 9.782  10  2.799 2.239 9.639  "
"1 2 0  -1   "
"1 "
"12 0  3 -1  -1  -1   8  3 6  4  9   11  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   6  3 -1  -1  -1   5  3 4  2  0   9  3 -1  -1  -1   10  3 9  6  4   "
"1 4 2  4  6  9   "
"1 9  "
"7 "
"1 "
"12 12 0  1  2  3  1  2  2  3  3  3  4  1   12 1  0  3  4  2  3  3  4  4  4  5  2   12 2  3  0  1  1  2  2  3  3  3  4  3   12 3  4  1  0  2  3  3  4  4  4  5  4   12 1  2  1  2  0  1  1  2  2  2  3  2   12 2  3  2  3  1  0  2  3  3  3  4  3   12 2  3  2  3  1  2  0  1  1  1  2  3   12 3  4  3  4  2  3  1  0  2  2  3  4   12 3  4  3  4  2  3  1  2  0  2  3  4   12 3  4  3  4  2  3  1  2  2  0  1  4   12 4  5  4  5  3  4  2  3  3  1  0  5   12 1  2  3  4  2  3  3  4  4  4  5  0   "
"6 "
"1 "
"1 "
"12 0  4 0  0  0  0   8  4 1  0  0  0   11  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   6  4 0  0  0  0   5  4 0  0  0  0   9  4 1  0  0  0   10  4 1  0  0  0   "
"12 "
"2 0  13 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!OD1  3!OD2  3!OXT   1  13 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!OD1  3!OD2  1!H  2!HA  3!1HB  3!2HB  3!OXT   "
"3 10  11  1  "
"1 "
"13 0  0.0 6.216 11.898  8  -2.018 6.663 10.337  12  0.0 7.226 12.635  6  -1.208 7.31 9.999  4  0.0 6.457 10.394  9  -1.295 8.649 10.719  1  0.0 5.0482 12.3438  2  0.0 5.2 9.658  7  -1.294 7.47 8.924  3  -0.04 4.337 10.183  10  -2.221 9.381 10.461  5  0.909 7.016 10.17  11  -0.53 8.862 11.629  "
"3 2 9  -1   2 9  -1   2 0  -1   "
"3 "
"13 0  3 -1  -1  -1   8  3 6  4  9   12  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   10  3 -1  -1  -1   6  3 -1  -1  -1   5  3 4  2  0   11  3 -1  -1  -1   "
"2 4 2  4  6  9   4 4  6  9  10   "
"3 9  10  11  "
"9 "
"3 "
"13 13 0  1  2  3  1  2  2  3  3  3  4  4  1   13 1  0  3  4  2  3  3  4  4  4  5  5  2   13 2  3  0  1  1  2  2  3  3  3  4  4  3   13 3  4  1  0  2  3  3  4  4  4  5  5  4   13 1  2  1  2  0  1  1  2  2  2  3  3  2   13 2  3  2  3  1  0  2  3  3  3  4  4  3   13 2  3  2  3  1  2  0  1  1  1  2  2  3   13 3  4  3  4  2  3  1  0  2  2  3  3  4   13 3  4  3  4  2  3  1  2  0  2  3  3  4   13 3  4  3  4  2  3  1  2  2  0  1  1  4   13 4  5  4  5  3  4  2  3  3  1  0  2  5   13 4  5  4  5  3  4  2  3  3  1  2  0  5   13 1  2  3  4  2  3  3  4  4  4  5  5  0   "
"6 "
"2 "
"2 "
"13 0  4 0  0  0  0   8  4 1  0  0  0   12  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   10  4 1  1  0  0   6  4 0  0  0  0   5  4 0  0  0  0   11  4 1  1  0  0   "
"13 "
"2 0  16 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!OE1  3!OE2  3!OXT   1  16 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  3!OE1  3!OE2  1!H  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  3!OXT   "
"3 14  13  1  "
"1 "
"16 0  0.0 8.591 14.761  5  -0.909 6.71 14.46  8  2.099 6.915 14.242  15  0.0 8.638 16.01  6  1.208 6.404 14.607  4  0.0 7.208 14.121  9  1.295 6.252 16.119  1  0.0 9.6128 14.04104  2  0.0 7.3 12.666  7  1.14 5.418 14.147  10  1.297 7.203 16.651  3  0.04 8.217 12.244  14  3.171 4.946 15.648  12  2.504 5.453 16.519  13  2.699 5.254 17.694  11  0.393 5.697 16.373  "
"3 2 12  -1   2 12  -1   2 0  -1   "
"3 "
"16 0  3 -1  -1  -1   8  3 6  4  9   15  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   12  3 -1  -1  -1   10  3 9  6  12   6  3 -1  -1  -1   5  3 4  2  0   14  3 -1  -1  -1   13  3 -1  -1  -1   11  3 9  6  12   "
"3 4 2  4  6  9   4 4  6  9  12   4 6  9  12  13   "
"3 12  13  14  "
"10 "
"3 "
"16 16 0  1  2  3  1  2  2  3  3  3  4  4  4  5  5  1   16 1  0  3  4  2  3  3  4  4  4  5  5  5  6  6  2   16 2  3  0  1  1  2  2  3  3  3  4  4  4  5  5  3   16 3  4  1  0  2  3  3  4  4  4  5  5  5  6  6  4   16 1  2  1  2  0  1  1  2  2  2  3  3  3  4  4  2   16 2  3  2  3  1  0  2  3  3  3  4  4  4  5  5  3   16 2  3  2  3  1  2  0  1  1  1  2  2  2  3  3  3   16 3  4  3  4  2  3  1  0  2  2  3  3  3  4  4  4   16 3  4  3  4  2  3  1  2  0  2  3  3  3  4  4  4   16 3  4  3  4  2  3  1  2  2  0  1  1  1  2  2  4   16 4  5  4  5  3  4  2  3  3  1  0  2  2  3  3  5   16 4  5  4  5  3  4  2  3  3  1  2  0  2  3  3  5   16 4  5  4  5  3  4  2  3  3  1  2  2  0  1  1  5   16 5  6  5  6  4  5  3  4  4  2  3  3  1  0  2  6   16 5  6  5  6  4  5  3  4  4  2  3  3  1  2  0  6   16 1  2  3  4  2  3  3  4  4  4  5  5  5  6  6  0   "
"6 "
"3 "
"3 "
"16 0  4 0  0  0  0   8  4 1  0  0  0   15  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   12  4 1  1  0  0   10  4 1  1  0  0   6  4 0  0  0  0   5  4 0  0  0  0   14  4 1  1  1  0   13  4 1  1  1  0   11  4 1  1  0  0   "
"16 "
"2 0  21 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!CD1  3!HD1  3!CD2  3!HD2  3!CE1  3!HE1  3!CE2  3!HE2  2!CZ  2!HZ  3!OXT   1  21 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!CD1  3!CD2  3!CE1  3!CE2  2!CZ  1!H  3!HD1  3!HE1  2!HZ  3!HE2  3!HD2  2!HA  3!1HB  3!2HB  3!OXT   "
"1 1  "
"0 "
"21 19  -1.473 15.446 18.993  0  0.0 9.639 18.33  17  0.386 13.888 19.46  14  -2.389 14.148 17.555  11  -3.087 12.664 16.17  20  0.0 10.648 19.067  6  -1.208 10.732 16.43  4  0.0 9.881 16.826  8  -2.131 10.201 16.659  9  -1.282 12.05 17.147  1  0.0 8.470927 18.7751  2  0.0 8.622 16.089  7  -1.175 10.958 15.365  18  -1.42 14.49 18.474  13  0.507 11.72 18.278  10  -2.32 12.935 16.896  12  -0.314 12.408 18.073  3  -0.04 7.76 16.614  15  -3.21 14.834 17.348  5  0.909 10.441 16.602  16  -0.381 13.619 18.734  "
"1 2 0  -1   "
"1 "
"21 19  3 18  14  16   0  3 -1  -1  -1   8  3 6  4  9   15  3 14  10  18   17  3 16  12  18   18  3 -1  -1  -1   14  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   11  3 10  9  14   16  3 -1  -1  -1   10  3 -1  -1  -1   12  3 -1  -1  -1   6  3 -1  -1  -1   5  3 4  2  0   20  3 -1  -1  -1   13  3 12  9  16   "
"2 4 2  4  6  9   4 4  6  9  10   "
"2 9  18  "
"12 "
"2 "
"21 21 0  1  2  3  1  2  2  3  3  3  4  5  4  5  5  6  5  6  6  7  1   21 1  0  3  4  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  2   21 2  3  0  1  1  2  2  3  3  3  4  5  4  5  5  6  5  6  6  7  3   21 3  4  1  0  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  4   21 1  2  1  2  0  1  1  2  2  2  3  4  3  4  4  5  4  5  5  6  2   21 2  3  2  3  1  0  2  3  3  3  4  5  4  5  5  6  5  6  6  7  3   21 2  3  2  3  1  2  0  1  1  1  2  3  2  3  3  4  3  4  4  5  3   21 3  4  3  4  2  3  1  0  2  2  3  4  3  4  4  5  4  5  5  6  4   21 3  4  3  4  2  3  1  2  0  2  3  4  3  4  4  5  4  5  5  6  4   21 3  4  3  4  2  3  1  2  2  0  1  2  1  2  2  3  2  3  3  4  4   21 4  5  4  5  3  4  2  3  3  1  0  1  2  3  1  2  3  4  2  3  5   21 5  6  5  6  4  5  3  4  4  2  1  0  3  4  2  3  4  5  3  4  6   21 4  5  4  5  3  4  2  3  3  1  2  3  0  1  3  4  1  2  2  3  5   21 5  6  5  6  4  5  3  4  4  2  3  4  1  0  4  5  2  3  3  4  6   21 5  6  5  6  4  5  3  4  4  2  1  2  3  4  0  1  2  3  1  2  6   21 6  7  6  7  5  6  4  5  5  3  2  3  4  5  1  0  3  4  2  3  7   21 5  6  5  6  4  5  3  4  4  2  3  4  1  2  2  3  0  1  1  2  6   21 6  7  6  7  5  6  4  5  5  3  4  5  2  3  3  4  1  0  2  3  7   21 6  7  6  7  5  6  4  5  5  3  2  3  2  3  1  2  1  2  0  1  7   21 7  8  7  8  6  7  5  6  6  4  3  4  3  4  2  3  2  3  1  0  8   21 1  2  3  4  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  0   "
"6 "
"4 "
"2 "
"21 19  4 1  1  0  0   0  4 0  0  0  0   8  4 1  0  0  0   13  4 1  1  0  0   11  4 1  1  0  0   17  4 1  1  0  0   20  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   18  4 1  1  0  0   16  4 1  1  0  0   10  4 1  1  0  0   12  4 1  1  0  0   6  4 0  0  0  0   15  4 1  1  0  0   5  4 0  0  0  0   14  4 1  1  0  0   "
"21 "
"2 0  8 1!C  1!O  1!N  1!H  2!CA  3!1HA  3!2HA  3!OXT   1  8 1!N  2!CA  1!C  1!O  1!H  3!1HA  3!2HA  3!OXT   "
"1 1  "
"0 "
"8 0  0.0 12.009 21.196  7  0.0 12.054 22.445  3  0.0 11.64 18.679  4  0.0 10.628 20.554  1  0.0 13.0321 20.4778  2  0.0 10.722 19.099  5  -0.89 10.087 20.876  6  0.889 10.087 20.876  "
"1 2 0  -1   "
"1 "
"8 0  3 -1  -1  -1   7  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   5  3 4  2  0   6  3 4  2  0   "
""
"1 4  "
"5 "
"1 "
"8 8 0  1  2  3  1  2  2  1   8 1  0  3  4  2  3  3  2   8 2  3  0  1  1  2  2  3   8 3  4  1  0  2  3  3  4   8 1  2  1  2  0  1  1  2   8 2  3  2  3  1  0  2  3   8 2  3  2  3  1  2  0  3   8 1  2  3  4  2  3  3  0   "
"4 "
"5 "
"0 "
"8 0  4 0  0  0  0   7  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   5  4 0  0  0  0   6  4 0  0  0  0   "
"8 "
"2 0  18 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!ND1  3!CD2  3!HD2  3!CE1  3!HE1  3!NE2  3!HE2  3!OXT   1  18 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!ND1  3!CD2  3!CE1  3!NE2  1!H  3!HE2  2!HA  3!1HB  3!2HB  3!HE1  3!HD2  3!OXT   "
"2 10  1  "
"1 "
"18 0  0.0 12.636 24.731  8  -2.133 13.566 23.169  13  -2.084 17.323 24.398  16  -0.583 17.701 25.789  17  0.0 13.443 25.685  6  -1.208 14.105 22.966  4  0.0 13.23 23.316  9  -1.274 15.38 23.748  1  0.0 11.3959 24.8883  2  0.0 12.014 22.522  7  -1.176 14.387 21.913  12  0.462 15.517 25.16  11  -0.456 15.885 24.701  3  -0.041 11.127 23.003  10  -2.284 16.304 23.58  5  0.91 13.796 23.119  15  -0.982 17.093 25.088  14  -2.778 18.163 24.418  "
"2 2 9  13   2 0  -1   "
"2 "
"18 0  3 -1  -1  -1   5  3 4  2  0   14  3 13  10  15   16  3 15  11  13   13  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   17  3 -1  -1  -1   11  3 -1  -1  -1   6  3 -1  -1  -1   10  3 -1  -1  -1   8  3 6  4  9   15  3 -1  -1  -1   12  3 11  9  15   "
"2 4 2  4  6  9   4 4  6  9  10   "
"2 10  11  "
"11 "
"2 "
"18 18 0  1  2  3  1  2  2  3  3  3  4  4  5  5  6  5  6  1   18 1  0  3  4  2  3  3  4  4  4  5  5  6  6  7  6  7  2   18 2  3  0  1  1  2  2  3  3  3  4  4  5  5  6  5  6  3   18 3  4  1  0  2  3  3  4  4  4  5  5  6  6  7  6  7  4   18 1  2  1  2  0  1  1  2  2  2  3  3  4  4  5  4  5  2   18 2  3  2  3  1  0  2  3  3  3  4  4  5  5  6  5  6  3   18 2  3  2  3  1  2  0  1  1  1  2  2  3  3  4  3  4  3   18 3  4  3  4  2  3  1  0  2  2  3  3  4  4  5  4  5  4   18 3  4  3  4  2  3  1  2  0  2  3  3  4  4  5  4  5  4   18 3  4  3  4  2  3  1  2  2  0  1  1  2  2  3  2  3  4   18 4  5  4  5  3  4  2  3  3  1  0  2  3  1  2  2  3  5   18 4  5  4  5  3  4  2  3  3  1  2  0  1  2  3  1  2  5   18 5  6  5  6  4  5  3  4  4  2  3  1  0  3  4  2  3  6   18 5  6  5  6  4  5  3  4  4  2  1  2  3  0  1  1  2  6   18 6  7  6  7  5  6  4  5  5  3  2  3  4  1  0  2  3  7   18 5  6  5  6  4  5  3  4  4  2  2  1  2  1  2  0  1  6   18 6  7  6  7  5  6  4  5  5  3  3  2  3  2  3  1  0  7   18 1  2  3  4  2  3  3  4  4  4  5  5  6  6  7  6  7  0   "
"6 "
"6 "
"2 "
"18 0  4 0  0  0  0   8  4 1  0  0  0   12  4 1  1  0  0   16  4 1  1  0  0   17  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   11  4 1  1  0  0   6  4 0  0  0  0   10  4 1  1  0  0   14  4 1  1  0  0   5  4 0  0  0  0   15  4 1  1  0  0   13  4 1  1  0  0   "
"18 "
"2 0  20 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  2!HB  3!CG2  4!1HG2  4!2HG2  4!3HG2  3!CG1  4!1HG1  4!2HG1  3!CD1  4!1HD1  4!2HD1  4!3HD1  3!OXT   1  20 1!N  2!CA  1!C  1!O  2!CB  3!CG1  3!CG2  3!CD1  1!H  2!HA  2!HB  4!1HG2  4!2HG2  4!3HG2  4!1HG1  4!2HG1  4!1HD1  4!2HD1  4!3HD1  3!OXT   "
"1 1  "
"0 "
"20 10  2.528 13.179 26.064  0  0.0 14.267 28.087  5  -0.917 12.54 27.36  19  0.0 14.007 29.31  6  1.214 12.186 27.44  4  0.0 13.079 27.125  13  1.197 12.653 29.515  14  0.254 11.212 29.069  1  0.0 15.434 27.639  2  0.0 13.51 25.733  18  3.286 11.401 29.141  7  1.152 11.278 26.841  9  3.357 12.272 27.35  15  2.351 10.866 29.301  17  2.343 9.96 28.694  3  0.031 14.501 25.539  12  1.189 11.749 28.907  8  2.509 12.917 27.121  11  2.572 13.825 27.721  16  2.264 10.597 30.354  "
"1 2 0  -1   "
"1 "
"20 10  3 8  6  4   14  3 12  6  15   8  3 -1  -1  -1   19  3 -1  -1  -1   3  3 -1  -1  -1   11  3 8  6  4   0  3 -1  -1  -1   1  3 -1  -1  -1   17  3 15  12  6   18  3 15  12  6   12  3 -1  -1  -1   2  3 -1  -1  -1   9  3 8  6  4   15  3 -1  -1  -1   13  3 12  6  15   7  3 6  4  12   5  3 4  2  0   4  3 -1  -1  -1   16  3 15  12  6   6  3 -1  -1  -1   "
"2 4 2  4  6  12   4 4  6  12  15   "
"3 12  8  15  "
"9 "
"3 "
"20 20 0  1  2  3  1  2  2  3  3  4  4  4  3  4  4  4  5  5  5  1   20 1  0  3  4  2  3  3  4  4  5  5  5  4  5  5  5  6  6  6  2   20 2  3  0  1  1  2  2  3  3  4  4  4  3  4  4  4  5  5  5  3   20 3  4  1  0  2  3  3  4  4  5  5  5  4  5  5  5  6  6  6  4   20 1  2  1  2  0  1  1  2  2  3  3  3  2  3  3  3  4  4  4  2   20 2  3  2  3  1  0  2  3  3  4  4  4  3  4  4  4  5  5  5  3   20 2  3  2  3  1  2  0  1  1  2  2  2  1  2  2  2  3  3  3  3   20 3  4  3  4  2  3  1  0  2  3  3  3  2  3  3  3  4  4  4  4   20 3  4  3  4  2  3  1  2  0  1  1  1  2  3  3  3  4  4  4  4   20 4  5  4  5  3  4  2  3  1  0  2  2  3  4  4  4  5  5  5  5   20 4  5  4  5  3  4  2  3  1  2  0  2  3  4  4  4  5  5  5  5   20 4  5  4  5  3  4  2  3  1  2  2  0  3  4  4  4  5  5  5  5   20 3  4  3  4  2  3  1  2  2  3  3  3  0  1  1  1  2  2  2  4   20 4  5  4  5  3  4  2  3  3  4  4  4  1  0  2  2  3  3  3  5   20 4  5  4  5  3  4  2  3  3  4  4  4  1  2  0  2  3  3  3  5   20 4  5  4  5  3  4  2  3  3  4  4  4  1  2  2  0  1  1  1  5   20 5  6  5  6  4  5  3  4  4  5  5  5  2  3  3  1  0  2  2  6   20 5  6  5  6  4  5  3  4  4  5  5  5  2  3  3  1  2  0  2  6   20 5  6  5  6  4  5  3  4  4  5  5  5  2  3  3  1  2  2  0  6   20 1  2  3  4  2  3  3  4  4  5  5  5  4  5  5  5  6  6  6  0   "
"6 "
"7 "
"2 "
"20 10  4 1  0  0  0   0  4 0  0  0  0   8  4 1  0  0  0   19  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   13  4 1  1  0  0   14  4 1  1  0  0   1  4 0  0  0  0   2  4 0  0  0  0   18  4 1  1  0  0   12  4 1  0  0  0   9  4 1  0  0  0   15  4 1  1  0  0   17  4 1  1  0  0   6  4 0  0  0  0   7  4 1  0  0  0   5  4 0  0  0  0   11  4 1  0  0  0   16  4 1  1  0  0   "
"20 "
"2 0  23 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!1HD  3!2HD  2!CE  3!1HE  3!2HE  2!NZ  3!1HZ  3!2HZ  3!3HZ  3!OXT   1  23 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  2!CE  2!NZ  1!H  3!1HZ  3!2HZ  3!3HZ  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  3!1HD  3!2HD  3!1HE  3!2HE  3!OXT   "
"1 1  "
"1 "
"23 5  0.909 15.61 30.323  21  -4.635 19.358 31.891  22  0.0 15.21 32.765  18  -3.797 19.917 31.819  3  -0.04 13.009 29.68  0  0.0 14.411 31.803  20  -3.747 20.332 30.899  19  -3.818 20.647 32.517  6  -1.207 15.936 30.229  4  0.0 15.013 30.404  9  -1.294 17.059 31.254  1  0.0 13.16958 31.9492  2  0.0 13.973 29.382  7  -1.14 16.363 29.228  15  -2.605 19.054 32.04  13  -2.45 18.358 30.014  16  -2.659 18.608 33.032  8  -2.099 15.313 30.298  17  -1.701 19.658 31.963  14  -3.408 17.308 31.085  11  -0.393 17.667 31.179  12  -2.517 17.932 31.016  10  -1.351 16.616 32.249  "
"1 2 0  -1   "
"1 "
"23 5  3 4  2  0   21  3 18  15  12   22  3 -1  -1  -1   18  3 -1  -1  -1   3  3 -1  -1  -1   0  3 -1  -1  -1   20  3 18  15  12   19  3 18  15  12   6  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   15  3 -1  -1  -1   13  3 12  9  15   16  3 15  12  18   8  3 6  4  9   17  3 15  12  18   14  3 12  9  15   11  3 -1  -1  -1   12  3 -1  -1  -1   10  3 -1  -1  -1   "
"4 4 2  4  6  9   4 4  6  9  12   4 6  9  12  15   4 9  12  15  18   "
"1 18  "
"10 "
"1 "
"23 23 0  1  2  3  1  2  2  3  3  3  4  4  4  5  5  5  6  6  6  7  7  7  1   23 1  0  3  4  2  3  3  4  4  4  5  5  5  6  6  6  7  7  7  8  8  8  2   23 2  3  0  1  1  2  2  3  3  3  4  4  4  5  5  5  6  6  6  7  7  7  3   23 3  4  1  0  2  3  3  4  4  4  5  5  5  6  6  6  7  7  7  8  8  8  4   23 1  2  1  2  0  1  1  2  2  2  3  3  3  4  4  4  5  5  5  6  6  6  2   23 2  3  2  3  1  0  2  3  3  3  4  4  4  5  5  5  6  6  6  7  7  7  3   23 2  3  2  3  1  2  0  1  1  1  2  2  2  3  3  3  4  4  4  5  5  5  3   23 3  4  3  4  2  3  1  0  2  2  3  3  3  4  4  4  5  5  5  6  6  6  4   23 3  4  3  4  2  3  1  2  0  2  3  3  3  4  4  4  5  5  5  6  6  6  4   23 3  4  3  4  2  3  1  2  2  0  1  1  1  2  2  2  3  3  3  4  4  4  4   23 4  5  4  5  3  4  2  3  3  1  0  2  2  3  3  3  4  4  4  5  5  5  5   23 4  5  4  5  3  4  2  3  3  1  2  0  2  3  3  3  4  4  4  5  5  5  5   23 4  5  4  5  3  4  2  3  3  1  2  2  0  1  1  1  2  2  2  3  3  3  5   23 5  6  5  6  4  5  3  4  4  2  3  3  1  0  2  2  3  3  3  4  4  4  6   23 5  6  5  6  4  5  3  4  4  2  3  3  1  2  0  2  3  3  3  4  4  4  6   23 5  6  5  6  4  5  3  4  4  2  3  3  1  2  2  0  1  1  1  2  2  2  6   23 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  0  2  2  3  3  3  7   23 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  2  0  2  3  3  3  7   23 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  2  2  0  1  1  1  7   23 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  3  1  0  2  2  8   23 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  3  1  2  0  2  8   23 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  3  1  2  2  0  8   23 1  2  3  4  2  3  3  4  4  4  5  5  5  6  6  6  7  7  7  8  8  8  0   "
"6 "
"8 "
"4 "
"23 5  4 0  0  0  0   21  4 1  1  1  1   22  4 0  0  0  0   18  4 1  1  1  1   6  4 0  0  0  0   0  4 0  0  0  0   20  4 1  1  1  1   19  4 1  1  1  1   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   15  4 1  1  1  0   13  4 1  1  1  0   16  4 1  1  1  1   8  4 1  0  0  0   17  4 1  1  1  1   14  4 1  1  1  0   11  4 1  1  0  0   12  4 1  1  0  0   10  4 1  1  0  0   "
"23 "
"2 0  20 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  2!HG  3!CD1  4!1HD1  4!2HD1  4!3HD1  3!CD2  4!1HD2  4!2HD2  4!3HD2  3!OXT   1  20 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!CD1  3!CD2  1!H  2!HA  3!1HB  3!2HB  2!HG  4!1HD1  4!2HD1  4!3HD1  4!1HD2  4!2HD2  4!3HD2  3!OXT   "
"1 1  "
"0 "
"20 12  -0.518 -3.996 2.46  0  -0.559 1.422 0.0  8  -1.583 -0.567 1.397  16  -0.894 -3.98 -0.007  19  -1.803 1.543 0.0  6  -0.53 -0.778 1.211  4  0.0 0.0 0.0  17  -2.133 -2.712 0.16  9  -0.286 -2.292 1.172  1  0.2198 2.3997 0.0  2  1.46 0.0 0.0  7  0.075 -0.322 1.993  18  -0.741 -2.46 -0.92  13  -0.106 -2.485 3.304  11  -0.695 -2.921 2.497  15  -1.069 -2.904 0.02  3  2.424 -0.301 0.0  5  -0.365 -0.473 -0.911  14  -1.753 -2.734 2.677  10  0.775 -2.444 0.972  "
"1 2 0  -1   "
"1 "
"20 14  3 11  9  6   0  3 -1  -1  -1   8  3 6  4  9   19  3 -1  -1  -1   16  3 15  9  6   12  3 11  9  6   17  3 15  9  6   1  3 -1  -1  -1   13  3 11  9  6   7  3 6  4  9   2  3 -1  -1  -1   18  3 15  9  6   11  3 -1  -1  -1   15  3 -1  -1  -1   3  3 -1  -1  -1   9  3 -1  -1  -1   5  3 4  2  0   4  3 -1  -1  -1   10  3 9  6  11   6  3 -1  -1  -1   "
"2 4 2  4  6  9   4 4  6  9  11   "
"3 9  11  15  "
"9 "
"3 "
"20 20 0  1  2  3  1  2  2  3  3  3  4  4  5  5  5  4  5  5  5  1   20 1  0  3  4  2  3  3  4  4  4  5  5  6  6  6  5  6  6  6  2   20 2  3  0  1  1  2  2  3  3  3  4  4  5  5  5  4  5  5  5  3   20 3  4  1  0  2  3  3  4  4  4  5  5  6  6  6  5  6  6  6  4   20 1  2  1  2  0  1  1  2  2  2  3  3  4  4  4  3  4  4  4  2   20 2  3  2  3  1  0  2  3  3  3  4  4  5  5  5  4  5  5  5  3   20 2  3  2  3  1  2  0  1  1  1  2  2  3  3  3  2  3  3  3  3   20 3  4  3  4  2  3  1  0  2  2  3  3  4  4  4  3  4  4  4  4   20 3  4  3  4  2  3  1  2  0  2  3  3  4  4  4  3  4  4  4  4   20 3  4  3  4  2  3  1  2  2  0  1  1  2  2  2  1  2  2  2  4   20 4  5  4  5  3  4  2  3  3  1  0  2  3  3  3  2  3  3  3  5   20 4  5  4  5  3  4  2  3  3  1  2  0  1  1  1  2  3  3  3  5   20 5  6  5  6  4  5  3  4  4  2  3  1  0  2  2  3  4  4  4  6   20 5  6  5  6  4  5  3  4  4  2  3  1  2  0  2  3  4  4  4  6   20 5  6  5  6  4  5  3  4  4  2  3  1  2  2  0  3  4  4  4  6   20 4  5  4  5  3  4  2  3  3  1  2  2  3  3  3  0  1  1  1  5   20 5  6  5  6  4  5  3  4  4  2  3  3  4  4  4  1  0  2  2  6   20 5  6  5  6  4  5  3  4  4  2  3  3  4  4  4  1  2  0  2  6   20 5  6  5  6  4  5  3  4  4  2  3  3  4  4  4  1  2  2  0  6   20 1  2  3  4  2  3  3  4  4  4  5  5  6  6  6  5  6  6  6  0   "
"6 "
"9 "
"2 "
"20 12  4 1  1  0  0   0  4 0  0  0  0   8  4 1  0  0  0   16  4 1  1  0  0   19  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   17  4 1  1  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   18  4 1  1  0  0   13  4 1  1  0  0   11  4 1  1  0  0   15  4 1  1  0  0   6  4 0  0  0  0   5  4 0  0  0  0   14  4 1  1  0  0   10  4 1  1  0  0   "
"20 "
"2 0  18 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!SD  2!CE  3!1HE  3!2HE  3!3HE  3!OXT   1  18 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!SD  2!CE  1!H  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  3!1HE  3!2HE  3!3HE  3!OXT   "
"1 1  "
"0 "
"18 16  -1.598 21.045 39.919  0  0.0 15.585 38.861  8  -2.097 16.764 37.541  17  0.0 16.164 39.969  6  -1.208 17.396 37.539  4  0.0 16.465 37.622  14  -3.365 21.23 40.03  9  -1.303 18.407 38.673  1  0.0 14.3405 38.7437  2  0.0 15.533 36.49  7  -1.138 17.922 36.588  13  -2.547 20.511 39.979  3  -0.04 14.543 36.685  10  -1.358 17.859 39.613  5  0.907 17.069 37.606  15  -2.556 19.886 40.873  11  -0.4 19.017 38.66  12  -2.745 19.481 38.528  "
"1 2 0  -1   "
"1 "
"18 0  3 -1  -1  -1   8  3 6  4  9   6  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   17  3 -1  -1  -1   12  3 -1  -1  -1   13  3 -1  -1  -1   10  3 9  6  12   14  3 13  12  9   5  3 4  2  0   15  3 13  12  9   11  3 9  6  12   16  3 13  12  9   "
"3 4 2  4  6  9   4 4  6  9  12   4 6  9  12  13   "
"1 12  "
"9 "
"1 "
"18 18 0  1  2  3  1  2  2  3  3  3  4  4  4  5  6  6  6  1   18 1  0  3  4  2  3  3  4  4  4  5  5  5  6  7  7  7  2   18 2  3  0  1  1  2  2  3  3  3  4  4  4  5  6  6  6  3   18 3  4  1  0  2  3  3  4  4  4  5  5  5  6  7  7  7  4   18 1  2  1  2  0  1  1  2  2  2  3  3  3  4  5  5  5  2   18 2  3  2  3  1  0  2  3  3  3  4  4  4  5  6  6  6  3   18 2  3  2  3  1  2  0  1  1  1  2  2  2  3  4  4  4  3   18 3  4  3  4  2  3  1  0  2  2  3  3  3  4  5  5  5  4   18 3  4  3  4  2  3  1  2  0  2  3  3  3  4  5  5  5  4   18 3  4  3  4  2  3  1  2  2  0  1  1  1  2  3  3  3  4   18 4  5  4  5  3  4  2  3  3  1  0  2  2  3  4  4  4  5   18 4  5  4  5  3  4  2  3  3  1  2  0  2  3  4  4  4  5   18 4  5  4  5  3  4  2  3  3  1  2  2  0  1  2  2  2  5   18 5  6  5  6  4  5  3  4  4  2  3  3  1  0  1  1  1  6   18 6  7  6  7  5  6  4  5  5  3  4  4  2  1  0  2  2  7   18 6  7  6  7  5  6  4  5  5  3  4  4  2  1  2  0  2  7   18 6  7  6  7  5  6  4  5  5  3  4  4  2  1  2  2  0  7   18 1  2  3  4  2  3  3  4  4  4  5  5  5  6  7  7  7  0   "
"6 "
"10 "
"3 "
"18 0  4 0  0  0  0   8  4 1  0  0  0   17  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   14  4 1  1  1  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   13  4 1  1  1  0   10  4 1  1  0  0   6  4 0  0  0  0   16  4 1  1  1  0   5  4 0  0  0  0   15  4 1  1  1  0   11  4 1  1  0  0   12  4 1  1  0  0   "
"18 "
"2 0  15 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!OD1  3!ND2  4!1HD2  4!2HD2  3!OXT   1  15 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!OD1  3!ND2  1!H  4!1HD2  4!2HD2  2!HA  3!1HB  3!2HB  3!OXT   "
"2 10  1  "
"1 "
"15 13  -0.825 -2.442 3.033  0  -0.565 1.411 0.0  5  -0.37 -0.475 -0.91  12  -0.338 -3.907 2.247  8  -1.591 -0.599 0.891  14  -1.81 1.524 0.0  6  -0.555 -0.778 1.179  4  0.0 0.0 0.0  9  -0.282 -2.255 1.112  1  0.2076 2.393 0.0  2  1.463 0.0 0.0  7  -0.397 -0.431 2.201  3  2.425 -0.306 0.0  10  0.05 -2.798 0.052  11  -0.499 -2.92 2.218  "
"2 2 9  -1   2 0  -1   "
"2 "
"15 0  3 -1  -1  -1   8  3 6  4  9   14  3 -1  -1  -1   12  3 11  9  6   4  3 -1  -1  -1   13  3 11  9  6   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   10  3 -1  -1  -1   3  3 -1  -1  -1   9  3 -1  -1  -1   11  3 -1  -1  -1   5  3 4  2  0   6  3 -1  -1  -1   "
"2 4 2  4  6  9   4 4  6  9  10   "
"3 9  10  11  "
"9 "
"3 "
"15 15 0  1  2  3  1  2  2  3  3  3  4  4  5  5  1   15 1  0  3  4  2  3  3  4  4  4  5  5  6  6  2   15 2  3  0  1  1  2  2  3  3  3  4  4  5  5  3   15 3  4  1  0  2  3  3  4  4  4  5  5  6  6  4   15 1  2  1  2  0  1  1  2  2  2  3  3  4  4  2   15 2  3  2  3  1  0  2  3  3  3  4  4  5  5  3   15 2  3  2  3  1  2  0  1  1  1  2  2  3  3  3   15 3  4  3  4  2  3  1  0  2  2  3  3  4  4  4   15 3  4  3  4  2  3  1  2  0  2  3  3  4  4  4   15 3  4  3  4  2  3  1  2  2  0  1  1  2  2  4   15 4  5  4  5  3  4  2  3  3  1  0  2  3  3  5   15 4  5  4  5  3  4  2  3  3  1  2  0  1  1  5   15 5  6  5  6  4  5  3  4  4  2  3  1  0  2  6   15 5  6  5  6  4  5  3  4  4  2  3  1  2  0  6   15 1  2  3  4  2  3  3  4  4  4  5  5  6  6  0   "
"6 "
"11 "
"2 "
"15 13  4 1  1  0  0   0  4 0  0  0  0   8  4 1  0  0  0   12  4 1  1  0  0   14  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   10  4 1  1  0  0   6  4 0  0  0  0   11  4 1  1  0  0   5  4 0  0  0  0   "
"15 "
"2 0  15 1!C  1!O  1!N  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!1HD  3!2HD  3!OXT   1  15 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  3!1HD  3!2HD  3!1HG  3!2HG  3!1HB  3!2HB  2!HA  3!OXT   "
"1 1  "
"0 "
"15 0  15.959 1.321 8.222  7  15.782 3.034 10.843  4  15.27 3.16 8.805  14  17.144 1.595 7.933  5  15.927 2.223 10.577  3  15.259 2.242 9.192  8  15.069 1.31 11.409  1  15.353 0.3366 7.7465  2  13.895 1.827 9.451  6  16.695 1.763 10.389  9  15.229 0.51 11.182  12  13.189 0.65 10.821  11  13.672 1.471 10.862  13  13.219 2.235 11.206  10  14.957 1.715 12.247  "
"1 2 0  -1   "
"1 "
"15 0  3 -1  -1  -1   4  3 3  2  0   14  3 -1  -1  -1   5  3 -1  -1  -1   3  3 -1  -1  -1   8  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   6  3 5  3  8   11  3 -1  -1  -1   9  3 8  5  11   12  3 11  2  8   7  3 5  3  8   13  3 11  2  8   10  3 8  5  11   "
"1 4 2  3  5  8   "
"3 5  8  11  "
"8 "
"3 "
"15 15 0  1  2  1  2  2  3  3  3  4  4  3  4  4  1   15 1  0  3  2  3  3  4  4  4  5  5  4  5  5  2   15 2  3  0  1  2  2  3  3  2  3  3  1  2  2  3   15 1  2  1  0  1  1  2  2  2  3  3  2  3  3  2   15 2  3  2  1  0  2  3  3  3  4  4  3  4  4  3   15 2  3  2  1  2  0  1  1  1  2  2  2  3  3  3   15 3  4  3  2  3  1  0  2  2  3  3  3  4  4  4   15 3  4  3  2  3  1  2  0  2  3  3  3  4  4  4   15 3  4  2  2  3  1  2  2  0  1  1  1  2  2  4   15 4  5  3  3  4  2  3  3  1  0  2  2  3  3  5   15 4  5  3  3  4  2  3  3  1  2  0  2  3  3  5   15 3  4  1  2  3  2  3  3  1  2  2  0  1  1  4   15 4  5  2  3  4  3  4  4  2  3  3  1  0  2  5   15 4  5  2  3  4  3  4  4  2  3  3  1  2  0  5   15 1  2  3  2  3  3  4  4  4  5  5  4  5  5  0   "
"5 "
"12 "
"1 "
"15 0  4 0  0  0  0   7  4 1  0  0  0   14  4 0  0  0  0   5  4 0  0  0  0   3  4 0  0  0  0   8  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   6  4 1  0  0  0   11  4 0  0  0  0   9  4 1  0  0  0   12  4 0  0  0  0   4  4 0  0  0  0   13  4 0  0  0  0   10  4 1  0  0  0   "
"15 "
"2 0  18 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!OE1  3!NE2  4!1HE2  4!2HE2  3!OXT   1  18 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  3!OE1  3!NE2  1!H  4!1HE2  4!2HE2  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  3!OXT   "
"2 13  1  "
"1 "
"18 7  -0.034 -0.351 2.091  0  -0.553 1.42 0.0  5  -0.365 -0.474 -0.911  8  -1.603 -0.548 1.275  17  -1.797 1.545 0.0  6  -0.536 -0.762 1.215  4  0.0 0.0 0.0  16  0.93 -3.747 -0.506  9  -0.317 -2.264 1.154  1  0.2289 2.395 0.0  2  1.458 0.0 0.0  15  -0.307 -4.048 -1.681  10  0.645 -2.729 1.368  3  2.424 -0.294 0.0  12  -0.856 -2.876 -0.125  14  -0.008 -3.618 -0.828  13  -2.024 -2.687 -0.476  11  -1.014 -2.486 1.963  "
"2 2 12  -1   2 0  -1   "
"2 "
"18 0  3 -1  -1  -1   8  3 6  4  9   17  3 -1  -1  -1   3  3 -1  -1  -1   15  3 14  12  9   16  3 14  12  9   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   12  3 -1  -1  -1   10  3 9  6  12   6  3 -1  -1  -1   13  3 -1  -1  -1   5  3 4  2  0   14  3 -1  -1  -1   4  3 -1  -1  -1   11  3 9  6  12   "
"3 4 2  4  6  9   4 4  6  9  12   4 6  9  12  13   "
"3 12  13  14  "
"10 "
"3 "
"18 18 0  1  2  3  1  2  2  3  3  3  4  4  4  5  5  6  6  1   18 1  0  3  4  2  3  3  4  4  4  5  5  5  6  6  7  7  2   18 2  3  0  1  1  2  2  3  3  3  4  4  4  5  5  6  6  3   18 3  4  1  0  2  3  3  4  4  4  5  5  5  6  6  7  7  4   18 1  2  1  2  0  1  1  2  2  2  3  3  3  4  4  5  5  2   18 2  3  2  3  1  0  2  3  3  3  4  4  4  5  5  6  6  3   18 2  3  2  3  1  2  0  1  1  1  2  2  2  3  3  4  4  3   18 3  4  3  4  2  3  1  0  2  2  3  3  3  4  4  5  5  4   18 3  4  3  4  2  3  1  2  0  2  3  3  3  4  4  5  5  4   18 3  4  3  4  2  3  1  2  2  0  1  1  1  2  2  3  3  4   18 4  5  4  5  3  4  2  3  3  1  0  2  2  3  3  4  4  5   18 4  5  4  5  3  4  2  3  3  1  2  0  2  3  3  4  4  5   18 4  5  4  5  3  4  2  3  3  1  2  2  0  1  1  2  2  5   18 5  6  5  6  4  5  3  4  4  2  3  3  1  0  2  3  3  6   18 5  6  5  6  4  5  3  4  4  2  3  3  1  2  0  1  1  6   18 6  7  6  7  5  6  4  5  5  3  4  4  2  3  1  0  2  7   18 6  7  6  7  5  6  4  5  5  3  4  4  2  3  1  2  0  7   18 1  2  3  4  2  3  3  4  4  4  5  5  5  6  6  7  7  0   "
"6 "
"13 "
"3 "
"18 0  4 0  0  0  0   8  4 1  0  0  0   17  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   16  4 1  1  1  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   12  4 1  1  0  0   10  4 1  1  0  0   15  4 1  1  1  0   6  4 0  0  0  0   5  4 0  0  0  0   14  4 1  1  1  0   13  4 1  1  1  0   11  4 1  1  0  0   "
"18 "
"2 0  25 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!1HG  3!2HG  2!CD  3!1HD  3!2HD  2!NE  2!HE  2!CZ  3!NH1  4!1HH1  4!2HH1  3!NH2  4!1HH2  4!2HH2  3!OXT   1  25 1!N  2!CA  1!C  1!O  2!CB  2!CG  2!CD  2!NE  2!CZ  3!NH1  3!NH2  1!H  4!1HH1  4!2HH1  4!1HH2  4!2HH2  2!HE  2!HA  3!1HB  3!2HB  3!1HG  3!2HG  3!1HD  3!2HD  3!OXT   "
"1 1  "
"1 "
"25 5  -0.369 -0.476 -0.909  16  -3.323 -2.333 -0.146  15  -2.624 -2.901 0.314  3  2.418 -0.306 0.0  23  -5.092 -3.876 2.121  0  -0.569 1.399 0.0  20  -3.16 -4.953 2.749  24  -1.814 1.505 0.0  6  -0.574 -0.82 1.146  4  0.0 0.0 0.0  9  -0.335 -2.318 1.043  1  0.1983 2.386 0  2  1.455 0.0 0.0  7  -0.121 -0.446 2.063  17  -3.279 -3.584 1.273  18  -2.651 -4.451 2.036  10  0.704 -2.485 0.758  13  -1.015 -2.583 -0.935  21  -4.577 -3.377 1.411  8  -1.647 -0.629 1.167  14  -0.947 -4.069 0.041  11  -0.52 -2.766 2.02  12  -1.198 -3.009 0.051  22  -5.048 -2.72 0.804  19  -1.662 -4.611 1.906  "
"1 2 0  -1   "
"1 "
"25 5  3 4  2  0   16  3 15  12  17   15  3 -1  -1  -1   6  3 -1  -1  -1   23  3 21  17  15   0  3 -1  -1  -1   20  3 18  17  15   24  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   17  3 -1  -1  -1   18  3 -1  -1  -1   10  3 9  6  12   13  3 12  9  15   21  3 -1  -1  -1   8  3 6  4  9   14  3 12  9  15   11  3 9  6  12   12  3 -1  -1  -1   22  3 21  17  15   19  3 18  17  15   "
"4 4 2  4  6  9   4 4  6  9  12   4 6  9  12  15   4 9  12  15  17   "
"1 17  "
"12 "
"1 "
"25 25 0  1  2  3  1  2  2  3  3  3  4  4  4  5  5  5  6  6  7  8  8  7  8  8  1   25 1  0  3  4  2  3  3  4  4  4  5  5  5  6  6  6  7  7  8  9  9  8  9  9  2   25 2  3  0  1  1  2  2  3  3  3  4  4  4  5  5  5  6  6  7  8  8  7  8  8  3   25 3  4  1  0  2  3  3  4  4  4  5  5  5  6  6  6  7  7  8  9  9  8  9  9  4   25 1  2  1  2  0  1  1  2  2  2  3  3  3  4  4  4  5  5  6  7  7  6  7  7  2   25 2  3  2  3  1  0  2  3  3  3  4  4  4  5  5  5  6  6  7  8  8  7  8  8  3   25 2  3  2  3  1  2  0  1  1  1  2  2  2  3  3  3  4  4  5  6  6  5  6  6  3   25 3  4  3  4  2  3  1  0  2  2  3  3  3  4  4  4  5  5  6  7  7  6  7  7  4   25 3  4  3  4  2  3  1  2  0  2  3  3  3  4  4  4  5  5  6  7  7  6  7  7  4   25 3  4  3  4  2  3  1  2  2  0  1  1  1  2  2  2  3  3  4  5  5  4  5  5  4   25 4  5  4  5  3  4  2  3  3  1  0  2  2  3  3  3  4  4  5  6  6  5  6  6  5   25 4  5  4  5  3  4  2  3  3  1  2  0  2  3  3  3  4  4  5  6  6  5  6  6  5   25 4  5  4  5  3  4  2  3  3  1  2  2  0  1  1  1  2  2  3  4  4  3  4  4  5   25 5  6  5  6  4  5  3  4  4  2  3  3  1  0  2  2  3  3  4  5  5  4  5  5  6   25 5  6  5  6  4  5  3  4  4  2  3  3  1  2  0  2  3  3  4  5  5  4  5  5  6   25 5  6  5  6  4  5  3  4  4  2  3  3  1  2  2  0  1  1  2  3  3  2  3  3  6   25 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  0  2  3  4  4  3  4  4  7   25 6  7  6  7  5  6  4  5  5  3  4  4  2  3  3  1  2  0  1  2  2  1  2  2  7   25 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  1  0  1  1  2  3  3  8   25 8  9  8  9  7  8  6  7  7  5  6  6  4  5  5  3  4  2  1  0  2  3  4  4  9   25 8  9  8  9  7  8  6  7  7  5  6  6  4  5  5  3  4  2  1  2  0  3  4  4  9   25 7  8  7  8  6  7  5  6  6  4  5  5  3  4  4  2  3  1  2  3  3  0  1  1  8   25 8  9  8  9  7  8  6  7  7  5  6  6  4  5  5  3  4  2  3  4  4  1  0  2  9   25 8  9  8  9  7  8  6  7  7  5  6  6  4  5  5  3  4  2  3  4  4  1  2  0  9   25 1  2  3  4  2  3  3  4  4  4  5  5  5  6  6  6  7  7  8  9  9  8  9  9  0   "
"6 "
"14 "
"4 "
"25 5  4 0  0  0  0   16  4 1  1  1  1   15  4 1  1  1  0   6  4 0  0  0  0   23  4 1  1  1  1   0  4 0  0  0  0   20  4 1  1  1  1   24  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   17  4 1  1  1  1   18  4 1  1  1  1   10  4 1  1  0  0   13  4 1  1  1  0   21  4 1  1  1  1   8  4 1  0  0  0   14  4 1  1  1  0   11  4 1  1  0  0   12  4 1  1  0  0   22  4 1  1  1  1   19  4 1  1  1  1   "
"25 "
"2 0  12 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!OG  2!HG  3!OXT   1  12 1!N  2!CA  1!C  1!O  2!CB  2!OG  1!H  2!HG  2!HA  3!1HB  3!2HB  3!OXT   "
"2 9  1  "
"1 "
"12 0  -0.572 1.422 0.0  8  -1.602 -0.639 1.253  9  -0.231 -2.137 1.113  6  -0.522 -0.769 1.198  4  0.0 0.0 0.0  1  0.199 2.406 0.0  2  1.47 0.0 0.0  7  -0.062 -0.364 2.099  11  -1.817 1.533 0.0  3  2.435 -0.299 0.0  5  -0.433 -0.566 -0.826  10  -0.577 -2.586 1.888  "
"2 2 10  -1   2 0  -1   "
"2 "
"12 0  3 -1  -1  -1   8  3 6  4  9   9  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   11  3 -1  -1  -1   6  3 -1  -1  -1   5  3 4  2  0   10  3 9  6  4   "
"2 4 2  4  6  9   4 4  6  9  10   "
"1 9  "
"7 "
"1 "
"12 12 0  1  2  3  1  2  2  3  3  3  4  1   12 1  0  3  4  2  3  3  4  4  4  5  2   12 2  3  0  1  1  2  2  3  3  3  4  3   12 3  4  1  0  2  3  3  4  4  4  5  4   12 1  2  1  2  0  1  1  2  2  2  3  2   12 2  3  2  3  1  0  2  3  3  3  4  3   12 2  3  2  3  1  2  0  1  1  1  2  3   12 3  4  3  4  2  3  1  0  2  2  3  4   12 3  4  3  4  2  3  1  2  0  2  3  4   12 3  4  3  4  2  3  1  2  2  0  1  4   12 4  5  4  5  3  4  2  3  3  1  0  5   12 1  2  3  4  2  3  3  4  4  4  5  0   "
"6 "
"15 "
"2 "
"12 0  4 0  0  0  0   8  4 1  0  0  0   9  4 1  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   11  4 0  0  0  0   6  4 0  0  0  0   5  4 0  0  0  0   10  4 1  1  0  0   "
"12 "
"2 0  15 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  2!HB  3!CG2  4!1HG2  4!2HG2  4!3HG2  3!OG1  3!HG1  3!OXT   1  15 1!N  2!CA  1!C  1!O  2!CB  3!OG1  3!CG2  1!H  3!HG1  2!HA  2!HB  4!1HG2  4!2HG2  4!3HG2  3!OXT   "
"2 12  1  "
"1 "
"15 10  -2.55 17.297 58.568  0  0.0 16.858 60.734  5  0.91 18.329 59.526  14  0.0 17.447 61.837  6  -1.215 18.675 59.53  4  0.0 17.73 59.484  12  -1.174 19.452 60.734  1  0.0 15.61257 60.6272  2  0.0 16.917 58.274  9  -3.358 18.565 59.521  13  -1.932 20.041 60.76  3  -0.031 15.912 58.372  7  -1.174 19.347 58.673  8  -2.511 17.88 59.488  11  -2.553 17.209 60.345  "
"2 2 13  -1   2 0  -1   "
"2 "
"15 10  3 8  6  4   0  3 -1  -1  -1   8  3 -1  -1  -1   14  3 -1  -1  -1   3  3 -1  -1  -1   11  3 8  6  4   12  3 -1  -1  -1   1  3 -1  -1  -1   13  3 12  6  4   2  3 -1  -1  -1   9  3 8  6  4   6  3 -1  -1  -1   7  3 6  4  12   5  3 4  2  0   4  3 -1  -1  -1   "
"2 4 2  4  6  12   4 4  6  12  13   "
"1 12  "
"8 "
"1 "
"15 15 0  1  2  3  1  2  2  3  3  4  4  4  3  4  1   15 1  0  3  4  2  3  3  4  4  5  5  5  4  5  2   15 2  3  0  1  1  2  2  3  3  4  4  4  3  4  3   15 3  4  1  0  2  3  3  4  4  5  5  5  4  5  4   15 1  2  1  2  0  1  1  2  2  3  3  3  2  3  2   15 2  3  2  3  1  0  2  3  3  4  4  4  3  4  3   15 2  3  2  3  1  2  0  1  1  2  2  2  1  2  3   15 3  4  3  4  2  3  1  0  2  3  3  3  2  3  4   15 3  4  3  4  2  3  1  2  0  1  1  1  2  3  4   15 4  5  4  5  3  4  2  3  1  0  2  2  3  4  5   15 4  5  4  5  3  4  2  3  1  2  0  2  3  4  5   15 4  5  4  5  3  4  2  3  1  2  2  0  3  4  5   15 3  4  3  4  2  3  1  2  2  3  3  3  0  1  4   15 4  5  4  5  3  4  2  3  3  4  4  4  1  0  5   15 1  2  3  4  2  3  3  4  4  5  5  5  4  5  0   "
"6 "
"16 "
"2 "
"15 10  4 1  0  0  0   0  4 0  0  0  0   8  4 1  0  0  0   14  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   12  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   9  4 1  0  0  0   13  4 1  1  0  0   6  4 0  0  0  0   7  4 1  0  0  0   5  4 0  0  0  0   11  4 1  0  0  0   "
"15 "
"2 0  17 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  2!HB  3!CG1  4!1HG1  4!2HG1  4!3HG1  3!CG2  4!1HG2  4!2HG2  4!3HG2  3!OXT   1  17 1!N  2!CA  1!C  1!O  2!CB  3!CG1  3!CG2  1!H  2!HA  2!HB  4!1HG1  4!2HG1  4!3HG1  4!1HG2  4!2HG2  4!3HG2  3!OXT   "
"1 1  "
"0 "
"17 14  0.325 14.257 62.153  0  0.0 17.753 64.344  5  -0.909 16.196 63.29  16  0.0 17.253 65.49  6  1.215 15.847 63.287  4  0.0 16.786 63.167  9  2.058 14.455 64.688  10  1.223 15.838 65.434  1  0.0 18.9862 64.1397  2  0.0 17.501 61.897  7  2.128 16.438 63.213  13  2.102 14.199 62.235  11  0.28 14.522 64.694  3  0.031 18.51 61.915  8  1.192 15.114 64.62  12  1.237 14.854 62.135  15  1.299 15.394 61.19  "
"1 2 0  -1   "
"1 "
"17 14  3 12  6  4   10  3 8  6  4   12  3 -1  -1  -1   16  3 -1  -1  -1   11  3 8  6  4   15  3 12  6  4   0  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   8  3 -1  -1  -1   13  3 12  6  4   3  3 -1  -1  -1   9  3 8  6  4   7  3 6  4  8   5  3 4  2  0   4  3 -1  -1  -1   6  3 -1  -1  -1   "
"1 4 2  4  6  8   "
"3 6  8  12  "
"8 "
"3 "
"17 17 0  1  2  3  1  2  2  3  3  4  4  4  3  4  4  4  1   17 1  0  3  4  2  3  3  4  4  5  5  5  4  5  5  5  2   17 2  3  0  1  1  2  2  3  3  4  4  4  3  4  4  4  3   17 3  4  1  0  2  3  3  4  4  5  5  5  4  5  5  5  4   17 1  2  1  2  0  1  1  2  2  3  3  3  2  3  3  3  2   17 2  3  2  3  1  0  2  3  3  4  4  4  3  4  4  4  3   17 2  3  2  3  1  2  0  1  1  2  2  2  1  2  2  2  3   17 3  4  3  4  2  3  1  0  2  3  3  3  2  3  3  3  4   17 3  4  3  4  2  3  1  2  0  1  1  1  2  3  3  3  4   17 4  5  4  5  3  4  2  3  1  0  2  2  3  4  4  4  5   17 4  5  4  5  3  4  2  3  1  2  0  2  3  4  4  4  5   17 4  5  4  5  3  4  2  3  1  2  2  0  3  4  4  4  5   17 3  4  3  4  2  3  1  2  2  3  3  3  0  1  1  1  4   17 4  5  4  5  3  4  2  3  3  4  4  4  1  0  2  2  5   17 4  5  4  5  3  4  2  3  3  4  4  4  1  2  0  2  5   17 4  5  4  5  3  4  2  3  3  4  4  4  1  2  2  0  5   17 1  2  3  4  2  3  3  4  4  5  5  5  4  5  5  5  0   "
"6 "
"17 "
"1 "
"17 14  4 1  0  0  0   0  4 0  0  0  0   12  4 1  0  0  0   16  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   10  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   8  4 1  0  0  0   13  4 1  0  0  0   11  4 1  0  0  0   6  4 0  0  0  0   7  4 1  0  0  0   5  4 0  0  0  0   15  4 1  0  0  0   "
"17 "
"2 0  25 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!CD1  3!HD1  3!CD2  3!NE1  3!HE1  3!CE2  3!CE3  3!HE3  3!CZ2  3!HZ2  3!CZ3  3!HZ3  3!CH2  3!HH2  3!OXT   1  25 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!CD1  3!CD2  3!NE1  3!CE2  3!CE3  3!CZ2  3!CZ3  3!CH2  1!H  3!HE1  3!HD1  3!HZ2  3!HH2  3!HZ3  3!HE3  2!HA  3!1HB  3!2HB  3!OXT   "
"1 1  "
"0 "
"25 23  1.572 20.577 72.361  18  -0.148 21.104 71.181  20  1.489 19.436 70.569  10  -2.237 20.752 68.28  12  -0.354 19.853 69.088  5  0.907 18.621 66.804  14  -2.524 22.078 69.917  17  1.237 18.387 68.728  22  1.018 20.384 71.442  21  2.403 18.883 70.787  19  -0.557 21.865 71.846  0  0.0 17.148 68.014  24  0.0 17.738 69.116  6  -1.21 18.954 66.777  4  0.0 18.018 66.764  9  -1.279 19.826 67.994  1  0.0 15.90245 67.9086  2  0.0 17.204 65.554  7  -1.18 19.622 65.916  16  0.821 19.151 69.384  15  -0.815 20.819 70.0  8  -2.133 18.375 66.755  11  -3.037 20.874 67.552  3  -0.038 16.199 65.653  13  -1.967 21.356 69.483  "
"1 2 0  -1   "
"1 "
"25 23  3 22  18  20   18  3 -1  -1  -1   20  3 -1  -1  -1   10  3 -1  -1  -1   12  3 -1  -1  -1   5  3 4  2  0   14  3 13  10  15   17  3 16  12  20   22  3 -1  -1  -1   21  3 20  16  22   19  3 18  15  22   6  3 -1  -1  -1   0  3 -1  -1  -1   24  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   16  3 -1  -1  -1   15  3 -1  -1  -1   8  3 6  4  9   11  3 10  9  13   13  3 -1  -1  -1   "
"2 4 2  4  6  9   4 4  6  9  10   "
"2 12  15  "
"15 "
"2 "
"25 25 0  1  2  3  1  2  2  3  3  3  4  5  4  5  6  5  5  6  6  7  6  7  7  8  1   25 1  0  3  4  2  3  3  4  4  4  5  6  5  6  7  6  6  7  7  8  7  8  8  9  2   25 2  3  0  1  1  2  2  3  3  3  4  5  4  5  6  5  5  6  6  7  6  7  7  8  3   25 3  4  1  0  2  3  3  4  4  4  5  6  5  6  7  6  6  7  7  8  7  8  8  9  4   25 1  2  1  2  0  1  1  2  2  2  3  4  3  4  5  4  4  5  5  6  5  6  6  7  2   25 2  3  2  3  1  0  2  3  3  3  4  5  4  5  6  5  5  6  6  7  6  7  7  8  3   25 2  3  2  3  1  2  0  1  1  1  2  3  2  3  4  3  3  4  4  5  4  5  5  6  3   25 3  4  3  4  2  3  1  0  2  2  3  4  3  4  5  4  4  5  5  6  5  6  6  7  4   25 3  4  3  4  2  3  1  2  0  2  3  4  3  4  5  4  4  5  5  6  5  6  6  7  4   25 3  4  3  4  2  3  1  2  2  0  1  2  1  2  3  2  2  3  3  4  3  4  4  5  4   25 4  5  4  5  3  4  2  3  3  1  0  1  2  1  2  2  3  4  3  4  4  5  4  5  5   25 5  6  5  6  4  5  3  4  4  2  1  0  3  2  3  3  4  5  4  5  5  6  5  6  6   25 4  5  4  5  3  4  2  3  3  1  2  3  0  2  3  1  1  2  2  3  2  3  3  4  5   25 5  6  5  6  4  5  3  4  4  2  1  2  2  0  1  1  3  4  2  3  4  5  3  4  6   25 6  7  6  7  5  6  4  5  5  3  2  3  3  1  0  2  4  5  3  4  5  6  4  5  7   25 5  6  5  6  4  5  3  4  4  2  2  3  1  1  2  0  2  3  1  2  3  4  2  3  6   25 5  6  5  6  4  5  3  4  4  2  3  4  1  3  4  2  0  1  3  4  1  2  2  3  6   25 6  7  6  7  5  6  4  5  5  3  4  5  2  4  5  3  1  0  4  5  2  3  3  4  7   25 6  7  6  7  5  6  4  5  5  3  3  4  2  2  3  1  3  4  0  1  2  3  1  2  7   25 7  8  7  8  6  7  5  6  6  4  4  5  3  3  4  2  4  5  1  0  3  4  2  3  8   25 6  7  6  7  5  6  4  5  5  3  4  5  2  4  5  3  1  2  2  3  0  1  1  2  7   25 7  8  7  8  6  7  5  6  6  4  5  6  3  5  6  4  2  3  3  4  1  0  2  3  8   25 7  8  7  8  6  7  5  6  6  4  5  6  3  3  4  2  2  3  1  2  1  2  0  1  8   25 8  9  8  9  7  8  6  7  7  5  6  7  4  4  5  3  3  4  2  3  2  3  1  0  9   25 1  2  3  4  2  3  3  4  4  4  5  6  5  6  7  6  6  7  7  8  7  8  8  9  0   "
"6 "
"18 "
"2 "
"25 23  4 1  1  0  0   18  4 1  1  0  0   20  4 1  1  0  0   10  4 1  1  0  0   12  4 1  1  0  0   5  4 0  0  0  0   14  4 1  1  0  0   17  4 1  1  0  0   22  4 1  1  0  0   21  4 1  1  0  0   19  4 1  1  0  0   6  4 0  0  0  0   0  4 0  0  0  0   24  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   16  4 1  1  0  0   15  4 1  1  0  0   8  4 1  0  0  0   11  4 1  1  0  0   13  4 1  1  0  0   "
"25 "
"2 0  22 1!C  1!O  1!N  1!H  2!CA  2!HA  2!CB  3!1HB  3!2HB  2!CG  3!CD1  3!HD1  3!CD2  3!HD2  3!CE1  3!HE1  3!CE2  3!HE2  2!CZ  2!OH  2!HH  3!OXT   1  22 1!N  2!CA  1!C  1!O  2!CB  2!CG  3!CD1  3!CD2  3!CE1  3!CE2  2!CZ  2!OH  1!H  2!HH  3!HD1  3!HE1  3!HE2  3!HD2  2!HA  3!1HB  3!2HB  3!OXT   "
"2 1  19  "
"0 "
"22 20  0.768 13.405 75.979  10  2.323 14.47 72.062  12  0.319 15.515 72.811  5  -0.908 16.48 70.536  15  3.218 13.056 73.41  17  -0.387 14.938 74.753  3  0.039 18.801 69.195  0  0.0 18.044 71.623  21  0.0 17.544 72.769  6  1.209 16.143 70.536  4  0.0 17.077 70.447  9  1.285 15.36 71.828  1  0.0 19.2771 71.4182  2  0.0 17.791 69.177  7  1.145 15.451 69.695  18  1.424 13.922 74.204  16  0.383 14.803 73.993  14  2.397 13.752 73.24  8  2.101 16.76 70.432  13  -0.501 16.212 72.638  11  3.088 14.341 71.296  19  1.493 13.211 75.38  "
"2 2 0  -1   2 20  -1   "
"2 "
"22 20  3 19  18  14   10  3 -1  -1  -1   12  3 -1  -1  -1   5  3 4  2  0   15  3 14  10  18   17  3 16  12  18   6  3 -1  -1  -1   0  3 -1  -1  -1   21  3 -1  -1  -1   3  3 -1  -1  -1   4  3 -1  -1  -1   9  3 -1  -1  -1   1  3 -1  -1  -1   2  3 -1  -1  -1   7  3 6  4  9   18  3 -1  -1  -1   16  3 -1  -1  -1   14  3 -1  -1  -1   8  3 6  4  9   13  3 12  9  16   11  3 10  9  14   19  3 -1  -1  -1   "
"3 4 2  4  6  9   4 4  6  9  10   4 16  18  19  20   "
"2 9  18  "
"13 "
"2 "
"22 22 0  1  2  3  1  2  2  3  3  3  4  5  4  5  5  6  5  6  6  7  8  1   22 1  0  3  4  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  9  2   22 2  3  0  1  1  2  2  3  3  3  4  5  4  5  5  6  5  6  6  7  8  3   22 3  4  1  0  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  9  4   22 1  2  1  2  0  1  1  2  2  2  3  4  3  4  4  5  4  5  5  6  7  2   22 2  3  2  3  1  0  2  3  3  3  4  5  4  5  5  6  5  6  6  7  8  3   22 2  3  2  3  1  2  0  1  1  1  2  3  2  3  3  4  3  4  4  5  6  3   22 3  4  3  4  2  3  1  0  2  2  3  4  3  4  4  5  4  5  5  6  7  4   22 3  4  3  4  2  3  1  2  0  2  3  4  3  4  4  5  4  5  5  6  7  4   22 3  4  3  4  2  3  1  2  2  0  1  2  1  2  2  3  2  3  3  4  5  4   22 4  5  4  5  3  4  2  3  3  1  0  1  2  3  1  2  3  4  2  3  4  5   22 5  6  5  6  4  5  3  4  4  2  1  0  3  4  2  3  4  5  3  4  5  6   22 4  5  4  5  3  4  2  3  3  1  2  3  0  1  3  4  1  2  2  3  4  5   22 5  6  5  6  4  5  3  4  4  2  3  4  1  0  4  5  2  3  3  4  5  6   22 5  6  5  6  4  5  3  4  4  2  1  2  3  4  0  1  2  3  1  2  3  6   22 6  7  6  7  5  6  4  5  5  3  2  3  4  5  1  0  3  4  2  3  4  7   22 5  6  5  6  4  5  3  4  4  2  3  4  1  2  2  3  0  1  1  2  3  6   22 6  7  6  7  5  6  4  5  5  3  4  5  2  3  3  4  1  0  2  3  4  7   22 6  7  6  7  5  6  4  5  5  3  2  3  2  3  1  2  1  2  0  1  2  7   22 7  8  7  8  6  7  5  6  6  4  3  4  3  4  2  3  2  3  1  0  1  8   22 8  9  8  9  7  8  6  7  7  5  4  5  4  5  3  4  3  4  2  1  0  9   22 1  2  3  4  2  3  3  4  4  4  5  6  5  6  6  7  6  7  7  8  9  0   "
"6 "
"19 "
"3 "
"22 20  4 1  1  1  0   10  4 1  1  0  0   12  4 1  1  0  0   5  4 0  0  0  0   15  4 1  1  0  0   17  4 1  1  0  0   6  4 0  0  0  0   0  4 0  0  0  0   21  4 0  0  0  0   3  4 0  0  0  0   4  4 0  0  0  0   9  4 1  0  0  0   1  4 0  0  0  0   2  4 0  0  0  0   7  4 1  0  0  0   18  4 1  1  0  0   16  4 1  1  0  0   14  4 1  1  0  0   8  4 1  0  0  0   13  4 1  1  0  0   11  4 1  1  0  0   19  4 1  1  0  0   "
"22 "
;

